This is CPFLAME version 0.98

   simple model on a c grid with nonhydrostatic version 

   1D domain decomposition for parallel computation

   Documentation available as pdf file (./doc/cpflame.pdf)

*** Quick start ***

 Comiling the code:
--------------------

  - make a new directory (<dir> hereafter)
  
  - extract tar-archive in <dir>

  - edit file "Makefile": 
    variable CPFLAME has to be set to <dir>

  - copy one of the files in <dir>/configure  
    to a (new) file <dir>/"Makfile_host" depending
    on the system where you want to compile on.
    You may have to set some paths to libraries 
    in <dir>/"Makefile_host"

  - type "make"

*** Directory structure ***

./bin           contains executables 
./configure     contains sample versions for Makefile_host
./doc           contains some documentation
./include       include files containing e.g. preprocessor directives
./model         source code for model
./setup         source code for specific configurations
./misc_modules  source code for utility functions
./mpp           source code relevant for parallel execution
./extra_modules source code for add-on modules
./extra_setup   source code for extra configurations

c=======================================================================
c
c     Setup for a simple passive tracer
c     linked in the code in ../extra_modules/tracer.F
c=======================================================================


      subroutine tracer_set_number
c ----------------------------------
c     set number of tracers
c ----------------------------------
      use tracer_module
      implicit none
      nt=1
      end subroutine tracer_set_number

      subroutine tracer_initial_conditions
c ----------------------------------
c     initial conditions for tracer
c ----------------------------------
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k
      real :: fac,B0,x,y,z
      fac = 2*0.2/rho_0*g
      do k=1,km
       do j=1,jmt
        do i=1,imt
         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
         B0=fac*0.5*(tanh(-(y-0.5)/0.1)+1.0)
         tr(i,j,k,:,1)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo

      do j=1,jmt
       do k=km-3,km
        do i=1,imt
         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
         B0=fac*0.5*(tanh(-(y-0.5)/0.1)+1.0)
         tr(i,j,k,:,1)  = (B0-0.0010**2*zt(k))*maskT(i,j,k)
        enddo
        enddo
      enddo

      end subroutine tracer_initial_conditions


      subroutine tracer_sources
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k,js,je,n
      real :: fxa,fxb
c ----------------------------------
c      add here restoring zones, surface boundary conditions etc.
c ----------------------------------

      js=max(2,js_pe); je = min(je_pe,jmt-1)
c ----------------------------------
c    diagnostic output
c ----------------------------------
      fxa=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          fxa=fxa+tr(i,j,k,tau,1)*dx**2*dz*maskT(i,j,k)
        enddo
       enddo
      enddo
      call global_sum(fxa)
      if (my_pe==0) print*, 'total tracer content ',fxa,' mol'
      call sub_flush(6)

      end subroutine tracer_sources

#include "options.inc"
    

c=======================================================================
c       Bolus velocity and isopycnal diffusion
c       linked in the code in driver.F
#ifdef enable_ekecalc
c       linked also in the code in eke_closure.F 
#endif
#ifdef enable_ekecalc_3D
c       linked also in the code in eke_closure_3D.F 
#endif
c=======================================================================

#ifdef enable_bolus_velocity

c write output to netcdf file
#define enable_bolus_diag

c only do isopycnal diffusion, bolus part is done elsewhere
#define enable_bolus_isopycnal_diffusion_only

c=======================================================================
c prevent spurious under shooting by advection of passive tracer
c due to isopycnal diffusion
c works only for positive tracer like concentrations
c#define delimit_tracer_fluxes
c=======================================================================

      module bolus_module
c-----------------------------------------------------------------------
c     module for bolus velocities
c-----------------------------------------------------------------------
      implicit none
      real, allocatable :: ub(:,:,:)
      real, allocatable :: vb(:,:,:)
      real, allocatable :: wb(:,:,:)
      real, allocatable :: psix(:,:,:)
      real, allocatable :: psiy(:,:,:)
      real, allocatable :: ahthk(:,:,:)
      real, parameter :: epsln = 1.0e-20 ! a small parameter
      real, parameter :: K_const=1e3 ! thickness diffusivity in m^2/s
      real, parameter :: K_min     = 10.0, K_max     = 5e4  ! threshold values bounding K_const
      real, parameter :: dslope=0.0008, slopec=0.005  ! parameters controlling max allowed isopycnal slopes
      end module bolus_module
 

      subroutine init_bolus
c-----------------------------------------------------------------------
c     initialize module
c-----------------------------------------------------------------------
      use cpflame_module
      use bolus_module
      implicit none
      real :: fxa

      if (my_pe==0) print*,' Initializing GM module '
      allocate( ub(imt,jmt,km) ); ub=0.
      allocate( vb(imt,jmt,km) ); vb=0.
      allocate( wb(imt,jmt,km) ); wb=0.
      allocate( psix(imt,jmt,km) ); psix=0.
      allocate( psiy(imt,jmt,km) ); psiy=0.
      allocate( ahthk(imt,jmt,km) ); ahthk=0.
      ahthk = K_const

#ifdef enable_bolus_diag
      if (my_pe==0) call init_bolus_diag
#else
      if (my_pe==0) print*,' no diagnostic output '
#endif
c
c-----------------------------------------------------------------------
c     Compute the grid factors which set the maximum slopes available
c     for the mixing schemes. 
c-----------------------------------------------------------------------
c
      fxa = dz*dx/(4*K_const*dt_in+epsln)
      if (my_pe==0) then
       print*,' steepest slope possible for linear stab = ',fxa
       print*,' critical slope specified as               ',slopec
#ifdef enable_bolus_isopycnal_diffusion_only
       print*,' does isopycnal diffusion only '
       print*,' assuming that bolus part is done elsewhere '
#endif
      print*,' K_const = ',k_const,' m^2/s'
      print*,' K_min = ',k_min,' m^2/s'
      print*,' K_max = ',k_max,' m^2/s'
      endif
      if (my_pe==0) print*,' done initializing GM module '
      end subroutine init_bolus




      subroutine bolus_velocity
c-----------------------------------------------------------------------
c     Verteiler funktion
c-----------------------------------------------------------------------
      use cpflame_module
      use bolus_module
#ifdef enable_diag_tracer
      use tracer_module
#endif
      implicit none
      integer :: n
#ifndef enable_bolus_isopycnal_diffusion_only
      call calculate_bolus
      call add_bolus(b)
#ifdef enable_diag_tracer
      do n=1,nt
       call add_bolus(tr(:,:,:,:,n))
      enddo
#endif
#endif
#ifdef enable_diag_tracer
      do n=1,nt
       call isopycnal_diffusion(n,tr(:,:,:,:,n))
      enddo
#endif
#ifdef enable_bolus_diag
      if (snapshot_time_step.or.initial_time==current_time) then
        call diag_bolus
      endif
#endif
      end subroutine bolus_velocity


      subroutine isopycnal_diffusion(n,tr)
c=======================================================================
c     Isopycnal diffusion
c=======================================================================
      use cpflame_module
      use bolus_module
      implicit none
      real :: tr(imt,jmt,km,0:2)
      integer :: i,j,k,js,je,n
      real :: diff_fn(imt,jmt,km),K_iso(imt,jmt,km)
      real :: diff_fe(imt,jmt,km),diff_ft(imt,jmt,km)
      real :: Tz(imt,jmt,km),bz(imt,jmt,km),sl,fxa
      real :: Tx(imt,jmt,km),bx(imt,jmt,km)
      real :: Ty(imt,jmt,km),by(imt,jmt,km)

      diff_fe(:,js_pe:je_pe,:)=0; diff_fn(:,js_pe:je_pe,:)=0
      diff_ft(:,js_pe:je_pe,:)=0

      js=max(2,js_pe); je = min(je_pe,jmt-1)
c-----------------------------------------------------------------------
c     derivatives of buoyancy
c-----------------------------------------------------------------------
      bz(:,js_pe:je_pe,:)=0; bx(:,js_pe:je_pe,:)=0
      by(:,js_pe:je_pe,:)=0
      do k=1,km-1
       do j=js,je
        do i=1,imt-1
         bx(i,j,k)= (b(i+1,j,k,taum1)-b(i,j,k,taum1))/dx*maskU(i,j,k) 
         by(i,j,k)= (b(i,j+1,k,taum1)-b(i,j,k,taum1))/dx*maskV(i,j,k) 
         bz(i,j,k)= (b(i,j,k+1,taum1)-b(i,j,k,taum1))/dz*maskW(i,j,k) 
        enddo
       enddo
      enddo
      call border_exchg3D(bx,1); call setcyclic3D(bx)
      call border_exchg3D(by,1); call setcyclic3D(by)
      call border_exchg3D(bz,1); call setcyclic3D(bz)
c-----------------------------------------------------------------------
c     derivatives of tracer
c-----------------------------------------------------------------------
      Tz(:,js_pe:je_pe,:)=0; Tx(:,js_pe:je_pe,:)=0
      Ty(:,js_pe:je_pe,:)=0
      do k=1,km-1
       do j=js,je
        do i=1,imt-1
         Tx(i,j,k)= (tr(i+1,j,k,taum1)-tr(i,j,k,taum1))/dx*maskU(i,j,k) 
         Ty(i,j,k)= (tr(i,j+1,k,taum1)-tr(i,j,k,taum1))/dx*maskV(i,j,k) 
         Tz(i,j,k)= (tr(i,j,k+1,taum1)-tr(i,j,k,taum1))/dz*maskW(i,j,k) 
        enddo
       enddo
      enddo
      call border_exchg3D(Tx,1); call setcyclic3D(Tx)
      call border_exchg3D(Ty,1); call setcyclic3D(Ty)
      call border_exchg3D(Tz,1); call setcyclic3D(Tz)

c-----------------------------------------------------------------------
c     diff_fe =  K (T_x - b_x/b_z T_z)
c-----------------------------------------------------------------------
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         fxa=(bz(i,j,k)+bz(i,j,k-1)+bz(i+1,j,k)+bz(i+1,j,k-1))
     &    /(maskW(i,j,k  )+maskW(i+1,j,k)
     &     +maskW(i,j,k-1)+maskW(i+1,j,k-1)+epsln)
         sl=bx(i,j,k)*sign(1.,fxa)/(abs(fxa)+epsln)
         sl=sl*0.5*(1.+tanh((-abs(sl)+slopec)/dslope))   
         fxa=(Tz(i,j,k)+Tz(i,j,k-1)+Tz(i+1,j,k)+Tz(i+1,j,k-1))
     &    /(maskW(i,j,k  )+maskW(i+1,j,k)
     &     +maskW(i,j,k-1)+maskW(i+1,j,k-1)+epsln)
         diff_fe(i,j,k)=(Tx(i,j,k)-sl*fxa)
     &                  *maskU(i,j,k)*ahthk(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(diff_fe)
c-----------------------------------------------------------------------
c     diff_fn =  K (T_y - b_y/b_z T_z)
c-----------------------------------------------------------------------
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fxa=(bz(i,j,k)+bz(i,j,k-1)+bz(i,j+1,k)+bz(i,j+1,k-1))
     &    /(maskW(i,j,k  )+maskW(i,j+1,k)
     &     +maskW(i,j,k-1)+maskW(i,j+1,k-1)+epsln)
         sl=by(i,j,k)*sign(1.,fxa)/(abs(fxa)+epsln)
         sl=sl*0.5*(1.+tanh((-abs(sl)+slopec)/dslope))   
         fxa=(Tz(i,j,k)+Tz(i,j,k-1)+Tz(i,j+1,k)+Tz(i,j+1,k-1))
     &    /(maskW(i,j,k  )+maskW(i,j+1,k)
     &     +maskW(i,j,k-1)+maskW(i,j+1,k-1)+epsln)
         diff_fn(i,j,k)=(Ty(i,j,k)-sl*fxa)
     &                  *maskV(i,j,k)*ahthk(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
c-----------------------------------------------------------------------
c     diff_fb =  - K(b_x/b_z T_x +b_y/b_z T_y) 
c                  + T_z K((bx/bz)**2+(by/bz))**2
c      second term is done implicitly
c-----------------------------------------------------------------------
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fxa=(bx(i,j,k)+bx(i-1,j,k)+bx(i,j,k+1)+bx(i-1,j,k+1))
     &    /(maskU(i,j,k  )+maskU(i-1,j,k  )
     &     +maskU(i,j,k+1)+maskU(i-1,j,k+1)+epsln)
         sl=fxa*sign(1.,bz(i,j,k))/(abs(bz(i,j,k))+epsln)
         sl=sl*0.5*(1.+tanh((-abs(sl)+slopec)/dslope))   
         fxa=(Tx(i,j,k)+Tx(i-1,j,k)+Tx(i,j,k+1)+Tx(i-1,j,k+1))
     &    /(maskU(i,j,k  )+maskU(i-1,j,k  )
     &     +maskU(i,j,k+1)+maskU(i-1,j,k+1)+epsln)
         diff_ft(i,j,k)=(-sl*fxa)*maskW(i,j,k)*ahthk(i,j,k)
         K_iso(i,j,k)=sl**2*maskW(i,j,k)*ahthk(i,j,k)

         fxa=(by(i,j,k)+by(i,j-1,k  )+by(i,j,k+1)+by(i,j-1,k+1))
     &    /(maskV(i,j,k  )+maskV(i,j-1,k  )
     &     +maskV(i,j,k+1)+maskV(i,j-1,k+1)+epsln)
         sl=fxa*sign(1.,bz(i,j,k))/(abs(bz(i,j,k))+epsln)
         sl=sl*0.5*(1.+tanh((-abs(sl)+slopec)/dslope))   
         fxa=(Ty(i,j,k)+Ty(i,j-1,k)+Ty(i,j,k+1)+Ty(i,j-1,k+1))
     &    /(maskV(i,j,k  )+maskV(i,j-1,k  )
     &     +maskV(i,j,k+1)+maskV(i,j-1,k+1)+epsln)
         diff_ft(i,j,k)=diff_ft(i,j,k)
     &                  +(-sl*fxa)*maskW(i,j,k)*ahthk(i,j,k)
         K_iso(i,j,k)=K_iso(i,j,k)+
     &                    sl**2*maskW(i,j,k)*ahthk(i,j,k)
        enddo
       enddo
      enddo

#if defined enable_diag_tracer & defined delimit_tracer_fluxes
       diff_fe(:,js_pe:je_pe,:)=-diff_fe(:,js_pe:je_pe,:)
       diff_fn(:,js_pe:je_pe,:)=-diff_fn(:,js_pe:je_pe,:)
       diff_ft(:,js_pe:je_pe,:)=-diff_ft(:,js_pe:je_pe,:)
       call border_exchg3D(diff_fn,1);
       call delimit_adv_flux_taup1(n,diff_fe,diff_fn,diff_ft)
       diff_fe(:,js_pe:je_pe,:)=-diff_fe(:,js_pe:je_pe,:)
       diff_fn(:,js_pe:je_pe,:)=-diff_fn(:,js_pe:je_pe,:)
       diff_ft(:,js_pe:je_pe,:)=-diff_ft(:,js_pe:je_pe,:)
       call border_exchg3D(diff_fn,1);
#endif
c---------------------------------------------------------------------------------
c     add explicit part 
c---------------------------------------------------------------------------------
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          tr(i,j,k,taup1)=tr(i,j,k,taup1)+maskT(i,j,k)*c2dt*( 
     &          +(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz
     &          +(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
     &          +(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx  
     &              )  
        enddo
       enddo
      enddo
c---------------------------------------------------------------------------------
c     add implicit part 
c---------------------------------------------------------------------------------
      call implicit_tracer_mix(tr,K_iso)
      call border_exchg3D(tr(:,:,:,taup1),2)
      call setcyclic3D(tr(:,:,:,taup1) )
      end subroutine isopycnal_diffusion


      subroutine bolus_set_ahthk(diff)
c-----------------------------------------------------------------------
c     set thickness diffusivity from other module
c-----------------------------------------------------------------------
      use cpflame_module
      use bolus_module
      implicit none
      real :: diff(imt,jmt,km)
      ahthk(:,js_pe:je_pe,:)=min(max(diff(:,js_pe:je_pe,:),K_min),K_max)
      call border_exchg3D(ahthk,1); call setcyclic3D(ahthk)
      end subroutine bolus_set_ahthk



      subroutine calculate_bolus
c-----------------------------------------------------------------------
c     calculate bolus velocities using diffusivity ahthk
c-----------------------------------------------------------------------
      use cpflame_module
      use bolus_module
      implicit none
      integer :: i,j,k,js,je
      real :: fxa,fxb,fxc

      real :: sx(imt,jmt,km),bz(imt,jmt,km),sy(imt,jmt,km)
      real :: a(imt,jmt,km)

      js=max(2,js_pe); je = min(je_pe,jmt-1)
c-----------------------------------------------------------------------
c     vertical derivative of buoyancy
c-----------------------------------------------------------------------
      bz(:,js_pe:je_pe,:)=0
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         bz(i,j,k)= (b(i,j,k+1,taum1)-b(i,j,k,taum1))/dz*maskW(i,j,k) 
        enddo
       enddo
      enddo
      call border_exchg3D(bz,1); call setcyclic3D(bz)
c-----------------------------------------------------------------------
c     zonal component of streamfunction
c-----------------------------------------------------------------------
      a(:,js_pe:je_pe,:)=0
      sx(:,js_pe:je_pe,:)=0
      psix(:,js_pe:je_pe,:)=0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         a(i,j,k)=(b(i+1,j,k,taum1)-b(i,j,k,taum1))/dx*maskU(i,j,k)
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fxa=(a(i,j,k+1)+a(i,j,k))/(maskU(i,j,k)+maskU(i,j,k+1)+epsln)
         fxb=(bz(i+1,j,k)+bz(i,j,k))/(maskW(i+1,j,k)+maskW(i,j,k)+epsln)
         fxa=fxa*sign(1.,fxb)/(abs(fxb)+epsln)
c         sx(i,j,k)=fxa*0.5*(1.+tanh((-abs(fxa)+slopec)/dslope))   
         sx(i,j,k)= max(min(fxa,slopec),-slopec)
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fxa=ahthk(i,j,k)+ahthk(i+1,j,k)+ahthk(i,j,k+1)+ahthk(i+1,j,k+1)
         psix(i,j,k)=fxa/4.*sx(i,j,k)*maskW(i,j,k)*maskU(i,j,k)
     &        *maskU(i,j,k+1)*maskW(i+1,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(psix,1); call setcyclic3D(psix)
c-----------------------------------------------------------------------
c     meridional component of streamfunction
c-----------------------------------------------------------------------
      a(:,js_pe:je_pe,:)=0
      sy(:,js_pe:je_pe,:)=0
      psiy(:,js_pe:je_pe,:)=0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         a(i,j,k)=(b(i,j+1,k,taum1)-b(i,j,k,taum1))/dx*maskV(i,j,k)
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fxa=(a(i,j,k+1)+a(i,j,k))/(maskV(i,j,k)+maskV(i,j,k+1)+epsln)
         fxb=(bz(i,j+1,k)+bz(i,j,k))/(maskW(i,j+1,k)+maskW(i,j,k)+epsln)
         fxa=fxa*sign(1.,fxb)/(abs(fxb)+epsln)
c         sy(i,j,k)=fxa*0.5*(1.+tanh((-abs(fxa)+slopec)/dslope))   
         sy(i,j,k)= max(min(fxa,slopec),-slopec)
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fxa=ahthk(i,j,k)+ahthk(i,j+1,k)+ahthk(i,j,k+1)+ahthk(i,j+1,k+1)
         psiy(i,j,k)=fxa/4.0*sy(i,j,k)*maskW(i,j,k)*maskV(i,j,k)
     &        *maskV(i,j,k+1)*maskW(i,j+1,k)
        enddo
       enddo
      enddo
      call border_exchg3D(psiy,1); call setcyclic3D(psiy)
c-----------------------------------------------------------------------
c        bolus velocities
c-----------------------------------------------------------------------
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         ub(i,j,k)=(psix(i,j,k)-psix(i,j,k-1))/dz*maskU(i,j,k)
         vb(i,j,k)=(psiy(i,j,k)-psiy(i,j,k-1))/dz*maskV(i,j,k)
         wb(i,j,k)=(-(psiy(i,j,k)-psiy(i,j-1,k))/dx
     &              -(psix(i,j,k)-psix(i-1,j,k))/dx)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(ub,1); call setcyclic3D(ub)
      call border_exchg3D(vb,1); call setcyclic3D(vb)
      call border_exchg3D(wb,1); call setcyclic3D(wb)
      end subroutine calculate_bolus


      subroutine add_bolus(tr)
c-----------------------------------------------------------------------
c     add divergence of advective eddy fluxes to tracer tr
c-----------------------------------------------------------------------
      use cpflame_module
      use bolus_module
      implicit none
      real :: tr(imt,jmt,km,0:2)
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      integer :: i,j,k,js,je


      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         adv_fe(i,j,k)=
     &  0.5*(tr(i,j,k,tau)+tr(i+1,j,k,tau) )*ub(i,j,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      adv_fn(:,1,:)=0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         adv_fn(i,j,k)=
     &  0.5*(tr(i,j,k,tau)+tr(i,j+1,k,tau) )*vb(i,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         adv_ft(i,j,k)=
     &  0.5*(tr(i,j,k,tau)+tr(i,j,k+1,tau) )*wb(i,j,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1)
      call setcyclic3D(adv_fe)
      call setcyclic3D(adv_fn)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         tr(i,j,k,taup1)=tr(i,j,k,taup1)+maskT(i,j,k)*c2dt*( 
     &                    -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx
     &                    -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx
     &                    -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo
      call border_exchg3D(tr(:,:,:,taup1),2);
      call setcyclic3D(tr(:,:,:,taup1) )
      end subroutine add_bolus




      subroutine init_bolus_diag
c-----------------------------------------------------------------------
c     initialize NetCDF snapshot file
c-----------------------------------------------------------------------
      use cpflame_module
      use bolus_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,i,j,k,n
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lat_tdim,lat_udim,varid
      integer :: dims(4), corner(4), edges(4)
      character :: name*24, unit*16

      call def_grid_cdf('bolus.cdf')
      iret=nf_open('bolus.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'xu',lon_udim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'yu',lat_udim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'zu',z_udim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)

c     2 dim variables on t grid
      dims = (/Lon_tdim,lat_udim, z_udim, iTimedim/)
      varid  = ncvdef (ncid,'psiy', NCFLOAT,4,dims,iret)
      name = 'Meridional streamfct'; unit = 'm^2/s'
      call dvcdf(ncid,varid,name,24,unit,16,spval)

      dims = (/Lon_udim,lat_tdim, z_udim, iTimedim/)
      varid  = ncvdef (ncid,'psix', NCFLOAT,4,dims,iret)
      name = 'Zonal streamfct'; unit = 'm^2/s'
      call dvcdf(ncid,varid,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, z_tdim, iTimedim/)
      varid  = ncvdef (ncid,'ahthk', NCFLOAT,4,dims,iret)
      name = 'thickness diffusivity'; unit = 'm^2/s'
      call dvcdf(ncid,varid,name,24,unit,16,spval)

      call ncclos (ncid, iret)
      end subroutine init_bolus_diag


      subroutine diag_bolus
c-----------------------------------------------------------------------
c     write to NetCDF snapshot file
c-----------------------------------------------------------------------
      use cpflame_module
      use bolus_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      real :: a(imt,js_pe:je_pe,km)
      integer :: itdimid,ilen,rid,itimeid
      integer :: i,j,is,ie,js,je
      real :: fxa,ut,vt
      type(time_type) :: time

      js=max(2,js_pe); je = min(je_pe,jmt-1)

      do npe=0,n_pes
       if (my_pe==npe) then

        iret=nf_open('bolus.cdf',NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,ilen)
        iret=nf_inq_varid(ncid,'Time',itimeid)
        if (my_pe==0) then
         ilen=ilen+1
         time = current_time-initial_time
         fxa = time%days + time%seconds/86400.
         iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
        endif

        Corner = (/1,js_pe,1,ilen/); 
        edges  = (/imt,je_pe-js_pe+1,km,1/)
        iret=nf_inq_varid(ncid,'psiy',rid)
        a=psiy(:,js_pe:je_pe,:)
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)

        iret=nf_inq_varid(ncid,'psix',rid)
        a=psix(:,js_pe:je_pe,:)
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)

        iret=nf_inq_varid(ncid,'ahthk',rid)
        a=ahthk(:,js_pe:je_pe,:)
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)

        call ncclos (ncid, iret)
       endif
       call barrier
      enddo
      end subroutine diag_bolus

#else
      subroutine bolus_dummy
      end subroutine bolus_dummy

#endif

    

#include "options.inc"
    

c=======================================================================
c      account for static instabilities
c=======================================================================

      subroutine convect
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      K_b(:,js:je,:) = 0.0
      do j=js,je
       do k=1,km-1
        do i=2,imt
         if (b(i,j,k+1,taum1) > b(i,j,k,taum1)) 
     &         K_b(i,j,k)=1000.*maskW(i,j,k)
        enddo
       enddo
      enddo
      call implicit_tracer_mix(b,K_b)
c      call convect_expl
      end subroutine convect


      subroutine implicit_tracer_mix(var,K_vert)
      use cpflame_module
      implicit none
      real :: var(imt,jmt,km,0:2)
      real :: K_vert(imt,jmt,km)
      integer :: j,k,js,je
      real :: a(imt,km),bb(imt,km),c(imt,km),bet(imt)
      real :: pu(imt,km),gam(imt,km),fxa, r(imt,km)

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      fxa = c2dt/dz**2

      do j=js,je

       bb(:,1) = 1+fxa*K_vert(:,j,1)
       c(:,1)  =  -fxa*K_vert(:,j,1)
       do k=2,km-1
        a(:,k)  =  -fxa *   K_vert(:,j,k-1)
        bb(:,k) = 1+fxa * ( K_vert(:,j,k)+K_vert(:,j,k-1) )
        c(:,k)  =  -fxa *   K_vert(:,j,k)
       enddo
       a(:,km)  =  -fxa * K_vert(:,j,km-1)
       bb(:,km) = 1+fxa * K_vert(:,j,km-1) 

       pu=0.0;gam=0.0
       r=var(:,j,:,taup1)
       r(:,km-1)=r(:,km-1)
c     &           +aidif_tracer*surf_flux(:,j)*c2dt/dz
       bet=bb(:,1)
       where (bet/=0.0) pu(:,1)=r(:,1)/bet
       do k=2,km
        where (bet/=0.0) gam(:,k)=c(:,k-1)/bet
        bet=bb(:,k)-a(:,k)*gam(:,k)
        where(bet/=0.0) pu(:,k)=(r(:,k)-a(:,k)*pu(:,k-1))/bet
       enddo
       do k=km-1,1,-1
        pu(:,k)=pu(:,k)-gam(:,k+1)*pu(:,k+1)
       enddo
       var(:,j,:,taup1)=pu
      enddo
      end subroutine implicit_tracer_mix





      subroutine convect_expl
c-----------------------------------------------------------------------
c      explicit convection
c-----------------------------------------------------------------------
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je,n
      real :: dztsum,bmix,bsum
      integer :: l,l1,kcon,lcon,lcona,lconb,lmix
      integer :: lctot(imt,jmt),lcven(imt,jmt)
c
c     check each row column by column; note that 'goto 1310'
c     finishes a particular column and moves to the next one.
c
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
        do i=2,imt
          kcon     = kmt(i,j)
c
c         1. initial search for uppermost unstable pair; if none is
c            found, move on to next column
c
          lcon       = 0
          do k=kcon+1,km
            if (b(i,j,k,taup1) > b(i,j,k-1,taup1)) lcon = k
          enddo
          if (lcon==0) cycle

1319      lcona = lcon
          lconb = lcon - 1
c
c         2. mix the first two unstable layers
c
          dztsum = 2*dz 
          bsum = b(i,j,lcona,taup1)*dz +b(i,j,lconb,taup1)*dz
          bmix = bsum / dztsum
          b(i,j,lconb:lcona,taup1) = bmix /dztsum
c
c         3. test layer below lconb
c
1306      continue
          if (lconb==kcon) goto 1308

          if (b(i,j,lconb,taup1) > b(i,j,lconb-1,taup1)) then
            lconb = lconb-1
            dztsum = dztsum + dz
            bsum = bsum + b(i,j,lconb,taup1)*dz
            bmix = bsum / dztsum
            b(i,j,lconb:lcona,taup1) = bmix
            goto 1306
          end if
c
c         4. test layer above lcona
c
1308      continue
          if (lcona < km-1) then
            if (b(i,j,lcona+1,taup1) > b(i,j,lcona,taup1)) then
              lcona = lcona+1
              dztsum = dztsum + dz
              bsum = bsum + b(i,j,lcona,taup1)*dz
              bmix = bsum / dztsum 
              b(i,j,lconb:lcona,taup1) = bmix
              goto 1306
            end if
          end if
c
c         6. resume search if step 3. and 4. have been passed and this
c            unstable part of the water column has thus been removed,
c            i.e. find further unstable areas further down the column
c
          if (lconb == kcon) cycle
          lcon = lconb
c
1302      continue
          lcon = lcon - 1
          if (lcon == kcon) cycle
          if (b(i,j,lcon,taup1) <= b(i,j,lcon-1,taup1)) goto 1302
          goto 1319

1310      continue
        enddo
      enddo
      end subroutine convect_expl

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      This is identical to the 2. exp. in Wardle and Marshall 2000, JPO
c=======================================================================


      subroutine set_parameter
      use cpflame_module
      implicit none
c ----------------------------------
c       set here main parameter
c ----------------------------------
c      integer, parameter :: imt=128,km=92,jmt=26
      dx=10.0e3
      dz=50.0
      dt_in=300.0
      K_h=000.0
      K_v=0.0e-4
      A_h=000.0
      A_v=1.e-4
      eps2D_sor = 1e-12
      runlen=365.0
      snap_int = 5.0
      enable_noslip              = .true.
      enable_cyclic_x            = .true.
      enable_quicker_advection   = .true.
      enable_bottom_stress       = .true.
      enable_biharmonic_friction = .true.
      Ahbi = 2e10
      cdbot=8e-5
      gamma=0.01
      lat_ref = 45.0
      beta    = 2*omega*cos(lat_ref/180.*pi)/radius
      N_0     = 0.0022
      M_0     = 0.0
      end subroutine set_parameter


      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: z,fac,x,y,B0
c ----------------------------------
c      add here initial conditions
c ----------------------------------
c        d rho / dt = 0.2 kg/m^3 /K,  d rho = 0.2 dT,  d b = 0.2 dT /1000*9.81
      fac = 2*0.2/rho_0*g
      do k=1,km
       do j=1,jmt
        do i=1,imt
         x=float(i)/float(imt)
         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
         B0=fac*0.5*(tanh((y-0.5)/0.3)+1.0)
         B0=B0+1e-6*sin(x*2.5*pi)*cos(y*4*pi)
         b(i,j,k,:)   = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions

      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones

      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions

      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      Rayleigh-Bernard convection
c=======================================================================

#define two_dim

      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: fac=1.0
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=64*fac;km=20*fac;jmt=imt
#ifdef two_dim
      jmt=3
#endif
      dx=0.5/fac; 
      dz=0.5/fac; 
      dt_in=0.25/fac
      eps2D_sor = 1e-6
      eps3D_sor = 1e-6
      snap_int = 5/86400.0
      runlen=300*snap_int
      enable_4th_advection       =.true.
      enable_hydrostatic         =.false.
c      enable_biharmonic_friction =.true.
c      enable_vert_biha_friction  =.true.
c      enable_biharmonic_diffusion=.true.
c      enable_vert_biha_diffusion =.true.
c      Ahbi = (10e-3/fac**2)*dx**2
c      Khbi = Ahbi
c      Avbi = (10e-3/fac**2)*dx**2
c      Kvbi = Avbi
      lat_ref=0.
      beta   =0.
      N_0 = 0.0
      M_0 = 0.0
      end subroutine set_parameter


      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: fxa
      do k=1,km
       do j=1,jmt
        do i=1,imt
#ifdef two_dim
         fxa=4e-5*sin(xt(i)/(20*dx)*pi)
#else
         fxa=4e-5*sin(xt(i)/(20*dx)*pi)*cos(yt(j)/(17*dx)*pi)
#endif
         b(i,j,k,:)=fxa
         b(i,j,k,:)=b(i,j,k,:)*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones



      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones





      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c      add here boundary conditions
c ----------------------------------
      surf_flux  = 175 *0.2/rho_0*g /4185.5 
      bottom_flux= 175 *0.2/rho_0*g /4185.5 
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"


c=======================================================================
c       zonal averaging diagnostics
c       linked in the code in driver only
c=======================================================================

#ifdef enable_diag_zonalave

c 
c  Reference buoyancy profile given by N_0 
c 
c  Note that the damping time scales of the resoring zones have to 
c  be adjusted in subroutine init_zonal_averages to match 
c  the setting in  subroutine restoring_zones
c

#define diag_eddy_fluxes
c#define diag_eddy_flux_tendency
c#define diag_energy_budget
c#define diag_potential_vorticity


      module zonal_averages_module
c=======================================================================
c       Module for zonal mean diagnostics
c=======================================================================
      implicit none
      real, allocatable, dimension(:,:) :: ulen,vlen,wlen,blen
      real, allocatable, dimension(:,:) :: um,vm,wm,bm,pm
      real, allocatable, dimension(:,:,:)   :: vb2,wb2 ,tm
      real, allocatable, dimension(:,:,:,:) :: vt2,wt2 
      real, allocatable, dimension(:,:) :: eke,bws,epe,T2,T4u,T4v,T4
      real, allocatable, dimension(:,:) :: mke,mpe,bwq,rest,restm
      real, allocatable, dimension(:,:) :: eps_b,eps_u,eps_v
      real, allocatable, dimension(:,:) :: eps_kh,eps_kv
      real, allocatable, dimension(:,:) :: vps,wps,veke,weke,vepe,wepe
      real, allocatable, dimension(:,:) :: vv,vvb,ageo,vw,ageo2,uv,vvu
      real, allocatable, dimension(:,:) :: agev1,agev2
      real, allocatable, dimension(:,:) :: mpv_qg,mpv_er,mrv_er
      real, allocatable, dimension(:,:,:) :: vq_qg,vq_er,wq_er,wq_qg
      real, allocatable, dimension(:,:) :: vvq_qg,vvq_er

      integer :: nr_var = 5  ! highest moment to be calculated
      integer :: nr_tr  = 0  ! numbers of tracers to be considered
      real, allocatable, dimension(:) :: t_rest
      real,parameter :: epsln     = 1.0e-20
      end module zonal_averages_module



      subroutine zonal_averages
c=======================================================================
c      Verteiler function
c=======================================================================
      use cpflame_module
      use zonal_averages_module
      implicit none
      if (snapshot_time_step.or.initial_time==current_time) then
       call zonal_averages_means
       call zonal_averages_eddy_fluxes
       call zonal_averages_energy
       call zonal_averages_flux_tendency
       call zonal_averages_pv_fluxes
       call zonal_averages_write
      endif
      end subroutine zonal_averages



      subroutine init_zonal_averages
c=======================================================================
c      Initialize zonal mean diagnostics
c=======================================================================
      use cpflame_module
#ifdef enable_diag_tracer
      use tracer_module
#endif
      use zonal_averages_module
      implicit none
#include "netcdf.inc"
      integer :: i,j,k,js,je,n
      integer :: ncid,iret
      integer :: z_tdim,z_udim,itimedim,varid
      integer :: lat_tdim,lat_udim, dims(4)
      character :: name*64, unit*32
c      real          :: fac=1e-5*0.2/rho_0*g  ! hor. shear of initial condition

      if (my_pe==0) then
       print*,''
       print*,' Initializing zonal averaging module '
       print*,''
      endif

#ifdef enable_diag_tracer
      nr_tr = nt
#endif

      if (my_pe==0) then
       print*,' found ',nr_tr,' tracer '
       print*,''
      endif

      allocate( um(jmt,km) ); um=0.0
      allocate( vm(jmt,km) ); vm=0.0
      allocate( wm(jmt,km) ); wm=0.0
      allocate( bm(jmt,km) ); bm=0.0
      allocate( pm(jmt,km) ); pm=0.0
      allocate( tm(jmt,km,nr_tr) ); tm=0.0

#ifdef diag_eddy_fluxes
      allocate( vb2(jmt,km,1:nr_var) ); vb2=0.0
      allocate( wb2(jmt,km,1:nr_var) ); wb2=0.0
      allocate( vt2(jmt,km,nr_tr,1:nr_var) ); vt2=0.0
      allocate( wt2(jmt,km,nr_tr,1:nr_var) ); wt2=0.0
#endif

#ifdef diag_energy_budget
      allocate( eke(jmt,km) ); eke=0.0
      allocate( epe(jmt,km) ); epe=0.0
      allocate( mke(jmt,km) ); mke=0.0
      allocate( mpe(jmt,km) ); mpe=0.0
      allocate( bws(jmt,km) ); bws=0.0
      allocate( bwq(jmt,km) ); bwq=0.0
      allocate( T2 (jmt,km) ); T2=0.0
      allocate( T4u(jmt,km) ); T4u=0.0
      allocate( T4v(jmt,km) ); T4v=0.0
      allocate( T4(jmt,km) );  T4=0.0

      allocate( eps_b(jmt,km) ); eps_b=0.0
      allocate( eps_u(jmt,km) ); eps_u=0.0
      allocate( eps_v(jmt,km) ); eps_v=0.0
      allocate( eps_kh(jmt,km)); eps_kh=0.0
      allocate( eps_kv(jmt,km)); eps_kv=0.0
      allocate( rest(jmt,km) );  rest=0.0
      allocate( restm(jmt,km) ); restm=0.0

      allocate( vps(jmt,km) ); vps=0.0
      allocate( wps(jmt,km) ); wps=0.0
      allocate( veke(jmt,km) ); veke=0.0
      allocate( weke(jmt,km) ); weke=0.0
      allocate( vepe(jmt,km) ); vepe=0.0
      allocate( wepe(jmt,km) ); wepe=0.0
#endif

#ifdef diag_eddy_flux_tendency
      allocate( vv(jmt,km)  ); vv  =0.0
      allocate( vvb(jmt,km) ); vvb =0.0
      allocate( ageo(jmt,km)); ageo=0.0
      allocate( ageo2(jmt,km));ageo2=0.0
      allocate( vw(jmt,km)  ); vw  =0.0
      allocate( uv(jmt,km)  ); uv  =0.0
      allocate( vvu(jmt,km)  ); vvu  =0.0
      allocate( agev1(jmt,km));agev1=0.0
      allocate( agev2(jmt,km));agev2=0.0
#endif

#ifdef diag_potential_vorticity
      allocate( mpv_qg(jmt,km)  ); mpv_qg=0.0
      allocate( mpv_er(jmt,km)  ); mpv_er=0.0
      allocate( mrv_er(jmt,km)  ); mrv_er=0.0
      allocate( vq_qg(jmt,km,1:nr_var)  );  vq_qg=0.0
      allocate( vq_er(jmt,km,1:nr_var)  );  vq_er=0.0
      allocate( wq_qg(jmt,km,1:nr_var)  );  wq_qg=0.0
      allocate( wq_er(jmt,km,1:nr_var)  );  wq_er=0.0
      allocate( vvq_er(jmt,km)  ); vvq_er=0.0
      allocate( vvq_qg(jmt,km)  ); vvq_qg=0.0
#endif

      allocate( ulen(jmt,km) ); ulen=0.0
      allocate( vlen(jmt,km) ); vlen=0.0
      allocate( wlen(jmt,km) ); wlen=0.0
      allocate( blen(jmt,km) ); blen=0.0

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do j=js,je
       do i=2,imt-1
        ulen(j,:)=ulen(j,:)+dx*maskU(i,j,:)
        vlen(j,:)=vlen(j,:)+dx*maskV(i,j,:)
        wlen(j,:)=wlen(j,:)+dx*maskW(i,j,:)
        blen(j,:)=blen(j,:)+dx*maskT(i,j,:)
       enddo 
      enddo 
c       Restoring time scale for buffer zone
      allocate( t_rest(jmt)); t_rest=0.
      do j=2,3+1
        t_rest(j)= 1./(5*85400)/(j-1.)
      enddo
      do j=jmt-1,jmt-3,-1
        t_rest(j)= 1./(5*85400)/(-1.*(j-jmt))
      enddo

      if (my_pe==0) then 

      call def_grid_cdf('zonal_ave.cdf')
      iret=nf_open('zonal_ave.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'yu',lat_udim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'zu',z_udim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'um', NCFLOAT,3,dims,iret)
      name = 'Zonal mean zonal velocity'; unit = 'm/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vm', NCFLOAT,3,dims,iret)
      name = 'Zonal mean meridional velocity'; unit = 'm/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'wm', NCFLOAT,3,dims,iret)
      name = 'Zonal mean vertical velocity'; unit = 'm/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'bm', NCFLOAT,3,dims,iret)
      name = 'Zonal mean buoyancy'; unit = 'm/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'pm', NCFLOAT,3,dims,iret)
      name = 'Zonal mean pressure'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      do n=1,nr_tr
       dims = (/lat_tdim, z_tdim, iTimedim,1/)
       write(name, '("trm",i2)') n; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       name = 'zonal mean tracer'; unit = ' '
       call dvcdf(ncid,varid,name,64,unit,32,spval)
      enddo

#ifdef diag_eddy_fluxes
      do k=1,nr_var
       write(unit, '("m**",i2,"/s**",i2)')k+1,2*k+1
       dims = (/lat_udim, z_tdim, iTimedim,1/)
       write(name, '("vb_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Meridional buoyancy ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/lat_tdim, z_udim, iTimedim,1/)
       write(name, '("wb_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Vertical buoyancy ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       do n=1,nr_tr
        unit = 'm/s'
        dims = (/lat_udim, z_tdim, iTimedim,1/)
        write(name, '("vt",i2,"_",i2)')n,k;call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
        write(name, '("Meridional ",i2,". moment tracer flux")')k
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/lat_tdim, z_udim, iTimedim,1/)
        write(name, '("wt",i2,"_",i2)')n,k;call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
        write(name, '("Vertical ",i2,". moment tracer flux")')k
        call dvcdf(ncid,varid,name,64,unit,32,spval)
       enddo
      enddo
#endif

#ifdef diag_energy_budget
      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'eke', NCFLOAT,3,dims,iret)
      name = 'Eddy kinetic energy'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mke', NCFLOAT,3,dims,iret)
      name = 'Mean kinetic energy'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'epe', NCFLOAT,3,dims,iret)
      name = 'Eddy potential energy'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mpe', NCFLOAT,3,dims,iret)
      name = 'Mean potential energy'; unit = 'm**2/s**2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'bws', NCFLOAT,3,dims,iret)
      name = 'EKE production (EPE->EKE)'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'bwq', NCFLOAT,3,dims,iret)
      name = 'MPE production (MPE->MKE)'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'T2', NCFLOAT,3,dims,iret)
      name = 'MPE production (EPE->MPE)'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'T4', NCFLOAT,3,dims,iret)
      name = 'MKE production (EKE->MKE)'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'eps_b', NCFLOAT,3,dims,iret)
      name = 'EPE dissipation'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'eps_kh', NCFLOAT,3,dims,iret)
      name = 'Horizontal EKE dissipation'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'eps_kv', NCFLOAT,3,dims,iret)
      name = 'Vertical EKE dissipation'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'rest', NCFLOAT,3,dims,iret)
      name = 'EPE dissipation by nudging'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'restm', NCFLOAT,3,dims,iret)
      name = 'MPE dissipation by nudging'; unit = 'm**2/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vps', NCFLOAT,3,dims,iret)
      name = 'Meridional wave radiation'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'wps', NCFLOAT,3,dims,iret)
      name = 'Vertical wave radiation'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'veke', NCFLOAT,3,dims,iret)
      name = 'Meridional EKE advection'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'weke', NCFLOAT,3,dims,iret)
      name = 'Vertical EKE advection'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vepe', NCFLOAT,3,dims,iret)
      name = 'Meridional EPE advection'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'wepe', NCFLOAT,3,dims,iret)
      name = 'Vertical EPE advection'; unit = 'm**3/s**3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)
#endif

#ifdef diag_eddy_flux_tendency
      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vv', NCFLOAT,3,dims,iret)
      name = 'Meridional velocity variance'; unit = 'm^2/s^2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vvb', NCFLOAT,3,dims,iret)
      name = 'Triple variance flux'; unit = 'm^3/s^4'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'ageo', NCFLOAT,3,dims,iret)
      name = 'Ageostrophic terms'; unit = 'm^2/s^4'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'ageo2', NCFLOAT,3,dims,iret)
      name = 'Ageostrophic (beta) term'; unit = 'm^2/s^4'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_udim, iTimedim,1/)
      varid = ncvdef (ncid,'vw', NCFLOAT,3,dims,iret)
      name = 'Velocity correlation'; unit = 'm^2/s^4'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'uv', NCFLOAT,3,dims,iret)
      name = 'Velocity correlation'; unit = 'm^2/s^2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vvu', NCFLOAT,3,dims,iret)
      name = 'Flux of velocity correlation'; unit = 'm^3/s^3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'agev1', NCFLOAT,3,dims,iret)
      name = 'Ageostrophic term 1'; unit = 'm^2/s^3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'agev2', NCFLOAT,3,dims,iret)
      name = 'Ageostrophic term 2'; unit = 'm^2/s^3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

#endif

#ifdef diag_potential_vorticity
      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mpv_qg', NCFLOAT,3,dims,iret)
      name = 'Potential vorticity (QG)'; unit = '1/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vvq_qg', NCFLOAT,3,dims,iret)
      name = 'Triple var. flux of PV (QG)'; unit = 'm/s^2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_tdim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mpv_er', NCFLOAT,3,dims,iret)
      name = 'Potential vorticity (Ertel)'; unit = '1/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'mrv_er', NCFLOAT,3,dims,iret)
      name = 'Relative vorticity (Ertel)'; unit = '1/s'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      dims = (/lat_udim, z_tdim, iTimedim,1/)
      varid = ncvdef (ncid,'vvq_er', NCFLOAT,3,dims,iret)
      name = 'Triple var. flux of PV (Ertel)'; unit = 'm^2/s^3'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      do k=1,nr_var
       write(unit, '("m**",i2,"/s**",i2)')k,k+1

       dims = (/lat_udim, z_tdim, iTimedim,1/)
       write(name, '("vq_qg_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Meridional PV (QG) ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/lat_udim, z_tdim, iTimedim,1/)
       write(name, '("vq_er_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Meridional PV (Ertel) ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/lat_tdim, z_udim, iTimedim,1/)
       write(name, '("wq_qg_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Vertical PV (QG) ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/lat_tdim, z_udim, iTimedim,1/)
       write(name, '("wq_er_",i2)') k; call replace_space_zero(name)
       varid = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       write(name, '("Vertical PV (Ertel) ",i2,". moment flux")')k
       call dvcdf(ncid,varid,name,64,unit,32,spval)

      enddo

#endif
      varid = ncvdef (ncid,'b_r', NCFLOAT,1,z_tdim,iret)
      name = 'Reference buoyancy profile'; unit = 'm/s^2'
      call dvcdf(ncid,varid,name,64,unit,32,spval)

      call ncendf(ncid, iret)
      iret= nf_put_vara_double(ncid,varid,1,km,b_r)

      call ncclos (ncid, iret)
      endif ! my_pe ==0
      end subroutine init_zonal_averages



      subroutine zonal_averages_write
c=======================================================================
c       compute zonal mean diagnostics
c=======================================================================
      use cpflame_module
      use zonal_averages_module
      implicit none
#include "netcdf.inc"
      integer :: i,j,k,m
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      integer :: itdimid,ilen,itimeid
      integer :: umid,vmid,wmid,bmid,trmid(nr_tr),varid
      integer :: vbid,wbid,vtid(nr_tr),wtid(nr_tr)
      real :: fxa
      type(time_type) :: time
      character :: name*64, unit*32
c-----------------------------------------------------------------------
c      write to netcdf file
c-----------------------------------------------------------------------
      do npe=0,n_pes
       if (my_pe==npe) then

         iret=nf_open('zonal_ave.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         do n=1,nr_tr
          write(name, '("trm",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,trmid(n))
         enddo

         iret=nf_inq_dimid(ncid,'Time',itdimid)
         iret=nf_inq_dimlen(ncid, itdimid,ilen)
         iret=nf_inq_varid(ncid,'Time',itimeid)
         if (my_pe==0) then
          ilen=ilen+1
          time = current_time-initial_time
          fxa = time%days + time%seconds/86400.
          iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
         endif

         Corner = (/js_pe,1,ilen,1/); 
         edges  = (/je_pe-js_pe+1,km,1,1/)
         iret=nf_inq_varid(ncid,'um',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          um(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,
     &          vm(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'wm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,
     &          wm(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,
     &          bm(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'pm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,
     &          pm(js_pe:je_pe,:))
         do n=1,nr_tr
          iret= nf_put_vara_double(ncid,trmid(n),corner,edges,
     &          tm(js_pe:je_pe,:,n))
         enddo

#ifdef diag_eddy_fluxes
         do m=1,nr_var
          write(name, '("vb_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,
     &          vb2(js_pe:je_pe,:,m))
          write(name, '("wb_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges,
     &          wb2(js_pe:je_pe,:,m))
          do n=1,nr_tr
           write(name, '("vt",i2,"_",i2)')n,m;
           call replace_space_zero(name)
           iret=nf_inq_varid(ncid,name,varid)
           iret= nf_put_vara_double(ncid,varid,corner,edges,
     &          vt2(js_pe:je_pe,:,n,m))
           write(name, '("wt",i2,"_",i2)')n,m;
           call replace_space_zero(name)
           iret=nf_inq_varid(ncid,name,varid)
           iret= nf_put_vara_double(ncid,varid,corner,edges,
     &          wt2(js_pe:je_pe,:,n,m))
          enddo
         enddo
#endif

#ifdef diag_energy_budget
         iret=nf_inq_varid(ncid,'eke',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          eke(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'mke',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          mke(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'epe',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          epe(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'mpe',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          mpe(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bws',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          bws(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bwq',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          bwq(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'T2',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          T2(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'T4',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          T4u(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'T4v',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          T4v(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'eps_b',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          eps_b(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'eps_kh',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          eps_kh(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'eps_kv',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          eps_kv(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'rest',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          rest(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'restm',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          restm(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vps',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          vps(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'wps',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          wps(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'veke',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          veke(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'weke',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          weke(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vepe',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          vepe(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'wepe',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          wepe(js_pe:je_pe,:))
#endif

#ifdef diag_eddy_flux_tendency
         iret=nf_inq_varid(ncid,'vv',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          vv(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vvb',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          vvb(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vw',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          vw(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'ageo',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          ageo(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'ageo2',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          ageo2(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'uv',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          uv(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vvu',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          vvu(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'agev1',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          agev1(js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'agev2',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          agev2(js_pe:je_pe,:))
#endif

#ifdef diag_potential_vorticity
         iret=nf_inq_varid(ncid,'mpv_qg',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          mpv_qg(js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'mpv_er',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          mpv_er(js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'mrv_er',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          mrv_er(js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'vvq_er',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          vvq_er(js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'vvq_qg',varid)
         iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          vvq_qg(js_pe:je_pe,:))

         do m=1,nr_var

          write(name, '("vq_qg_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          vq_qg(js_pe:je_pe,:,m))

          write(name, '("wq_qg_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret=nf_put_vara_double(ncid,varid,corner,edges,
     &          wq_qg(js_pe:je_pe,:,m))

          write(name, '("vq_er_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret=nf_put_vara_double(ncid,varid,corner,edges,
     &           vq_er(js_pe:je_pe,:,m))

          write(name, '("wq_er_",i2)')m; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret=nf_put_vara_double(ncid,varid,corner,edges,
     &           wq_er(js_pe:je_pe,:,m))

         enddo
#endif

         call ncclos (ncid, iret)
       endif
       call barrier
      enddo
      end subroutine zonal_averages_write





      subroutine zonal_averages_means
c=======================================================================
c       get zonal means
c=======================================================================
      use cpflame_module
      use zonal_averages_module
#ifdef enable_diag_tracer
      use tracer_module
#endif
      implicit none
      integer :: i,j,k,js,je,n

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      um=0.0;vm=0.0;wm=0.0;bm=0.0;tm=0.0
      do j=js,je 
        do i=2,imt-1
         um(j,:)=um(j,:)+u(i,j,:,1,tau)*dx*maskU(i,j,:) 
         vm(j,:)=vm(j,:)+u(i,j,:,2,tau)*dx*maskV(i,j,:) 
         wm(j,:)=wm(j,:)+u(i,j,:,3,tau)*dx*maskW(i,j,:) 
         bm(j,:)=bm(j,:)+b(i,j,:,  tau)*dx*maskT(i,j,:) 
         pm(j,:)=pm(j,:)+p_full(i,j,:,tau)*dx*maskT(i,j,:) 
#ifdef enable_diag_tracer
         do n=1,nr_tr
          tm(j,:,n)=tm(j,:,n)+tr(i,j,:,tau,n)*dx*maskT(i,j,:) 
         enddo
#endif
        enddo 
      enddo 
      where (ulen/=0); um=um/ulen; else where; um=spval ; end where
      where (vlen/=0); vm=vm/vlen; else where; vm=spval ; end where
      where (wlen/=0); wm=wm/wlen; else where; wm=spval ; end where
      where (blen/=0); bm=bm/blen; else where; bm=spval ; end where
      where (blen/=0); pm=pm/blen; else where; pm=spval ; end where
      call border_exchg_merid(um,1)
      call border_exchg_merid(vm,1)
      call border_exchg_merid(wm,1)
      call border_exchg_merid(bm,1)
      call border_exchg_merid(pm,1)
      do n=1,nr_tr
        where (blen/=0); tm(:,:,n)=tm(:,:,n)/blen
        else where; tm(:,:,n)=spval;end where
        call border_exchg_merid(tm(:,:,n),1)
      enddo
      end subroutine zonal_averages_means





      subroutine zonal_averages_eddy_fluxes
#ifdef diag_eddy_fluxes
c=======================================================================
c       compute zonal mean eddy fluxes
c=======================================================================
      use cpflame_module
#ifdef enable_diag_tracer
      use tracer_module
#endif
      use zonal_averages_module
      implicit none
      integer :: i,j,k,js,je,m,n

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      vb2=0.0;wb2=0.0;vt2=0.0;wt2=0.0
      do m=1,nr_var
        do j=js,je 
         do k=1,km
          do i=2,imt-1
           vb2(j,k,m)=vb2(j,k,m)+u(i,j,k,2,tau)*dx*maskV(i,j,k) 
     &     *.5/m*( (b(i,j  ,k,tau)-bm(j  ,k))**m
     &           + (b(i,j+1,k,tau)-bm(j+1,k))**m  )
          enddo
         enddo
         do k=1,km-1
          do i=2,imt-1
           wb2(j,k,m)=wb2(j,k,m)+u(i,j,k,3,tau)*dx*maskW(i,j,k) 
     &      *.5/m*( (b(i,j,k  ,tau)-bm(j,k  ))**m
     &            + (b(i,j,k+1,tau)-bm(j,k+1))**m )
          enddo
         enddo
       enddo
       where (vlen/=0); vb2(:,:,m)=vb2(:,:,m)/vlen; 
       else where; vb2(:,:,m)=spval; end where
       where (wlen/=0); wb2(:,:,m)=wb2(:,:,m)/wlen; 
       else where; wb2(:,:,m)=spval; end where

#ifdef enable_diag_tracer
       do n=1,nr_tr
         do j=js,je 
          do k=1,km
           do i=2,imt-1
            vt2(j,k,n,m)=vt2(j,k,n,m)+u(i,j,k,2,tau)*dx*maskV(i,j,k) 
     &      *.5/m*( (tr(i,j  ,k,tau,n)-tm(j  ,k,n))**m 
     &            + (tr(i,j+1,k,tau,n)-tm(j+1,k,n))**m )
           enddo
          enddo
          do k=1,km-1
           do i=2,imt-1
            wt2(j,k,n,m)=wt2(j,k,n,m)+u(i,j,k,3,tau)*dx*maskW(i,j,k) 
     &      *.5/m*( (tr(i,j,k  ,tau,n)-tm(j,k  ,n))**m
     &            + (tr(i,j,k+1,tau,n)-tm(j,k+1,n))**m )
           enddo
          enddo
         enddo ! j
         where (vlen/=0); vt2(:,:,n,m)=vt2(:,:,n,m)/vlen; 
         else where; vt2(:,:,n,m)=spval; end where
         where (wlen/=0); wt2(:,:,n,m)=wt2(:,:,n,m)/wlen; 
         else where; wt2(:,:,n,m)=spval; end where
       enddo ! n
#endif
      enddo ! m
#endif
      end subroutine zonal_averages_eddy_fluxes





      subroutine zonal_averages_pv_fluxes
#ifdef diag_potential_vorticity
c=======================================================================
c       compute zonal mean potential vorticity
c=======================================================================
      use cpflame_module
      use zonal_averages_module
      implicit none
      integer :: i,j,k,js,je,m
      real   :: pv_qg(imt,jmt,km),f0,y0,ps(imt,jmt,km)
      real   :: rv_qg(imt,jmt,km),pv_er(imt,jmt,km)
      real   :: rv(imt,jmt,km),fxa

      f0 = coriolis_t(jmt/2); y0 = yt(jmt/2)
      js=max(2,js_pe); je = min(je_pe,jmt-1)
c
c       relative potential vorticity
c
      rv=0.0
      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
          rv(i,j,k)=
     &       (u(i+1,j,k,2,tau)-u(i,j,k,2,tau) )/dx*maskU(i,j,k)
     &      -(u(i,j+1,k,1,tau)-u(i,j,k,1,tau) )/dx*maskV(i,j,k)
        enddo 
       enddo 
      enddo 
      call border_exchg3D(rv,1)
c
c       Ertel potential vorticity  Q N0^2 = b_z (v_x-u_y + f) + u_z b_y - v_z b_x
c
      pv_er=0.
      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
         fxa= (rv(i,j,k)+rv(i-1,j,k)+rv(i,j-1,k)+rv(i-1,j-1,k))/4.0
         pv_er(i,j,k)=(fxa+coriolis_t(j)  )*
     &    ((b(i,j,k+1,tau)-b(i,j,k,tau))/dz*maskW(i,j,k)
     &    +(b(i,j,k,tau)-b(i,j,k-1,tau))/dz*maskW(i,j,k-1))/
     &     (maskW(i,j,k)+maskW(i,j,k-1)+epsln) 
         pv_er(i,j,k)=-N_0**(-2)*pv_er(i,j,k)
        enddo 
       enddo 
      enddo 
      call border_exchg3D(pv_er,1); call setcyclic3D(pv_er)
c
c       QG streamfunction
c
      psi=0.0
      do k=1,km
       do j=js,je 
        ps(:,j,k)=(p_full(:,j,k,tau)-p_r(k))/f0
       enddo
      enddo
      call border_exchg3D(ps,1); call setcyclic3D(ps)
c
c       QG relative potential vorticity
c
      rv_qg=0.
      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
         rv_qg(i,j,k)=
     &    ((ps(i,j+1,k)-ps(i,j,k))/dx*maskV(i,j  ,k)
     &    -(ps(i,j,k)-ps(i,j-1,k))/dx*maskV(i,j-1,k))/dx
     &   +((ps(i+1,j,k)-ps(i,j,k))/dx*maskU(i-1,j,k)
     &    -(ps(i,j,k)-ps(i-1,j,k))/dx*maskU(i-1,j,k))/dx
        enddo 
       enddo 
      enddo 
      call border_exchg3D(rv_qg,1); call setcyclic3D(rv_qg)
c
c       add QG planetary and stretching term to relative vorticity
c
      pv_qg=0.
      do j=js,je 
       pv_qg(:,j,:)=rv_qg(:,j,:)+beta*(yt(j)-y0)
       do k=2,km-1
         pv_qg(:,j,k)=pv_qg(:,j,k)+f0**2/N_0**2*
     &    ((ps(:,j,k+1)-ps(:,j,k))/dz*maskW(:,j,k)
     &    -(ps(:,j,k)-ps(:,j,k-1))/dz*maskW(:,j,k-1))/dz
       enddo 
       k=2
       pv_qg(:,j,k)=pv_qg(:,j,k)+f0**2/N_0**2*
     &    ((ps(:,j,k+1)-ps(:,j,k))/dz*maskW(:,j,k)
     &    -(b(:,j,k,tau)-bm(j,k))*maskT(i,j,k) )/dz
       k=km-1
       pv_qg(:,j,k)=pv_qg(:,j,k)+f0**2/N_0**2*
     &    ((b(:,j,k,tau)-bm(j,k))*maskT(:,j,k)
     &    -(ps(:,j,k)-ps(:,j,k-1))/dz*maskW(:,j,k-1))/dz
      enddo 
      call border_exchg3D(pv_qg,1); call setcyclic3D(pv_qg)
c
c       mean QG and Ertel PV
c
      mpv_qg=0.
      do j=js,je 
        do i=2,imt-1
         mpv_qg(j,:)=mpv_qg(j,:)+pv_qg(i,j,:)*dx*maskT(i,j,:) 
         mpv_er(j,:)=mpv_er(j,:)+pv_er(i,j,:)*dx*maskT(i,j,:) 
         mrv_er(j,:)=mrv_er(j,:)+rv(i,j,:)*dx*maskT(i,j,:) 
        enddo 
      enddo 
      where (blen/=0); mpv_qg=mpv_qg/blen; 
      else where; mpv_qg=spval ; end where
      where (blen/=0); mpv_er=mpv_er/blen; 
      else where; mpv_er=spval ; end where
      where (vlen/=0); mrv_er=mrv_er/vlen; 
      else where; mrv_er=spval ; end where
      call border_exchg_merid(mpv_qg,1)
      call border_exchg_merid(mpv_er,1)
      call border_exchg_merid(mrv_er,1)
c

c       meridional and vertical fluxes of PV
c
      vq_qg=0.;vq_er=0.; wq_qg=0.;wq_er=0.; 
      do m=1,nr_var
        do j=js,je 
         do k=1,km
          do i=2,imt-1
           vq_qg(j,k,m)=vq_qg(j,k,m)+u(i,j,k,2,tau)*dx*maskV(i,j,k) 
     &     *.5/m*( (pv_qg(i,j  ,k)-mpv_qg(j  ,k))**m
     &           + (pv_qg(i,j+1,k)-mpv_qg(j+1,k))**m  )
           vq_er(j,k,m)=vq_er(j,k,m)+u(i,j,k,2,tau)*dx*maskV(i,j,k) 
     &     *.5/m*( (pv_er(i,j  ,k)-mpv_er(j  ,k))**m
     &           + (pv_er(i,j+1,k)-mpv_er(j+1,k))**m  )
          enddo
         enddo
         do k=1,km-1
          do i=2,imt-1
           wq_qg(j,k,m)=wq_qg(j,k,m)+u(i,j,k,3,tau)*dx*maskW(i,j,k) 
     &      *.5/m*( (pv_qg(i,j,k  )-mpv_qg(j,k  ))**m
     &            + (pv_qg(i,j,k+1)-mpv_qg(j,k+1))**m )
           wq_er(j,k,m)=wq_er(j,k,m)+u(i,j,k,3,tau)*dx*maskW(i,j,k) 
     &      *.5/m*( (pv_er(i,j,k  )-mpv_er(j,k  ))**m
     &            + (pv_er(i,j,k+1)-mpv_er(j,k+1))**m )
          enddo
         enddo
       enddo
       where (vlen/=0); vq_qg(:,:,m)=vq_qg(:,:,m)/vlen; 
       else where; vq_qg(:,:,m)=spval; end where
       where (wlen/=0); wq_qg(:,:,m)=wq_qg(:,:,m)/wlen; 
       else where; wq_qg(:,:,m)=spval; end where
       where (vlen/=0); vq_er(:,:,m)=vq_er(:,:,m)/vlen; 
       else where; vq_er(:,:,m)=spval; end where
       where (wlen/=0); wq_er(:,:,m)=wq_er(:,:,m)/wlen; 
       else where; wq_er(:,:,m)=spval; end where
      enddo
c
c      triple flux of PV (for eddy pv flux tendency)
c
      vvq_qg=0.;vvq_er=0.
      do j=js,je 
       do k=1,km
        do i=2,imt-1
         vvq_qg(j,k)=vvq_qg(j,k)
     &     +(u(i,j,k,2,tau)-vm(j,k))**2*dx*maskV(i,j,k) 
     &     *((pv_qg(i,j  ,k)-mpv_qg(j  ,k))
     &      +(pv_qg(i,j+1,k)-mpv_qg(j+1,k)))/2.
         vvq_er(j,k)=vvq_er(j,k)
     &     +(u(i,j,k,2,tau)-vm(j,k))**2*dx*maskV(i,j,k) 
     &     *((pv_er(i,j  ,k)-mpv_er(j  ,k))
     &      +(pv_er(i,j+1,k)-mpv_er(j+1,k)))/2.
        enddo
       enddo
      enddo
      where (vlen/=0); vvq_qg(:,:)=vvq_qg(:,:)/vlen; 
      else where; vvq_qg(:,:)=spval; end where
      where (vlen/=0); vvq_er(:,:)=vvq_er(:,:)/vlen; 
      else where; vvq_er(:,:)=spval; end where
#endif
      end subroutine zonal_averages_pv_fluxes



      subroutine zonal_averages_flux_tendency
#ifdef diag_eddy_flux_tendency
c=======================================================================
c        eddy flux balance :  (v'b')_t = - v'^2 b_y + ...
c=======================================================================
      use cpflame_module
      use zonal_averages_module
      implicit none
      integer :: i,j,k,js,je
      real :: fxa,a(imt,jmt,km)

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      vv=0.;vvb=0.;vw=0.0; ageo=0.0; ageo2=0.
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          vv(j,k)=vv(j,k)+maskV(i,j,k)*dx*(u(i,j,k,2,tau)-vm(j,k))**2
          vvb(j,k)=vvb(j,k)+maskV(i,j,k)*dx*
     &           (u(i,j,k,2,tau)-vm(j,k))**2
     &        *0.5*( b(i,j,k,tau)-bm(j,k)+b(i,j+1,k,tau)-bm(j+1,k))
          vw(j,k)=vw(j,k)+maskW(i,j,k)* N_0**2*dx*
     &        0.5*( (u(i,j  ,k,2,tau)-vm(j  ,k))*maskV(i,j  ,k)
     &             +(u(i,j-1,k,2,tau)-vm(j-1,k))*maskV(i,j-1,k))
     &           *(u(i,j,k,3,tau)-wm(j,k))
          ageo(j,k)=ageo(j,k)+maskV(i,j,k)*dx*
     &        0.5*( b(i,j,k,tau)-bm(j,k)+b(i,j+1,k,tau)-bm(j+1,k))
     &        *( 
     &           (p_full(i,j+1,k,tau)-pm(j+1,k)
     &           -p_full(i,j  ,k,tau)+pm(j  ,k))/dx
     &    +(coriolis_t(j    )*(u(i-1,j  ,k,1,tau)-um(j,k)
     &                      +u(i  ,j  ,k,1,tau)-um(j,k)) 
     &     +coriolis_t(j+1  )*(u(i-1,j+1,k,1,tau)-um(j+1,k)
     &                      +u(i  ,j+1,k,1,tau)-um(j+1,k)))/4.0
     &          )
          ageo2(j,k)=ageo2(j,k)+maskV(i,j,k)*dx*
     &        0.5*( b(i,j,k,tau)-bm(j,k)+b(i,j+1,k,tau)-bm(j+1,k))
     &        *( 
     &    +(beta*(yt(j  )-yt(jmt/2))*(u(i-1,j  ,k,1,tau)-um(j,k)
     &                      +u(i  ,j  ,k,1,tau)-um(j,k)) 
     &     +beta*(yt(j+1)-yt(jmt/2))*(u(i-1,j+1,k,1,tau)-um(j+1,k)
     &                      +u(i  ,j+1,k,1,tau)-um(j+1,k)))/4.0
     &          )
         enddo 
        enddo 
      enddo 
      where (vlen/=0); vv=vv/vlen; else where; vv=spval; end where
      where (vlen/=0); vvb=vvb/vlen; else where; vvb=spval; end where
      where (wlen/=0); vw=vw/wlen; else where; vw=spval; end where
      where (vlen/=0); ageo=ageo/vlen;else where;ageo=spval; end where
      where (vlen/=0);ageo2=ageo2/vlen;else where;ageo2=spval;end where

c
c        tendency of cross correlation u'v' 
c
      uv=0.;vvu=0.
      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
         fxa=0.5*(u(i,j,k,1,tau)-um(j,k)+u(i,j+1,k,1,tau)-um(j+1,k) )
     &      *0.5*(u(i,j,k,2,tau)-vm(j,k)+u(i+1,j,k,2,tau)-vm(j,k) )
         uv(j,k)=uv(j,k)+maskV(i,j,k)*dx*fxa
         vvu(j,k)=vvu(j,k)+maskV(i,j,k)*dx*fxa
     &      *0.5*(u(i,j,k,2,tau)+u(i+1,j,k,2,tau))
        enddo 
       enddo 
      enddo 
      where (vlen/=0);uv=uv/vlen;else where;uv=spval;end where
      where (vlen/=0);vvu=vvu/vlen;else where;vvu=spval;end where

      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
          a(i,j,k)= maskU(i,j,k)*( 
     &     coriolis_t(j)*(u(i,j  ,k,2,tau)+u(i+1,j  ,k,2,tau)+
     &                    u(i,j-1,k,2,tau)+u(i+1,j-1,k,2,tau))/4.0
     &              -(p_full(i+1,j,k,tau)-p_full(i,j,k,tau))/dx )
        enddo 
       enddo 
      enddo 
      call border_exchg3D(a,1); call setcyclic3D(a)
      agev1=0.
      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
         agev1(j,k)=agev1(j,k)+maskV(i,j,k)*dx*
     &    0.5*(a(i,j,k)+a(i,j+1,k))*
     &    0.5*(u(i,j,k,2,tau)-vm(j,k)+u(i+1,j,k,2,tau)-vm(j,k))
        enddo 
       enddo 
      enddo 
      where (vlen/=0);agev1=agev1/vlen;else where;agev1=spval;end where

      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
          a(i,j,k)= maskV(i,j,k)*( 
     &    -(coriolis_t(j  )*(u(i-1,j  ,k,1,tau)+u(i,j  ,k,1,tau)) 
     &     +coriolis_t(j+1)*(u(i-1,j+1,k,1,tau)+u(i,j+1,k,1,tau)))/4.0
     &    -(p_full(i,j+1,k,tau)-p_full(i,j,k,tau))/dx) 
        enddo 
       enddo 
      enddo 
      call border_exchg3D(a,1); call setcyclic3D(a)
      agev2=0.
      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
         agev2(j,k)=agev2(j,k)+maskU(i,j,k)*dx*
     &    0.5*(a(i,j,k)+a(i+1,j,k))*
     &    0.5*(u(i,j,k,1,tau)-um(j,k)+u(i,j+1,k,1,tau)-um(j+1,k))
        enddo 
       enddo 
      enddo 
      where (vlen/=0);agev2=agev2/vlen;else where;agev2=spval;end where

#endif
      end subroutine zonal_averages_flux_tendency







      subroutine zonal_averages_energy
#ifdef diag_energy_budget
c=======================================================================
c       compute zonal mean energy budget
c=======================================================================
      use cpflame_module
      use zonal_averages_module
      implicit none

      integer :: i,j,k,js,je,m,n
      real   :: fxa,a(jmt,km),bs(imt,jmt,km),bms(jmt,km)
      real   :: bss(imt,jmt,km),del2(imt,jmt,km),us(imt,jmt,km)

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      bs=0.0;bms=0.0;bss=0.  ! buoyancy deviation from reference state
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
           bs(i,j,k)=(b(i,j,k,tau)-b_r(k))*maskT(i,j,k)
         enddo 
        enddo 
      enddo 
      call border_exchg3D(bs,1); call setcyclic3D(bs)
      do j=js,je 
        do i=2,imt-1
         bms(j,:)=bms(j,:)+bs(i,j,:)*dx*maskT(i,j,:) 
        enddo 
      enddo 
      where (blen/=0) bms=bms/blen
      call border_exchg_merid(bms,1)
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
           bss(i,j,k)=(bs(i,j,k)-bms(j,k))*maskT(i,j,k)
         enddo 
        enddo 
      enddo 
      call border_exchg3D(bss,1); call setcyclic3D(bss)
c-----------------------------------------------------------------------
c       Mean energy
c-----------------------------------------------------------------------
      where (vlen==0); vm=0; end where
      where (wlen==0); wm=0; end where
      call border_exchg_merid(vm,1)
      call border_exchg_merid(wm,1)

      do j=js,je 
        do k=2,km-1
         mke(j,k)=um(j,k)**2/2+(0.5*(vm(j,k)+vm(j-1,k)))**2/2.
         mpe(j,k)=bms(j,k)**2/2/N_0**2
         bwq(j,k)= 0.25*wm(j,k  )*(bms(j,k  )+bms(j,k+1))
     &            +0.25*wm(j,k-1)*(bms(j,k-1)+bms(j,k  ))
        enddo
      enddo
      where (blen==0); mke=spval; end where
      where (blen==0); mpe=spval; end where
      where (blen==0); bwq=spval; end where

      where (vlen==0); vm=spval; end where
      where (wlen==0); wm=spval; end where
      call border_exchg_merid(vm,1)
      call border_exchg_merid(wm,1)
c-----------------------------------------------------------------------
c        Eddy energy
c-----------------------------------------------------------------------
      eke=0.0;bws=0.0;epe=0.0;
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          eke(j,k)=eke(j,k)+dx*( 
     &      ( 0.5*((u(i  ,j,k,1,tau)-um(j  ,k))*maskU(i  ,j,k)
     &            +(u(i-1,j,k,1,tau)-um(j  ,k))*maskU(i-1,j,k) ) )**2/2
     &     +( 0.5*((u(i,j-1,k,2,tau)-vm(j-1,k))*maskV(i,j-1,k)
     &            +(u(i,j-1,k,2,tau)-vm(j  ,k))*maskV(i,j  ,k) ) )**2/2
     &                          )
          epe(j,k)=epe(j,k)+dx*bss(i,j,k)**2/2/N_0**2

          bws(j,k)=bws(j,k)+dx*( 
     &      (u(i,j,k  ,3,tau)-wm(j,k  ))*0.25*maskW(i,j,k  )*
     &         (bss(i,j,k  )+bss(i,j,k+1))
     &     +(u(i,j,k-1,3,tau)-wm(j,k-1))*0.25*maskW(i,j,k-1)*
     &         (bss(i,j,k-1)+bss(i,j,k  ))
     &                          )
         enddo 
        enddo 
      enddo 
      where (blen/=0); eke=eke/blen; else where; eke=spval; end where
      where (blen/=0); epe=epe/blen; else where; epe=spval; end where
      where (blen/=0); bws=bws/blen; else where; bws=spval; end where
c-----------------------------------------------------------------------
c        Baroclinic instability term
c-----------------------------------------------------------------------
      a=0.0 ! v'b' bar b_y /N_0**2 
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          a(j,k)=a(j,k)+dx/N_0**2*( 
     &          (u(i,j,k,2,tau)-vm(j,k))*
     &      0.5*(bss(i,j,k)+bss(i,j+1,k))*(bms(j+1,k)-bms(j,k))/dx 
     &                          )*maskV(i,j,k)
         enddo 
        enddo 
      enddo 
      where (vlen/=0) a=a/vlen
      call border_exchg_merid(a,1)
      do j=js,je 
        do k=2,km-1
         T2(j,k)=0.5*( a(j-1,k)+a(j,k))
        enddo 
      enddo 

      a=0.0 ! w'b' bar b_z /N_0**2 
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          a(j,k)=a(j,k)+dx/N_0**2*( 
     &          (u(i,j,k,3,tau)-wm(j,k))*
     &      0.5*(bss(i,j,k)+bss(i,j,k+1))*( bms(j,k+1)-bms(j,k))/dz 
     &                          )*maskW(i,j,k)
         enddo 
        enddo 
      enddo 
      where (wlen/=0) a=a/wlen
      do j=js,je 
        do k=2,km-1
         T2(j,k)=T2(j,k)+0.5*(a(j,k-1)+a(j,k))
        enddo 
      enddo 
      where (blen==0); T2 =spval; end where

c-----------------------------------------------------------------------
c       Shear instability terms
c-----------------------------------------------------------------------
      a=0.0; 
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1 ! bar(u' v') bar u_y    
          a(j,k)=a(j,k)+dx*( 
     &        0.5*( u(i,j,k,1,tau)-um(j,k) + u(i,j+1,k,1,tau)-um(j+1,k))
     &       *0.5*( u(i,j,k,2,tau)-vm(j,k) + u(i+1,j,k,2,tau)-vm(j,k))
     &       *(um(j+1,k)-um(j,k))/dx
     &                          )*maskU(i,j,k)*maskU(i,j+1,k)
         enddo 
        enddo 
      enddo 
      where (ulen/=0) a=a/ulen
      call border_exchg_merid(a,1)
      do j=js,je 
        do k=2,km-1
         T4u(j,k)=0.5*( a(j-1,k)+a(j,k))
        enddo 
      enddo 

      a=0.0; 
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1 ! bar(u' w') bar u_z
          a(j,k)=a(j,k)+dx*( 
     &        0.5*( u(i,j,k,1,tau)-um(j,k) + u(i,j,k+1,1,tau)-um(j,k+1))
     &       *0.5*( u(i,j,k,3,tau)-wm(j,k) + u(i+1,j,k,3,tau)-wm(j,k))
     &       *(um(j,k+1)-um(j,k))/dz
     &                          )*maskU(i,j,k)*maskU(i,j,k+1)
         enddo 
        enddo 
      enddo 
      where (ulen/=0) a=a/ulen
      do j=js,je 
        do k=2,km-1
         T4u(j,k)=T4u(j,k)+0.5*( a(j,k)+a(j,k-1))
        enddo 
      enddo 
c       where (blen==0); T4u=spval; end where

      a=0.0; 
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1 ! bar(v' v') bar v_y
          a(j,k)=a(j,k)+dx*( 
     &        0.5*( u(i,j,k,2,tau)-vm(j,k) + u(i,j-1,k,2,tau)-vm(j-1,k))
     &       *0.5*( u(i,j,k,2,tau)-vm(j,k) + u(i,j-1,k,2,tau)-vm(j-1,k))
     &       *(vm(j,k)-vm(j-1,k))/dx
     &                          )*maskV(i,j,k)*maskV(i,j-1,k)
         enddo 
        enddo 
      enddo 
      where (vlen/=0) a=a/vlen
      do j=js,je 
        do k=2,km-1
         T4v(j,k)=a(j,k)
        enddo 
      enddo 

      a=0.0; 
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1 ! bar(v' w') bar v_z
          a(j,k)=a(j,k)+dx*( 
     &        0.5*( u(i,j,k,2,tau)-vm(j,k) + u(i,j,k+1,2,tau)-vm(j,k+1))
     &       *0.5*( u(i,j,k,3,tau)-wm(j,k) + u(i,j+1,k,3,tau)-wm(j+1,k))
     &       *(vm(j,k+1)-vm(j,k))/dz
     &                          )*maskV(i,j,k)*maskV(i,j,k+1)
         enddo 
        enddo 
      enddo 
      where (vlen/=0) a=a/vlen
      call border_exchg_merid(a,1)
      do j=js,je 
        do k=2,km-1
         T4v(j,k)=T4v(j,k)+(a(j,k)+a(j,k-1)+a(j-1,k)+a(j-1,k-1))/4.0
        enddo 
      enddo 
      T4u=T4u+T4v
      where (blen==0); T4u=spval; end where
      where (blen==0); T4v=spval; end where
c-----------------------------------------------------------------------
c        Dissipation of EKE:  M'_u**2   M'_v**2
c-----------------------------------------------------------------------
      eps_kh = 0.
      if (enable_biharmonic_friction) then
        do j=js,je 
         do k=2,km-1
          do i=2,imt-1
            us(i,j,k)=(u(i,j,k,1,tau)-um(j,k))*maskU(i,j,k)
          enddo 
         enddo 
        enddo 
        call border_exchg3D(us,1); call setcyclic3D(us)
        call biha_diss_u(us,del2)
        eps_u=0.0;
        do j=js,je 
         do k=2,km-1
          do i=2,imt-1
           eps_u(j,k)=eps_u(j,k)+dx*del2(i,j,k)**2*maskU(i,j,k)
          enddo 
         enddo 
        enddo 
        do j=js,je 
         do k=2,km-1
          do i=2,imt-1
            us(i,j,k)=(u(i,j,k,2,tau)-vm(j,k))*maskV(i,j,k)
          enddo 
         enddo 
        enddo 
        call border_exchg3D(us,1); call setcyclic3D(us)
        call biha_diss_v(us,del2)
        eps_v=0.0;
        do j=js,je 
         do k=2,km-1
          do i=2,imt-1
           eps_v(j,k)=eps_v(j,k)+dx*del2(i,j,k)**2*maskV(i,j,k)
          enddo 
         enddo 
        enddo 
        call border_exchg_merid(eps_v,1)
        eps_kh=0
        do j=js,je 
         do k=2,km-1
          eps_kh(j,k)=eps_u(j,k)+0.5*(eps_v(j,k)+eps_v(j-1,k))
         enddo 
        enddo 
      endif

c        add here dissipation by harmonic friction

      where (blen/=0); eps_kh=eps_kh/blen; 
      else where; eps_kh=spval; end where
c-----------------------------------------------------------------------
c        Dissipation of EKE:  A_v (u'_z)**2  +A_v (v'_z)**2 
c-----------------------------------------------------------------------
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
           us(i,j,k)=(u(i,j,k,1,tau)-um(j,k))*maskU(i,j,k)
         enddo 
        enddo 
      enddo 
      call border_exchg3D(us,1); call setcyclic3D(us)
      eps_u=0.0;
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          eps_u(j,k)=eps_u(j,k)+dx*A_v*(
     &      0.5*(us(i,j,k+1)-us(i,j,k  ))/dz*maskW(i,j,k  ) 
     &     +0.5*(us(i,j,k  )-us(i,j,k-1))/dz*maskW(i,j,k-1) 
     &           )**2         
         enddo 
        enddo 
      enddo 
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
           us(i,j,k)=(u(i,j,k,2,tau)-vm(j,k))*maskV(i,j,k)
         enddo 
        enddo 
      enddo 
      call border_exchg3D(us,1); call setcyclic3D(us)
      eps_v=0.0;
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          eps_v(j,k)=eps_v(j,k)+dx*A_v*(
     &      0.5*(us(i,j,k+1)-us(i,j,k  ))/dz*maskW(i,j,k  ) 
     &     +0.5*(us(i,j,k  )-us(i,j,k-1))/dz*maskW(i,j,k-1) 
     &           )**2         
         enddo 
        enddo 
      enddo 
      call border_exchg_merid(eps_v,1)
      eps_kv=0
      do j=js,je 
        do k=2,km-1
         eps_kv(j,k)=eps_u(j,k)+0.5*(eps_v(j,k)+eps_v(j-1,k))
        enddo 
      enddo 
c
c        Dissipation of EKE by bottom stress
c
      if (enable_bottom_stress) then
        eps_u=0.;eps_v=0.
        do j=js,je 
         do i=2,imt-1
          k=max(1,kmu(i,j))
          eps_u(j,k)=eps_u(j,k)
     &          +dx*cdbot*(u(i,j,k,1,tau)-um(j,k))**2*masku(i,j,k)
          k=max(1,kmv(i,j))
          eps_v(j,k)=eps_v(j,k)
     &          +dx*cdbot*(u(i,j,k,2,tau)-vm(j,k))**2*maskV(i,j,k)
         enddo
        enddo
        do j=js,je 
         do k=2,km-1
          eps_kv(j,k)=eps_kv(j,k)
     &             +eps_u(j,k)+0.5*(eps_v(j,k)+eps_v(j-1,k))
         enddo 
        enddo 
      endif
c
c        Dissipation of EKE by interior stress
c
      if (enable_interior_stress) then
        eps_u=0.;eps_v=0.
        do k=2,km-1
         do j=js,je 
          do i=2,imt-1
           eps_u(j,k)=eps_u(j,k)
     &           +dx*cdint*(u(i,j,k,1,tau)-um(j,k))**2*masku(i,j,k)
           eps_v(j,k)=eps_v(j,k)
     &           +dx*cdint*(u(i,j,k,2,tau)-vm(j,k))**2*maskV(i,j,k)
          enddo
         enddo
        enddo
        do k=2,km-1
         do j=js,je 
           eps_kv(j,k)=eps_kv(j,k)+
     &              eps_u(j,k)+0.5*(eps_v(j,k)+eps_v(j-1,k))
         enddo 
        enddo 
      endif

      where (blen/=0); eps_kv=eps_kv/blen; 
      else where; eps_kv=spval; end where
c-----------------------------------------------------------------------
c        Dissipation of EPE:  K_v (b'_z)**2 /N**2 +  M'_b**2
c-----------------------------------------------------------------------
      eps_b=0.0;
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          eps_b(j,k)=eps_b(j,k)+dx/N_0**2*( 
     &     +0.5*(K_v+K_b(i,j,k  ))
     &       *(bss(i,j,k+1)-bss(i,j,k))/dz
     &       *(b(i,j,k+1,tau)-b(i,j,k,tau))/dz*maskW(i,j,k) 
     &     +0.5*(K_v+K_b(i,j,k-1))
     &       *(bss(i,j,k)-bss(i,j,k-1))/dz
     &       *(b(i,j,k,tau)-b(i,j,k-1,tau))/dz*maskW(i,j,k-1) 
c     &       (K_v+0.5*(K_b(i,j,k)+K_b(i,j,k-1)) )
c     &        *( (b(i,j,k+1,tau)-b(i,j,k-1,tau))/(2*dz) )**2
     &                          )
         enddo 
        enddo 
      enddo 
      if (enable_biharmonic_diffusion) then
        call biha_diss_b(bss,del2)
        do j=js,je 
         do k=2,km-1
          do i=2,imt-1
           eps_b(j,k)=eps_b(j,k)+dx/N_0**2*del2(i,j,k)**2*maskT(i,j,k)
          enddo 
         enddo 
        enddo 
      endif
      where (blen/=0); eps_b=eps_b/blen; 
      else where; eps_b=spval; end where
c-----------------------------------------------------------------------
c        Dissipation of EPE due to buffer zones
c-----------------------------------------------------------------------
      rest =0.0;
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          rest (j,k)=rest (j,k)+dx/N_0**2*( 
     &       bss(i,j,k)*b(i,j,k,tau)*t_rest(j)*maskT(i,j,k)
     &                          )
         enddo 
        enddo 
      enddo 
      where (blen/=0); rest =rest /blen; 
      else where; rest =spval; end where

      restm =0.0;
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          restm(j,k)=restm(j,k)+dx/N_0**2*( 
     &       bms(j,k)*b(i,j,k,tau)*t_rest(j)*maskT(i,j,k)
     &                          )
         enddo 
        enddo 
      enddo 
      where (blen/=0); restm=restm/blen; 
      else where; restm=spval; end where
c-----------------------------------------------------------------------
c        EKE radiation  vp wp
c-----------------------------------------------------------------------
      vps=0.0; wps=0.0;
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          vps(j,k)=vps(j,k)+dx*( 
     &     ( u(i,j,k,2,tau)-vm(j,k) )*
     &       0.5*(p_full(i,j,k,tau)+p_full(i,j+1,k,tau))*maskV(i,j,k)
     &                          )
          wps(j,k)=wps(j,k)+dx*( 
     &     ( u(i,j,k,3,tau)-wm(j,k) )*
     &       0.5*(p_full(i,j,k,tau)+p_full(i,j,k+1,tau))*maskW(i,j,k)
     &                          )
         enddo 
        enddo 
      enddo 
      where (vlen/=0); vps  =vps  /vlen; 
      else where; vps  =spval; end where
      where (wlen/=0); wps  =wps  /wlen; 
      else where; wps  =spval; end where
c-----------------------------------------------------------------------
c        EKE advection
c-----------------------------------------------------------------------
      del2=0 
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
           del2(i,j,k)=
     &      ( 0.5*((u(i  ,j,k,1,tau)-um(j  ,k))*maskU(i  ,j,k)
     &            +(u(i-1,j,k,1,tau)-um(j  ,k))*maskU(i-1,j,k) ) )**2/2
     &     +( 0.5*((u(i,j-1,k,2,tau)-vm(j-1,k))*maskV(i,j-1,k)
     &            +(u(i,j-1,k,2,tau)-vm(j  ,k))*maskV(i,j  ,k) ) )**2/2
         enddo 
        enddo 
      enddo 
      call border_exchg3D(del2,1); call setcyclic3D(del2)

      veke=0.0; weke=0.0;
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          veke(j,k)=veke(j,k)+dx*( 
     &     u(i,j,k,2,tau)*maskV(i,j,k)*
     &       0.5*(del2(i,j,k)+del2(i,j+1,k))*maskV(i,j,k)
     &                          )
          weke(j,k)=weke(j,k)+dx*( 
     &     u(i,j,k,3,tau)*maskW(i,j,k)*
     &       0.5*(del2(i,j,k)+del2(i,j,k+1))*maskW(i,j,k)
     &                          )
         enddo 
        enddo 
      enddo 
      where (vlen/=0); veke =veke /vlen; 
      else where; veke =spval; end where
      where (wlen/=0); weke =weke /wlen; 
      else where; weke =spval; end where
c-----------------------------------------------------------------------
c        EPE advection
c-----------------------------------------------------------------------
      del2=0 
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
           del2(i,j,k)= bss(i,j,k)**2/2/N_0**2
         enddo 
        enddo 
      enddo 
      call border_exchg3D(del2,1); call setcyclic3D(del2)

      vepe=0.0; wepe=0.0;
      do j=js,je 
        do k=2,km-1
         do i=2,imt-1
          vepe(j,k)=vepe(j,k)+dx*( 
     &     u(i,j,k,2,tau)*maskV(i,j,k)*
     &       0.5*(del2(i,j,k)+del2(i,j+1,k))*maskV(i,j,k)
     &                          )
          wepe(j,k)=wepe(j,k)+dx*( 
     &     u(i,j,k,3,tau)*maskW(i,j,k)*
     &       0.5*(del2(i,j,k)+del2(i,j,k+1))*maskW(i,j,k)
     &                          )
         enddo 
        enddo 
      enddo 
      where (vlen/=0); vepe =vepe /vlen; 
      else where; vepe =spval; end where
      where (wlen/=0); wepe =wepe /wlen; 
      else where; wepe =spval; end where
#endif
      end subroutine zonal_averages_energy








#ifdef diag_energy_budget

      subroutine biha_diss_b(var,del2)
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: var(imt,jmt,km) 
      real :: diff_fe(imt,jmt,km), diff_fn(imt,jmt,km) 
      real :: del2(imt,jmt,km),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      diffx = sqrt(abs(Khbi)); diff_fe=0.0;diff_fn=0.0
      do k=1,km
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k)=diffx*(var(i+1,j,k)-var(i,j,k))/dx
     &                  *maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=1,imt
         diff_fn(i,j,k)=diffx*(var(i,j+1,k)-var(i,j,k))/dx
     &                  *maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      del2=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
	  del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(del2,1); call setcyclic3D(del2)
      end subroutine biha_diss_b




      subroutine biha_diss_u (var,del2)
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: var(imt,jmt,km) 
      real :: diff_fe(imt,jmt,km), diff_fn(imt,jmt,km) 
      real :: del2(imt,jmt,km),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k) = (diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k) = (diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      diffx = sqrt(abs(ahbi)); diff_fe=0.0;diff_fn=0.0
      do k=1,km
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k)=diffx*(var(i+1,j,k)-var(i,j,k))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=1,imt
         diff_fn(i,j,k)=diffx*(var(i,j+1,k)-var(i,j,k))/dx
     &                  *maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js-1,je
         diff_fn(:,j,:)=diff_fn(:,j,:)-2*diffx*var(:,j,:)/dx
     &                   *(1-maskU(:,j+1,:))*maskU(:,j,:)
     &                                +2*diffx*var(:,j+1,:)/dx
     &                   *(1-maskU(:,j,:))*maskU(:,j+1,:)
       enddo
      endif
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      del2=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
	  del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(del2,1); call setcyclic3D(del2)
      end subroutine biha_diss_u




      subroutine biha_diss_v (var,del2)
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: var(imt,jmt,km) 
      real :: diff_fe(imt,jmt,km), diff_fn(imt,jmt,km) 
      real :: del2(imt,jmt,km),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      diffx = sqrt(abs(ahbi)); diff_fe=0.0;diff_fn=0.0
      do k=1,km
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k)=diffx*(var(i+1,j,k)-var(i,j,k))/dx
     &                  *maskV(i,j,k)*maskV(i+1,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do i=1,imt-1
         diff_fe(i,:,:)=diff_fe(i,:,:)-2*diffx*var(i,:,:)/dx
     &                   *(1-maskV(i+1,:,:))*maskV(i,:,:)
     &                                +2*diffx*var(i+1,:,:)/dx
     &                   *(1-maskV(i,:,:))*maskV(i+1,:,:)
       enddo
      endif
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=1,imt
         diff_fn(i,j,k)=diffx*(var(i,j+1,k)-var(i,j,k))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      del2=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
	  del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(del2,1); call setcyclic3D(del2)
      end subroutine biha_diss_v
#endif



#else
      subroutine zonal_averages_dummy
      end
#endif

#include "options.inc"
    

c=======================================================================
c       calculate numbers
c       linked in the code in driver.F
c=======================================================================

#ifdef enable_diag_numbers

c#define write_threedim

      module numbers_module
      implicit none
      real,allocatable :: cfl_h(:,:,:)
      real,allocatable :: cfl_v(:,:,:)
      real :: cfl_h_max ,cfl_v_max

      real,allocatable :: pec_h(:,:,:)
      real,allocatable :: pec_v(:,:,:)
      real :: pec_h_max ,pec_v_max

      real,allocatable :: rey_h(:,:,:)
      real,allocatable :: rey_v(:,:,:)
      real :: rey_h_max ,rey_v_max

      real,allocatable :: ro(:,:,:)
      real :: ro_max
      real,allocatable :: ri(:,:,:)
      real :: ri_min
      real,allocatable :: Ek_h(:),Ek_v(:)

      real, parameter :: eps = 1e-20
      end module numbers_module
 
      subroutine init_numbers
c=======================================================================
c       allocate work space
c=======================================================================
      use cpflame_module
      use numbers_module
      implicit none
      real :: L_r, c, cfl

      if (my_pe==0) then
       print*,''
       print*,' intializing diagnostic for numerical'
       print*,' and physical critria and numbers '
       print*,''
      endif

      allocate( cfl_h(imt,jmt,km) ); cfl_h=0.0
      allocate( cfl_v(imt,jmt,km) ); cfl_v=0.0
      allocate( pec_h(imt,jmt,km) ); pec_h=0.0
      allocate( pec_v(imt,jmt,km) ); pec_v=0.0
      allocate( rey_h(imt,jmt,km) ); rey_h=0.0
      allocate( rey_v(imt,jmt,km) ); rey_v=0.0
      allocate( ro(imt,jmt,km)    ); ro=0.0
      allocate( ri(imt,jmt,km)    ); ri=0.0
      allocate( Ek_h(jmt),Ek_v(jmt));Ek_h=0.0;Ek_v=0.0
      call init_numbers_diag
c
c=======================================================================
c      check CFL criterion for barotropic Rossby wave speed
c=======================================================================
c
      L_r = sqrt( g * maxval(ht )) /minval(coriolis_t)
      L_r = min( L_r, sqrt( sqrt( g * maxval(ht )) / beta ) )
      c = beta * L_r**2
      cfl = dt_in/dx *c
      if (my_pe==0) then
        print *,' barotropic Rossby radius     ', L_r/1e3 , ' km'
        print *,' barotropic Rossby wave speed ', c , ' m/s'
        print *,' Courant number for that speed ', cfl
        if (cfl >0.5) then
          print*,'---------------------------------------------'
          print*,'!!!!! WARNING CFL FOR ROSSBY WAVES > 0.5 !!!!'
          print*,'---------------------------------------------'
        endif
      endif

      if (my_pe==0) print*,' Checking horizontal diffusive criteria'
      if (dt_in > dx**2/(2.*max(K_h,1e-8))) 
     &            call halt_stop('K_h too large')
      if (dt_in > dx**2/(2.*max(A_h,1e-8))) 
     &            call halt_stop('A_h too large')
      if (dt_in > dz**2/(2.*max(K_v,1e-8))) 
     &            call halt_stop('K_v too large ')
      if (dt_in > dz**2/(2.*max(A_v,1e-8))) 
     &            call halt_stop('A_v too large ')
      if (my_pe==0) then
        print*,' max. possible K_h/A_h = ',dx**2/dt_in/2.0
        print*,' max. possible K_v/A_v = ',dz**2/dt_in/2.0
      endif
      end subroutine init_numbers



      subroutine init_numbers_diag
c-----------------------------------------------------------------------
c=======================================================================
c      initialize NetCDF snapshot file
c=======================================================================
c-----------------------------------------------------------------------
      use cpflame_module
      use numbers_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,i,j,k,n
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lat_tdim,lat_udim, vid
      integer :: dims(4), corner(4), edges(4)
      character (len=80) :: name, unit
      real :: fxa,fxb,fxc
c
c=======================================================================
c       Ekman number on the grid
c=======================================================================
c
      fxa = A_h; fxb = A_v
      if (enable_biharmonic_friction) fxa = max(A_h,Ahbi/dx**2)
      if (enable_vert_biha_friction)  fxb = max(A_v,Avbi/dz**2)
      do j=1,jmt
       fxc = eps + abs(coriolis_t(j))
       Ek_h(j) = fxa/dx**2/fxc
       Ek_v(j) = fxb/dz**2/fxc
      enddo

      if (my_pe==0) then

      call def_grid_cdf('numbers.cdf')
      iret=nf_open('numbers.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'zu',z_udim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)

      vid = ncvdef (ncid,'CFL_h_max', NCFLOAT,1,itimedim,iret)
      name = 'Max. hor. Courant number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
      vid = ncvdef (ncid,'CFL_v_max', NCFLOAT,1,itimedim,iret)
      name = 'Max. vert. Courant number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      vid = ncvdef (ncid,'Pec_h_max', NCFLOAT,1,itimedim,iret)
      name = 'Max. horz. Peclet number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
      vid = ncvdef (ncid,'Pec_v_max', NCFLOAT,1,itimedim,iret)
      name = 'Max. vert. Peclet number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      vid = ncvdef (ncid,'Rey_h_max', NCFLOAT,1,itimedim,iret)
      name = 'Max. horz. Reynolds number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
      vid = ncvdef (ncid,'Rey_v_max', NCFLOAT,1,itimedim,iret)
      name = 'Max. vert. Reynolds number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      vid = ncvdef (ncid,'Ro_max', NCFLOAT,1,itimedim,iret)
      name = 'Max. Rossby number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
      vid = ncvdef (ncid,'Ri_min', NCFLOAT,1,itimedim,iret)
      name = 'Min. Richardson number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

#ifdef write_threedim
      dims = (/Lon_tdim,lat_tdim, z_tdim, iTimedim/)
      vid = ncvdef (ncid,'CFL_h', NCFLOAT,4,dims,iret)
      name = 'Horizontal Courant number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
      vid = ncvdef (ncid,'CFL_v', NCFLOAT,4,dims,iret)
      name = 'Vertical Courant number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      vid = ncvdef (ncid,'Pec_h', NCFLOAT,4,dims,iret)
      name = 'Horizontal Peclet number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
      vid = ncvdef (ncid,'Pec_v', NCFLOAT,4,dims,iret)
      name = 'Vertical Peclet number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      vid = ncvdef (ncid,'Rey_h', NCFLOAT,4,dims,iret)
      name = 'Horizontal Reynolds number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
      vid = ncvdef (ncid,'Rey_v', NCFLOAT,4,dims,iret)
      name = 'Vertical Reynolds number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      vid = ncvdef (ncid,'Ro', NCFLOAT,4,dims,iret)
      name = 'Grid Rossby number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      vid = ncvdef (ncid,'Nsqr', NCFLOAT,4,dims,iret)
      name = 'Square of stability frequency'; unit = '1/s^2'
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      dims = (/Lon_tdim,lat_tdim, z_udim, iTimedim/)

      vid = ncvdef (ncid,'Ri', NCFLOAT,4,dims,iret)
      name = 'Richardson number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
#endif

      vid = ncvdef (ncid,'f', NCFLOAT,1,lat_tdim,iret)
      name = 'Vert. Coriolis parameter'; unit = '1/s'
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      vid = ncvdef (ncid,'Ek_h', NCFLOAT,1,lat_tdim,iret)
      name = 'Hor. Ekman number'; unit = '1/s'
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      vid = ncvdef (ncid,'Ek_v', NCFLOAT,1,lat_tdim,iret)
      name = 'Vert. Ekman number'; unit = ' '
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)

      call ncendf(ncid, iret)

      iret=nf_inq_varid(ncid,'f',vid)
      iret= nf_put_vara_double(ncid,vid,1,jmt,coriolis_t)
      iret=nf_inq_varid(ncid,'Ek_h',vid)
      iret= nf_put_vara_double(ncid,vid,1,jmt,Ek_h)
      iret=nf_inq_varid(ncid,'Ek_v',vid)
      iret= nf_put_vara_double(ncid,vid,1,jmt,Ek_v)

      call ncclos (ncid, iret)
      endif
      end subroutine init_numbers_diag




      subroutine diag_numbers
c-----------------------------------------------------------------------
c=======================================================================
c      write to NetCDF snapshot file
c=======================================================================
c-----------------------------------------------------------------------
      use cpflame_module
      use numbers_module
#ifdef enable_tke_closure
      use tke_closure_module
#endif
#ifdef enable_smagorinsky_friction
      use smagorinsky_module
#endif
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      real :: a(imt,js_pe:je_pe,km),fxa,fxb,fxc,uabs
      integer :: itdimid,ilen,varid,itimeid
      integer :: i,j,js,je,k
      type(time_type) :: time
      real :: Nsqrw(imt,js_pe:je_pe,km)
#ifndef enable_tke_closure
      real :: Nsqr(imt,jmt,km)
#endif


      if (snapshot_time_step.or.initial_time==current_time) then
      js=max(2,js_pe); je = min(je_pe,jmt-1)
c
c=======================================================================
c      CFL cirterion
c=======================================================================
c
      cfl_h(:,js:je,:)=0.; cfl_h_max=0
      fxa = dt_in/dx 
      do k=2,km  -1
       do j=js,je
        do i=2,imt-1
         uabs=max(     abs(u(i,j,k,1,tau)) , abs(u(i-1,j,k,1,tau)) )
         uabs=max(uabs,abs(u(i,j,k,2,tau)) , abs(u(i,j-1,k,2,tau)) )
         cfl_h(i,j,k)=fxa*uabs
         cfl_h_max = max( cfl_h_max, cfl_h(i,j,k) )
        enddo
       enddo
      enddo
      call global_max(cfl_h_max)

      cfl_v(:,js:je,:)=0.;cfl_v_max=0
      if (.not. enable_hydrostatic )  then
       fxa = dt_in/dz
       do k=2,km  -1
        do j=js,je
         do i=2,imt-1
          uabs=max(abs(u(i,j,k,3,tau)),abs(u(i,j,k-1,3,tau)) )
          cfl_v(i,j,k)=fxa*uabs
          cfl_v_max = max( cfl_v_max, cfl_v(i,j,k) )
         enddo
        enddo
       enddo
       call global_max(cfl_v_max)
      endif
c
c=======================================================================
c      Peclet number 
c=======================================================================
c
      pec_h(:,js:je,:)=0.; pec_v(:,js:je,:)=0.
      pec_h_max=0; pec_v_max=0
      fxa = dx/(eps+K_h)
      if (enable_biharmonic_diffusion) fxa = dx/max(K_h,Khbi/dx**2)
      fxb = dz/(eps+K_v)
      if (enable_vert_biha_diffusion)  fxb = dz/max(K_v,Kvbi/dz**2)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         uabs=max(     abs(u(i,j,k,1,tau)) , abs(u(i-1,j,k,1,tau)) )
         uabs=max(uabs,abs(u(i,j,k,2,tau)) , abs(u(i,j-1,k,2,tau)) )
#ifdef enable_tke_closure
         fxa = dx/max(diffT(i,j,k),eps)
         fxb = dz/max(diffT(i,j,k),eps)
#endif
         pec_h(i,j,k)= fxa*uabs
         pec_h_max   = max( pec_h_max, pec_h(i,j,k) )

         uabs=max(abs(u(i,j,k,3,tau)),abs(u(i,j,k-1,3,tau)) )
         pec_v(i,j,k)= fxb*uabs
         pec_v_max   = max( pec_v_max, pec_v(i,j,k) )
        enddo
       enddo
      enddo
      call global_max(pec_h_max)
      call global_max(pec_v_max)
c
c=======================================================================
c      Reynolds number 
c=======================================================================
c
      rey_h(:,js:je,:)=0.; rey_v(:,js:je,:)=0.
      rey_h_max=0; rey_v_max=0
      fxa = dx/(eps+A_h)
      if (enable_biharmonic_friction) fxa = dx/max(A_h,Ahbi/dx**2)
      fxb = dz/(eps+A_v)
      if (enable_vert_biha_friction)  fxb = dz/max(A_v,Avbi/dz**2)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         uabs=max(     abs(u(i,j,k,1,tau)) , abs(u(i-1,j,k,1,tau)) )
         uabs=max(uabs,abs(u(i,j,k,2,tau)) , abs(u(i,j-1,k,2,tau)) )
#ifdef enable_tke_closure
         fxa = dx/max(diffU(i,j,k),eps)
         fxb = dz/max(diffU(i,j,k),eps)
#endif
#ifdef enable_smagorinsky_friction
         fxa = dx/max( diff_T(i,j,k) ,eps)
#endif
         rey_h(i,j,k)= fxa*uabs
         rey_h_max   = max( rey_h_max, rey_h(i,j,k) )

         uabs=max(abs(u(i,j,k,3,tau)),abs(u(i,j,k-1,3,tau)) )
         rey_v(i,j,k)= fxb*uabs
         rey_v_max   = max( rey_v_max, rey_v(i,j,k) )
        enddo
       enddo
      enddo
      call global_max(rey_h_max)
      call global_max(rey_v_max)
c
c=======================================================================
c      output
c=======================================================================
c
      if (my_pe==0) then
         print*,' maximum hor. Courant number  : ',cfl_h_max
         if (.not. enable_hydrostatic ) 
     &   print*,' maximum vert.Courant number  : ',cfl_v_max
         print*,' maximum hor. Peclet number   : ',pec_h_max
         print*,' maximum vert.Peclet number   : ',pec_v_max
         print*,' maximum hor. Reynolds number : ',rey_h_max
         print*,' maximum vert.Reynolds number : ',rey_v_max
         if (cfl_h_max > 1.0 ) 
     &           print*,' WARNING: hor.  CFL criterion violated'
         if (cfl_v_max > 1.0 .and. .not. enable_hydrostatic ) 
     &           print*,' WARNING: vert. CFL criterion violated'
      endif

c
c=======================================================================
c       Rossby number on the grid
c=======================================================================
c
      ro(:,js:je,:)=0.; ro_max=0.
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fxa = 1./dx/(eps + abs(coriolis_t(j)))
         ro(i,j,k)=fxa*max(abs(u(i,j,k,1,tau)),abs(u(i,j,k,2,tau)))
         ro_max = max( ro_max, ro(i,j,k) )
        enddo
       enddo
      enddo
      call global_max(ro_max)
c---------------------------------------------------------------------------------
c=======================================================================
c       stability freq.
c=======================================================================
c---------------------------------------------------------------------------------
      Nsqrw=0
      do k=1,km-1
       do j=js,je
        Nsqrw(:,j,k)=-(b(:,j,k+1,tau)-b(:,j,k,tau))/dz
       enddo
      enddo
#ifndef enable_tke_closure
c---------------------------------------------------------------------------------
c=======================================================================
c      Interpolate Nsqr vertically on T grid and bound Nsqr
c=======================================================================
c---------------------------------------------------------------------------------
      do k=2,km-1
       do j=js,je
         Nsqr(:,j,k)=maskT(:,j,k)*(
     &     Nsqrw(:,j,k  )*maskW(:,j,k  )+Nsqrw(:,j,k-1)*maskW(:,j,k-1) )
     &     /(maskW(:,j,k)+maskW(:,j,k-1)+eps)
       enddo
      enddo
      call border_exchg3D(Nsqr,1)
      call setcyclic3D(Nsqr )
#endif
c
c=======================================================================
c       Richardson Number
c=======================================================================
c
      ri(:,js:je,:)=0.; ri_min=1/eps
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         fxa=0.5*( (u(i  ,j,k+1,1,tau)-u(i  ,j,k,1,tau))/dz )**2
     &      +0.5*( (u(i-1,j,k+1,1,tau)-u(i-1,j,k,1,tau))/dz )**2
         fxb=0.5*( (u(i,j  ,k+1,2,tau)-u(i,j  ,k,2,tau))/dz )**2
     &      +0.5*( (u(i,j-1,k+1,2,tau)-u(i,j-1,k,2,tau))/dz )**2
         Ri(i,j,k)=max(0.0,Nsqrw(i,j,k))/(eps + fxa+fxb)
         if (maskW(i,j,k)==1.0) ri_min = min( ri_min, ri(i,j,k) )
        enddo
       enddo
      enddo
      call global_max(ri_min)
c
c=======================================================================
c      output
c=======================================================================
c
       if (my_pe==0) then
         print*,' maximum grid  Rossby number  : ',ro_max
         print*,' minimal   Richardson number  : ',ri_min
       endif

       do npe=0,n_pes-1
        if (my_pe==npe) then
         iret=nf_open('numbers.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
 
         iret=nf_inq_dimid(ncid,'Time',itdimid)
         iret=nf_inq_dimlen(ncid, itdimid,ilen)
         iret=nf_inq_varid(ncid,'Time',itimeid)
         if (my_pe==0) then
          ilen=ilen+1
          time = current_time-initial_time
          fxa = time%days + time%seconds/86400.
          iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
         endif
         iret=nf_inq_varid(ncid,'CFL_h_max',varid)
         iret= nf_put_vara_double(ncid,varid,ilen,1,cfl_h_max)
         iret=nf_inq_varid(ncid,'CFL_v_max',varid)
         iret= nf_put_vara_double(ncid,varid,ilen,1,cfl_v_max)

         iret=nf_inq_varid(ncid,'Pec_h_max',varid)
         iret= nf_put_vara_double(ncid,varid,ilen,1,pec_h_max)
         iret=nf_inq_varid(ncid,'Pec_v_max',varid)
         iret= nf_put_vara_double(ncid,varid,ilen,1,pec_v_max)

         iret=nf_inq_varid(ncid,'Rey_h_max',varid)
         iret= nf_put_vara_double(ncid,varid,ilen,1,Rey_h_max)
         iret=nf_inq_varid(ncid,'Rey_v_max',varid)
         iret= nf_put_vara_double(ncid,varid,ilen,1,Rey_v_max)

         iret=nf_inq_varid(ncid,'Ro_max',varid)
         iret= nf_put_vara_double(ncid,varid,ilen,1,ro_max)
         iret=nf_inq_varid(ncid,'Ri_min',varid)
         iret= nf_put_vara_double(ncid,varid,ilen,1,ri_min)

#ifdef write_threedim
         Corner = (/1,js_pe,1,ilen/); 
         edges  = (/imt,je_pe-js_pe+1,km,1/)
         iret=nf_inq_varid(ncid,'CFL_h',varid)
         a=cfl_h(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)
         iret=nf_inq_varid(ncid,'CFL_v',varid)
         a=cfl_v(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)

         iret=nf_inq_varid(ncid,'Pec_h',varid)
         a=Pec_h(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)
         iret=nf_inq_varid(ncid,'Pec_v',varid)
         a=Pec_v(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)

         iret=nf_inq_varid(ncid,'Rey_h',varid)
         a=Rey_h(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)
         iret=nf_inq_varid(ncid,'Rey_v',varid)
         a=Rey_v(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)

         iret=nf_inq_varid(ncid,'Ro',varid)
         a=ro(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)
         iret=nf_inq_varid(ncid,'Nsqr',varid)
         a=Nsqr(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)
         iret=nf_inq_varid(ncid,'Ri',varid)
         a=ri(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)
#endif
         call ncclos (ncid, iret)
        endif
        call barrier
       enddo
      endif

      end subroutine diag_numbers

#else
      subroutine numbers_dummy
      end
#endif

#include "options.inc"

c=======================================================================
c     Templates for setup
c=======================================================================


      subroutine set_parameter
      use cpflame_module
      implicit none
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=10;km=10;jmt=10
      dx=1.0*degtom
      dz=500.0
      dt_in=3600.0
      K_h=100.0
      K_v=1.e-4
      A_h=100.0
      A_v=1.e-4
      eps2D_sor = 1e-8
      runlen=1*365.0
      snap_int = 5.0
      enable_noslip=.true.
      enable_cyclic_x=.false.
      enable_cyclic_y=.false.
      lat_ref = 45.0      
      beta    = 2*omega*cos(lat_ref/180.*pi)/radius
      N_0     = 0.005
      M_0     = 0.0
      end subroutine set_parameter




      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: z,r,x,y,B0
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt
         x=(float(i)/float(imt)-0.5)*2.
         y=(float(j)/float(jmt)-0.5)*2.
         B0 = 0.2
c     &   +1e-5*exp(-(x-0.5)**2*10.)*exp(-(y)**2*10.)
c     &               *exp(-(zt(km)-zt(k))/200. )
         b(i,j,k,:) = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions




      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones


      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: k,i,j
      real :: x,y
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
      integer :: i,k
      real :: z
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c       time averaging diagnostics
c       linked in the code in driver only
c       Reference buoyancy profile given by N_0 
c=======================================================================

#ifdef enable_diag_timeave

c=======================================================================
c local preprocessor switches
c=======================================================================

c#define diag_eddy_fluxes
c#define diag_eddy_flux_tendency
c#define diag_potential_vorticity

c#define remove_back_stratification

      module time_averages_module
c=======================================================================
c        Main module for time averages
c=======================================================================
      implicit none
      integer :: nitts
      real, allocatable :: umean(:,:,:),vmean(:,:,:),wmean(:,:,:)
      real, allocatable :: bmean(:,:,:),pmean(:,:,:)
      real, allocatable :: bs(:,:,:),ps(:,:,:),b3(:,:,:)
      real, allocatable :: uvar(:,:,:),vvar(:,:,:),wvar(:,:,:)
      real, allocatable :: bvar(:,:,:), pvar(:,:,:), uv(:,:,:,:)

#ifdef diag_eddy_fluxes
      real, allocatable :: ub(:,:,:,:),vb(:,:,:,:),wb(:,:,:,:)
      real, allocatable :: ubb(:,:,:,:),vbb(:,:,:,:),wbb(:,:,:,:)
      real, allocatable :: ub3(:,:,:,:),vb3(:,:,:,:),wb3(:,:,:,:)
#endif

#ifdef diag_eddy_flux_tendency
      real, allocatable :: ugeo1(:,:,:),ugeo2(:,:,:)
      real, allocatable :: vgeo1(:,:,:),vgeo2(:,:,:)
      real, allocatable :: bpx(:,:,:,:),bpy(:,:,:,:)
      real, allocatable :: bfv(:,:,:,:),bfu(:,:,:,:)
      real, allocatable :: uwN(:,:,:,:),vwN(:,:,:,:)
#endif
      integer :: nr_tr  = 0  ! numbers of tracers to be considered
      real, allocatable :: tmean(:,:,:,:),tvar(:,:,:,:),t3(:,:,:,:)
#ifdef diag_eddy_fluxes
      real, allocatable :: ut(:,:,:,:,:),vt(:,:,:,:,:),wt(:,:,:,:,:)
      real, allocatable :: utt(:,:,:,:,:),vtt(:,:,:,:,:),wtt(:,:,:,:,:)
      real, allocatable :: ut3(:,:,:,:,:),vt3(:,:,:,:,:),wt3(:,:,:,:,:)
#endif
#ifdef diag_potential_vorticity
      real, allocatable :: rv(:,:,:),pv(:,:,:)
      real, allocatable :: qmean(:,:,:),qvar(:,:,:),q3(:,:,:)
      real, allocatable :: uq(:,:,:,:),vq(:,:,:,:),wq(:,:,:,:)
      real, allocatable :: uqq(:,:,:,:),vqq(:,:,:,:),wqq(:,:,:,:)
      real, allocatable :: uq3(:,:,:,:),vq3(:,:,:,:),wq3(:,:,:,:)
#endif
      real,parameter :: epsln     = 1.0e-20
      end module time_averages_module


      subroutine init_time_averages
c=======================================================================
c      Initialize time mean diagnostics
c=======================================================================
      use cpflame_module
      use time_averages_module
#ifdef enable_diag_tracer
      use tracer_module
#endif
      implicit none
      logical :: file_exists = .false.
      integer :: io,j,n
#ifdef enable_diag_tracer
      nr_tr = nt
#endif
      if (my_pe==0) then
       print*,''
       print*,' Initializing time averaging module '
       print*,''
       print*,' found ',nr_tr,' tracer '
       print*,''
      endif
      allocate(bs(imt,jmt,km),ps(imt,jmt,km) );bs=0.;ps=0.
      allocate(umean(imt,jmt,km),vmean(imt,jmt,km),wmean(imt,jmt,km))
      allocate(bmean(imt,jmt,km),pmean(imt,jmt,km))
      allocate(uvar(imt,jmt,km),vvar(imt,jmt,km),wvar(imt,jmt,km))
      allocate(bvar(imt,jmt,km),pvar(imt,jmt,km),uv(imt,jmt,km,4))
      allocate(b3(imt,jmt,km))
#ifdef diag_eddy_fluxes
      allocate(ub(imt,jmt,km,2),vb(imt,jmt,km,2))
      allocate(ubb(imt,jmt,km,2),vbb(imt,jmt,km,2))
      allocate(wb(imt,jmt,km,2),wbb(imt,jmt,km,2))
      allocate(ub3(imt,jmt,km,2),vb3(imt,jmt,km,2))
      allocate(wb3(imt,jmt,km,2))
#endif
#ifdef diag_eddy_flux_tendency
      allocate(bpx(imt,jmt,km,3),bpy(imt,jmt,km,3))
      allocate(bfv(imt,jmt,km,6),bfu(imt,jmt,km,6))
      allocate(ugeo1(imt,jmt,km),ugeo2(imt,jmt,km) );ugeo1=0.;ugeo2=0.
      allocate(vgeo1(imt,jmt,km),vgeo2(imt,jmt,km) );vgeo1=0.;vgeo2=0.
      allocate(uwN(imt,jmt,km,4),vwN(imt,jmt,km,4))
#endif
      allocate(tmean(imt,jmt,km,nr_tr),tvar(imt,jmt,km,nr_tr))
      allocate(t3(imt,jmt,km,nr_tr) )
#ifdef diag_eddy_fluxes
      allocate(ut(imt,jmt,km,2,nr_tr),vt(imt,jmt,km,2,nr_tr))
      allocate(utt(imt,jmt,km,2,nr_tr),vtt(imt,jmt,km,2,nr_tr))
      allocate(wt(imt,jmt,km,2,nr_tr),wtt(imt,jmt,km,2,nr_tr))
      allocate(ut3(imt,jmt,km,2,nr_tr),vt3(imt,jmt,km,2,nr_tr))
      allocate(wt3(imt,jmt,km,2,nr_tr))
#endif
#ifdef diag_potential_vorticity
      allocate(rv(imt,jmt,km),pv(imt,jmt,km))
      allocate(qmean(imt,jmt,km),qvar(imt,jmt,km),q3(imt,jmt,km))
      allocate(uq(imt,jmt,km,2),vq(imt,jmt,km,2))
      allocate(uqq(imt,jmt,km,2),vqq(imt,jmt,km,2))
      allocate(wq(imt,jmt,km,2),wqq(imt,jmt,km,2))
      allocate(uq3(imt,jmt,km,2),vq3(imt,jmt,km,2))
      allocate(wq3(imt,jmt,km,2))
#endif

      inquire( FILE='restart_ave.dta', EXIST=file_exists )
      if (file_exists) then 
       if (my_pe==0) print*,' reading data from restart file '
       call get_free_iounit(io)
       open(io,file='restart_ave.dta',form='unformatted',status='old')
       read(io) nitts 
       if (my_pe==0) then 
        print*,' number of itts = ',nitts
       endif
       do j=1,jmt
        read(io) umean(:,j,:), vmean(:,j,:), wmean(:,j,:)
        read(io) bmean(:,j,:), pmean(:,j,:)
        read(io) uvar(:,j,:), vvar(:,j,:), wvar(:,j,:)
        read(io) bvar(:,j,:), pvar(:,j,:),uv(:,j,:,:),b3(:,j,:)
#ifdef diag_eddy_fluxes
        read(io) ub(:,j,:,:), vb(:,j,:,:), wb(:,j,:,:)
        read(io) ubb(:,j,:,:),vbb(:,j,:,:),wbb(:,j,:,:)
        read(io) ub3(:,j,:,:),vb3(:,j,:,:),wb3(:,j,:,:)
#endif
#ifdef diag_eddy_flux_tendency
        read(io) bpx(:,j,:,:),bpy(:,j,:,:)
        read(io) bfv(:,j,:,:),bfu(:,j,:,:)
        read(io) uwN(:,j,:,:),vwN(:,j,:,:)
#endif
        do n=1,nr_tr
         read(io) tmean(:,j,:,n), tvar(:,j,:,n),t3(:,j,:,n)
#ifdef diag_eddy_fluxes
         read(io) ut(:,j,:,:,n), vt(:,j,:,:,n), wt(:,j,:,:,n)
         read(io) utt(:,j,:,:,n),vtt(:,j,:,:,n),wtt(:,j,:,:,n)
         read(io) ut3(:,j,:,:,n),vt3(:,j,:,:,n),wt3(:,j,:,:,n)
#endif
       enddo
#ifdef diag_potential_vorticity
        read(io) qmean(:,j,:), qvar(:,j,:),q3(:,j,:)
        read(io) uq(:,j,:,:), vq(:,j,:,:), wq(:,j,:,:)
        read(io) uqq(:,j,:,:),vqq(:,j,:,:),wqq(:,j,:,:)
        read(io) uq3(:,j,:,:),vq3(:,j,:,:),wq3(:,j,:,:)
#endif
       enddo
       close(io)
       if (my_pe==0) print*,' done reading restart'
      else
       if (my_pe==0) print*,' cannot read restart file '
       nitts=0
       umean=0;vmean=0;wmean=0;bmean=0;pmean=0
       uvar=0;vvar=0;wvar=0;bvar=0;pvar=0; uv=0.;b3=0
#ifdef diag_eddy_fluxes
       ub=0;vb=0;wb=0; ubb=0;vbb=0;wbb=0
       ub3=0;vb3=0;wb3=0.
#endif
#ifdef diag_eddy_flux_tendency
       bpx=0;bpy=0;bfv=0;bfu=0;uwN=0;vwN=0
#endif
       do n=1,nr_tr
        tmean(:,:,:,n)=0;tvar(:,:,:,n)=0;t3(:,:,:,n)=0
#ifdef diag_eddy_fluxes
        ut(:,:,:,:,n)=0;vt(:,:,:,:,n)=0;wt(:,:,:,:,n)=0; 
        utt(:,:,:,:,n)=0;vtt(:,:,:,:,n)=0;wtt(:,:,:,:,n)=0
        ut3(:,:,:,:,n)=0;vt3(:,:,:,:,n)=0;wt3(:,:,:,:,n)=0
#endif
       enddo
#ifdef diag_potential_vorticity
       qmean=0;qvar=0;q3=0
       uq=0;vq=0;wq=0;wqq=0;uqq=0;vqq=0
       vq3=0;uq3=0;wq3=0
#endif
      endif
      if (my_pe==0) print*,' Done initializing time averaging module'
      end subroutine init_time_averages


      subroutine time_averages_restart
c=======================================================================
c       write restart
c=======================================================================
      use cpflame_module
      use time_averages_module
      implicit none
      integer :: io,n,js,je,j,k

      if (my_pe==0) then
       print*,' writing restart file for time averages'
       call get_free_iounit(io)
       open(io,file='restart_ave.dta',
     &         form='unformatted',status='unknown')
       write(io) nitts
       do j=js_pe,je_pe
        write(io) umean(:,j,:),vmean(:,j,:),wmean(:,j,:)
        write(io) bmean(:,j,:),pmean(:,j,:)
        write(io) uvar(:,j,:),vvar(:,j,:),wvar(:,j,:)
        write(io) bvar(:,j,:),pvar(:,j,:),uv(:,j,:,:),b3(:,j,:)
#ifdef diag_eddy_fluxes
        write(io)  ub(:,j,:,:), vb(:,j,:,:), wb(:,j,:,:)
        write(io) ubb(:,j,:,:),vbb(:,j,:,:),wbb(:,j,:,:)
        write(io) ub3(:,j,:,:),vb3(:,j,:,:),wb3(:,j,:,:)
#endif
#ifdef diag_eddy_flux_tendency
        write(io) bpx(:,j,:,:),bpy(:,j,:,:)
        write(io) bfv(:,j,:,:),bfu(:,j,:,:)
        write(io) uwN(:,j,:,:),vwN(:,j,:,:)
#endif
        do k=1,nr_tr
         write(io) tmean(:,j,:,k),tvar(:,j,:,k),t3(:,j,:,k)
#ifdef diag_eddy_fluxes
         write(io)  ut(:,j,:,:,k), vt(:,j,:,:,k), wt(:,j,:,:,k)
         write(io) utt(:,j,:,:,k),vtt(:,j,:,:,k),wtt(:,j,:,:,k)
         write(io) ut3(:,j,:,:,k),vt3(:,j,:,:,k),wt3(:,j,:,:,k)
#endif
        enddo
#ifdef diag_potential_vorticity
        write(io)  qmean(:,j,:), qvar(:,j,:), q3(:,j,:)
        write(io)  uq(:,j,:,:), vq(:,j,:,:), wq(:,j,:,:)
        write(io) uqq(:,j,:,:),vqq(:,j,:,:),wqq(:,j,:,:)
        write(io) uq3(:,j,:,:),vq3(:,j,:,:),wq3(:,j,:,:)
#endif
       enddo
      endif

      do n=1,n_pes-1
        if (my_pe==n) then
         call send_integer(js_pe,1,0,0)
         call send_integer(je_pe,1,0,0)
         do j=js_pe,je_pe
          call send_real(umean(:,j,:),imt*km,0,0)
          call send_real(vmean(:,j,:),imt*km,0,0)
          call send_real(wmean(:,j,:),imt*km,0,0)
          call send_real(bmean(:,j,:),imt*km,0,0)
          call send_real(pmean(:,j,:),imt*km,0,0)
          call send_real(uvar(:,j,:),imt*km,0,0)
          call send_real(vvar(:,j,:),imt*km,0,0)
          call send_real(wvar(:,j,:),imt*km,0,0)
          call send_real(bvar(:,j,:),imt*km,0,0)
          call send_real(pvar(:,j,:),imt*km,0,0)
          call send_real(uv(:,j,:,:),imt*km*4,0,0)
          call send_real(b3(:,j,:),imt*km,0,0)
#ifdef diag_eddy_fluxes
          call send_real(ub(:,j,:,:),imt*km*2,0,0)
          call send_real(vb(:,j,:,:),imt*km*2,0,0)
          call send_real(wb(:,j,:,:),imt*km*2,0,0)
          call send_real(ubb(:,j,:,:),imt*km*2,0,0)
          call send_real(vbb(:,j,:,:),imt*km*2,0,0)
          call send_real(wbb(:,j,:,:),imt*km*2,0,0)
          call send_real(ub3(:,j,:,:),imt*km*2,0,0)
          call send_real(vb3(:,j,:,:),imt*km*2,0,0)
          call send_real(wb3(:,j,:,:),imt*km*2,0,0)
#endif
#ifdef diag_eddy_flux_tendency
          call send_real(bpx(:,j,:,:),imt*km*3,0,0)
          call send_real(bpy(:,j,:,:),imt*km*3,0,0)
          call send_real(bfv(:,j,:,:),imt*km*6,0,0)
          call send_real(bfu(:,j,:,:),imt*km*6,0,0)
          call send_real(uwN(:,j,:,:),imt*km*4,0,0)
          call send_real(vwN(:,j,:,:),imt*km*4,0,0)
#endif
          do k=1,nr_tr
           call send_real(tmean(:,j,:,k),imt*km,0,0)
           call send_real(tvar(:,j,:,k),imt*km,0,0)
           call send_real(t3(:,j,:,k),imt*km,0,0)
#ifdef diag_eddy_fluxes
           call send_real(ut(:,j,:,:,k),imt*km*2,0,0)
           call send_real(vt(:,j,:,:,k),imt*km*2,0,0)
           call send_real(wt(:,j,:,:,k),imt*km*2,0,0)
           call send_real(utt(:,j,:,:,k),imt*km*2,0,0)
           call send_real(vtt(:,j,:,:,k),imt*km*2,0,0)
           call send_real(wtt(:,j,:,:,k),imt*km*2,0,0)
           call send_real(ut3(:,j,:,:,k),imt*km*2,0,0)
           call send_real(vt3(:,j,:,:,k),imt*km*2,0,0)
           call send_real(wt3(:,j,:,:,k),imt*km*2,0,0)
#endif
          enddo
#ifdef diag_potential_vorticity
          call send_real(qmean(:,j,:),imt*km,0,0)
          call send_real(qvar(:,j,:),imt*km,0,0)
          call send_real(q3(:,j,:),imt*km,0,0)
          call send_real(uq(:,j,:,:),imt*km*2,0,0)
          call send_real(vq(:,j,:,:),imt*km*2,0,0)
          call send_real(wq(:,j,:,:),imt*km*2,0,0)
          call send_real(uqq(:,j,:,:),imt*km*2,0,0)
          call send_real(vqq(:,j,:,:),imt*km*2,0,0)
          call send_real(wqq(:,j,:,:),imt*km*2,0,0)
          call send_real(uq3(:,j,:,:),imt*km*2,0,0)
          call send_real(vq3(:,j,:,:),imt*km*2,0,0)
          call send_real(wq3(:,j,:,:),imt*km*2,0,0)
#endif
         enddo
        elseif (my_pe==0) then
         call recv_integer(js,1,n,0)
         call recv_integer(je,1,n,0)
         do j=js,je
          call recv_real(umean(:,j,:),imt*km,n,0)
          call recv_real(vmean(:,j,:),imt*km,n,0)
          call recv_real(wmean(:,j,:),imt*km,n,0)
          call recv_real(bmean(:,j,:),imt*km,n,0)
          call recv_real(pmean(:,j,:),imt*km,n,0)
          call recv_real(uvar(:,j,:),imt*km,n,0)
          call recv_real(vvar(:,j,:),imt*km,n,0)
          call recv_real(wvar(:,j,:),imt*km,n,0)
          call recv_real(bvar(:,j,:),imt*km,n,0)
          call recv_real(pvar(:,j,:),imt*km,n,0)
          call recv_real(uv(:,j,:,:),imt*km*4,n,0)
          call recv_real(b3(:,j,:),imt*km,n,0)
#ifdef diag_eddy_fluxes
          call recv_real(ub(:,j,:,:),imt*km*2,n,0)
          call recv_real(vb(:,j,:,:),imt*km*2,n,0)
          call recv_real(wb(:,j,:,:),imt*km*2,n,0)
          call recv_real(ubb(:,j,:,:),imt*km*2,n,0)
          call recv_real(vbb(:,j,:,:),imt*km*2,n,0)
          call recv_real(wbb(:,j,:,:),imt*km*2,n,0)
          call recv_real(ub3(:,j,:,:),imt*km*2,n,0)
          call recv_real(vb3(:,j,:,:),imt*km*2,n,0)
          call recv_real(wb3(:,j,:,:),imt*km*2,n,0)
#endif
#ifdef diag_eddy_flux_tendency
          call recv_real(bpx(:,j,:,:),imt*km*3,n,0)
          call recv_real(bpy(:,j,:,:),imt*km*3,n,0)
          call recv_real(bfv(:,j,:,:),imt*km*6,n,0)
          call recv_real(bfu(:,j,:,:),imt*km*6,n,0)
          call recv_real(uwN(:,j,:,:),imt*km*4,n,0)
          call recv_real(vwN(:,j,:,:),imt*km*4,n,0)
#endif
          do k=1,nr_tr
           call recv_real(tmean(:,j,:,k),imt*km,n,0)
           call recv_real(tvar(:,j,:,k),imt*km,n,0)
           call recv_real(t3(:,j,:,k),imt*km,n,0)
#ifdef diag_eddy_fluxes
           call recv_real(ut(:,j,:,:,k),imt*km*2,n,0)
           call recv_real(vt(:,j,:,:,k),imt*km*2,n,0)
           call recv_real(wt(:,j,:,:,k),imt*km*2,n,0)
           call recv_real(utt(:,j,:,:,k),imt*km*2,n,0)
           call recv_real(vtt(:,j,:,:,k),imt*km*2,n,0)
           call recv_real(wtt(:,j,:,:,k),imt*km*2,n,0)
           call recv_real(ut3(:,j,:,:,k),imt*km*2,n,0)
           call recv_real(vt3(:,j,:,:,k),imt*km*2,n,0)
           call recv_real(wt3(:,j,:,:,k),imt*km*2,n,0)
#endif
          enddo
#ifdef diag_potential_vorticity
          call recv_real(qmean(:,j,:),imt*km,n,0)
          call recv_real(qvar(:,j,:),imt*km,n,0)
          call recv_real(q3(:,j,:),imt*km,n,0)
          call recv_real(uq(:,j,:,:),imt*km*2,n,0)
          call recv_real(vq(:,j,:,:),imt*km*2,n,0)
          call recv_real(wq(:,j,:,:),imt*km*2,n,0)
          call recv_real(uqq(:,j,:,:),imt*km*2,n,0)
          call recv_real(vqq(:,j,:,:),imt*km*2,n,0)
          call recv_real(wqq(:,j,:,:),imt*km*2,n,0)
          call recv_real(uq3(:,j,:,:),imt*km*2,n,0)
          call recv_real(vq3(:,j,:,:),imt*km*2,n,0)
          call recv_real(wq3(:,j,:,:),imt*km*2,n,0)
#endif
          write(io) umean(:,j,:),vmean(:,j,:),wmean(:,j,:)
          write(io) bmean(:,j,:),pmean(:,j,:)
          write(io) uvar(:,j,:),vvar(:,j,:),wvar(:,j,:)
          write(io) bvar(:,j,:),pvar(:,j,:),uv(:,j,:,:),b3(:,j,:)
#ifdef diag_eddy_fluxes
          write(io)  ub(:,j,:,:), vb(:,j,:,:), wb(:,j,:,:)
          write(io) ubb(:,j,:,:),vbb(:,j,:,:),wbb(:,j,:,:)
          write(io) ub3(:,j,:,:),vb3(:,j,:,:),wb3(:,j,:,:)
#endif
#ifdef diag_eddy_flux_tendency
          write(io) bpx(:,j,:,:),bpy(:,j,:,:)
          write(io) bfv(:,j,:,:),bfu(:,j,:,:)
          write(io) uwN(:,j,:,:),vwN(:,j,:,:)
#endif
          do k=1,nr_tr
           write(io) tmean(:,j,:,k),tvar(:,j,:,k),t3(:,j,:,k)
#ifdef diag_eddy_fluxes
           write(io)  ut(:,j,:,:,k), vt(:,j,:,:,k), wt(:,j,:,:,k)
           write(io) utt(:,j,:,:,k),vtt(:,j,:,:,k),wtt(:,j,:,:,k)
           write(io) ut3(:,j,:,:,k),vt3(:,j,:,:,k),wt3(:,j,:,:,k)
#endif
          enddo
#ifdef diag_potential_vorticity
          write(io)  qmean(:,j,:), qvar(:,j,:), q3(:,j,:)
          write(io)  uq(:,j,:,:), vq(:,j,:,:), wq(:,j,:,:)
          write(io) uqq(:,j,:,:),vqq(:,j,:,:),wqq(:,j,:,:)
          write(io) uq3(:,j,:,:),vq3(:,j,:,:),wq3(:,j,:,:)
#endif
         enddo
        endif
        call barrier
      enddo
      if (my_pe==0) then
        close(io)
        print*,' done '
      endif
      end subroutine time_averages_restart


      subroutine time_averages
c=======================================================================
c        Hauptverteiler function fuer time averages
c=======================================================================
      use cpflame_module
      use time_averages_module
      implicit none
      integer :: i,j,k,js,je
      real :: fxa
c
c        first calculate auxilliary variables
c
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
#ifdef  remove_back_stratification
         bs(i,j,k)=b(i,j,k,tau)-b_r(k)
         ps(i,j,k)=p_full(i,j,k,tau)-p_r(k)
#else
         bs(i,j,k)=b(i,j,k,tau)
         ps(i,j,k)=p_full(i,j,k,tau)
#endif
        enddo
       enddo
      enddo
      call border_exchg3D(bs,1); call setcyclic3D(bs)
      call border_exchg3D(ps,1); call setcyclic3D(ps)
#ifdef diag_potential_vorticity
c
c       relative potential vorticity
c
      rv=0.0
      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
          rv(i,j,k)=
     &       (u(i+1,j,k,2,tau)-u(i,j,k,2,tau) )/dx*maskU(i,j,k)
     &      -(u(i,j+1,k,1,tau)-u(i,j,k,1,tau) )/dx*maskV(i,j,k)
        enddo 
       enddo 
      enddo 
      call border_exchg3D(rv,1); call setcyclic3D(rv)
c
c       Ertel potential vorticity  Q N0^2 = b_z (v_x-u_y + f) + u_z b_y - v_z b_x
c
      pv=0.
      do j=js,je 
       do k=2,km-1
        do i=2,imt-1
         fxa= (rv(i,j,k)+rv(i-1,j,k)+rv(i,j-1,k)+rv(i-1,j-1,k))/4.0
         pv(i,j,k)=(fxa+coriolis_t(j)  )*
     &    ((b(i,j,k+1,tau)-b(i,j,k,tau))/dz*maskW(i,j,k)
     &    +(b(i,j,k,tau)-b(i,j,k-1,tau))/dz*maskW(i,j,k-1))/
     &     (maskW(i,j,k)+maskW(i,j,k-1)+epsln) 
         pv(i,j,k)=-N_0**(-2)*pv(i,j,k)
        enddo 
       enddo 
      enddo 
      call border_exchg3D(pv,1); call setcyclic3D(pv)
#endif
c
c       average
c
      nitts=nitts+1      
      call time_averages_means
      call time_averages_eddy_fluxes
      call time_averages_flux_tendency
c
c        write results and restart file
c
      if (last_time_step) then
       call time_averages_restart
       call time_averages_calc
       call time_averages_write
      endif
      end subroutine time_averages


      subroutine time_averages_means
c=======================================================================
c       sum up the mean variables
c=======================================================================
      use cpflame_module
      use time_averages_module
#ifdef enable_diag_tracer
      use tracer_module
#endif
      implicit none
      integer :: i,j,k,js,je
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
         umean(i,j,k)=umean(i,j,k)+u(i,j,k,1,tau)
         vmean(i,j,k)=vmean(i,j,k)+u(i,j,k,2,tau)
         wmean(i,j,k)=wmean(i,j,k)+u(i,j,k,3,tau)
         bmean(i,j,k)=bmean(i,j,k)+bs(i,j,k)
         pmean(i,j,k)=pmean(i,j,k)+ps(i,j,k)
         uvar(i,j,k) =uvar(i,j,k) +u(i,j,k,1,tau)**2
         vvar(i,j,k) =vvar(i,j,k) +u(i,j,k,2,tau)**2
         wvar(i,j,k) =wvar(i,j,k) +u(i,j,k,3,tau)**2
         bvar(i,j,k) =bvar(i,j,k) +bs(i,j,k)**2
         b3(i,j,k)    =b3(i,j,k) +bs(i,j,k)**3
         pvar(i,j,k) =pvar(i,j,k) +ps(i,j,k)**2
         uv(i,j,k,1) =uv(i,j,k,1) +u(i  ,j,k,1,tau)*u(i,j  ,k,2,tau)
         uv(i,j,k,2) =uv(i,j,k,2) +u(i-1,j,k,1,tau)*u(i,j  ,k,2,tau)
         uv(i,j,k,3) =uv(i,j,k,3) +u(i  ,j,k,1,tau)*u(i,j-1,k,2,tau)
         uv(i,j,k,4) =uv(i,j,k,4) +u(i-1,j,k,1,tau)*u(i,j-1,k,2,tau)
#ifdef enable_diag_tracer
         tmean(i,j,k,:)=tmean(i,j,k,:)+tr(i,j,k,tau,:)
         tvar(i,j,k,:)=tvar(i,j,k,:)+tr(i,j,k,tau,:)**2
         t3(i,j,k,:)=t3(i,j,k,:)+tr(i,j,k,tau,:)**3
#endif
#ifdef diag_potential_vorticity
         qmean(i,j,k)=qmean(i,j,k)+pv(i,j,k)
         qvar(i,j,k)=qvar(i,j,k)+pv(i,j,k)**2
         q3(i,j,k)=q3(i,j,k)+pv(i,j,k)**3
#endif
        enddo
       enddo
      enddo
      end subroutine time_averages_means


      subroutine time_averages_eddy_fluxes
c=======================================================================
c       sum up the eddy and variance fluxes 
c=======================================================================
      use cpflame_module
      use time_averages_module
#ifdef enable_diag_tracer
      use tracer_module
#endif
      implicit none
      integer :: i,j,k,js,je

#ifdef diag_eddy_fluxes
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
c        buoyancy eddy fluxes
          ub(i,j,k,1) =ub(i,j,k,1) +u(i,j,k,1,tau)*bs(i  ,j,k)          
          ub(i,j,k,2) =ub(i,j,k,2) +u(i,j,k,1,tau)*bs(i+1,j,k)          
          vb(i,j,k,1) =vb(i,j,k,1) +u(i,j,k,2,tau)*bs(i,j  ,k)          
          vb(i,j,k,2) =vb(i,j,k,2) +u(i,j,k,2,tau)*bs(i,j+1,k)          
          wb(i,j,k,1) =wb(i,j,k,1) +u(i,j,k,3,tau)*bs(i,j,k  )          
          wb(i,j,k,2) =wb(i,j,k,2) +u(i,j,k,3,tau)*bs(i,j,k+1)          
c        buoyancy variance fluxes
          ubb(i,j,k,1)=ubb(i,j,k,1)+u(i,j,k,1,tau)*bs(i  ,j,k)**2
          ubb(i,j,k,2)=ubb(i,j,k,2)+u(i,j,k,1,tau)*bs(i+1,j,k)**2
          vbb(i,j,k,1)=vbb(i,j,k,1)+u(i,j,k,2,tau)*bs(i,j  ,k)**2
          vbb(i,j,k,2)=vbb(i,j,k,2)+u(i,j,k,2,tau)*bs(i,j+1,k)**2
          wbb(i,j,k,1)=wbb(i,j,k,1)+u(i,j,k,3,tau)*bs(i,j,k  )**2
          wbb(i,j,k,2)=wbb(i,j,k,2)+u(i,j,k,3,tau)*bs(i,j,k+1)**2
c        third order fluxes
          ub3(i,j,k,1)=ub3(i,j,k,1)+u(i,j,k,1,tau)*bs(i  ,j,k)**3
          ub3(i,j,k,2)=ub3(i,j,k,2)+u(i,j,k,1,tau)*bs(i+1,j,k)**3
          vb3(i,j,k,1)=vb3(i,j,k,1)+u(i,j,k,2,tau)*bs(i,j  ,k)**3
          vb3(i,j,k,2)=vb3(i,j,k,2)+u(i,j,k,2,tau)*bs(i,j+1,k)**3
          wb3(i,j,k,1)=wb3(i,j,k,1)+u(i,j,k,3,tau)*bs(i,j,k  )**3
          wb3(i,j,k,2)=wb3(i,j,k,2)+u(i,j,k,3,tau)*bs(i,j,k+1)**3
#ifdef enable_diag_tracer
c        tracer eddy fluxes
          ut(i,j,k,1,:) =ut(i,j,k,1,:) +u(i,j,k,1,tau)*tr(i  ,j,k,tau,:)          
          ut(i,j,k,2,:) =ut(i,j,k,2,:) +u(i,j,k,1,tau)*tr(i+1,j,k,tau,:)          
          vt(i,j,k,1,:) =vt(i,j,k,1,:) +u(i,j,k,2,tau)*tr(i,j  ,k,tau,:)          
          vt(i,j,k,2,:) =vt(i,j,k,2,:) +u(i,j,k,2,tau)*tr(i,j+1,k,tau,:)          
          wt(i,j,k,1,:) =wt(i,j,k,1,:)+u(i,j,k,3,tau)*tr(i,j,k  ,tau,:)          
          wt(i,j,k,2,:) =wt(i,j,k,2,:)+u(i,j,k,3,tau)*tr(i,j,k+1,tau,:)          
c        tracer variance fluxes
          utt(i,j,k,1,:)=utt(i,j,k,1,:)
     &                     +u(i,j,k,1,tau)*tr(i  ,j,k,tau,:)**2
          utt(i,j,k,2,:)=utt(i,j,k,2,:)
     &                     +u(i,j,k,1,tau)*tr(i+1,j,k,tau,:)**2
          vtt(i,j,k,1,:)=vtt(i,j,k,1,:)
     &                      +u(i,j,k,2,tau)*tr(i,j  ,k,tau,:)**2
          vtt(i,j,k,2,:)=vtt(i,j,k,2,:)
     &                      +u(i,j,k,2,tau)*tr(i,j+1,k,tau,:)**2
          wtt(i,j,k,1,:)=wtt(i,j,k,1,:)
     &                      +u(i,j,k,3,tau)*tr(i,j,k  ,tau,:)**2
          wtt(i,j,k,2,:)=wtt(i,j,k,2,:)
     &                       +u(i,j,k,3,tau)*tr(i,j,k+1,tau,:)**2
c        third order fluxes
          ut3(i,j,k,1,:)=ut3(i,j,k,1,:)
     &                     +u(i,j,k,1,tau)*tr(i  ,j,k,tau,:)**3
          ut3(i,j,k,2,:)=ut3(i,j,k,2,:)
     &                     +u(i,j,k,1,tau)*tr(i+1,j,k,tau,:)**3
          vt3(i,j,k,1,:)=vt3(i,j,k,1,:)
     &                      +u(i,j,k,2,tau)*tr(i,j  ,k,tau,:)**3
          vt3(i,j,k,2,:)=vt3(i,j,k,2,:)
     &                      +u(i,j,k,2,tau)*tr(i,j+1,k,tau,:)**3
          wt3(i,j,k,1,:)=wt3(i,j,k,1,:)
     &                      +u(i,j,k,3,tau)*tr(i,j,k  ,tau,:)**3
          wt3(i,j,k,2,:)=wt3(i,j,k,2,:)
     &                       +u(i,j,k,3,tau)*tr(i,j,k+1,tau,:)**3
#endif
#ifdef diag_potential_vorticity
c        pv eddy fluxes
          uq(i,j,k,1) =uq(i,j,k,1) +u(i,j,k,1,tau)*pv(i  ,j,k)          
          uq(i,j,k,2) =uq(i,j,k,2) +u(i,j,k,1,tau)*pv(i+1,j,k)          
          vq(i,j,k,1) =vq(i,j,k,1) +u(i,j,k,2,tau)*pv(i,j  ,k)          
          vq(i,j,k,2) =vq(i,j,k,2) +u(i,j,k,2,tau)*pv(i,j+1,k)          
          wq(i,j,k,1) =wq(i,j,k,1) +u(i,j,k,3,tau)*pv(i,j,k  )          
          wq(i,j,k,2) =wq(i,j,k,2) +u(i,j,k,3,tau)*pv(i,j,k+1)          
c        pv variance fluxes
          uqq(i,j,k,1)=uqq(i,j,k,1)+u(i,j,k,1,tau)*pv(i  ,j,k)**2
          uqq(i,j,k,2)=uqq(i,j,k,2)+u(i,j,k,1,tau)*pv(i+1,j,k)**2
          vqq(i,j,k,1)=vqq(i,j,k,1)+u(i,j,k,2,tau)*pv(i,j  ,k)**2
          vqq(i,j,k,2)=vqq(i,j,k,2)+u(i,j,k,2,tau)*pv(i,j+1,k)**2
          wqq(i,j,k,1)=wqq(i,j,k,1)+u(i,j,k,3,tau)*pv(i,j,k  )**2
          wqq(i,j,k,2)=wqq(i,j,k,2)+u(i,j,k,3,tau)*pv(i,j,k+1)**2
c        third order fluxes
          uq3(i,j,k,1)=uq3(i,j,k,1)+u(i,j,k,1,tau)*pv(i  ,j,k)**3
          uq3(i,j,k,2)=uq3(i,j,k,2)+u(i,j,k,1,tau)*pv(i+1,j,k)**3
          vq3(i,j,k,1)=vq3(i,j,k,1)+u(i,j,k,2,tau)*pv(i,j  ,k)**3
          vq3(i,j,k,2)=vq3(i,j,k,2)+u(i,j,k,2,tau)*pv(i,j+1,k)**3
          wq3(i,j,k,1)=wq3(i,j,k,1)+u(i,j,k,3,tau)*pv(i,j,k  )**3
          wq3(i,j,k,2)=wq3(i,j,k,2)+u(i,j,k,3,tau)*pv(i,j,k+1)**3
#endif
        enddo
       enddo
      enddo
#endif
      end subroutine time_averages_eddy_fluxes



      subroutine time_averages_flux_tendency
c=======================================================================
c        flux tendencies
c=======================================================================
      use cpflame_module
      use time_averages_module
      implicit none
      integer :: i,j,k,js,je
      js=max(2,js_pe); je = min(je_pe,jmt-1)

#ifdef diag_eddy_flux_tendency
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
         bpx(i,j,k,1)=bpx(i,j,k,1)+bs(i  ,j,k)*ps(i  ,j,k)
         bpx(i,j,k,2)=bpx(i,j,k,2)+bs(i+1,j,k)*ps(i  ,j,k)
         bpx(i,j,k,3)=bpx(i,j,k,3)+bs(i  ,j,k)*ps(i+1,j,k)

         bpy(i,j,k,1)=bpy(i,j,k,1)+bs(i,j  ,k)*ps(i,j  ,k)
         bpy(i,j,k,2)=bpy(i,j,k,2)+bs(i,j+1,k)*ps(i,j  ,k)
         bpy(i,j,k,3)=bpy(i,j,k,3)+bs(i,j  ,k)*ps(i,j+1,k)

         bfv(i,j,k,1)=bfv(i,j,k,1) + bs(i  ,j,k)*u(i  ,j  ,k,2,tau)
         bfv(i,j,k,2)=bfv(i,j,k,2) + bs(i+1,j,k)*u(i  ,j  ,k,2,tau)
         bfv(i,j,k,3)=bfv(i,j,k,3) + bs(i  ,j,k)*u(i+1,j  ,k,2,tau)
         bfv(i,j,k,4)=bfv(i,j,k,4) + bs(i  ,j,k)*u(i  ,j-1,k,2,tau)
         bfv(i,j,k,5)=bfv(i,j,k,5) + bs(i+1,j,k)*u(i  ,j-1,k,2,tau)
         bfv(i,j,k,6)=bfv(i,j,k,6) + bs(i  ,j,k)*u(i+1,j-1,k,2,tau)

         bfu(i,j,k,1)=bfu(i,j,k,1) + bs(i,j  ,k)*u(i  ,j  ,k,1,tau)
         bfu(i,j,k,2)=bfu(i,j,k,2) + bs(i,j+1,k)*u(i  ,j  ,k,1,tau)
         bfu(i,j,k,3)=bfu(i,j,k,3) + bs(i,j  ,k)*u(i  ,j+1,k,1,tau)
         bfu(i,j,k,4)=bfu(i,j,k,4) + bs(i,j  ,k)*u(i-1,j  ,k,1,tau)
         bfu(i,j,k,5)=bfu(i,j,k,5) + bs(i,j+1,k)*u(i-1,j  ,k,1,tau)
         bfu(i,j,k,6)=bfu(i,j,k,6) + bs(i,j  ,k)*u(i-1,j+1,k,1,tau)

         uwN(i,j,k,1)=uwN(i,j,k,1) + u(i,j,k,1,tau)*u(i  ,j,k  ,3,tau)
         uwN(i,j,k,2)=uwN(i,j,k,2) + u(i,j,k,1,tau)*u(i+1,j,k  ,3,tau)
         uwN(i,j,k,3)=uwN(i,j,k,3) + u(i,j,k,1,tau)*u(i  ,j,k-1,3,tau)
         uwN(i,j,k,4)=uwN(i,j,k,4) + u(i,j,k,1,tau)*u(i+1,j,k-1,3,tau)

         vwN(i,j,k,1)=vwN(i,j,k,1) + u(i,j,k,2,tau)*u(i,j  ,k  ,3,tau)
         vwN(i,j,k,2)=vwN(i,j,k,2) + u(i,j,k,2,tau)*u(i,j+1,k  ,3,tau)
         vwN(i,j,k,3)=vwN(i,j,k,3) + u(i,j,k,2,tau)*u(i,j  ,k-1,3,tau)
         vwN(i,j,k,4)=vwN(i,j,k,4) + u(i,j,k,2,tau)*u(i,j+1,k-1,3,tau)
        enddo
       enddo
      enddo
#endif
      end subroutine time_averages_flux_tendency



      subroutine time_averages_calc
c=======================================================================
c        calculate time mean diagnostics
c=======================================================================
      use cpflame_module
      use time_averages_module
#ifdef enable_diag_tracer
      use tracer_module
#endif
      implicit none
      integer :: i,j,k,js,je,n,m
      js=max(2,js_pe); je = min(je_pe,jmt-1)
c
c        calculate means
c
      n=max(1,nitts)
      umean=umean*maskU/n
      vmean=vmean*maskV/n
      wmean=wmean*maskW/n
      bmean=bmean*maskT/n
      pmean=pmean*maskT/n
      call border_exchg3D(bmean,1); call setcyclic3D(bmean)
      call border_exchg3D(pmean,1); call setcyclic3D(pmean)
      call border_exchg3D(umean,1); call setcyclic3D(umean)
      call border_exchg3D(vmean,1); call setcyclic3D(vmean)
      do k=1,nr_tr
       tmean(:,:,:,k)=tmean(:,:,:,k)*maskT/n
       call border_exchg3D(tmean(:,:,:,k),1)
       call setcyclic3D(tmean(:,:,:,k))
      enddo
#ifdef diag_potential_vorticity
      qmean=qmean*maskT/n
      call border_exchg3D(qmean,1); call setcyclic3D(qmean)
#endif
c
c       Variances
c
      uvar=uvar/n - umean**2
      vvar=vvar/n - vmean**2
      wvar=wvar/n - wmean**2
      bvar=bvar/n - bmean**2
      pvar=pvar/n - pmean**2
!  (b+b')(b+b')(b+b')=(b^2 + 2bb'+b'^2)(b+b')=b^3 + 2b^2b'+b'^2 b + b^2b'+2bb'^2+b'^3=b^3 + 3bb'^2+b'^3
      b3=b3/n - bmean**3-3*bmean*bvar
      do k=1,nr_tr
       tvar(:,:,:,k)=tvar(:,:,:,k)/n - tmean(:,:,:,k)**2
       t3(:,:,:,k)=t3(:,:,:,k)/n - tmean(:,:,:,k)**3
     &                               -3*tmean(:,:,:,k)*tvar(:,:,:,k)
      enddo
#ifdef diag_potential_vorticity
      qvar=qvar/n - qmean**2
      q3=q3/n - qmean**3-3*qmean*qvar
#endif

      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
         uv(i,j,k,1)=uv(i,j,k,1)/n +umean(i  ,j,k)*vmean(i,j  ,k)
         uv(i,j,k,2)=uv(i,j,k,2)/n +umean(i-1,j,k)*vmean(i,j  ,k)
         uv(i,j,k,3)=uv(i,j,k,3)/n +umean(i  ,j,k)*vmean(i,j-1,k)
         uv(i,j,k,4)=uv(i,j,k,4)/n +umean(i-1,j,k)*vmean(i,j-1,k)
         uv(i,j,k,1)=(uv(i,j,k,1)+uv(i,j,k,2)
     &               +uv(i,j,k,3)+uv(i,j,k,4))/4.0
        enddo
       enddo
      enddo

#ifdef diag_eddy_fluxes
c
c       Eddy fluxes
c
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
c       buoyancy
         ub(i,j,k,1)=ub(i,j,k,1)/n-umean(i,j,k)*bmean(i ,j,k)
         ub(i,j,k,2)=ub(i,j,k,2)/n-umean(i,j,k)*bmean(i+1,j,k)
         vb(i,j,k,1)=vb(i,j,k,1)/n-vmean(i,j,k)*bmean(i,j,k)
         vb(i,j,k,2)=vb(i,j,k,2)/n-vmean(i,j,k)*bmean(i,j+1,k)
         wb(i,j,k,1)=wb(i,j,k,1)/n-wmean(i,j,k)*bmean(i,j,k)
         wb(i,j,k,2)=wb(i,j,k,2)/n-wmean(i,j,k)*bmean(i,j,k+1)
        enddo
       enddo
      enddo

      do m=1,nr_tr
       do k=2,km-1
        do j=js,je 
         do i=2,imt-1
c       tracer
          ut(i,j,k,1,m)=ut(i,j,k,1,m)/n-umean(i,j,k)*tmean(i,j,k,m)
          ut(i,j,k,2,m)=ut(i,j,k,2,m)/n-umean(i,j,k)*tmean(i+1,j,k,m)
          vt(i,j,k,1,m)=vt(i,j,k,1,m)/n-vmean(i,j,k)*tmean(i,j,k,m)
          vt(i,j,k,2,m)=vt(i,j,k,2,m)/n-vmean(i,j,k)*tmean(i,j+1,k,m)
          wt(i,j,k,1,m)=wt(i,j,k,1,m)/n-wmean(i,j,k)*tmean(i,j,k,m)
          wt(i,j,k,2,m)=wt(i,j,k,2,m)/n-wmean(i,j,k)*tmean(i,j,k+1,m)
         enddo
        enddo
       enddo
      enddo
#ifdef diag_potential_vorticity
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
c       pv
         uq(i,j,k,1)=uq(i,j,k,1)/n-umean(i,j,k)*qmean(i ,j,k)
         uq(i,j,k,2)=uq(i,j,k,2)/n-umean(i,j,k)*qmean(i+1,j,k)
         vq(i,j,k,1)=vq(i,j,k,1)/n-vmean(i,j,k)*qmean(i,j,k)
         vq(i,j,k,2)=vq(i,j,k,2)/n-vmean(i,j,k)*qmean(i,j+1,k)
         wq(i,j,k,1)=wq(i,j,k,1)/n-wmean(i,j,k)*qmean(i,j,k)
         wq(i,j,k,2)=wq(i,j,k,2)/n-wmean(i,j,k)*qmean(i,j,k+1)
        enddo
       enddo
      enddo
#endif
c
c       Variance fluxes
c
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
c       buoyancy
         ubb(i,j,k,1)=ubb(i,j,k,1)/n-umean(i,j,k)*bmean(i,j,k)**2
     &                   -2*bmean(i  ,j,k)*ub(i,j,k,1)
         ubb(i,j,k,2)=ubb(i,j,k,2)/n-umean(i,j,k)*bmean(i+1,j,k)**2
     &                   -2*bmean(i+1,j,k)*ub(i,j,k,2)
         vbb(i,j,k,1)=vbb(i,j,k,1)/n-vmean(i,j,k)*bmean(i,j,k)**2
     &                   -2*bmean(i,j  ,k)*vb(i,j,k,1)
         vbb(i,j,k,2)=vbb(i,j,k,2)/n-vmean(i,j,k)*bmean(i,j+1,k)**2
     &                   -2*bmean(i,j+1,k)*vb(i,j,k,2)
         wbb(i,j,k,1)=wbb(i,j,k,1)/n-wmean(i,j,k)*bmean(i,j,k)**2
     &                   -2*bmean(i,j,k  )*wb(i,j,k,1)
         wbb(i,j,k,2)=wbb(i,j,k,2)/n-wmean(i,j,k)*bmean(i,j,k+1)**2
     &                   -2*bmean(i,j,k+1)*wb(i,j,k,2)
#ifdef diag_potential_vorticity
c       pv
         uqq(i,j,k,1)=uqq(i,j,k,1)/n-umean(i,j,k)*qmean(i,j,k)**2
     &                   -2*qmean(i  ,j,k)*uq(i,j,k,1)
         uqq(i,j,k,2)=uqq(i,j,k,2)/n-umean(i,j,k)*qmean(i+1,j,k)**2
     &                   -2*qmean(i+1,j,k)*uq(i,j,k,2)
         vqq(i,j,k,1)=vqq(i,j,k,1)/n-vmean(i,j,k)*qmean(i,j,k)**2
     &                   -2*qmean(i,j  ,k)*vq(i,j,k,1)
         vqq(i,j,k,2)=vqq(i,j,k,2)/n-vmean(i,j,k)*qmean(i,j+1,k)**2
     &                   -2*qmean(i,j+1,k)*vq(i,j,k,2)
         wqq(i,j,k,1)=wqq(i,j,k,1)/n-wmean(i,j,k)*qmean(i,j,k)**2
     &                   -2*qmean(i,j,k  )*wq(i,j,k,1)
         wqq(i,j,k,2)=wqq(i,j,k,2)/n-wmean(i,j,k)*qmean(i,j,k+1)**2
     &                   -2*qmean(i,j,k+1)*wq(i,j,k,2)
#endif

c       third order fluxes of buoyancy
        ub3(i,j,k,1)=ub3(i,j,k,1)/n-umean(i,j,k)*bmean(i,j,k)**3
     &           -3*bmean(i,j,k)*ubb(i,j,k,1)
     &           -3*bmean(i,j,k)**2*ub(i,j,k,1)
        ub3(i,j,k,2)=ub3(i,j,k,2)/n-umean(i,j,k)*bmean(i+1,j,k)**3
     &           -3*bmean(i+1,j,k)*ubb(i,j,k,2)
     &           -3*bmean(i+1,j,k)**2*ub(i,j,k,2)

        vb3(i,j,k,1)=vb3(i,j,k,1)/n-vmean(i,j,k)*bmean(i,j,k)**3
     &           -3*bmean(i,j,k)*vbb(i,j,k,1)
     &           -3*bmean(i,j,k)**2*vb(i,j,k,1)
        vb3(i,j,k,2)=vb3(i,j,k,2)/n-vmean(i,j,k)*bmean(i,j+1,k)**3
     &           -3*bmean(i,j+1,k)*vbb(i,j,k,2)
     &           -3*bmean(i,j+1,k)**2*vb(i,j,k,2)

        wb3(i,j,k,1)=wb3(i,j,k,1)/n-wmean(i,j,k)*bmean(i,j,k)**3
     &           -3*bmean(i,j,k)*wbb(i,j,k,1)
     &           -3*bmean(i,j,k)**2*wb(i,j,k,1)
        wb3(i,j,k,2)=wb3(i,j,k,2)/n-wmean(i,j,k)*bmean(i,j,k+1)**3
     &           -3*bmean(i,j,k+1)*wbb(i,j,k,2)
     &           -3*bmean(i,j,k+1)**2*wb(i,j,k,2)
#ifdef diag_potential_vorticity
c       third order fluxes of pv
        uq3(i,j,k,1)=uq3(i,j,k,1)/n-umean(i,j,k)*qmean(i,j,k)**3
     &           -3*qmean(i,j,k)*uqq(i,j,k,1)
     &           -3*qmean(i,j,k)**2*uq(i,j,k,1)
        uq3(i,j,k,2)=uq3(i,j,k,2)/n-umean(i,j,k)*qmean(i+1,j,k)**3
     &           -3*qmean(i+1,j,k)*uqq(i,j,k,2)
     &           -3*qmean(i+1,j,k)**2*uq(i,j,k,2)

        vq3(i,j,k,1)=vq3(i,j,k,1)/n-vmean(i,j,k)*qmean(i,j,k)**3
     &           -3*qmean(i,j,k)*vqq(i,j,k,1)
     &           -3*qmean(i,j,k)**2*vq(i,j,k,1)
        vq3(i,j,k,2)=vq3(i,j,k,2)/n-vmean(i,j,k)*qmean(i,j+1,k)**3
     &           -3*qmean(i,j+1,k)*vqq(i,j,k,2)
     &           -3*qmean(i,j+1,k)**2*vq(i,j,k,2)

        wq3(i,j,k,1)=wq3(i,j,k,1)/n-wmean(i,j,k)*qmean(i,j,k)**3
     &           -3*qmean(i,j,k)*wqq(i,j,k,1)
     &           -3*qmean(i,j,k)**2*wq(i,j,k,1)
        wq3(i,j,k,2)=wq3(i,j,k,2)/n-wmean(i,j,k)*qmean(i,j,k+1)**3
     &           -3*qmean(i,j,k+1)*wqq(i,j,k,2)
     &           -3*qmean(i,j,k+1)**2*wq(i,j,k,2)
#endif
        enddo
       enddo
      enddo

c       tracer
      do m=1,nr_tr
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
         utt(i,j,k,1,m)=utt(i,j,k,1,m)/n
     &                    -umean(i,j,k)*tmean(i,j,k,m)**2
     &                   -2*tmean(i  ,j,k,m)*ut(i,j,k,1,m)
         utt(i,j,k,2,m)=utt(i,j,k,2,m)/n
     &                    -umean(i,j,k)*tmean(i+1,j,k,m)**2
     &                   -2*tmean(i+1,j,k,m)*ut(i,j,k,2,m)
         vtt(i,j,k,1,m)=vtt(i,j,k,1,m)/n
     &                   -vmean(i,j,k)*tmean(i,j,k,m)**2
     &                   -2*tmean(i,j  ,k,m)*vt(i,j,k,1,m)
         vtt(i,j,k,2,m)=vtt(i,j,k,2,m)/n
     &                    -vmean(i,j,k)*tmean(i,j+1,k,m)**2
     &                   -2*tmean(i,j+1,k,m)*vt(i,j,k,2,m)
         wtt(i,j,k,1,m)=wtt(i,j,k,1,m)/n
     &                   -wmean(i,j,k)*tmean(i,j,k,m)**2
     &                   -2*tmean(i,j,k  ,m)*wt(i,j,k,1,m)
         wtt(i,j,k,2,m)=wtt(i,j,k,2,m)/n
     &                    -wmean(i,j,k)*tmean(i,j,k+1,m)**2
     &                   -2*tmean(i,j,k+1,m)*wt(i,j,k,2,m)
c       third order fluxes of tracer
        ut3(i,j,k,1,m)=ut3(i,j,k,1,m)/n-umean(i,j,k)*tmean(i,j,k,m)**3
     &           -3*tmean(i,j,k,m)*utt(i,j,k,1,m)
     &           -3*tmean(i,j,k,m)**2*ut(i,j,k,1,m)
        ut3(i,j,k,2,m)=ut3(i,j,k,2,m)/n-umean(i,j,k)*tmean(i+1,j,k,m)**3
     &           -3*tmean(i+1,j,k,m)*utt(i,j,k,2,m)
     &           -3*tmean(i+1,j,k,m)**2*ut(i,j,k,2,m)

        vt3(i,j,k,1,m)=vt3(i,j,k,1,m)/n-vmean(i,j,k)*tmean(i,j,k,m)**3
     &           -3*tmean(i,j,k,m)*vtt(i,j,k,1,m)
     &           -3*tmean(i,j,k,m)**2*vt(i,j,k,1,m)
        vt3(i,j,k,2,m)=vt3(i,j,k,2,m)/n-vmean(i,j,k)*tmean(i,j+1,k,m)**3
     &           -3*tmean(i,j+1,k,m)*vtt(i,j,k,2,m)
     &           -3*tmean(i,j+1,k,m)**2*vt(i,j,k,2,m)

        wt3(i,j,k,1,m)=wt3(i,j,k,1,m)/n-wmean(i,j,k)*tmean(i,j,k,m)**3
     &           -3*tmean(i,j,k,m)*wtt(i,j,k,1,m)
     &           -3*tmean(i,j,k,m)**2*wt(i,j,k,1,m)
        wt3(i,j,k,2,m)=wt3(i,j,k,2,m)/n-wmean(i,j,k)*tmean(i,j,k+1,m)**3
     &           -3*tmean(i,j,k+1,m)*wtt(i,j,k,2,m)
     &           -3*tmean(i,j,k+1,m)**2*wt(i,j,k,2,m)
        enddo
       enddo
      enddo
      enddo

      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
         ub(i,j,k,1)=0.5*(ub(i,j,k,1)+ub(i,j,k,2))
         vb(i,j,k,1)=0.5*(vb(i,j,k,1)+vb(i,j,k,2))
         wb(i,j,k,1)=0.5*(wb(i,j,k,1)+wb(i,j,k,2))
         ubb(i,j,k,1)=0.5*(ubb(i,j,k,1)+ubb(i,j,k,2))/2.0
         vbb(i,j,k,1)=0.5*(vbb(i,j,k,1)+vbb(i,j,k,2))/2.0
         wbb(i,j,k,1)=0.5*(wbb(i,j,k,1)+wbb(i,j,k,2))/2.0
         ub3(i,j,k,1)=0.5*(ub3(i,j,k,1)+ub3(i,j,k,2))/3.0
         vb3(i,j,k,1)=0.5*(vb3(i,j,k,1)+vb3(i,j,k,2))/3.0
         wb3(i,j,k,1)=0.5*(wb3(i,j,k,1)+wb3(i,j,k,2))/3.0
#ifdef diag_potential_vorticity
         uq(i,j,k,1)=0.5*(uq(i,j,k,1)+uq(i,j,k,2))
         vq(i,j,k,1)=0.5*(vq(i,j,k,1)+vq(i,j,k,2))
         wq(i,j,k,1)=0.5*(wq(i,j,k,1)+wq(i,j,k,2))
         uqq(i,j,k,1)=0.5*(uqq(i,j,k,1)+uqq(i,j,k,2))/2.0
         vqq(i,j,k,1)=0.5*(vqq(i,j,k,1)+vqq(i,j,k,2))/2.0
         wqq(i,j,k,1)=0.5*(wqq(i,j,k,1)+wqq(i,j,k,2))/2.0
         uq3(i,j,k,1)=0.5*(uq3(i,j,k,1)+uq3(i,j,k,2))/3.0
         vq3(i,j,k,1)=0.5*(vq3(i,j,k,1)+vq3(i,j,k,2))/3.0
         wq3(i,j,k,1)=0.5*(wq3(i,j,k,1)+wq3(i,j,k,2))/3.0
#endif
        enddo
       enddo
      enddo

      do m=1,nr_tr
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
         ut(i,j,k,1,m)=0.5*(ut(i,j,k,1,m) +ut(i,j,k,2,m))
         vt(i,j,k,1,m)=0.5*(vt(i,j,k,1,m) +vt(i,j,k,2,m))
         wt(i,j,k,1,m)=0.5*(wt(i,j,k,1,m)+wt(i,j,k,2,m))

         utt(i,j,k,1,m)=0.5*(utt(i,j,k,1,m) +utt(i,j,k,2,m))/2.0
         vtt(i,j,k,1,m)=0.5*(vtt(i,j,k,1,m) +vtt(i,j,k,2,m))/2.0
         wtt(i,j,k,1,m)=0.5*(wtt(i,j,k,1,m)+wtt(i,j,k,2,m))/2.0

         ut3(i,j,k,1,m)=0.5*(ut3(i,j,k,1,m) +ut3(i,j,k,2,m))/2.0
         vt3(i,j,k,1,m)=0.5*(vt3(i,j,k,1,m) +vt3(i,j,k,2,m))/2.0
         wt3(i,j,k,1,m)=0.5*(wt3(i,j,k,1,m)+wt3(i,j,k,2,m))/2.0
        enddo
       enddo
      enddo
      enddo
#endif

#ifdef diag_eddy_flux_tendency
c
c       flux tendencies :  geostrophic terms
c
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
          bpx(i,j,k,1)=bpx(i,j,k,1)/n-bmean(i  ,j,k)*pmean(i  ,j,k)
          bpx(i,j,k,2)=bpx(i,j,k,2)/n-bmean(i+1,j,k)*pmean(i  ,j,k)
          bpx(i,j,k,3)=bpx(i,j,k,3)/n-bmean(i  ,j,k)*pmean(i+1,j,k)

          bpy(i,j,k,1)=bpy(i,j,k,1)/n-bmean(i,j  ,k)*pmean(i,j  ,k)
          bpy(i,j,k,2)=bpy(i,j,k,2)/n-bmean(i,j+1,k)*pmean(i,j  ,k)
          bpy(i,j,k,3)=bpy(i,j,k,3)/n-bmean(i,j  ,k)*pmean(i,j+1,k)

          bfv(i,j,k,1)=bfv(i,j,k,1)/n-bmean(i  ,j,k)*vmean(i  ,j  ,k)
          bfv(i,j,k,2)=bfv(i,j,k,2)/n-bmean(i+1,j,k)*vmean(i  ,j  ,k)
          bfv(i,j,k,3)=bfv(i,j,k,3)/n-bmean(i  ,j,k)*vmean(i+1,j  ,k)
          bfv(i,j,k,4)=bfv(i,j,k,4)/n-bmean(i  ,j,k)*vmean(i  ,j-1,k)
          bfv(i,j,k,5)=bfv(i,j,k,5)/n-bmean(i+1,j,k)*vmean(i  ,j-1,k)
          bfv(i,j,k,6)=bfv(i,j,k,6)/n-bmean(i  ,j,k)*vmean(i+1,j-1,k)

          bfu(i,j,k,1)=bfu(i,j,k,1)/n-bmean(i,j  ,k)*umean(i  ,j  ,k)
          bfu(i,j,k,2)=bfu(i,j,k,2)/n-bmean(i,j+1,k)*umean(i  ,j  ,k)
          bfu(i,j,k,3)=bfu(i,j,k,3)/n-bmean(i,j  ,k)*umean(i  ,j+1,k)
          bfu(i,j,k,4)=bfu(i,j,k,4)/n-bmean(i,j  ,k)*umean(i-1,j  ,k)
          bfu(i,j,k,5)=bfu(i,j,k,5)/n-bmean(i,j+1,k)*umean(i-1,j  ,k)
          bfu(i,j,k,6)=bfu(i,j,k,6)/n-bmean(i,j  ,k)*umean(i-1,j+1,k)
        enddo
       enddo
      enddo
      call border_exchg3D(bpx(:,:,:,1),1)
      call setcyclic3D(bpx(:,:,:,1))
      call border_exchg3D(bpy(:,:,:,1),1)
      call setcyclic3D(bpy(:,:,:,1))
      call border_exchg3D(bfv(:,:,:,1),1)
      call setcyclic3D(bfv(:,:,:,1))
      call border_exchg3D(bfv(:,:,:,4),1)
      call setcyclic3D(bfv(:,:,:,4))
      call border_exchg3D(bfu(:,:,:,1),1)
      call setcyclic3D(bfu(:,:,:,1))
      call border_exchg3D(bfu(:,:,:,4),1)
      call setcyclic3D(bfu(:,:,:,4))

      ugeo1=0;ugeo2=0; vgeo1=0;vgeo2=0
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
         ugeo1(i,j,k)=-(bpx(i+1,j,k,1)-bpx(i,j,k,2)
     &                 +bpx(i,j,k,3)-bpx(i,j,k,1))/(2*dx)
         vgeo1(i,j,k)=-(bpy(i,j+1,k,1)-bpy(i,j,k,2)
     &                 +bpy(i,j,k,3)-bpy(i,j,k,1))/(2*dx)
         ugeo2(i,j,k)=(bfv(i,j,k,1)+bfv(i,j,k,2)
     &                +bfv(i,j,k,3)+bfv(i+1,j,k,1) 
     &                +bfv(i,j,k,4)+bfv(i,j,k,5)
     &                +bfv(i,j,k,6)+bfv(i+1,j,k,4) )/8.*coriolis_t(j)
         vgeo2(i,j,k)=-(bfu(i,j,k,1)+bfu(i,j,k,2)
     &                 +bfu(i,j,k,4)+bfu(i,j,k,5) )/8.*coriolis_t(j)
     &                -(bfu(i,j+1,k,1)+bfu(i,j+1,k,4)
     &                 +bfu(i,j,k,6)+bfu(i,j,k,3))/8.*coriolis_t(j+1)
        enddo
       enddo
      enddo
c
c       flux tendencies:   vertical advection
c
      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
          uwN(i,j,k,1)=uwN(i,j,k,1)/n-umean(i,j,k)*wmean(i  ,j,k)
          uwN(i,j,k,2)=uwN(i,j,k,2)/n-umean(i,j,k)*wmean(i+1,j,k)
          uwN(i,j,k,3)=uwN(i,j,k,3)/n-umean(i,j,k)*wmean(i  ,j,k-1)
          uwN(i,j,k,4)=uwN(i,j,k,4)/n-umean(i,j,k)*wmean(i+1,j,k-1)
          vwN(i,j,k,1)=vwN(i,j,k,1)/n-vmean(i,j,k)*wmean(i,j  ,k)
          vwN(i,j,k,2)=vwN(i,j,k,2)/n-vmean(i,j,k)*wmean(i,j+1,k)
          vwN(i,j,k,3)=vwN(i,j,k,3)/n-vmean(i,j,k)*wmean(i,j  ,k-1)
          vwN(i,j,k,4)=vwN(i,j,k,4)/n-vmean(i,j,k)*wmean(i,j+1,k-1)
        enddo
       enddo
      enddo

      do k=2,km-1
       do j=js,je 
        do i=2,imt-1
          uwN(i,j,k,1)=
     &        uwN(i,j,k,1)*(bmean(i,j,k+1)+bmean(i,j,k))/(4*dz)
     &       +uwN(i,j,k,2)*(bmean(i+1,j,k+1)+bmean(i+1,j,k))/(4*dz)
     &       -uwN(i,j,k,3)*(bmean(i,j,k)+bmean(i,j,k-1))/(4*dz)
     &       -uwN(i,j,k,4)*(bmean(i+1,j,k)+bmean(i+1,j,k-1))/(4*dz)
#ifdef  remove_back_stratification
     &       +uwN(i,j,k,1)*(b_r(k+1)+b_r(k))/(4*dz)
     &       +uwN(i,j,k,2)*(b_r(k+1)+b_r(k))/(4*dz)
     &       -uwN(i,j,k,3)*(b_r(k)+b_r(k-1))/(4*dz)
     &       -uwN(i,j,k,4)*(b_r(k)+b_r(k-1))/(4*dz)
#endif
          vwN(i,j,k,1)=
     &        vwN(i,j,k,1)*(bmean(i,j,k+1)+bmean(i,j,k))/(4*dz)
     &       +vwN(i,j,k,2)*(bmean(i,j+1,k+1)+bmean(i,j+1,k))/(4*dz)
     &       -vwN(i,j,k,3)*(bmean(i,j,k)+bmean(i,j,k-1))/(4*dz)
     &       -vwN(i,j,k,4)*(bmean(i,j+1,k)+bmean(i,j+1,k-1))/(4*dz)
#ifdef  remove_back_stratification
     &       +vwN(i,j,k,1)*(b_r(k+1)+b_r(k))/(4*dz)
     &       +vwN(i,j,k,2)*(b_r(k+1)+b_r(k))/(4*dz)
     &       -vwN(i,j,k,3)*(b_r(k)+b_r(k-1))/(4*dz)
     &       -vwN(i,j,k,4)*(b_r(k)+b_r(k-1))/(4*dz)
#endif
        enddo
       enddo
      enddo
#endif
c
c       apply  land mask
c
      where (maskU==0) 
        umean=spval; uvar=spval
      end where
      where (maskV==0) 
        vmean=spval; wvar=spval
      end where
      where (maskW==0) 
        wmean=spval; wvar=spval
      end where
      where (maskT==0) 
       bmean=spval;pmean=spval;b3=spval
       bvar=spval;pvar=spval; uv(:,:,:,1)=spval
      end where
#ifdef diag_eddy_fluxes
      where (maskU==0) 
        ub(:,:,:,1)=spval; ubb(:,:,:,1)=spval;ub3(:,:,:,1)=spval
      end where
      where (maskV==0) 
        vb(:,:,:,1)=spval; vbb(:,:,:,1)=spval;vb3(:,:,:,1)=spval
      end where
      where (maskW==0) 
        wb(:,:,:,1)=spval; wbb(:,:,:,1)=spval;wb3(:,:,:,1)=spval
      end where
#endif
#ifdef diag_potential_vorticity
      where (maskT==0) 
       qmean=spval;q3=spval; qvar=spval;
      end where
      where (maskU==0) 
        uq(:,:,:,1)=spval; uqq(:,:,:,1)=spval;uq3(:,:,:,1)=spval
      end where
      where (maskV==0) 
        vq(:,:,:,1)=spval; vqq(:,:,:,1)=spval;vq3(:,:,:,1)=spval
      end where
      where (maskW==0) 
        wq(:,:,:,1)=spval; wqq(:,:,:,1)=spval;wq3(:,:,:,1)=spval
      end where
#endif

#ifdef diag_eddy_flux_tendency
      where (maskU==0) 
        ugeo1=spval; ugeo2=spval; uwN(:,:,:,1)=spval
      end where
      where (maskV==0) 
        vgeo1=spval; vgeo2=spval; vwN(:,:,:,1)=spval
      end where
#endif
      do k=1,nr_tr
       where (maskT==0) 
        tmean(:,:,:,k)=spval;tvar(:,:,:,k)=spval;t3(:,:,:,k)=spval
       end where
#ifdef diag_eddy_fluxes
       where (maskU==0) 
         ut(:,:,:,1,k)=spval; utt(:,:,:,1,k)=spval;ut3(:,:,:,1,k)=spval
       end where
       where (maskV==0) 
         vt(:,:,:,1,k)=spval; vtt(:,:,:,1,k)=spval;vt3(:,:,:,1,k)=spval
       end where
       where (maskW==0) 
         wt(:,:,:,1,k)=spval; wtt(:,:,:,1,k)=spval;wt3(:,:,:,1,k)=spval
       end where
#endif
      enddo
      end subroutine time_averages_calc



      subroutine time_averages_write
c=======================================================================
c        write time mean diagnostics
c=======================================================================
      use cpflame_module
      use time_averages_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      integer :: tdim,ilen,timeid,varid,dims(4)
      integer :: xtdim,xudim,ytdim,yudim,ztdim,zudim
      real :: fxa
      type(time_type) :: time
      character :: name*64, unit*32
c
c        define netcdf file
c
      if (my_pe==0) then 
       print*,' writing time averages to file time_ave.cdf'
       call def_grid_cdf('time_ave.cdf')
       iret=nf_open('time_ave.cdf',NF_WRITE,ncid)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       call ncredf(ncid, iret)
       iret=nf_inq_dimid(ncid,'xt',xtdim)
       iret=nf_inq_dimid(ncid,'xu',xudim)
       iret=nf_inq_dimid(ncid,'yt',ytdim)
       iret=nf_inq_dimid(ncid,'yu',yudim)
       iret=nf_inq_dimid(ncid,'zt',ztdim)
       iret=nf_inq_dimid(ncid,'zu',zudim)
       iret=nf_inq_dimid(ncid,'Time',tdim)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'um', NCFLOAT,4,dims,iret)
       name='Mean zonal velocity'; unit = 'm/s'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vm', NCFLOAT,4,dims,iret)
       name='Mean meridional velocity'; unit = 'm/s'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wm', NCFLOAT,4,dims,iret)
       name='Mean vertical velocity'; unit = 'm/s'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'bm', NCFLOAT,4,dims,iret)
       name='Mean buoyancy'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'pm', NCFLOAT,4,dims,iret)
       name='Mean pressure'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uu', NCFLOAT,4,dims,iret)
       name='Zonal velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vv', NCFLOAT,4,dims,iret)
       name='Meridional velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uv', NCFLOAT,4,dims,iret)
       name='Cross velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'ww', NCFLOAT,4,dims,iret)
       name='Vertical velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'bb', NCFLOAT,4,dims,iret)
       name='Buoyancy variance'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'b3', NCFLOAT,4,dims,iret)
       name='3. moment buoyancy'; unit = 'm^3/s^6'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'pp', NCFLOAT,4,dims,iret)
       name='Pressure variance'; unit = 'm^4/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

#ifdef diag_eddy_fluxes
       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ub', NCFLOAT,4,dims,iret)
       name='Zonal eddy buoyancy flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vb', NCFLOAT,4,dims,iret)
       name='Meridional eddy buoyancy flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wb', NCFLOAT,4,dims,iret)
       name='Vertical eddy buoyancy flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ubb', NCFLOAT,4,dims,iret)
       name='Zonal buoyancy variance flux'; unit = 'm^3/s^5'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vbb', NCFLOAT,4,dims,iret)
       name='Meridional buoyancy variance flux'; unit = 'm^3/s^5'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wbb', NCFLOAT,4,dims,iret)
       name='Vertical buoyancy variance flux'; unit = 'm^3/s^5'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ub3', NCFLOAT,4,dims,iret)
       name='Zonal buoyancy 3.order flux'; unit = 'm^4/s^7'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vb3', NCFLOAT,4,dims,iret)
       name='Meridional buoyancy 3. order flux'; unit = 'm^4/s^7'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wb3', NCFLOAT,4,dims,iret)
       name='Vertical buoyancy 3. order flux'; unit = 'm^4/s^7'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

#endif

#ifdef diag_eddy_flux_tendency
       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ugeo1', NCFLOAT,4,dims,iret)
       name='Geostr. flux tendency 1'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'ugeo2', NCFLOAT,4,dims,iret)
       name='Geostr. flux tendency 2'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vgeo1', NCFLOAT,4,dims,iret)
       name='Geostr. flux tendency 1'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vgeo2', NCFLOAT,4,dims,iret)
       name='Geostr. flux tendency 2'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uwN', NCFLOAT,4,dims,iret)
       name='Vertical flux tendency'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vwN', NCFLOAT,4,dims,iret)
       name='Vertical flux tendency'; unit = 'm^2/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)
#endif

#ifdef  remove_back_stratification
       varid = ncvdef (ncid,'b_r', NCFLOAT,1,ztdim,iret)
       name = 'Reference buoyancy profile'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)
#endif
       do n=1,nr_tr
        dims = (/xtdim, ytdim,ztdim, tdim/)
        write(name, '("trm",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name = 'Mean tracer'; unit = ' '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        write(name, '("trvar",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name = 'Tracer variance'; unit = ' '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        write(name, '("tr3",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name = '3. moment tracer'; unit = ' '
        call dvcdf(ncid,varid,name,64,unit,32,spval)
#ifdef diag_eddy_fluxes
        dims = (/xudim, ytdim,ztdim, tdim/)
        write(name, '("utr",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Zonal eddy tracer flux'; unit = 'm/s '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, yudim,ztdim, tdim/)
        write(name, '("vtr",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Meridional eddy tracer flux'; unit = 'm/s '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, ytdim,zudim, tdim/)
        write(name, '("wtr",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Vertical eddy tracer flux'; unit = 'm/s '
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xudim, ytdim,ztdim, tdim/)
        write(name, '("utrvar",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Zonal tracer variance flux'; unit = ' m/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, yudim,ztdim, tdim/)
        write(name, '("vtrvar",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Meridional tracer variance flux'; unit = 'm/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, ytdim,zudim, tdim/)
        write(name, '("wtrvar",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Vertical tracer variance flux'; unit = 'm/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xudim, ytdim,ztdim, tdim/)
        write(name, '("ut3_",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Zonal tracer  3.order flux'; unit = ' m/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, yudim,ztdim, tdim/)
        write(name, '("vt3_",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Meridional tracer 3.order flux'; unit = 'm/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

        dims = (/xtdim, ytdim,zudim, tdim/)
        write(name, '("wt3_",i2)') n; call replace_space_zero(name)
        varid = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
        name='Vertical tracer 3.order flux'; unit = 'm/s'
        call dvcdf(ncid,varid,name,64,unit,32,spval)

#endif
       enddo
#ifdef diag_potential_vorticity
       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'qm', NCFLOAT,4,dims,iret)
       name='Ertel PV'; unit = '1/s'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'qq', NCFLOAT,4,dims,iret)
       name='PV variance'; unit = '1/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'q3', NCFLOAT,4,dims,iret)
       name='3. moment pv'; unit = '1/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uq', NCFLOAT,4,dims,iret)
       name='Zonal eddy pv flux'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vq', NCFLOAT,4,dims,iret)
       name='Meridional eddy pv flux'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wq', NCFLOAT,4,dims,iret)
       name='Vertical eddy pv flux'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uqq', NCFLOAT,4,dims,iret)
       name='Zonal pv variance flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vqq', NCFLOAT,4,dims,iret)
       name='Meridional pv variance flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wqq', NCFLOAT,4,dims,iret)
       name='Vertical pv variance flux'; unit = 'm^2/s^3'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xudim, ytdim,ztdim, tdim/)
       varid = ncvdef (ncid,'uq3', NCFLOAT,4,dims,iret)
       name='Zonal pv 3.order flux'; unit = 'm^3/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, yudim,ztdim, tdim/)
       varid = ncvdef (ncid,'vq3', NCFLOAT,4,dims,iret)
       name='Meridional pv 3. order flux'; unit = 'm^3/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)

       dims = (/xtdim, ytdim,zudim, tdim/)
       varid = ncvdef (ncid,'wq3', NCFLOAT,4,dims,iret)
       name='Vertical pv 3. order flux'; unit = 'm^3/s^4'
       call dvcdf(ncid,varid,name,64,unit,32,spval)
#endif

       iret= nf_put_att_int(ncid,nf_global,'nitts',nf_int,1,nitts)
       call ncendf(ncid, iret)
#ifdef  remove_back_stratification
       iret=nf_inq_varid(ncid,'b_r',varid)
       iret= nf_put_vara_double(ncid,varid,1,km,b_r)
#endif
       call ncclos (ncid, iret)
      endif ! my_pe ==0
c-----------------------------------------------------------------------
c      write to netcdf file
c-----------------------------------------------------------------------
      do npe=0,n_pes
       if (my_pe==npe) then

         iret=nf_open('time_ave.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)

         iret=nf_inq_dimid(ncid,'Time',tdim)
         iret=nf_inq_dimlen(ncid,tdim,ilen)
         iret=nf_inq_varid(ncid,'Time',timeid)
         if (my_pe==0) then
          ilen=ilen+1
          time = current_time-initial_time
          fxa = time%days + time%seconds/86400.
          iret= nf_put_vara_double(ncid,timeid,ilen,1,fxa)
         endif

         Corner = (/1,js_pe,1,ilen/); 
         edges  = (/imt,je_pe-js_pe+1,km,1/)
         iret=nf_inq_varid(ncid,'um',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          umean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vmean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'wm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wmean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          bmean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'pm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          pmean(:,js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'uu',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          uvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vv',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'uv',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          uv(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'ww',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'bb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          bvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'b3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          b3(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'pp',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          pvar(:,js_pe:je_pe,:))

#ifdef diag_eddy_fluxes
         iret=nf_inq_varid(ncid,'ub',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          ub(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vb(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wb(:,js_pe:je_pe,:,1))

         iret=nf_inq_varid(ncid,'ubb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          ubb(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vbb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vbb(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wbb',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wbb(:,js_pe:je_pe,:,1))

         iret=nf_inq_varid(ncid,'ub3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          ub3(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vb3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vb3(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wb3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wb3(:,js_pe:je_pe,:,1))
#endif

#ifdef diag_eddy_flux_tendency
         iret=nf_inq_varid(ncid,'ugeo1',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          ugeo1(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'ugeo2',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          ugeo2(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vgeo1',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vgeo1(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'vgeo2',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vgeo2(:,js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'uwN',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          uwN(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vwN',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vwN(:,js_pe:je_pe,:,1))
#endif
        do n=1,nr_tr
         write(name, '("trm",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          tmean(:,js_pe:je_pe,:,n))

         write(name, '("trvar",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          tvar(:,js_pe:je_pe,:,n))

         write(name, '("tr3",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          t3(:,js_pe:je_pe,:,n))
#ifdef diag_eddy_fluxes
          write(name, '("utr",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          ut(:,js_pe:je_pe,:,1,n))
          write(name, '("vtr",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vt(:,js_pe:je_pe,:,1,n))
          write(name, '("wtr",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wt(:,js_pe:je_pe,:,1,n))

          write(name, '("utrvar",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          utt(:,js_pe:je_pe,:,1,n))
          write(name, '("vtrvar",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vtt(:,js_pe:je_pe,:,1,n))
          write(name, '("wtrvar",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wtt(:,js_pe:je_pe,:,1,n))

          write(name, '("ut3_",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          ut3(:,js_pe:je_pe,:,1,n))
          write(name, '("vt3_",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vt3(:,js_pe:je_pe,:,1,n))
          write(name, '("wt3_",i2)') n; call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,varid)
          iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wt3(:,js_pe:je_pe,:,1,n))

#endif
         enddo
#ifdef diag_potential_vorticity
         iret=nf_inq_varid(ncid,'qm',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          qmean(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'qq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          qvar(:,js_pe:je_pe,:))
         iret=nf_inq_varid(ncid,'q3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          q3(:,js_pe:je_pe,:))

         iret=nf_inq_varid(ncid,'uq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          uq(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vq(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wq(:,js_pe:je_pe,:,1))

         iret=nf_inq_varid(ncid,'uqq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          uqq(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vqq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vqq(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wqq',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wqq(:,js_pe:je_pe,:,1))

         iret=nf_inq_varid(ncid,'uq3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          uq3(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'vq3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          vq3(:,js_pe:je_pe,:,1))
         iret=nf_inq_varid(ncid,'wq3',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges, 
     &          wq3(:,js_pe:je_pe,:,1))
#endif
         call ncclos (ncid, iret)
       endif
       call barrier
      enddo
      end subroutine time_averages_write

#else
      subroutine time_averages_dummy
      end
#endif

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      two-dimensional channel with restoring zones at side walls
c=======================================================================

      subroutine set_parameter
      use cpflame_module
      implicit none
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=3;km=20;jmt=30
      dx=1./3.*degtom*cos(30./180.*pi)
      dz=100.0
      dt_in=2400.0
      K_h=000.0
      K_v=0.0e-4
      A_h=0000.0
      A_v=2.e-4
      Ahbi = 5e11
      cdbot=5e-5
      cdint=1e-7
      eps2D_sor = 1e-6
      runlen=4*30.0
      snap_int = 3.0

      enable_noslip              = .true.
      enable_cyclic_x            = .true.
      enable_quicker_advection   = .true.
      enable_bottom_stress       = .false.
      enable_interior_stress     = .true.
      enable_biharmonic_friction = .true.
      gamma=0.01
      lat_ref=30.0
      beta    = 2*omega*cos(lat_ref/180.*pi)/radius
      N_0 = 0.004
      M_0 = sqrt(1e-5*0.2/rho_0*g)
      end subroutine set_parameter


      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: B0,x,y
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt
         x=float(i)/float(imt)
         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
         B0=M_0**2*yt(j)+1e-6*sin(x*2.5*pi)*cos(y*4*pi)
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je, spg_width = 3
      real :: T_rest=1./(5.*86400),B0

c ----------------------------------
c      add here restoring zones
c ----------------------------------
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      if (my_blk_j==1) then
       do k=1,km
        do j=2,spg_width+1
         B0= yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt* 
     &             t_rest/(j-1.)*(B0-b(:,j,k,taum1))
        enddo
       enddo
      endif
      if (my_blk_j==n_pes_j) then
       do k=1,km
        do j=jmt-1,jmt-spg_width,-1
         B0= yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt* 
     &             t_rest/(-1.*(j-jmt))*(B0-b(:,j,k,taum1))
        enddo
       enddo
      endif
      end subroutine restoring_zones



      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c      Boundary conditions and PE exchange
c=======================================================================

      subroutine setcyclic3D(p1)
c--------------------------------------------------------------
c       set cyclic boundary conditions for 3D array
c--------------------------------------------------------------
      use cpflame_module
      implicit none
      real :: p1(imt,jmt,km)
      integer :: j
#ifndef no_mpp
#include "../mpp/sub_mpif.h"
      integer  :: tag=0, ier, Sta(MPI_STATUS_SIZE),len
#endif

      if (enable_cyclic_x) then
        do j=max(1,js_pe-1),min(jmt,je_pe+1)
          p1(1  ,j,:)=p1(imt-1,j,:); 
          p1(imt,j,:)=p1(2    ,j,:)
         enddo
      endif
      if (enable_cyclic_y) then
#ifndef no_mpp
       if ( n_pes_j > 1) then
        len=imt*km
        call mpi_barrier(my_comm,ier)
        if (my_pe ==0 ) then
         call mpi_send(p1(:,2,:),len,impireal,n_pes-1,tag,my_comm,ier)
         call mpi_recv(p1(:,1,:),len,impireal,
     &                 n_pes-1,tag,my_comm,Sta,ier)
        endif
        if (my_pe == n_pes-1) then 
         call mpi_recv(p1(:,jmt,:),len,impireal,0,tag,my_comm,Sta,ier)
         call mpi_send(p1(:,jmt-1,:),len,impireal,0,tag,my_comm,ier)
        endif
        call mpi_barrier(my_comm,ier)
       else
#endif
        p1(:,1  ,:)=p1(:,jmt-1,:); 
        p1(:,jmt,:)=p1(:,2    ,:)
#ifndef no_mpp
       endif
#endif
      endif
      end subroutine setcyclic3D




      subroutine setcyclic3D_j2(p1)
c--------------------------------------------------------------
c       set cyclic boundary conditions for 3D array
c       communicate 2 rows in meridional direction
c       needed for higher order advection schemes
c--------------------------------------------------------------
      use cpflame_module
      implicit none
      real :: p1(imt,jmt,km)
      integer :: j
#ifndef no_mpp
#include "../mpp/sub_mpif.h"
      integer  :: tag=0, ier, Sta(MPI_STATUS_SIZE),len
#endif

#ifndef no_mpp
      if (enable_cyclic_y .and. n_pes_j > 1) then
        len=imt*km
        call mpi_barrier(my_comm,ier)
        if (my_pe ==0 ) then 
         call mpi_send(p1(:,3,:),len,impireal,n_pes-1,tag,my_comm,ier)
         call mpi_recv(p1(:,jmt-2,:),len,impireal,
     &                 n_pes-1,tag,my_comm,Sta,ier)
        endif
        if (my_pe == n_pes-1) then 
         call mpi_recv(p1(:,3,:),len,impireal,0,tag,my_comm,Sta,ier)
         call mpi_send(p1(:,jmt-2,:),len,impireal,0,tag,my_comm,ier)
        endif
        call mpi_barrier(my_comm,ier)
      endif
#endif
      end subroutine setcyclic3D_j2



      subroutine setcyclic2D(p1)
c--------------------------------------------------------------
c       set cyclic boundary conditions for 2D array
c--------------------------------------------------------------
      use cpflame_module
      implicit none
      real :: p1(imt,jmt)
      integer :: j
#ifndef no_mpp
#include "../mpp/sub_mpif.h"
      integer  :: tag=0, ier, Sta(MPI_STATUS_SIZE)
#endif

      if (enable_cyclic_x) then
        do j=max(1,js_pe-1),min(jmt,je_pe+1)
         p1(1  ,j)=p1(imt-1,j); 
         p1(imt,j)=p1(2    ,j)
        enddo
      endif
      if (enable_cyclic_y) then
#ifndef no_mpp
       if ( n_pes_j > 1) then
        call mpi_barrier(my_comm,ier)
        if (my_pe ==0 ) then
         call mpi_send(p1(:,2),imt,impireal,n_pes-1,tag,my_comm,ier)
         call mpi_recv(p1(:,1),imt,impireal,n_pes-1,tag,my_comm,Sta,ier)
        endif
        if (my_pe == n_pes-1) then 
         call mpi_recv(p1(:,jmt),imt,impireal,0,tag,my_comm,Sta,ier)
         call mpi_send(p1(:,jmt-1),imt,impireal,0,tag,my_comm,ier)
        endif
        call mpi_barrier(my_comm,ier)
       else
#endif
        p1(:,1  )=p1(:,jmt-1); 
        p1(:,jmt)=p1(:,2    )
#ifndef no_mpp
       endif
#endif
      endif
      end subroutine setcyclic2D


      subroutine border_exchg3D(a,jx)
c--------------------------------------------------------------
c     Exchange overlapping areas of 3D array a in all PEs of sub 
c     domain. Number of overlapping indicees are given by jx.
c--------------------------------------------------------------
      use cpflame_module
      implicit none
      integer :: jx
      real  :: a(imt,jmt,km)
#ifndef no_mpp
#include "../mpp/sub_mpif.h"
      
      integer  ::  j, tag, ierr,len
      integer,dimension(MPI_STATUS_SIZE)  :: Status
c
      tag  = 0; len=imt*km
      call mpi_barrier(my_comm,ierr)
      if ( n_pes_j > 1) then
c    Austausch von Norden nach Sueden
        if (my_blk_j /=1 ) then
         do j=2*jx-1,jx,-1
          call mpi_send(a(:,js_pe+j-jx,:),len,impireal,my_pe-1,
     &                  tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /= n_pes_j) then 
         do j=0,jx-1
          call mpi_recv(a(:,je_pe+jx-j,:),len,
     &        impireal,my_pe+1,tag,my_comm,Status,ierr)
         enddo
       endif
c     Austausch von Sueden nach Norden
       if (my_blk_j /= n_pes_j) then 
         do j=jx,2*jx-1
         call mpi_send(a(:,je_pe+jx-j,:),len,impireal,my_pe+1,
     &                tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /=1 ) then
         do j=jx-1,0,-1
          call mpi_recv(a(:,js_pe-jx+j,:),len,
     &        impireal,my_pe-1,tag,my_comm,Status,ierr)
         enddo
        endif
      endif
      call mpi_barrier(my_comm,ierr)
#endif
      end subroutine border_exchg3D





      subroutine border_exchg2D(a,jx)
c--------------------------------------------------------------
c     Exchange overlapping areas of 2D array a in all PEs of sub 
c     domain. Number of overlapping indicees are given by jx.
c--------------------------------------------------------------
      use cpflame_module
      implicit none
      integer :: jx
      real  :: a(imt,jmt)
#ifndef no_mpp
#include "../mpp/sub_mpif.h"
      
      integer  ::  j, tag, ierr
      integer,dimension(MPI_STATUS_SIZE)  :: Status
c
      tag  = 0
      call mpi_barrier(my_comm,ierr)
      if ( n_pes_j > 1) then
c    Austausch von Norden nach Sueden
        if (my_blk_j /=1 ) then
         do j=2*jx-1,jx,-1
          call mpi_send(a(1,js_pe+j-jx),imt,impireal,my_pe-1,
     &                  tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /= n_pes_j) then 
         do j=0,jx-1
          call mpi_recv(a(1,je_pe+jx-j),imt,
     &        impireal,my_pe+1,tag,my_comm,Status,ierr)
         enddo
       endif
c     Austausch von Sueden nach Norden
       if (my_blk_j /= n_pes_j) then 
         do j=jx,2*jx-1
         call mpi_send(a(1,je_pe+jx-j),imt,impireal,my_pe+1,
     &                tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /=1 ) then
         do j=jx-1,0,-1
          call mpi_recv(a(1,js_pe-jx+j),imt,
     &        impireal,my_pe-1,tag,my_comm,Status,ierr)
         enddo
        endif
      endif
      call mpi_barrier(my_comm,ierr)
#endif
      end subroutine border_exchg2D






      subroutine border_exchg_merid(a,jx)
c--------------------------------------------------------------
c     Exchange overlapping areas of array a in all PEs of sub 
c     domain. Number of overlapping indicees are given by jx.
c--------------------------------------------------------------
      use cpflame_module
      implicit none
      integer :: jx
      real  :: a(jmt,km)
#ifndef no_mpp
#include "../mpp/sub_mpif.h"
      
      integer  ::  j, tag, ierr,len
      integer,dimension(MPI_STATUS_SIZE)  :: Status
c
      tag  = 0; len=km
      call mpi_barrier(my_comm,ierr)
      if ( n_pes_j > 1) then
c    Austausch von Norden nach Sueden
        if (my_blk_j /=1 ) then
         do j=2*jx-1,jx,-1
          call mpi_send(a(js_pe+j-jx,:),len,impireal,my_pe-1,
     &                  tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /= n_pes_j) then 
         do j=0,jx-1
          call mpi_recv(a(je_pe+jx-j,:),len,
     &        impireal,my_pe+1,tag,my_comm,Status,ierr)
         enddo
       endif
c     Austausch von Sueden nach Norden
       if (my_blk_j /= n_pes_j) then 
         do j=jx,2*jx-1
         call mpi_send(a(je_pe+jx-j,:),len,impireal,my_pe+1,
     &                tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /=1 ) then
         do j=jx-1,0,-1
          call mpi_recv(a(js_pe-jx+j,:),len,
     &        impireal,my_pe-1,tag,my_comm,Status,ierr)
         enddo
        endif
      endif
      call mpi_barrier(my_comm,ierr)
#endif
      end subroutine border_exchg_merid




      subroutine pe0_recv_2D(a)
c--------------------------------------------------------------
c     all PEs send their data of a 2D array to PE0
c--------------------------------------------------------------
#ifndef no_mpp
      use cpflame_module
      implicit none
#include "sub_mpif.h"
      real, dimension(imt,jmt)     :: a
      integer                     :: js,je,iproc
      integer                     :: tag=0, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(je,1,impiinteger,0,tag,my_comm,ierr)
        len=imt*(je-js+1)
        call mpi_send(a(:,js:je),len,impireal,0,tag,my_comm,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(je,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        len=imt*(je-js+1)
        call  mpi_recv(a(:,js:je),len,impireal,iproc,tag,my_comm,
     &                  Status,ierr)
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_recv_2D


      subroutine pe0_send_2D(a)
c--------------------------------------------------------------
c     all PEs gets data of a 2D array from PE0
c--------------------------------------------------------------
#ifndef no_mpp
      use cpflame_module
      implicit none
#include "sub_mpif.h"
      real, dimension(imt,jmt)     :: a
      integer                      :: js,je,iproc
      integer                      :: tag=0, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(je,1,impiinteger,0,tag,my_comm,ierr)
        len=imt*(je-js+1)
        call mpi_recv(a(:,js:je),len,impireal,0,tag,my_comm,status,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(je,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        len=imt*(je-js+1)
        call mpi_send(a(:,js:je),len,impireal,iproc,tag,my_comm,ierr)
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_send_2D




      subroutine pe0_recv_1D(a)
c--------------------------------------------------------------
c     all PEs send their data of a 1D array to PE0
c--------------------------------------------------------------
#ifndef no_mpp
      use cpflame_module
      implicit none
#include "sub_mpif.h"
      real, dimension(jmt)         :: a
      integer                     :: js,je,iproc
      integer                     :: tag=0, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(je,1,impiinteger,0,tag,my_comm,ierr)
        len=(je-js+1)
        call mpi_send(a(js:je),len,impireal,0,tag,my_comm,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(je,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        len=(je-js+1)
        call  mpi_recv(a(js:je),len,impireal,iproc,tag,my_comm,
     &                  Status,ierr)
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_recv_1D


      subroutine pe0_send_1D(a)
c--------------------------------------------------------------
c     all PEs gets data of a 1D array from PE0
c--------------------------------------------------------------
#ifndef no_mpp
      use cpflame_module
      implicit none
#include "sub_mpif.h"
      real, dimension(jmt)          :: a
      integer                      :: js,je,iproc
      integer                      :: tag=0, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status
      js=js_pe; je=je_pe
      do iproc=1,n_pes-1
       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(je,1,impiinteger,0,tag,my_comm,ierr)
        len=(je-js+1)
        call mpi_recv(a(js:je),len,impireal,0,tag,my_comm,status,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(je,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        len=(je-js+1)
        call mpi_send(a(js:je),len,impireal,iproc,tag,my_comm,ierr)
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_send_1D

#include "options.inc"

#define remove_coriolis_expl_free_surf

      subroutine solve_pressure
c=======================================================================
c      solve for surface pressure or implicit linear free surface
c=======================================================================
      use cpflame_module
      use congrad2D_module
      use congrad3D_module
      implicit none
      integer :: i,j,k,n,js,je,js2,je2, maxitt=5000
      real :: forc2D(imt,jmt), forc3D(imt,jmt,km)
      real :: fpx(imt,jmt), fpy(imt,jmt)

      real :: etam(imt,jmt),bum(imt,jmt),bvm(imt,jmt)

      logical, save :: first = .true.

      js =max(2,js_pe);   je  = min(je_pe,jmt-1)
      js2=max(1,js_pe-1); je2 = min(je_pe+1,jmt)
c---------------------------------------------------------------------------------
c      hydrostatic pressure
c---------------------------------------------------------------------------------
      do j=js2,je2
       p_hydro(:,j,km) = 0
       do k=km-1,1,-1
        p_hydro(:,j,k)= maskT(:,j,k)*
     &    (p_hydro(:,j,k+1)+(b(:,j,k+1,tau)+b(:,j,k,tau))/2.0*dz)
       enddo
      enddo
      call setcyclic3D(p_hydro)
c---------------------------------------------------------------------------------
c       surface pressure forcing, etc
c---------------------------------------------------------------------------------
      fpx(:,js_pe:je_pe)=0.;fpy(:,js_pe:je_pe)=0.
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
           fpx(i,j)=fpx(i,j)
     &         +(fu(i,j,k)-(p_hydro(i+1,j,k)-p_hydro(i,j,k))/dx
     &                )*maskU(i,j,k)*dz
           fpy(i,j)=fpy(i,j)
     &         +(fv(i,j,k)-(p_hydro(i,j+1,k)-p_hydro(i,j,k))/dx
     &                )*maskV(i,j,k)*dz
        enddo
       enddo
      enddo

      if (enable_free_surface) then
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
           fpx(i,j)=fpx(i,j)+(u(i,j,k,1,taum1)/c2dt
     &                )*maskU(i,j,k)*dz
           fpy(i,j)=fpy(i,j)+(u(i,j,k,2,taum1)/c2dt
     &                )*maskV(i,j,k)*dz
        enddo
       enddo
      enddo
      endif

      if (.not.enable_hydrostatic) then
       do k=1,km-1
        do j=js,je
         do i=2,imt-1
           fpx(i,j)=fpx(i,j)
     &         -(psi(i+1,j,k)-psi(i,j,k))/dx*maskU(i,j,k)*dz
           fpy(i,j)=fpy(i,j)
     &         -(psi(i,j+1,k)-psi(i,j,k))/dx*maskV(i,j,k)*dz
         enddo
        enddo
       enddo
      endif

#ifdef remove_coriolis_expl_free_surf
      if (enable_expl_free_surf) then
       do k=1,km-1
        do j=js,je
         do i=2,imt-1
           fpx(i,j)=fpx(i,j)-
     &    maskU(i,j,k)*dz*
     &     coriolis_t(j)*(u(i,j  ,k,2,tau)+u(i+1,j  ,k,2,tau)+
     &                    u(i,j-1,k,2,tau)+u(i+1,j-1,k,2,tau))/4.0
           fpy(i,j)=fpy(i,j)
     &              +maskV(i,j,k)*dz*
     &     (coriolis_t(j  )*(u(i-1,j  ,k,1,tau)+u(i,j  ,k,1,tau)) 
     &     +coriolis_t(j+1)*(u(i-1,j+1,k,1,tau)+u(i,j+1,k,1,tau)))/4.0
         enddo
        enddo
       enddo
      endif
#endif

      call border_exchg2D(fpx,1); call border_exchg2D(fpy,1)
      call setcyclic2D(fpx); call setcyclic2D(fpy)

      if (enable_expl_free_surf) then
        n=nint(dt_in/dtex)
        do j=js2,je2
         etam(:,j)=0;
         bum(:,j)=0;
         bvm(:,j)=0;
        enddo
        do k=1,n*2
c        (eta'-eta)/dt + U_x + V_y = 0
c        (U'-U)/dt + g H eta_x = fu
c        (V'-V)/dt + g H eta_y = fv
         do j=js,je
          do i=2,imt-1
           eta(i,j,taum1)=eta(i,j,tau)+maskT(i,j,km-1)*dtex*(
     &         -(bu(i,j,tau)-bu(i-1,j,tau))/dx
     &         -(bv(i,j,tau)-bv(i,j-1,tau))/dx )
           bu(i,j,taum1)=bu(i,j,tau)+maskU(i,j,km-1)*dtex*(
     &          - g*hu(i,j)*(eta(i+1,j,tau)-eta(i,j,tau))/dx
#ifdef remove_coriolis_expl_free_surf
     &    +coriolis_t(j)*(bv(i,j,tau)+bv(i+1,j,tau)+
     &                           bv(i,j-1,tau)+bv(i+1,j-1,tau))/4.0
#endif
     &          + fpx(i,j) )
           bv(i,j,taum1)=bv(i,j,tau)+maskV(i,j,km-1)*dtex*(
     &          - g*hv(i,j)*(eta(i,j+1,tau)-eta(i,j,tau))/dx
#ifdef remove_coriolis_expl_free_surf
     &     -(coriolis_t(j  )*(bu(i-1,j,tau)+bu(i,j,tau)) 
     &      +coriolis_t(j+1)*(bu(i-1,j+1,tau)+bu(i,j+1,tau)))/4.0
#endif
     &          + fpy(i,j) )
          enddo
         enddo
         call border_exchg2D(eta(:,:,taum1),1); 
         call setcyclic2D(eta(:,:,taum1))
         call border_exchg2D(bu(:,:,taum1),1); 
         call setcyclic2D(bu(:,:,taum1))
         call border_exchg2D(bv(:,:,taum1),1); 
         call setcyclic2D(bv(:,:,taum1))
c        (eta''-eta)/dt+U'_x+V'_y = 0
c        (U''-U)/dt + g H eta'_x = fu
c        (V''-V)/dt + g H eta'_y = fv
         do j=js,je
          do i=2,imt-1
           eta(i,j,taup1)=eta(i,j,tau)+maskT(i,j,km-1)*dtex*(
     &         -(bu(i,j,taum1)-bu(i-1,j,taum1))/dx
     &         -(bv(i,j,taum1)-bv(i,j-1,taum1))/dx )
           bu(i,j,taup1)=bu(i,j,tau)+maskU(i,j,km-1)*dtex*(
     &          - g*hu(i,j)*(eta(i+1,j,taum1)-eta(i,j,taum1))/dx
#ifdef remove_coriolis_expl_free_surf
     &    +coriolis_t(j)*(bv(i,j,taum1)+bv(i+1,j,taum1)+
     &                           bv(i,j-1,taum1)+bv(i+1,j-1,taum1))/4.0
#endif
     &          + fpx(i,j) )
           bv(i,j,taup1)=bv(i,j,tau)+maskV(i,j,km-1)*dtex*(
     &          - g*hv(i,j)*(eta(i,j+1,taum1)-eta(i,j,taum1))/dx
#ifdef remove_coriolis_expl_free_surf
     &     -(coriolis_t(j  )*(bu(i-1,j,taum1)+bu(i,j,taum1)) 
     &      +coriolis_t(j+1)*(bu(i-1,j+1,taum1)+bu(i,j+1,taum1)))/4.0
#endif
     &          + fpy(i,j) )
          enddo
         enddo
         call border_exchg2D(eta(:,:,taup1),1); 
         call setcyclic2D(eta(:,:,taup1))
         call border_exchg2D(bu(:,:,taup1),1); 
         call setcyclic2D(bu(:,:,taup1))
         call border_exchg2D(bv(:,:,taup1),1); 
         call setcyclic2D(bv(:,:,taup1))
c       shift time positions
         do j=js2,je2
          eta(:,j,tau)=eta(:,j,taup1)
          bu(:,j,tau)=bu(:,j,taup1)
          bv(:,j,tau)=bv(:,j,taup1)
         enddo
c        accumulate eta,u and v
         do j=js2,je2
          etam(:,j)=etam(:,j)+eta(:,j,taup1)
          bum(:,j)=bum(:,j)+bu(:,j,taup1)
          bvm(:,j)=bvm(:,j)+bv(:,j,taup1)
         enddo
        enddo! n
c       use averaged eta, u and v
        do j=js2,je2
          eta(:,j,tau)=etam(:,j)/(2.*n); eta(:,j,taup1)=eta(:,j,tau)
          bu(:,j,tau)=bum(:,j)/(2.*n); bu(:,j,taup1)=bu(:,j,tau)
          bv(:,j,tau)=bvm(:,j)/(2.*n); bv(:,j,taup1)=bv(:,j,tau)
        enddo
        do j=js2,je2
         p_surf(:,j)=eta(:,j,taup1)*g
        enddo
      else ! enable_expl_free_surf
       forc2D(:,js_pe:je_pe)=0.0
       do j=js,je
        do i=2,imt-1
         forc2D(i,j)=(fpx(i,j)-fpx(i-1,j))/dx+(fpy(i,j)-fpy(i,j-1))/dx 
        enddo
       enddo
       if (enable_free_surface) then
        do j=js,je
         do i=2,imt-1
          forc2D(i,j)=forc2D(i,j)-eta(i,j,taum1)/(c2dt**2)
         enddo
        enddo
       endif
       call setcyclic2D(forc2D)
c---------------------------------------------------------------------------------
c      solve for surface pressure or free surface
c---------------------------------------------------------------------------------
       if (first) call make_coef2D(cf2D)
       if (enable_free_surface) then
        p_surf(:,js_pe:je_pe)=eta(:,js_pe:je_pe,taup1)
        call border_exchg2D(p_surf,1); call setcyclic2D(p_surf)
       endif
       call congrad2D(cf2D,forc2D,maxitt,sor2D_itts,eps2D_sor)
c      call border_exchg2D(p_surf,1); call setcyclic2D(p_surf)
       if (enable_free_surface) then
        do j=js,je
         do i=2,imt-1
          eta(i,j,taup1)=p_surf(i,j)
          p_surf(i,j)=eta(i,j,taup1)*g
          eta(i,j,tau) = eta(i,j,tau) + gamma*
     &      (0.5*(eta(i,j,taup1) + eta(i,j,taum1)) - eta(i,j,tau)) 
         enddo
        enddo
       endif
       call border_exchg2D(p_surf,1); call setcyclic2D(p_surf)
      endif

c---------------------------------------------------------------------------------
c       full pressure is surface pressure plus hydrostatic pressure
c---------------------------------------------------------------------------------
      do k=1,km
       do j=js,je
        p_full(:,j,k,tau) =(p_hydro(:,j,k)+p_surf(:,j))*maskT(:,j,k)
       enddo
      enddo
      call border_exchg3D(p_full(:,:,:,tau),1)
      call setcyclic3D(p_full(:,:,:,tau))

      if (.not. enable_hydrostatic) then
c---------------------------------------------------------------------------------
c        forcing for non-hydrostatic pressure
c---------------------------------------------------------------------------------
       forc3D=0.
       do k=2,km-1
        do j=js,je
         do i=2,imt-1
          forc3D(i,j,k)= (fw(i,j,k)-fw(i,j,k-1))/dz
     &                 + (fu(i,j,k)-fu(i-1,j,k))/dx
     &                 + (fv(i,j,k)-fv(i,j-1,k))/dx
     &  -((p_full(i+1,j,k,tau)-p_full(i,j,k,tau))/dx*maskU(i  ,j,k)
     &   -(p_full(i,j,k,tau)-p_full(i-1,j,k,tau))/dx*maskU(i-1,j,k))/dx
     &  -((p_full(i,j+1,k,tau)-p_full(i,j,k,tau))/dx*maskV(i,j  ,k)
     &   -(p_full(i,j,k,tau)-p_full(i,j-1,k,tau))/dx*maskV(i,j-1,k))/dx
         enddo
        enddo
       enddo
       call setcyclic3D(forc3D)
c---------------------------------------------------------------------------------
c        solve for non hydrostatic pressure
c---------------------------------------------------------------------------------
       if (first) call make_coef3D(cf3D)
       call congrad3D(cf3D,forc3D,maxitt,sor3D_itts,eps3D_sor)
       call border_exchg3D(psi,1)
       call setcyclic3D(psi)
c---------------------------------------------------------------------------------
c       full pressure 
c---------------------------------------------------------------------------------
       do j=js,je
        p_full(:,j,:,tau) =(p_full(:,j,:,tau)+psi(:,j,:))*maskT(:,j,:)
       enddo
       call border_exchg3D(p_full(:,:,:,tau),1)
       call setcyclic3D(p_full(:,:,:,tau))
      endif

      first=.false.
      end subroutine solve_pressure



      subroutine make_coef3D(cf)
      use cpflame_module
      implicit none
c-----------------------------------------------------------------------
c             A * dpsi = forc
c                       res = A * p
c          res = res +  cf(...,ii,jj,kk) * p(i+ii,j+jj,k+kk) 
c
c          forc = p_xx + p_yy + p_zz
c         forc = (p(i+1) - 2p(i) + p(i-1))  /dx^2 ...
c              = [ (p(i+1) - p(i))/dx - (p(i)-p(i-1))/dx ] /dx 
c-----------------------------------------------------------------------
      real :: cf(imt,jmt,km,-1:1,-1:1,-1:1)
      real :: maskM(imt,jmt,km),mp,mm
      integer :: i,j,k

      cf=0.
      do k=2,km-1
       do j=2,jmt-1
        do i=2,imt-1
         mp=maskT(i,j,k)*maskT(i+1,j,k)/dx**2
         mm=maskT(i,j,k)*maskT(i-1,j,k)/dx**2
         cf(i,j,k, 0, 0, 0)= cf(i,j,k, 0, 0, 0)-mp
         cf(i,j,k, 1, 0, 0)= cf(i,j,k, 1, 0, 0)+mp
         cf(i,j,k, 0, 0, 0)= cf(i,j,k, 0, 0, 0)-mm
         cf(i,j,k,-1, 0, 0)= cf(i,j,k,-1, 0, 0)+mm

         mp=maskT(i,j,k)*maskT(i,j+1,k)/dx**2
         mm=maskT(i,j,k)*maskT(i,j-1,k)/dx**2
         cf(i,j,k, 0, 0, 0)= cf(i,j,k, 0, 0, 0)-mp
         cf(i,j,k, 0, 1, 0)= cf(i,j,k, 0, 1, 0)+mp
         cf(i,j,k, 0, 0, 0)= cf(i,j,k, 0, 0, 0)-mm
         cf(i,j,k, 0,-1, 0)= cf(i,j,k, 0,-1, 0)+mm

         mp=maskT(i,j,k)*maskT(i,j,k+1)/dz**2
         mm=maskT(i,j,k)*maskT(i,j,k-1)/dz**2
         cf(i,j,k, 0, 0, 0)= cf(i,j,k, 0, 0, 0)-mp
         cf(i,j,k, 0, 0, 1)= cf(i,j,k, 0, 0, 1)+mp
         cf(i,j,k, 0, 0, 0)= cf(i,j,k, 0, 0, 0)-mm
         cf(i,j,k, 0, 0,-1)= cf(i,j,k, 0, 0,-1)+mm

        end do
       end do
      end do
      end subroutine make_coef3D


      subroutine make_coef2D(cf)
      use cpflame_module
      implicit none
c-----------------------------------------------------------------------
c         A * dpsi = forc
c         res = A * p
c         res = res +  cf(...,ii,jj,kk) * p(i+ii,j+jj,k+kk) 
c
c         forc = (h p_x)_x +(h p_y)_y + (hp_z)_z
c         forc = [ hu(i)(p(i+1) - p(i))/dx - hu(i-1)(p(i)-p(i-1))/dx ] /dx 
c         forc = hu(i) p(i+1)/dx^2  - p(i) (hu(i)+hu(i-1))/dx^2  + hu(i-1) p(i-1)/dx^2
c-----------------------------------------------------------------------
      real :: cf(imt,jmt,-1:1,-1:1)
      real :: maskM(imt,jmt),mp,mm
      integer :: i,j

      cf=0.
      maskM=maskT(:,:,km-1)
      do j=2,jmt-1
       do i=2,imt-1
         mp=maskM(i,j)*maskM(i+1,j)/dx**2
         mm=maskM(i,j)*maskM(i-1,j)/dx**2
         cf(i,j, 0, 0)= cf(i,j, 0, 0)-mp*hu(i  ,j)
         cf(i,j, 1, 0)= cf(i,j, 1, 0)+mp*hu(i  ,j)
         cf(i,j, 0, 0)= cf(i,j, 0, 0)-mm*hu(i-1,j)
         cf(i,j,-1, 0)= cf(i,j,-1, 0)+mm*hu(i-1,j)

         mp=maskM(i,j)*maskM(i,j+1)/dx**2
         mm=maskM(i,j)*maskM(i,j-1)/dx**2
         cf(i,j, 0, 0)= cf(i,j, 0, 0)-mp*hv(i,j)
         cf(i,j, 0, 1)= cf(i,j, 0, 1)+mp*hv(i,j)
         cf(i,j, 0, 0)= cf(i,j, 0, 0)-mm*hv(i,j-1)
         cf(i,j, 0,-1)= cf(i,j, 0,-1)+mm*hv(i,j-1)
       end do
      end do
      if (enable_free_surface) then
       cf=cf*g
       do j=2,jmt-1
        do i=2,imt-1
         cf(i,j, 0, 0)= cf(i,j,0,0)-1/( c2dt )**2
        end do
       end do
      endif
      end subroutine make_coef2D

#include "options.inc"


c=======================================================================
c       Integrate particles
c       linked in the code in driver only
c=======================================================================

#ifdef enable_diag_particle

c#define two_dim
c#define  remove_zonal_mean
c
c write out also buoyancy and pressure
#define  particle_buoyancy

c
c
c#define  particle_averages

      module particle_module
       use time_type_module
      implicit none
      integer :: nptraj 
      real, allocatable  :: pxyz(:,:),puvw(:,:),ptr(:,:)
      integer, allocatable :: pijk(:,:)
      real, allocatable  :: mu(:),muu(:)
      real, allocatable  :: mv(:),mvv(:)
      real, allocatable  :: mw(:),mww(:)
      integer :: counter
 
      logical, allocatable :: particle_active(:)
      integer, allocatable :: particle_pe(:)
      integer :: mmax
      type( time_type )          :: float_snapshot_time   
      type( time_type )          :: float_snapshot_inctime
      logical :: float_snapshot_time_step   = .false.
      real :: float_snap_int = 0.05
      real, allocatable  :: ulen(:,:),vlen(:,:),wlen(:,:)
      end module particle_module


      subroutine init_particle
c=======================================================================
c      initialize the particles
c=======================================================================
      use cpflame_module
      use particle_module
      implicit none 
#include "netcdf.inc"
      integer :: n,iret,dims(2),xid,yid,zid,uid,vid,wid,bid,pid
      integer :: ncid,Timedim,Timeid,pdim,uuid,vvid,wwid
      character :: name*24, unit*16
      integer :: i,j,k,indp,io,js,je
      logical :: file_exists = .false.
    
      if (my_pe==0) then
       print*,''
       print*,' Initializing particle module '
       print*,''
       if (n_pes>1) print*,'WARNNING: floats do not work with PE>1'
       print*,''
      endif

      mmax = 20
      if (my_pe==0) 
     &  print*,' Euler forward time step for particles ',dt_in/mmax,' s'

c-----------------------------------------------------------------------
c    read restart file
c-----------------------------------------------------------------------
       if (my_pe==0) then
       inquire( FILE='restart_float.dta', EXIST=file_exists )
       if (file_exists) then 
        print*,' reading data from restart file '
        call get_free_iounit(io)
        open(io,file='restart_float.dta',form='unformatted',
     &         status='old')
        read(io) nptraj
        allocate( pxyz(3,nptraj), pijk(3,nptraj),puvw(3,nptraj) )
        print*,' number of particles = ',nptraj
        do n=1,nptraj
         read(io) pijk(1:3,n),pxyz(1:3,n),puvw(1:3,n)
        enddo
        close(io)
        print*,' done reading restart'
       else
c-----------------------------------------------------------------------
c     initialize new set of particles 
c-----------------------------------------------------------------------
        print*,' cannot read restart file '
        nptraj=500
        allocate( pxyz(3,nptraj), pijk(3,nptraj),puvw(3,nptraj) )
        call seed_particles_randomly
c        call seed_particles_regular
        do n=1,nptraj
          i = indp (pxyz(1,n), xu, imt)
          if (xu(i) > pxyz(1,n)) then
            pijk(1,n) = i
          else
            pijk(1,n) = i+1
          endif
          j = indp (pxyz(2,n), yu, jmt)
          if (yu(j) > pxyz(2,n)) then
            pijk(2,n) = j
          else
           pijk(2,n) = j+1
          endif
          k = indp (pxyz(3,n), zw, km)
          if (zw(k) > pxyz(3,n)) then
           pijk(3,n) = k
          else
           pijk(3,n) = k+1
          endif
        enddo
       endif
      endif
c-----------------------------------------------------------------------
c    communicate particles to other pes
c-----------------------------------------------------------------------
      call barrier
      call bcast_integer(nptraj,1,0)
      if (my_pe/=0) 
     &      allocate( pxyz(3,nptraj), pijk(3,nptraj) ,puvw(3,nptraj))
      allocate(particle_active(nptraj),particle_pe(nptraj) )
      call bcast_real(pxyz,3*nptraj,0)
      call bcast_integer(pijk,3*nptraj,0)
      puvw=0.
#ifdef particle_buoyancy
      allocate( ptr(2,nptraj) ); ptr=0.
#endif

#ifdef  particle_averages
      allocate( mu(nptraj) ); mu=0.
      allocate( muu(nptraj) ); muu=0.
      allocate( mv(nptraj) ); mv=0.
      allocate( mvv(nptraj) ); mvv=0.
      allocate( mw(nptraj) ); mw=0.
      allocate( mww(nptraj) ); mww=0.
      counter=0
#endif

c-----------------------------------------------------------------------
c     define output file
c-----------------------------------------------------------------------
      if (my_pe==0) then
       ncid = nccre ('float.cdf', NCCLOB, iret)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       Timedim = ncddef(ncid, 'Time', nf_unlimited, iret)
       pdim    = ncddef(ncid, 'Number', nptraj, iret)
       timeid  = ncvdef (ncid,'Time', NCFLOAT,1,timedim,iret)
       dims = (/pdim,Timedim/)
       xid  = ncvdef (ncid,'x_pos', NCFLOAT,2,dims,iret)
       yid  = ncvdef (ncid,'y_pos', NCFLOAT,2,dims,iret)
       zid  = ncvdef (ncid,'z_pos', NCFLOAT,2,dims,iret)
       uid  = ncvdef (ncid,'u', NCFLOAT,2,dims,iret)
       vid  = ncvdef (ncid,'v', NCFLOAT,2,dims,iret)
       wid  = ncvdef (ncid,'w', NCFLOAT,2,dims,iret)
#ifdef  particle_averages
       uuid  = ncvdef (ncid,'uu', NCFLOAT,2,dims,iret)
       vvid  = ncvdef (ncid,'vv', NCFLOAT,2,dims,iret)
       wwid  = ncvdef (ncid,'ww', NCFLOAT,2,dims,iret)
#endif
#ifdef particle_buoyancy
       pid  = ncvdef (ncid,'p', NCFLOAT,2,dims,iret)
       bid  = ncvdef (ncid,'b', NCFLOAT,2,dims,iret)
#endif
       name = 'Time '; unit = 'days'
       call ncaptc(ncid, timeid, 'long_name', NCCHAR, 24, name, iret) 
       call ncaptc(ncid, timeid, 'units',     NCCHAR, 16, unit, iret) 
       call ncaptc(ncid, Timeid,'time_origin',NCCHAR, 20,
     &  '01-JAN-1900 00:00:00', iret)
       name = 'X position'; unit = 'm'
       call dvcdf(ncid,xid,name,24,unit,16,spval)
       name = 'Y position'; unit = 'm'
       call dvcdf(ncid,yid,name,24,unit,16,spval)
       name = 'Z position'; unit = 'm'
       call dvcdf(ncid,zid,name,24,unit,16,spval)
       name = 'zonal velocity'; unit = 'm/s'
       call dvcdf(ncid,uid,name,24,unit,16,spval)
       name = 'meridional velocity'; unit = 'm/s'
       call dvcdf(ncid,vid,name,24,unit,16,spval)
       name = 'vertical velocity'; unit = 'm/s'
       call dvcdf(ncid,wid,name,24,unit,16,spval)
#ifdef particle_buoyancy
       name = 'buoyancy'; unit = 'm/s^2'
       call dvcdf(ncid,bid,name,24,unit,16,spval)
       name = 'pressure'; unit = 'm^2/s'
       call dvcdf(ncid,pid,name,24,unit,16,spval)
#endif
#ifdef  particle_averages
       name = 'zonal velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,uuid,name,24,unit,16,spval)
       name = 'meridional velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,vvid,name,24,unit,16,spval)
       name = 'vertical velocity variance'; unit = 'm^2/s^2'
       call dvcdf(ncid,wwid,name,24,unit,16,spval)
#endif
       call ncclos (ncid, iret)
      endif

#ifdef remove_zonal_mean
      allocate(ulen(jmt,km),vlen(jmt,km),wlen(jmt,km))
      ulen=0;vlen=0;wlen=0
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do j=js,je
       do i=2,imt-1
        ulen(j,:)=ulen(j,:)+dx*maskU(i,j,:)
        vlen(j,:)=vlen(j,:)+dx*maskV(i,j,:)
        wlen(j,:)=wlen(j,:)+dx*maskW(i,j,:)
       enddo 
      enddo 
#endif

      if (my_pe==0)  then
       print*,' float snapshot interval is ', float_snap_int*86400,'s'
       print*,' Done initializing time averaging module'
       print*,' '
      endif
      end subroutine init_particle


      function ilim(i)
      use cpflame_module
      implicit none 
      integer :: i ,ilim
      if (enable_cyclic_x) then
        ilim=i
        if (i>imt) ilim=i-(imt-2)
        if (i<1) ilim=i+(imt-2)
      else
        ilim=max(1,min(imt,i))
      endif
      end function ilim

      function jlim(j)
      use cpflame_module
      implicit none 
      integer :: j ,jlim
      if (enable_cyclic_y) then
        jlim=j
        if (j>jmt) jlim=j-(jmt-2)
        if (j<1) jlim=j+(jmt-2)
      else
        jlim=max(1,min(jmt,j))
      endif
      end function jlim

      function klim(k)
      use cpflame_module
      implicit none 
      integer :: k ,klim
      klim=max(1,min(km,k))
      end function klim

 
      subroutine integrate_particle
c=======================================================================
c       integrate particles
c=======================================================================
      use cpflame_module
      use particle_module
      implicit none 
      integer :: i,j,k,n,m,js,je
      real :: xe,xw,yn,ys,zu,zl,dv,th,tf
      real :: xeyszu,xeyszl,xeynzu,xeynzl
      real :: xwyszu,xwyszl,xwynzu,xwynzl
      real :: uuh,vvh,wwh,xold,yold,zold
      real :: uuf,vvf,wwf,uu,vv,ww
      real :: bbf,bbh
#include "netcdf.inc"
      integer :: ncid,iret,xid,yid,zid,timedim,ilen,timeid,io
      integer :: uid,vid,wid,bid,pid,uuid,vvid,wwid
      real :: fxa
      type(time_type) :: time
      logical, save :: first = .true.
#ifdef remove_zonal_mean
      real :: um(jmt,km),vm(jmt,km),wm(jmt,km)
      real :: um2(jmt,km),vm2(jmt,km),wm2(jmt,km)
#endif
      integer, external :: ilim,jlim,klim
      if (first) then
c-----------------------------------------------------------------------
c      set next snapshot time
c-----------------------------------------------------------------------
       float_snapshot_time = initial_time
       call set_time(float_snapshot_inctime ,
     &         (float_snap_int-int(float_snap_int))*60*60*24 , 
     &        int(float_snap_int))
       if (float_snap_int>0.) then
 20   float_snapshot_time=float_snapshot_time+float_snapshot_inctime
        if (float_snapshot_time < current_time ) goto 20
       else
        float_snapshot_time=current_time
       endif

      endif
c-----------------------------------------------------------------------
c      is this a float snapshot time step ?
c-----------------------------------------------------------------------
       if ( current_time >= float_snapshot_time .and. 
     &      .not. eulerback1  ) then 
        float_snapshot_time_step = .true.
        float_snapshot_time = float_snapshot_time 
     &        + float_snapshot_inctime
        if (float_snapshot_time <= current_time) then
         float_snapshot_time = current_time
        endif
       else
        float_snapshot_time_step = .false.
       endif

#ifdef remove_zonal_mean
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      um=0.0;vm=0.0;wm=0.0; um2=0.0;vm2=0.0;wm2=0.0
      do j=js,je 
        do i=2,imt-1
         um(j,:)=um(j,:)+u(i,j,:,1,tau)*dx*maskU(i,j,:) 
         vm(j,:)=vm(j,:)+u(i,j,:,2,tau)*dx*maskV(i,j,:) 
         wm(j,:)=wm(j,:)+u(i,j,:,3,tau)*dx*maskW(i,j,:) 
         um2(j,:)=um2(j,:)+u(i,j,:,1,taup1)*dx*maskU(i,j,:) 
         vm2(j,:)=vm2(j,:)+u(i,j,:,2,taup1)*dx*maskV(i,j,:) 
         wm2(j,:)=wm2(j,:)+u(i,j,:,3,taup1)*dx*maskW(i,j,:) 
        enddo 
      enddo 
      where (ulen/=0); um=um/ulen; um2=um2/ulen; else where; 
      um=spval ; um2=spval; end where
      where (vlen/=0); vm=vm/vlen; vm2=vm2/vlen; else where; 
      vm=spval ; vm2=spval; end where
      where (wlen/=0); wm=wm/wlen; wm2=wm2/wlen; else where; 
      wm=spval ; wm2=spval; end where
      call border_exchg_merid(um,1); call border_exchg_merid(vm,1);
      call border_exchg_merid(wm,1); call border_exchg_merid(um2,1);
      call border_exchg_merid(vm2,1); call border_exchg_merid(wm2,1);
#endif


      do m=1,mmax
       call particle_inside_pe_domain()
       do n=1,nptraj
        th= (m-1.)/mmax;  tf = 1.-th;
        if (particle_active(n)) then
#ifdef  particle_buoyancy
c-----------------------------------------------------------------------
c        interpolate buoyancy on particle
c-----------------------------------------------------------------------
          i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
          if (pxyz(1,n) > xt(i) )  i=i+1
          xe = (xt(i) - pxyz(1,n)); xw = (pxyz(1,n)-xt(i-1))
          if (pxyz(2,n) > yt(j) )  j=j+1
          yn = (yt(j) - pxyz(2,n)); ys = (pxyz(2,n) - yt(j-1))
          if (pxyz(3,n) > zt(k) )  k=k+1
          zu = (zt(k) - pxyz(3,n)); zl = (pxyz(3,n)-zt(k-1))

          if (maskT(ilim(i+1),j,k)==0) then; xe=dx;xw=0; endif
          if (maskT(i-1,j,k)==0) then; xe=0;xw=dx; endif
          if (maskT(i,jlim(j+1),k)==0) then; yn=dx;ys=0; endif
          if (maskT(i,j-1,k)==0) then; yn=0;ys=dx; endif
          if (maskT(i,j,klim(k+1))==0) then; zu=dz;zl=0; endif
          if (maskT(i,j,k-1)==0) then; zu=0;zl=dz; endif

          dv = 1./(dx*dx*dz)
          xeyszu = xe*ys*zu*dv; xwyszu = xw*ys*zu*dv
          xeyszl = xe*ys*zl*dv; xwyszl = xw*ys*zl*dv
          xeynzu = xe*yn*zu*dv; xwynzu = xw*yn*zu*dv
          xeynzl = xe*yn*zl*dv; xwynzl = xw*yn*zl*dv

          bbh=b(i-1,j  ,k-1,tau  )*xeyszu+b(i,j  ,k-1,tau  )*xwyszu
     &       +b(i-1,j  ,k  ,tau  )*xeyszl+b(i,j  ,k  ,tau  )*xwyszl
     &       +b(i-1,j-1,k-1,tau  )*xeynzu+b(i,j-1,k-1,tau  )*xwynzu
     &       +b(i-1,j-1,k  ,tau  )*xeynzl+b(i,j-1,k  ,tau  )*xwynzl
          bbf=b(i-1,j  ,k-1,taup1)*xeyszu+b(i,j  ,k-1,taup1)*xwyszu
     &       +b(i-1,j  ,k  ,taup1)*xeyszl+b(i,j  ,k  ,taup1)*xwyszl
     &       +b(i-1,j-1,k-1,taup1)*xeynzu+b(i,j-1,k-1,taup1)*xwynzu
     &       +b(i-1,j-1,k  ,taup1)*xeynzl+b(i,j-1,k  ,taup1)*xwynzl
          ptr(1,n)=th*bbh+tf*bbf

          ptr(2,n) =p_full(i-1,j  ,k-1,tau  )*xeyszu
     & +p_full(i,j  ,k-1,tau  )*xwyszu
     &       +p_full(i-1,j  ,k  ,tau  )*xeyszl
     & +p_full(i,j  ,k  ,tau  )*xwyszl
     &       +p_full(i-1,j-1,k-1,tau  )*xeynzu
     & +p_full(i,j-1,k-1,tau  )*xwynzu
     &       +p_full(i-1,j-1,k  ,tau  )*xeynzl
     & +p_full(i,j-1,k  ,tau  )*xwynzl

#endif
c-----------------------------------------------------------------------
c            pijk gives tracer box of the particle, 
c            find u-box and distances to borders, account for free slip
c-----------------------------------------------------------------------
          i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
          xe = (xu(i) - pxyz(1,n)); xw = (pxyz(1,n)-xu(i-1))
          if (pxyz(2,n) > yt(j) )  j=j+1
          yn = (yt(j) - pxyz(2,n)); ys = (pxyz(2,n) - yt(j-1))
          if (pxyz(3,n) > zt(k) )  k=k+1
          zu = (zt(k) - pxyz(3,n)); zl = (pxyz(3,n)-zt(k-1))

          if (maskT(i,jlim(j+1),k)==0) then; yn=dx;ys=0; endif
          if (maskT(i,j-1,k)==0) then; yn=0;ys=dx; endif
          if (maskT(i,j,klim(k+1))==0) then; zu=dz;zl=0; endif
          if (maskT(i,j,k-1)==0) then; zu=0;zl=dz; endif

	  dv = 1./(dx*dx*dz)
          xeyszu = xe*ys*zu*dv; xwyszu = xw*ys*zu*dv
          xeyszl = xe*ys*zl*dv; xwyszl = xw*ys*zl*dv
          xeynzu = xe*yn*zu*dv; xwynzu = xw*yn*zu*dv
          xeynzl = xe*yn*zl*dv; xwynzl = xw*yn*zl*dv
c-----------------------------------------------------------------------
c           interpolate u on particle position
c-----------------------------------------------------------------------
#ifdef remove_zonal_mean
          uuh=
     &  (u(i-1,j  ,k-1,1,tau  )-um(j,k-1))*xeyszu*maskU(i-1,j,k-1)
     & +(u(i,j  ,k-1,1,tau  )-um(j,k-1))*xwyszu*maskU(i,j,k-1)
     & +(u(i-1,j  ,k  ,1,tau  )-um(j,k))*xeyszl*maskU(i-1,j,k)
     & +(u(i,j  ,k  ,1,tau  )-um(j,k))*xwyszl*maskU(i,j,k)
     & +(u(i-1,j-1,k-1,1,tau  )-um(j-1,k-1))*xeynzu*maskU(i-1,j-1,k-1)
     & +(u(i,j-1,k-1,1,tau  )-um(j-1,k-1))*xwynzu*maskU(i,j-1,k-1)
     & +(u(i-1,j-1,k  ,1,tau  )-um(j-1,k))*xeynzl*maskU(i-1,j-1,k)
     & +(u(i,j-1,k  ,1,tau  )-um(j-1,k))*xwynzl*maskU(i,j-1,k)
          uuf=
     &  (u(i-1,j  ,k-1,1,taup1)-um2(j,k-1))*xeyszu*maskU(i-1,j,k-1)
     & +(u(i,j  ,k-1,1,taup1)-um2(j,k-1))*xwyszu*maskU(i,j,k-1)
     & +(u(i-1,j  ,k  ,1,taup1)-um2(j,k))*xeyszl*maskU(i-1,j,k)
     & +(u(i,j  ,k  ,1,taup1)-um2(j,k))*xwyszl*maskU(i,j,k)
     & +(u(i-1,j-1,k-1,1,taup1)-um2(j-1,k-1))*xeynzu*maskU(i-1,j-1,k-1)
     & +(u(i,j-1,k-1,1,taup1)-um2(j-1,k-1))*xwynzu*maskU(i,j-1,k-1)
     & +(u(i-1,j-1,k  ,1,taup1)-um2(j-1,k))*xeynzl*maskU(i-1,j-1,k)
     & +(u(i,j-1,k  ,1,taup1)-um2(j-1,k))*xwynzl*maskU(i,j-1,k)
#else
          uuh=u(i-1,j  ,k-1,1,tau  )*xeyszu+u(i,j  ,k-1,1,tau  )*xwyszu
     &       +u(i-1,j  ,k  ,1,tau  )*xeyszl+u(i,j  ,k  ,1,tau  )*xwyszl
     &       +u(i-1,j-1,k-1,1,tau  )*xeynzu+u(i,j-1,k-1,1,tau  )*xwynzu
     &       +u(i-1,j-1,k  ,1,tau  )*xeynzl+u(i,j-1,k  ,1,tau  )*xwynzl
          uuf=u(i-1,j  ,k-1,1,taup1)*xeyszu+u(i,j  ,k-1,1,taup1)*xwyszu
     &       +u(i-1,j  ,k  ,1,taup1)*xeyszl+u(i,j  ,k  ,1,taup1)*xwyszl
     &       +u(i-1,j-1,k-1,1,taup1)*xeynzu+u(i,j-1,k-1,1,taup1)*xwynzu
     &       +u(i-1,j-1,k  ,1,taup1)*xeynzl+u(i,j-1,k  ,1,taup1)*xwynzl
#endif
          uu=th*uuh+tf*uuf
c-----------------------------------------------------------------------
c           find v-box and distances to borders, account for free slip
c-----------------------------------------------------------------------
          i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
          if (pxyz(1,n) > xt(i) )  i=i+1
          xe = (xt(i) - pxyz(1,n)); xw = (pxyz(1,n)-xt(i-1))
          yn = (yu(j) - pxyz(2,n)); ys = (pxyz(2,n) - yu(j-1))
          if (pxyz(3,n) > zt(k) )  k=k+1
          zu = (zt(k) - pxyz(3,n)); zl = (pxyz(3,n)-zt(k-1))

          if (maskT(ilim(i+1),j,k)==0) then; xe=dx;xw=0; endif
          if (maskT(i-1,j,k)==0) then; xe=0;xw=dx; endif
          if (maskT(i,j,klim(k+1))==0) then; zu=dz;zl=0; endif
          if (maskT(i,j,k-1)==0) then; zu=0;zl=dz; endif

          dv = 1./(dx*dx*dz)
          xeyszu = xe*ys*zu*dv; xwyszu = xw*ys*zu*dv
          xeyszl = xe*ys*zl*dv; xwyszl = xw*ys*zl*dv
          xeynzu = xe*yn*zu*dv; xwynzu = xw*yn*zu*dv
          xeynzl = xe*yn*zl*dv; xwynzl = xw*yn*zl*dv
c-----------------------------------------------------------------------
c           interpolate v on particle position
c-----------------------------------------------------------------------
#ifdef remove_zonal_mean
          vvh=
     &   (u(i-1,j  ,k-1,2,tau  )-vm(j,k-1))*xeyszu*maskV(i-1,j,k-1)
     & +(u(i,j  ,k-1,2,tau  )-vm(j,k-1))*xwyszu*maskV(i,j,k-1)
     & +(u(i-1,j  ,k  ,2,tau  )-vm(j,k))*xeyszl*maskV(i-1,j,k)
     & +(u(i,j  ,k  ,2,tau  )-vm(j,k))*xwyszl*maskV(i,j,k)
     & +(u(i-1,j-1,k-1,2,tau  )-vm(j-1,k-1))*xeynzu*maskV(i-1,j-1,k-1)
     & +(u(i,j-1,k-1,2,tau  )-vm(j-1,k-1))*xwynzu*maskV(i,j-1,k-1)
     & +(u(i-1,j-1,k  ,2,tau  )-vm(j-1,k))*xeynzl*maskV(i-1,j-1,k)
     & +(u(i,j-1,k  ,2,tau  )-vm(j-1,k))*xwynzl*maskV(i,j-1,k)
          vvf=
     &  (u(i-1,j  ,k-1,2,taup1)-vm2(j,k-1))*xeyszu*maskV(i-1,j,k-1)
     & +(u(i,j  ,k-1,2,taup1)-vm2(j,k-1))*xwyszu*maskV(i,j,k-1)
     & +(u(i-1,j  ,k  ,2,taup1)-vm2(j,k))*xeyszl*maskV(i-1,j,k)
     & +(u(i,j  ,k  ,2,taup1)-vm2(j,k))*xwyszl*maskV(i,j,k)
     & +(u(i-1,j-1,k-1,2,taup1)-vm2(j-1,k-1))*xeynzu*maskV(i-1,j-1,k-1)
     & +(u(i,j-1,k-1,2,taup1)-vm2(j-1,k-1))*xwynzu*maskV(i,j-1,k-1)
     & +(u(i-1,j-1,k  ,2,taup1)-vm2(j-1,k))*xeynzl*maskV(i-1,j-1,k)
     & +(u(i,j-1,k  ,2,taup1)-vm2(j-1,k))*xwynzl*maskV(i,j-1,k)
#else
          vvh=u(i-1,j  ,k-1,2,tau  )*xeyszu+u(i,j  ,k-1,2,tau  )*xwyszu
     &       +u(i-1,j  ,k  ,2,tau  )*xeyszl+u(i,j  ,k  ,2,tau  )*xwyszl
     &       +u(i-1,j-1,k-1,2,tau  )*xeynzu+u(i,j-1,k-1,2,tau  )*xwynzu
     &       +u(i-1,j-1,k  ,2,tau  )*xeynzl+u(i,j-1,k  ,2,tau  )*xwynzl
          vvf=u(i-1,j  ,k-1,2,taup1)*xeyszu+u(i,j  ,k-1,2,taup1)*xwyszu
     &       +u(i-1,j  ,k  ,2,taup1)*xeyszl+u(i,j  ,k  ,2,taup1)*xwyszl
     &       +u(i-1,j-1,k-1,2,taup1)*xeynzu+u(i,j-1,k-1,2,taup1)*xwynzu
     &       +u(i-1,j-1,k  ,2,taup1)*xeynzl+u(i,j-1,k  ,2,taup1)*xwynzl
#endif
          vv=th*vvh+tf*vvf
c-----------------------------------------------------------------------
c           find w-box and distances to borders, account for free slip
c-----------------------------------------------------------------------
          i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
          if (pxyz(1,n) > xt(i) )  i=i+1
          xe = (xt(i) - pxyz(1,n)); xw = (pxyz(1,n)-xt(i-1))
          if (pxyz(2,n) > yt(j) )  j=j+1
          yn = (yt(j) - pxyz(2,n)); ys = (pxyz(2,n) - yt(j-1))
          zu = (zw(k) - pxyz(3,n)); zl = (pxyz(3,n)-zw(k-1))

          if (maskT(ilim(i+1),j,k)==0) then; xe=dx;xw=0; endif
          if (maskT(i-1,j,k)==0) then; xe=0;xw=dx; endif
          if (maskT(i,jlim(j+1),k)==0) then; yn=dx;ys=0; endif
          if (maskT(i,j-1,k)==0) then; yn=0;ys=dx; endif

	  dv = 1./(dx*dx*dz)
          xeyszu = xe*ys*zu*dv; xwyszu = xw*ys*zu*dv
          xeyszl = xe*ys*zl*dv; xwyszl = xw*ys*zl*dv
          xeynzu = xe*yn*zu*dv; xwynzu = xw*yn*zu*dv
          xeynzl = xe*yn*zl*dv; xwynzl = xw*yn*zl*dv
c-----------------------------------------------------------------------
c           interpolate w on particle position
c-----------------------------------------------------------------------
#ifdef remove_zonal_mean
          wwh=
     &  (u(i-1,j  ,k-1,3,tau  )-wm(j,k-1))*xeyszu*maskW(i-1,j,k-1)
     & +(u(i,j  ,k-1,3,tau  )-wm(j,k-1))*xwyszu*maskW(i,j,k-1)
     & +(u(i-1,j  ,k  ,3,tau  )-wm(j,k))*xeyszl*maskW(i-1,j,k)
     & +(u(i,j  ,k  ,3,tau  )-wm(j,k))*xwyszl*maskW(i,j,k)
     & +(u(i-1,j-1,k-1,3,tau  )-wm(j-1,k-1))*xeynzu*maskW(i-1,j-1,k-1)
     & +(u(i,j-1,k-1,3,tau  )-wm(j-1,k-1))*xwynzu*maskW(i,j-1,k-1)
     & +(u(i-1,j-1,k  ,3,tau  )-wm(j-1,k))*xeynzl*maskW(i-1,j-1,k)
     & +(u(i,j-1,k  ,3,tau  )-wm(j-1,k))*xwynzl*maskW(i,j-1,k)
         if (.not. enable_hydrostatic ) then
          wwf=
     &  (u(i-1,j  ,k-1,3,taup1)-wm2(j,k-1))*xeyszu*maskW(i-1,j,k-1)
     & +(u(i,j  ,k-1,3,taup1)-wm2(j,k-1))*xwyszu*maskW(i,j,k-1)
     & +(u(i-1,j  ,k  ,3,taup1)-wm2(j,k))*xeyszl*maskW(i-1,j,k)
     & +(u(i,j  ,k  ,3,taup1)-wm2(j,k))*xwyszl*maskW(i,j,k)
     & +(u(i-1,j-1,k-1,3,taup1)-wm2(j-1,k-1))*xeynzu*maskW(i-1,j-1,k-1)
     & +(u(i,j-1,k-1,3,taup1)-wm2(j-1,k-1))*xwynzu*maskW(i,j-1,k-1)
     & +(u(i-1,j-1,k  ,3,taup1)-wm2(j-1,k))*xeynzl*maskW(i-1,j-1,k)
     & +(u(i,j-1,k  ,3,taup1)-wm2(j-1,k))*xwynzl*maskW(i,j-1,k)
#else
          wwh=u(i-1,j  ,k-1,3,tau  )*xeyszu+u(i,j  ,k-1,3,tau  )*xwyszu
     &       +u(i-1,j  ,k  ,3,tau  )*xeyszl+u(i,j  ,k  ,3,tau  )*xwyszl
     &       +u(i-1,j-1,k-1,3,tau  )*xeynzu+u(i,j-1,k-1,3,tau  )*xwynzu
     &       +u(i-1,j-1,k  ,3,tau  )*xeynzl+u(i,j-1,k  ,3,tau  )*xwynzl
         if (.not. enable_hydrostatic ) then
          wwf=u(i-1,j  ,k-1,3,taup1)*xeyszu+u(i,j  ,k-1,3,taup1)*xwyszu
     &       +u(i-1,j  ,k  ,3,taup1)*xeyszl+u(i,j  ,k  ,3,taup1)*xwyszl
     &       +u(i-1,j-1,k-1,3,taup1)*xeynzu+u(i,j-1,k-1,3,taup1)*xwynzu
     &       +u(i-1,j-1,k  ,3,taup1)*xeynzl+u(i,j-1,k  ,3,taup1)*xwynzl
#endif          
          ww=th*wwh+tf*wwf
         else
          ww=wwh
         endif
c-----------------------------------------------------------------------
c         integrate the particle trajectory forward for one time step
c-----------------------------------------------------------------------
          xold=pxyz(1,n); yold=pxyz(2,n); zold=pxyz(3,n)
          pxyz(1,n) = pxyz(1,n) + dt_in*uu/mmax
          pxyz(2,n) = pxyz(2,n) + dt_in*vv/mmax
          pxyz(3,n) = pxyz(3,n) + dt_in*ww/mmax
          puvw(1,n)=uu; puvw(2,n)=vv; puvw(3,n)=ww
c-----------------------------------------------------------------------
c           update index of bounding tracer volume
c-----------------------------------------------------------------------
          i  = pijk(1,n); j  = pijk(2,n); k  = pijk(3,n)
          if (pxyz(1,n) >= xu(i)) then
            pijk(1,n) = i + 1
          else if (pxyz(1,n) < xu(i-1)) then
            pijk(1,n) = i - 1
          endif
          if (enable_cyclic_x .and. pijk(1,n)==imt) then
             pijk(1,n)=2; pxyz(1,n)=pxyz(1,n)-dx*(imt-2)
          endif
          if (enable_cyclic_x .and. pijk(1,n)==1) then
            pijk(1,n)=imt-1; pxyz(1,n)=pxyz(1,n)+dx*(imt-2)
          endif

          if (pxyz(2,n) >= yu(j)) then
            pijk(2,n) = j + 1
          else if (pxyz(2,n) < yu(j-1)) then
            pijk(2,n) = j - 1
          endif
          if (enable_cyclic_y .and. pijk(2,n)==jmt) then
             pijk(2,n)=2; pxyz(2,n)=pxyz(2,n)-dx*(jmt-2)
          endif
          if (enable_cyclic_y .and. pijk(2,n)==1) then
            pijk(2,n)=jmt-1; pxyz(2,n)=pxyz(2,n)+dx*(jmt-2)
          endif

          if (pxyz(3,n) >= zw(k)) then
            pijk(3,n) = k + 1
          else if (pxyz(3,n) < zw(k-1)) then
            pijk(3,n) = k - 1
          endif
c-----------------------------------------------------------------------
c         constrain particles vertically to lie within ocean
c-----------------------------------------------------------------------
          if (pijk(3,n) /= k) then
            if (pijk(3,n) > k .and. maskT(i,j,k+1) ==0.) then
              pxyz(3,n) = zold
              pijk(3,n) = k
            endif
            if (pijk(3,n) < k .and. maskT(i,j,k-1) ==0.) then
              pxyz(3,n) = zold
              pijk(3,n) = k
            endif
          endif
c-----------------------------------------------------------------------
c         constrain particles longitudinally to stay within ocean 
c-----------------------------------------------------------------------
          if (pijk(1,n) /= i) then
            if (pijk(1,n) > i .and. maskT(i+1,j,k) ==0.) then
              pxyz(1,n) = xold
              pijk(1,n) = i
            else if (pijk(1,n) < i .and. maskT(i-1,j,k) ==0.) then
              pxyz(1,n) = xold
              pijk(1,n) = i
            endif 
          endif 
c-----------------------------------------------------------------------
c         constrain particles latitudinally to stay within ocean 
c-----------------------------------------------------------------------
          if (pijk(2,n) /= j) then
            if (pijk(2,n) > j .and. maskT(i,j+1,k) == 0. ) then
              pxyz(2,n) = yold
              pijk(2,n) = j
            else if (pijk(2,n) < j .and. maskT(i,j-1,k) == 0.) then
              pxyz(2,n) = yold
              pijk(2,n) = j
            endif 
          endif 
        endif ! particle_active
c-----------------------------------------------------------------------
c      average some quantitites
c-----------------------------------------------------------------------

#ifdef  particle_averages
        mu(n)=mu(n)+uu
        muu(n)=muu(n)+uu**2
        mv(n)=mv(n)+vv
        mvv(n)=mvv(n)+vv**2
        mw(n)=mw(n)+ww
        mww(n)=mww(n)+ww**2
#endif
       enddo ! nptraj
#ifdef  particle_averages
       counter=counter+1
#endif
       call particle_distribute
      enddo ! m
c-----------------------------------------------------------------------
c      write particle positions to netcdf file
c-----------------------------------------------------------------------
      if (float_snapshot_time_step.or.initial_time==current_time) then
#ifdef  particle_averages
         mu=mu/counter; muu=muu/counter-mu**2
         mv=mv/counter; mvv=mvv/counter-mv**2
         mw=mw/counter; mww=mww/counter-mw**2
#endif
        if (my_pe==0) then
         print*,'writing particles to file float.cdf'
         iret=nf_open('float.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         iret=nf_inq_varid(ncid,'x_pos',xid)
         iret=nf_inq_varid(ncid,'y_pos',yid)
         iret=nf_inq_varid(ncid,'z_pos',zid)
         iret=nf_inq_varid(ncid,'u',uid)
         iret=nf_inq_varid(ncid,'v',vid)
         iret=nf_inq_varid(ncid,'w',wid)
         iret=nf_inq_varid(ncid,'uu',uuid)
         iret=nf_inq_varid(ncid,'vv',vvid)
         iret=nf_inq_varid(ncid,'ww',wwid)
#ifdef particle_buoyancy
         iret=nf_inq_varid(ncid,'b',bid)
         iret=nf_inq_varid(ncid,'p',pid)
#endif
         iret=nf_inq_dimid(ncid,'Time',timedim)
         iret=nf_inq_dimlen(ncid, timedim,ilen)
         iret=nf_inq_varid(ncid,'Time',timeid)
         ilen=ilen+1
         time = current_time-initial_time
         fxa = time%days + time%seconds/86400.
         iret= nf_put_vara_double(ncid,timeid,ilen,1,fxa)
         do n=1,nptraj
        iret= nf_put_vara_double(ncid,xid,(/n,ilen/),(/1,1/),pxyz(1,n))
        iret= nf_put_vara_double(ncid,yid,(/n,ilen/),(/1,1/),pxyz(2,n))
        iret= nf_put_vara_double(ncid,zid,(/n,ilen/),(/1,1/),pxyz(3,n))
#ifdef  particle_averages
        iret= nf_put_vara_double(ncid,uid,(/n,ilen/),(/1,1/),mu(n))
        iret= nf_put_vara_double(ncid,vid,(/n,ilen/),(/1,1/),mv(n))
        iret= nf_put_vara_double(ncid,wid,(/n,ilen/),(/1,1/),mw(n))
        iret= nf_put_vara_double(ncid,uuid,(/n,ilen/),(/1,1/),muu(n))
        iret= nf_put_vara_double(ncid,vvid,(/n,ilen/),(/1,1/),mvv(n))
        iret= nf_put_vara_double(ncid,wwid,(/n,ilen/),(/1,1/),mww(n))
#else
        iret= nf_put_vara_double(ncid,uid,(/n,ilen/),(/1,1/),puvw(1,n))
        iret= nf_put_vara_double(ncid,vid,(/n,ilen/),(/1,1/),puvw(2,n))
        iret= nf_put_vara_double(ncid,wid,(/n,ilen/),(/1,1/),puvw(3,n))
#endif
#ifdef particle_buoyancy
        iret= nf_put_vara_double(ncid,bid,(/n,ilen/),(/1,1/),ptr(1,n))
        iret= nf_put_vara_double(ncid,pid,(/n,ilen/),(/1,1/),ptr(2,n))
#endif
         enddo
         call ncclos (ncid, iret)
       endif
       call barrier
#ifdef  particle_averages
       counter=0; mu=0;muu=0;mv=0;mvv=0;mw=0;mww=0
#endif
      endif
c-----------------------------------------------------------------------
c    write restart file
c-----------------------------------------------------------------------
      if (last_time_step.and. my_pe==0) then
         print*,'writing restart file for particles'
         call get_free_iounit(io)
         open(io,file='restart_float.dta',form='unformatted',
     &          status='unknown')
         write(io) nptraj
         do n=1,nptraj
          write(io) pijk(1:3,n),pxyz(1:3,n),puvw(1:3,n)
         enddo
         close(io)
         print*,' done writing restart'
      endif
      first = .false.
      end subroutine integrate_particle


      subroutine particle_inside_pe_domain()
c=======================================================================
c       is particle inside domain of pe?
c=======================================================================
      use cpflame_module
      use particle_module
      implicit none 
      integer :: n

      do n=1,nptraj
       if (pijk(2,n)>=js_pe .and. pijk(2,n)<=je_pe) then
        particle_active(n) = .true. 
        particle_pe(n)=my_pe
       else
        particle_active(n) = .false.
        particle_pe(n)=-1
       endif
      enddo
      call global_max_int(particle_pe,nptraj)
      end subroutine particle_inside_pe_domain


      subroutine particle_distribute
c=======================================================================
c     distribute particles to all pes
c=======================================================================
      use cpflame_module
      use particle_module
      implicit none 
      integer :: n
      call barrier()
      do n=1,nptraj
       if (particle_pe(n)>=0) then
        call bcast_real(    pxyz(3,n),3,particle_pe(n))
        call bcast_integer(pijk(3,n),3,particle_pe(n))
      elseif (my_pe==0) then
        print*,' WARNING : particle #',n,' is out of domain.',
     &          ' pxyz= ',pxyz(:,n),' pijk= ',pijk(:,n),
     &          ' particle PE=',particle_pe(n)
      endif
      enddo
      end subroutine particle_distribute


      subroutine seed_particles_randomly
c=======================================================================
c      seed the particles
c=======================================================================
      use cpflame_module
      use particle_module
      implicit none 
      real :: fxa, xs,xe,ys,ye,zs,ze
      integer :: n
#ifdef two_dim
      xs=xt(2); xe=xt(imt-1)
      ys=yt(2);
      zs=zt(2); ze=zt(km-1)
      do n=1,nptraj
        pxyz(2,n) = ys
        call random_number(fxa)
        pxyz(1,n) = xs+fxa*(xe-xs)
        call random_number(fxa)
        pxyz(3,n) = zs+fxa*(ze-zs)
      enddo
#else
      xs=xt(2); xe=xt(imt-1)
      ys=xt(2); ye=yt(jmt-1)
      zs=zt(2); ze=zt(km-1)
      do n=1,nptraj
        call random_number(fxa)
        pxyz(1,n) = xs+fxa*(xe-xs)
        call random_number(fxa)
        pxyz(2,n) = ys+fxa*(ye-ys)
        call random_number(fxa)
        pxyz(3,n) = zs+fxa*(ze-zs)
      enddo
#endif
      end subroutine seed_particles_randomly


      subroutine seed_particles_regular
c=======================================================================
c      seed the particles
c=======================================================================
      use cpflame_module
      use particle_module
      implicit none 
      real :: cubr,distx,disty,distz
      integer :: i,j,k,n
      real :: xs,xe,ys,ye,zs,ze

#ifdef two_dim
      xs=xt(2); xe=xt(imt-1)
      ys=yt(2);
      zs=zt(2); ze=zt(km-1)
      cubr       = float(nptraj)**0.5
      distx      = (xe - xs)/cubr
      distz      = (ze - zs)/cubr
      pxyz(1,1) = .5*distx + xs
      pxyz(2,1) =  ys
      pxyz(3,1) = .5*distz + zs
      do n=2,nptraj
        pxyz(1,n) = pxyz(1,n-1)
        pxyz(2,n) = pxyz(2,n-1)
        pxyz(3,n) = pxyz(3,n-1)
        pxyz(1,n)  = pxyz(1,n) + distx
        if (pxyz(1,n) > xe) then
         pxyz(1,n) = xs + (pxyz(1,n)-xe)
         pxyz(2,n) = ys
         pxyz(3,n) = pxyz(3,n) + distz
       endif
      enddo
#else

      xs=xt(2); xe=xt(imt-1)
      ys=yt(2); ye=yt(jmt-1)
      zs=zt(2); ze=zt(km-1)
      cubr       = float(nptraj)**0.333333
      distx      = (xe - xs)/cubr
      disty      = (ye - ys)/cubr
      distz      = (ze - zs)/cubr
      pxyz(1,1) = .5*distx + xs
      pxyz(2,1) = .5*disty + ys
      pxyz(3,1) = .5*distz + zs
      do n=2,nptraj
        pxyz(1,n) = pxyz(1,n-1)
        pxyz(2,n) = pxyz(2,n-1)
        pxyz(3,n) = pxyz(3,n-1)
        pxyz(1,n)  = pxyz(1,n) + distx
        if (pxyz(1,n) > xe) then
         pxyz(1,n) = xs + (pxyz(1,n)-xe)
         pxyz(2,n) = pxyz(2,n) + disty
         if (pxyz(2,n) > ye) then
          pxyz(2,n) = ys + (pxyz(2,n)-ye)
          pxyz(3,n) = pxyz(3,n) + distz
         endif
        endif
      enddo
#endif
      end subroutine seed_particles_regular




#else
      subroutine particle_dummy
      end
#endif

#include "options.inc"


c#define with_topography

c=======================================================================
c     Templates for setup
c
c      Wide eddying domain with restoring zones at side walls
c=======================================================================

c increase this parameter to enhance resolution
#define RESOLVE  0.25


      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: f_0,Ro,delta,s,fxa
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt   = 128*RESOLVE 
      km    = 20 !*RESOLVE;
      jmt   = 128*RESOLVE

      dx    = 1./3.*degtom*cos(30./180.*pi)/RESOLVE
      dz    = 100.0!   /RESOLVE
      dt_in = 1800.0/RESOLVE

      K_h=000.0 /RESOLVE
      A_h=0000.0/RESOLVE
      K_v=1.0e-4!  /RESOLVE
      A_v=10.e-4!  /RESOLVE

      Ahbi  = 8e11/RESOLVE**2
      Khbi  = Ahbi
c      cdbot = 1e-6*RESOLVE
      cdbot = 0e-6*RESOLVE
      cdint = 0.1e-7


      eps2D_sor = 1e-9
      runlen    = 365.0/RESOLVE**3
      snap_int  = 3.0

c      enable_noslip               = .true.
      enable_interior_stress      = .true.
      enable_biharmonic_friction  = .true.
c      enable_biharmonic_diffusion = .true.
      enable_quicker_advection    = .true.
      enable_hydrostatic          = .true.

      gamma=0.01
      lat_ref = 20.
      beta    = 2*omega*cos(lat_ref/180.*pi)/radius
      N_0     = 0.004
      M_0     = sqrt(0.0e-5*0.1/rho_0*g)

      if (my_pe==0) then
       f_0 = 2*omega*sin(lat_ref/180.*pi)
       Ro  = (km-2)*dz*M_0**2/((jmt-2)*dx)/f_0**2
       delta = (km-2)*dz/( (jmt-2)*dx )
       s = M_0**2/N_0**2
       print*,' '
       print*,' The setup :'
       print*,' '
       print*,' Prandtl number '
       print*,'   f^2/N^2       = ',f_0**2/N_0**2
       print*,' Aspect ratio '
       print*,'   delta=H/L     = ',delta
       print*,' Rossby radius '
       print*,'  N h/(f pi)     = ',N_0*(km-2)*dz/(f_0*pi)/1e3,' km'
       print*,' Isopycnal slope '
       print*,'   s=M^2/N^2     = ',s
       print*,' '
       print*,' Rossby number '
       print*,'   H M^2/(L f^2) = ',Ro
      endif

      end subroutine set_parameter




      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: B0,x,y
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt
         x=float(i)/float(imt)
         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
         B0=M_0**2*yt(j)+0.5e-4*sin(x*8.5*pi)*exp(-(y-0.5)**2/0.5**2)
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je, spg_width = 3*RESOLVE
      real :: T_rest=1./(5.*86400),B0
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      if (my_blk_j==1) then
       do k=1,km
        do j=2,spg_width+1
         B0= yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt* 
     &             t_rest/(j-1.)*(B0-b(:,j,k,taum1))
        enddo
       enddo
      endif
      if (my_blk_j==n_pes_j) then
       do k=1,km
        do j=jmt-1,jmt-spg_width,-1
         B0= yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt* 
     &             t_rest/(-1.*(j-jmt))*(B0-b(:,j,k,taum1))
        enddo
       enddo
      endif
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: k,i,j
      real :: x,y
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
! units are m^2/s^3  
! since  b_z = N^2   b[m/s^2]   b_t = F_z   [m/s^3]=[ m^2/s^3]_z

      do j=1,jmt
       do i=1,imt
        surf_flux(i,j)  = dz/dt_in*0.0*maskT(i,j,km-1)
        y = (yu(j)-yu(1))/ (yu(jmt)-yu(1))
        surf_tau(i,j,1) = -2.0e-4*cos(2*pi*y)*maskU(i,j,km-1)
        surf_tau(i,j,2) = 0.0*maskV(i,j,km-1)
       enddo
      enddo
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none

      end subroutine topography

#include "options.inc"



      subroutine diagnose
c=======================================================================
c      Diagnostic routines
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,k,j,js,je
      real :: totke,tbar
      real :: area,fx,cflcrt,cflu,cflv,cflw,cl
      character (len=32) :: stamp
c--------------------------------------------------------------
c   calculate basin integrated kinetic energy and thickness
c--------------------------------------------------------------
      js=max(2,js_pe); je = min(je_pe,jmt-1)

      if (snapshot_time_step.or.initial_time==current_time) then

      fx = dx**2*dz
      totke=0.0;area=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          area=area + fx*maskT(i,j,k)
          totke = totke + u(i,j,k,1,tau)**2/2.0*fx*masku(i,j,k)
          totke = totke + u(i,j,k,2,tau)**2/2.0*fx*maskv(i,j,k)
        enddo
       enddo
      enddo

      if (.not. enable_hydrostatic) then
       do k=2,km-1
        do j=js,je
         do i=2,imt-1
          totke = totke + u(i,j,k,3,tau)**2/2.0*fx*maskW(i,j,k)
         enddo
        enddo
       enddo
      endif

      call global_sum(area)
      call global_sum(totke)
      totke = totke/area

      tbar=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          tbar=tbar+b(i,j,k,tau)*fx*maskT(i,j,k)
        enddo
       enddo
      enddo
      call global_sum(tbar)
      tbar = tbar / area

      call set_stamp(stamp,get_current_time())
      if (my_pe==0) print'(a,i5,a,a,a,e12.7,a,f10.8,a,a,i5,a,i5)', 
     &      ' itt=',itt,'  ',stamp,
     &  ' ke=',totke,' m^2/m^2  tbar=',tbar,' kg/m^3',
     &    ' sor2D itts = ',sor2D_itts,' sor3D_itts = ',sor3D_itts
      call sub_flush(6)

      if (totke > 1e20 ) then
        if (my_pe==0) print*,''
        if (my_pe==0) print*,' ERROR: Kinetic energy diverges '
        if (my_pe==0) print*,''
        call halt_stop(' in diagnostics')
      endif

      if (totke +1.0 .eq. totke ) then
        if (my_pe==0) print*,''
        if (my_pe==0) print*,' ERROR: detected Nans in kinetic energy '
        if (my_pe==0) print*,''
        call halt_stop(' in diagnostics')
      endif

      call diag_snap
      endif
      end subroutine diagnose


      subroutine init_snap_cdf
c-----------------------------------------------------------------------
c     initialize NetCDF snapshot file
c-----------------------------------------------------------------------
      use cpflame_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,i,j,k,n
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lat_tdim,lat_udim,id
      integer :: dims(4), corner(4), edges(4)
      character :: name*24, unit*16

      call def_grid_cdf('cpflame.cdf')
      iret=nf_open('cpflame.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'xu',lon_udim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'yu',lat_udim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'zu',z_udim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)

c     2 dim variables on t grid
      dims = (/Lon_udim,lat_tdim, z_tdim, iTimedim/)
      id  = ncvdef (ncid,'u', NCFLOAT,4,dims,iret)
      name = 'Zonal velocity         '; unit = 'm/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_udim, z_tdim, iTimedim/)
      id  = ncvdef (ncid,'v', NCFLOAT,4,dims,iret)
      name = 'Meridional velocity          '; unit = 'm/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, z_udim, iTimedim/)
      id  = ncvdef (ncid,'w', NCFLOAT,4,dims,iret)
      name = 'Vertical velocity         '; unit = 'm/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, z_tdim, iTimedim/)
      id  = ncvdef (ncid,'b', NCFLOAT,4,dims,iret)
      name = 'Buoyancy               '; unit = 'm/s^2'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      id  = ncvdef (ncid,'p', NCFLOAT,4,dims,iret)
      name = 'Pressure      '; unit = 'm^2/s^2'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, iTimedim,1/)
      id = ncvdef (ncid,'ps', NCFLOAT,3,dims,iret)
      if (enable_free_surface.or.enable_expl_free_surf) then
       name = 'Surface height'; unit = 'm'
      else
       name = 'Surface pressure'; unit = 'm^2/s^2'
      endif
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, z_udim, iTimedim/)
      if (enable_hydrostatic) then
       id  = ncvdef (ncid,'K_b', NCFLOAT,4,dims,iret)
       name = 'Vertical diffusivity'; unit = 'm^2/s'
       call dvcdf(ncid,id,name,24,unit,16,spval)
      else
       id  = ncvdef (ncid,'psi', NCFLOAT,4,dims,iret)
       name = 'Non-hydrostatic pressure'; unit = 'm^2/s^2'
       call dvcdf(ncid,id,name,24,unit,16,spval)
      endif

      dims = (/Lon_tdim,lat_tdim, iTimedim,1/)
      id = ncvdef (ncid,'surf_flux', NCFLOAT,3,dims,iret)
      name = 'Surface buoyancy flux'; unit = 'm^2/s^3'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, iTimedim,1/)
      id = ncvdef (ncid,'taux', NCFLOAT,3,dims,iret)
      name = 'Zonal wind stress'; unit = 'm^2/s^2'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      dims = (/Lon_tdim,lat_tdim, iTimedim,1/)
      id = ncvdef (ncid,'tauy', NCFLOAT,3,dims,iret)
      name = 'Meridional wind stress'; unit = 'm^2/s^2'
      call dvcdf(ncid,id,name,24,unit,16,spval)

      call ncclos (ncid, iret)

      end subroutine init_snap_cdf




      subroutine diag_snap
c-----------------------------------------------------------------------
c     write to NetCDF snapshot file
c-----------------------------------------------------------------------
      use cpflame_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      real :: a(imt,js_pe:je_pe,km)
      integer :: itdimid,ilen,pid,rid,uid,wid,itimeid
      integer :: i,j,js,je,vid,sflid,kbid,id
      real :: fxa,ut,vt
      type(time_type) :: time

      js=max(2,js_pe); je = min(je_pe,jmt-1)

      do npe=0,n_pes-1
       call barrier
       if (my_pe==npe) then

        iret=nf_open('cpflame.cdf',NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)

        iret=nf_inq_varid(ncid,'b',rid)
        iret=nf_inq_varid(ncid,'p',pid)
        iret=nf_inq_varid(ncid,'u',uid)
        iret=nf_inq_varid(ncid,'v',vid)
        iret=nf_inq_varid(ncid,'w',wid)
        iret=nf_inq_varid(ncid,'ps',sflid)
        if (enable_hydrostatic) then
         iret=nf_inq_varid(ncid,'K_b',kbid)
        else
         iret=nf_inq_varid(ncid,'psi',kbid)
        endif
        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,ilen)
        iret=nf_inq_varid(ncid,'Time',itimeid)
        if (my_pe==0) then
         ilen=ilen+1
         time = current_time-initial_time
         fxa = time%days + time%seconds/86400.
         print*,' writing a snapshot at stamp=',current_stamp,
     &          ' (days since origin : ',fxa,')',
     &          ' (time steps in file : ',ilen,')'
         iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
        endif

        Corner = (/1,js_pe,1,ilen/); !edges  = (/imt,j_blk,km,1/)
        edges  = (/imt,je_pe-js_pe+1,km,1/)

        a=b(:,js_pe:je_pe,:,tau)
        where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)

        a=p_full(:,js_pe:je_pe,:,tau)
        where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,pid,corner,edges,a)

        a=u(:,js_pe:je_pe,:,1,tau)
        where( maskU(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,uid,corner,edges,a)

        a=u(:,js_pe:je_pe,:,2,tau)
        where( maskV(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,vid,corner,edges,a)

        a=u(:,js_pe:je_pe,:,3,tau)
        where( maskW(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,wid,corner,edges,a)

        if (enable_hydrostatic) then
         a=K_b(:,js_pe:je_pe,:)+K_v
         where( maskW(:,js_pe:je_pe,:) == 0.) a = spval
        else
         a=psi(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
        endif
        iret= nf_put_vara_double(ncid,kbid,corner,edges,a)

        Corner = (/1,js_pe,ilen,1/); edges  = (/imt,j_blk,1,1/)
        if (enable_free_surface.or.enable_expl_free_surf) then
         a(:,:,km-1)=eta(:,js_pe:je_pe,tau)
        else
         a(:,:,km-1)=p_surf(:,js_pe:je_pe)
        endif
        where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,sflid,corner,edges,a(:,:,km-1))

        Corner = (/1,js_pe,ilen,1/); edges  = (/imt,j_blk,1,1/)
        iret=nf_inq_varid(ncid,'surf_flux',id)
        a(:,:,km-1)=surf_flux(:,js_pe:je_pe)
        where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a(:,:,km-1))

        iret=nf_inq_varid(ncid,'taux',id)
        a(:,:,km-1)=surf_tau(:,js_pe:je_pe,1)
        where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a(:,:,km-1))

        iret=nf_inq_varid(ncid,'tauy',id)
        a(:,:,km-1)=surf_tau(:,js_pe:je_pe,2)
        where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a(:,:,km-1))

        call ncclos (ncid, iret)

       endif
       call barrier
      enddo
      end subroutine diag_snap




      subroutine def_grid_cdf(filename)
c-----------------------------------------------------------------------
c      Define standard grid in netcdf file
c-----------------------------------------------------------------------
      use cpflame_module
      implicit none
#include "netcdf.inc"
      character*(*) filename
      integer :: ncid,iret
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lon_tid,lon_uid,z_tid,z_uid,itimeid
      integer :: lat_tdim,lat_udim,lat_uid,lat_tid
      integer :: dims(4), corner(4), edges(4)
      character :: name*24, unit*16
      character (len=200) :: text

      ncid = nccre (filename, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c     dimensions
      lon_tdim  = ncddef(ncid, 'xt', imt, iret)
      Lon_udim  = ncddef(ncid, 'xu', imt, iret)
      lat_tdim  = ncddef(ncid, 'yt', jmt, iret)
      Lat_udim  = ncddef(ncid, 'yu', jmt, iret)
      z_tdim    = ncddef(ncid, 'zt',  km, iret)
      z_udim    = ncddef(ncid, 'zu',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      Lon_tid  = ncvdef (ncid,'xt',NCFLOAT,1,lon_tdim,iret)
      Lon_uid  = ncvdef (ncid,'xu',NCFLOAT,1,lon_udim,iret)
      Lat_tid  = ncvdef (ncid,'yt',NCFLOAT,1,lat_tdim,iret)
      Lat_uid  = ncvdef (ncid,'yu',NCFLOAT,1,lat_udim,iret)
      z_tid  = ncvdef (ncid,'zt', NCFLOAT,1,z_tdim,iret)
      z_uid  = ncvdef (ncid,'zu', NCFLOAT,1,z_udim,iret)
      itimeid  = ncvdef (ncid,'Time', NCFLOAT,1,itimedim,iret)
c     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'm'
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'm'
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid     '; unit = 'm'
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid     '; unit = 'm'
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
c      name = 'Depth on T grid      '; unit = 'm'
      name = 'Height on T grid      '; unit = 'm'
      call ncaptc(ncid, z_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, z_tid, 'units',     NCCHAR, 16, unit, iret) 
c      name = 'Depth on U grid      '; unit = 'm'
      name = 'Height on U grid      '; unit = 'm'
      call ncaptc(ncid, z_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, z_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time '; unit = 'days'
      call ncaptc(ncid, itimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, itimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '01-JAN-1900 00:00:00', iret)


      write(text,'("CPFLAME Version ",f5.3)') version
#ifdef no_mpp
      text=text(1:len_trim(text))//' without MPP'
#else
      text=text(1:len_trim(text))//' with MPI'
#endif
      iret= nf_put_att_text(ncid,nf_global,'history',
     &                      len_trim(text),text)

#ifndef no_mpp
      iret= nf_put_att_int(ncid,nf_global,'n_pes_j',nf_int,1,n_pes_j)
      iret= nf_put_att_int(ncid,nf_global,'j_blk',nf_int,1,j_blk)
#endif


      call ncendf(ncid, iret)
      iret= nf_put_vara_double(ncid,lon_Tid,1,imt,xt)
      iret= nf_put_vara_double(ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_double(ncid,lat_Tid,1,jmt,yt)
      iret= nf_put_vara_double(ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_double(ncid,z_tid,1,km,zt)
      iret= nf_put_vara_double(ncid,z_uid,1,km,zw)
      call ncclos (ncid, iret)
      end subroutine def_grid_cdf





      subroutine dvcdf(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c     define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character (len=*) :: name, unit
      real :: spval
      real :: vv
#include "netcdf.inc"
      vv=spval
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
c      call ncapt (ncid,ivarid, 'missing_value',NCFLOAT,1,vv,iret)
      call ncapt (ncid,ivarid, 'missing_value',NCDOUBLE,1,vv,iret)
        if (iret.ne.0) print*,nf_strerror(iret)
c      call ncapt (ncid,ivarid, '_FillValue', NCFLOAT, 1,vv, iret)
      call ncapt (ncid,ivarid, '_FillValue', NCDOUBLE, 1,vv, iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf

#include "options.inc"


c=======================================================================
c  add effect of a prescribed background stratification in buoyancy
c  to buoyancy budget. Also the effect of background zonal and meridional
c  velocity (but not both).
c  linked in the code in driver.F 
c
c    the case 
c    b=b'(x,y,z,t) + B(z)
c    p=p'(x,y,t,z)+P(z) with P_z = -B,  P(z=0)=0
c    u=u'(x,y,z,t)+U(z)
c
c    b'_t = -(u'b')_x - (vb')_y - (wb')_z + diffusion(b')+convection(b+B)
c             -(wB)_z-(u'B)_x-(vB)_y-(Ub')_x
c    
c    u'_t =-p_x -(u'u')_x-(vu')_y-(wu')_z+friction(u')  -(Uu')_x  -(u'U)_x-(vU)_y-(wU)_z
c    v'_t =-p_y -(u'v)_x-(vv)_y-(wv)_z+friction(v)  -(Uv)_x
c    w'_t =-p_z -(u'w)_x-(vw)_y-(ww)_z+friction(w)  -(Uw)_x - b 
c
c   with Coriolis force: specify U(z) and B=f y U_z with U(0)=0
c   thus best to set U=U_0 z/h  and B=f y U_0/h 
c
c    P_y = -fU(z)   ->  P(y,z)= - f y U(z) + f(z),  note that U(0)=0, such that P(0)=0
c    P_z = -B, ->  B= f y U_z + f'Q
c
c   numerically consistent:  B_{j+1}=B_{j} + dx*U_z (coriolis_t(j  )+coriolis_t(j+1))/2.0
c
c    U(z), P(y,z), B(y,z)
c
c    b'_t = -(u'b')_x - (vb')_y - (wb')_z + diffusion(b')+convection(b+B)
c             -(wB)_z-(u'B)_x-(vB)_y-(Ub')_x
c    u'_t =fv  -p_x -(u'u')_x-(vu')_y-(wu')_z  -(Uu')_x  -(u'U)_x-(vU)_y-(wU)_z
c    v'_t =-fu' -p_y -(u'v)_x-(vv)_y-(wv)_z  -(Uv)_x 
c
c    non-hydrostatic and U(z), P(y,z) and B(y,z):
c    b'_t = -(u'b')_x - (vb')_y - (wb')_z + diffusion(b')+convection(b+B)
c             -(wB)_z-(u'B)_x-(vB)_y-(Ub')_x
c    u'_t =fv -f_h w -p_x -(u'u')_x-(vu')_y-(wu')_z  -(Uu')_x -(u'U)_x-(vU)_y-(wU)_z
c    v'_t =-fu'      -p_y -(u'v)_x-(vv)_y-(wv)_z     -(Uv)_x 
c    w'_t =f_h u'    -p_z -(u'w)_x-(vw)_y-(ww)_z     -(Uw)_x  -b + f_h U 
c                                  (the last term is not yet implemented!!!!)
c
c=======================================================================

#ifdef enable_back_stratification

c-----------------------------------------------------------------------
c  enable effect of a background stratification B
c
#define apply_back_stratification
c-----------------------------------------------------------------------
c   enable effect of background zonal or meridional advection 
c   no not use both
c
c#define apply_back_zonal_velocity
#define apply_back_meridional_velocity
c-----------------------------------------------------------------------
c    convection accounting for full buoyancy b+B
c
#define apply_back_convection
c-----------------------------------------------------------------------

      module back_stratification_module
      implicit none
      real, allocatable :: back(:,:,:,:)  ! background stratification B, depends on
                                          ! time and x/y only for technical reasons
      real, allocatable :: u0(:,:,:)      ! background zonal/meridional advection U
      end module back_stratification_module

      subroutine init_back_stratification
c-----------------------------------------------------------------------
c     initialize module
c-----------------------------------------------------------------------
      use cpflame_module
      use back_stratification_module
      implicit none
      integer :: k

      if (my_pe==0) print*,' using module background stratification '
#ifdef apply_back_stratification
      if (my_pe==0) print*,' applying background stratification '
#endif
#ifdef apply_back_zonal_velocity
      if (my_pe==0) print*,' applying background zonal velocity '
#endif
#ifdef apply_back_meridional_velocity
      if (my_pe==0) print*,' applying background meridional velocity '
#endif
#ifdef apply_back_convection
      if (my_pe==0) print*,' applying convection '
#endif
#if defined apply_back_meridional_velocity && defined apply_back_zonal_velocity
      if (my_pe==0) then
       print*,' ERROR: background meridional ',
     &           'plus zonal velocity does not work'
      endif
      call halt_stop('in back_stratification')
#endif
      allocate( back(imt,jmt,km,0:2), u0(imt,jmt,km) )
      back=0;u0=0
c    call template routine to set background stratification
      call set_back_stratification(back(:,:,:,0),u0)
      back(:,:,:,1)=back(:,:,:,0); back(:,:,:,2)=back(:,:,:,0)
      call diag_back_stratification
      end subroutine init_back_stratification



      subroutine back_stratification
c-----------------------------------------------------------------------
c    apply effect of background stratification on buoyancy budget
c-----------------------------------------------------------------------
      use cpflame_module
      use back_stratification_module
      implicit none
      integer :: i,j,k,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real :: uback(imt,jmt,km,3)

      js=max(2,js_pe); je = min(je_pe,jmt-1)
#ifdef apply_back_stratification
c---------------------------------------------------------------------------------
c     background stratification  
c---------------------------------------------------------------------------------
      adv_fe(:,js_pe:je_pe,:)=0; adv_fn(:,js_pe:je_pe,:)=0
      adv_ft(:,js_pe:je_pe,:)=0
      call adv_flux(adv_fe,adv_fn,adv_ft,back)
      call border_exchg3D(adv_fn,1)
      call setcyclic3D(adv_fe); call setcyclic3D(adv_fn)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         b(i,j,k,taup1)=b(i,j,k,taup1)+maskT(i,j,k)*c2dt*( 
     &  -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx
     &  -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx
     &  -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo
#endif

#ifdef apply_back_zonal_velocity
c---------------------------------------------------------------------------------
c     effect of zonal background velocity
c---------------------------------------------------------------------------------
      do j=js_pe,je_pe
       uback(:,j,:,:)=u(:,j,:,1:3,tau);
       u(:,j,:,1,tau)=u0(:,j,:); u(:,j,:,2:3,tau)=0.
      enddo
      adv_fe(:,js_pe:je_pe,:)=0; adv_fn(:,js_pe:je_pe,:)=0
      adv_ft(:,js_pe:je_pe,:)=0
      call adv_flux(adv_fe,adv_fn,adv_ft,b)
      u(:,js_pe:je_pe,:,1:3,tau)=uback(:,js_pe:je_pe,:,:)
      call border_exchg3D(adv_fn,1)
      call setcyclic3D(adv_fe); call setcyclic3D(adv_fn)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         b(i,j,k,taup1)=b(i,j,k,taup1)+maskT(i,j,k)*c2dt*( 
     &  -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx
     &  -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx
     &  -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo
#endif

#ifdef apply_back_meridional_velocity
c---------------------------------------------------------------------------------
c     effect of zonal background velocity
c---------------------------------------------------------------------------------
      do j=js_pe,je_pe
       uback(:,j,:,:)=u(:,j,:,1:3,tau);
       u(:,j,:,2,tau)=u0(:,j,:); u(:,j,:,1,tau)=0.;u(:,j,:,3,tau)=0.
      enddo
      adv_fe(:,js_pe:je_pe,:)=0; adv_fn(:,js_pe:je_pe,:)=0
      adv_ft(:,js_pe:je_pe,:)=0
      call adv_flux(adv_fe,adv_fn,adv_ft,b)
      u(:,js_pe:je_pe,:,1:3,tau)=uback(:,js_pe:je_pe,:,:)
      call border_exchg3D(adv_fn,1)
      call setcyclic3D(adv_fe); call setcyclic3D(adv_fn)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         b(i,j,k,taup1)=b(i,j,k,taup1)+maskT(i,j,k)*c2dt*( 
     &  -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx
     &  -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx
     &  -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz )
        enddo
       enddo
      enddo
#endif

#ifdef apply_back_convection
c---------------------------------------------------------------------------------
c      Convection
c---------------------------------------------------------------------------------
       if (enable_hydrostatic) then
        K_b(:,js:je,:) = 0.0
        do j=js,je
         do k=1,km-1
          do i=2,imt
           if ( b(i,j,k+1,taum1)+back(i,j,k+1,taum1) > 
     &         b(i,j,k   ,taum1) +back(i,j,k,taum1) )
     &         K_b(i,j,k)=1000.*maskW(i,j,k)
          enddo
         enddo
        enddo
        call implicit_tracer_mix(b,K_b)
       endif
#endif
c---------------------------------------------------------------------------------
c      Boundary exchange 
c---------------------------------------------------------------------------------
      call border_exchg3D(b(:,:,:,taup1),2);
      call setcyclic3D(b(:,:,:,taup1) )
      end subroutine back_stratification



      subroutine back_strat_momentum
c-----------------------------------------------------------------------
c    apply effect of background velocity on momentum
c-----------------------------------------------------------------------
      use cpflame_module
      use back_stratification_module
      implicit none
      integer :: i,j,k,js,je
      real :: adv_fe(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real :: adv_ft(imt,jmt,km)

      js=max(2,js_pe); je = min(je_pe,jmt-1)

c-----------------------------------------------------------------------
c    zonal momentum equation
c-----------------------------------------------------------------------
#ifdef apply_back_zonal_velocity
      adv_fe(:,js_pe:je_pe,:)=0.0; adv_fn(:,js_pe:je_pe,:)=0.0; 
      adv_ft(:,js_pe:je_pe,:)=0.0; 
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         adv_fe(i,j,k)=2*
     &  0.5*( u0(i  ,j,k) + u0(i+1,j,k) )*
     &   (u(i,j,k,1,tau)+u(i+1,j,k,1,tau))
     &        *0.5*maskU(i+1,j,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(adv_fe)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         adv_fn(i,j,k)=
     &  0.5*( u0(i,j,k) + u0(i,j+1,k) )*
     &   (u(i,j,k,2,tau)+u(i+1,j,k,2,tau))
     &        *0.5*maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         adv_ft(i,j,k)=
     &  0.5*(u0(i,j,k)+u0(i,j,k+1))*
     &   (u(i,j,k,3,tau)+u(i+1,j,k,3,tau))
     &        *0.5*maskU(i,j,k+1)*maskU(i,j,k)
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fu(i,j,k)= fu(i,j,k)+maskU(i,j,k)*(
     &    -(adv_fe(i,j,k) - adv_fe(i-1,j,k) )/dx
     &    -(adv_fn(i,j,k) - adv_fn(i,j-1,k) )/dx
     &    -(adv_ft(i,j,k) - adv_ft(i,j,k-1) )/dz  )
        enddo
       enddo
      enddo
#endif
#ifdef apply_back_meridional_velocity
      adv_fn(:,js_pe:je_pe,:)=0.0; 
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         adv_fn(i,j,k)=
     &  0.5*( u(i,j,k,1,tau) + u(i,j+1,k,1,tau) )*
     &   (u0(i,j,k)+u0(i+1,j,k))
     &        *0.5*maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fu(i,j,k)= fu(i,j,k)+maskU(i,j,k)*(
     &    -(adv_fn(i,j,k) - adv_fn(i,j-1,k) )/dx )
        enddo
       enddo
      enddo
#endif

c-----------------------------------------------------------------------
c    meridional momentum equation
c-----------------------------------------------------------------------
#ifdef apply_back_zonal_velocity
      adv_fe(:,js_pe:je_pe,:)=0.0; 
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         adv_fe(i,j,k)=
     &  0.5*( u(i  ,j,k,2,tau) + u(i+1,j,k,2,tau) )*
     &    (u0(i,j,k)+u0(i,j+1,k))
     &        *0.5*maskV(i+1,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(adv_fe)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fv(i,j,k)= fv(i,j,k)+maskV(i,j,k)*(
     &    -(adv_fe(i,j,k) - adv_fe(i-1,j,k) )/dx)
        enddo
       enddo
      enddo
#endif

#ifdef apply_back_meridional_velocity
      adv_fe(:,js_pe:je_pe,:)=0.0; adv_fn(:,js_pe:je_pe,:)=0.0; 
      adv_ft(:,js_pe:je_pe,:)=0.0; 
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         adv_fe(i,j,k)=
     &  0.5*( u0(i  ,j,k) + u0(i+1,j,k) )*
     &    (u(i,j,k,1,tau)+u(i,j+1,k,1,tau))
     &        *0.5*maskV(i+1,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(adv_fe)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         adv_fn(i,j,k)=2*
     &  0.5*( u0(i,j,k) + u0(i,j+1,k) )*
     &   (u(i,j,k,2,tau)+u(i,j+1,k,2,tau))
     &        *0.5*maskV(i,j+1,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         adv_ft(i,j,k)=
     &  0.5*( u0(i,j,k) + u0(i,j,k+1) )*
     &   (u(i,j,k,3,tau)+u(i,j+1,k,3,tau))
     &        *0.5*maskV(i,j,k+1)*maskV(i,j,k)
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fv(i,j,k)= fv(i,j,k)+maskV(i,j,k)*(
     &    -(adv_fe(i,j,k) - adv_fe(i-1,j,k) )/dx
     &    -(adv_fn(i,j,k) - adv_fn(i,j-1,k) )/dx
     &    -(adv_ft(i,j,k) - adv_ft(i,j,k-1) )/dz  )
        enddo
       enddo
      enddo
#endif

      if (.not. enable_hydrostatic) then
c-----------------------------------------------------------------------
c    vertical momentum equation
c-----------------------------------------------------------------------
#ifdef apply_back_zonal_velocity
       adv_fe(:,js_pe:je_pe,:)=0.0
       do k=2,km-1
        do j=js,je
         do i=1,imt-1
          adv_fe(i,j,k)=
     &     0.5*( u(i  ,j,k,3,tau) + u(i+1,j,k,3,tau) )*
     &         (u0(i,j,k)+u0(i,j,k+1))
     &        *0.5*maskW(i+1,j,k)*maskW(i,j,k)
         enddo
        enddo
       enddo
       call setcyclic3D(adv_fe)
       do k=2,km-1
        do j=js,je
         do i=2,imt-1
          fw(i,j,k)= fw(i,j,k)+maskW(i,j,k)*(
     &     -(adv_fe(i,j,k) - adv_fe(i-1,j,k) )/dx)
         enddo
        enddo
       enddo
#endif
#ifdef apply_back_meridional_velocity
      adv_fn(:,js_pe:je_pe,:)=0.0; 
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         adv_fn(i,j,k)=
     &     0.5*( u(i,j,k,3,tau) + u(i,j+1,k,3,tau) )*
     &     (u0(i,j,k)+u0(i,j,k+1))
     &        *0.5*maskW(i,j+1,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
      do k=2,km-1
       do j=js,je
         do i=2,imt-1
          fw(i,j,k)= fw(i,j,k)+maskW(i,j,k)*(
     &     -(adv_fn(i,j,k) - adv_fn(i,j-1,k) )/dx)
        enddo
       enddo
      enddo
#endif
      endif
#if defined apply_back_zonal_velocity || defined apply_back_meridional_velocity
c---------------------------------------------------------------------------------
c       boundary exchange for result
c---------------------------------------------------------------------------------
      call border_exchg3D(fu,1); call setcyclic3D(fu)
      call border_exchg3D(fv,1); call setcyclic3D(fv)
      if (.not. enable_hydrostatic) then
       call border_exchg3D(fw,1); call setcyclic3D(fw)
      endif
#endif
      end subroutine back_strat_momentum



      subroutine diag_back_stratification
c-----------------------------------------------------------------------
c    write diagnostics
c-----------------------------------------------------------------------
      use cpflame_module
      use back_stratification_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,i,j,k,n,npe
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lat_tdim,lat_udim,varid
      integer :: dims(4), corner(4), edges(4)
      character :: name*24, unit*16
      real :: a(imt,js_pe:je_pe,km)
      if (my_pe==0) then
       call def_grid_cdf('back_stratification.cdf')
       iret=nf_open('back_stratification.cdf',NF_WRITE,ncid)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       call ncredf(ncid, iret)
       iret=nf_inq_dimid(ncid,'xt',lon_tdim)
       iret=nf_inq_dimid(ncid,'xu',lon_udim)
       iret=nf_inq_dimid(ncid,'yt',lat_tdim)
       iret=nf_inq_dimid(ncid,'yu',lat_udim)
       iret=nf_inq_dimid(ncid,'zt',z_tdim)
       iret=nf_inq_dimid(ncid,'zu',z_udim)
#ifdef apply_back_stratification
       dims = (/Lon_tdim,lat_tdim, z_tdim, 1/)
       varid  = ncvdef (ncid,'back', NCFLOAT,3,dims,iret)
       name = 'Background buoyancy'; unit = 'm/s^2'
       call dvcdf(ncid,varid,name,24,unit,16,spval)
#endif
#ifdef apply_back_zonal_velocity
       dims = (/Lon_udim,lat_tdim, z_tdim, 1/)
       varid  = ncvdef (ncid,'u0', NCFLOAT,3,dims,iret)
       name = 'Background zonal velocity'; unit = 'm/s'
       call dvcdf(ncid,varid,name,24,unit,16,spval)
#endif
#ifdef apply_back_meridional_velocity
       dims = (/Lon_tdim,lat_udim, z_tdim, 1/)
       varid  = ncvdef (ncid,'v0', NCFLOAT,3,dims,iret)
       name = 'Background meridional velocity'; unit = 'm/s'
       call dvcdf(ncid,varid,name,24,unit,16,spval)
#endif
       call ncclos (ncid, iret)
      endif

      do npe=0,n_pes-1
       call barrier
       if (my_pe==npe) then
        iret=nf_open('back_stratification.cdf',NF_WRITE,ncid)
        Corner = (/1,js_pe,1,1/); edges=(/imt,je_pe-js_pe+1,km,1/)
#ifdef apply_back_stratification
        iret=nf_inq_varid(ncid,'back',varid)
        a=back(:,js_pe:je_pe,:,tau)
        where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,varid,corner,edges,a)
#endif
#ifdef apply_back_zonal_velocity
        iret=nf_inq_varid(ncid,'u0',varid)
        a=u0(:,js_pe:je_pe,:)
        where( maskU(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,varid,corner,edges,a)
#endif
#ifdef apply_back_meridional_velocity
        iret=nf_inq_varid(ncid,'v0',varid)
        a=u0(:,js_pe:je_pe,:)
        where( maskV(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,varid,corner,edges,a)
#endif
        call ncclos (ncid, iret)
       endif
      enddo
      end subroutine diag_back_stratification





#else
      subroutine dummy_back_stratification
      end subroutine dummy_back_stratification
#endif

c=======================================================================
c
c     Setup for a simple biogeochemical model:
c      (P: phytoplankton, N: Nitrate and D: Detritus)
c
#define enable_zooplankton
c
#ifdef enable_zooplankton
c      dN/dt = r D + d Z - u(N,Temp.,Light) P  
c      dP/dt = u(N,Temp.,Light) P - p_P P       - g(P) P Z 
c      dD/dt =  p_P P -r D + w_D dD/dz          + (1-a) g(P) P Z + p_Z Z^2
c      dZ/dt = a g(P) P Z - d Z - p_Z Z^2
#else
c      dN/dt = r D  - u(N,Temp.,Light) P  
c      dP/dt = 0.2 u(N,Temp.,Light) P - p_P P      
c      dD/dt =  p_P P -r D + w_D dD/dz   +0.8 u(N,Temp.,Light) P
#endif
c
c     linked in the code in ../extra_modules/tracer.F
c=======================================================================

      module bgc_module
      use cpflame_module
      use tracer_module
      implicit none
c ----------------------------------
c    Parameters for the biogeochemical model
c ----------------------------------
#ifdef enable_zooplankton
      integer :: nut=1,phy=2,zoo=3,det=4,oxy=5,dic=6
#else
      integer :: nut=1,phy=2,det=3,oxy=4,dic=5
#endif
      real, allocatable :: solar(:,:) ! solar radiation in W/m^2
      real, allocatable :: sss(:,:)   ! sea surface salinity in psu
      real, allocatable :: u10(:,:)  ! wind speed in 10 m height in m/s
      real, allocatable :: u_nut(:,:,:)  ! phytoplankton growth rate
      real, allocatable :: u_light(:,:,:)  ! phytoplankton growth rate
      real, allocatable :: o2_sflx(:,:), o2_sat(:,:)
      real, allocatable :: dic_sflx(:,:) ,pco2(:,:)
      real, parameter :: phiphy   = 0.03 /86400.  ! phytoplankton death rate
      real, parameter :: remina =   0.05*0.8 /86400. ! detritus remineralisation rate 
      real, parameter :: w_detr   = -5.0  /86400.  ! sinking velocity of detritus at surface
      real, parameter :: w_detr2  = -5.0  /86400.  ! sinking velocity of detritus at depth
      real, parameter :: abio     = 0.6 /86400.  ! saturation growth rate
      real, parameter :: bbio     = 1.066 ! constants for saturation growth rate
      real, parameter :: cbio     = 1.0
#ifdef enable_zooplankton
      real, parameter  :: phizoo   = 0.20 /86400.   ! zooplankton mortality rate
      real, parameter  :: d_npz    = 0.03 /86400.  ! zooplankton excretation rate
      real, parameter  :: a_npz    = 0.75             ! zooplanktion grazing fraction
      real, parameter  :: gbio      = 2.0  /86400.   ! zooplankton grazing rate
      real, parameter  :: epsbio   = 1.0  /86400.   ! zooplankton grazing rate
#endif
      real, parameter :: rk1bio   = 0.5
      real, parameter :: dbio     = 25.0  ! penetration depth of solar radiation in meters
      real, parameter :: alphabio = 0.025 /86400. ! add docu for biological parameters
      real, parameter :: parbio   = 0.43

      real, parameter :: c_ON   = 10.0
      real, parameter :: c_CN   = 6.6
      real, parameter :: max_dt = 900.0 ! maximal time step in biog. model
      integer :: ts_npz                       ! additional time steps in bio. module 
      end module bgc_module


      subroutine tracer_set_number
c ----------------------------------
c     set number of tracers
c ----------------------------------
      use bgc_module
      implicit none
#ifdef enable_zooplankton
      nt=6
#else
      nt=5
#endif
      ts_npz=max(1,nint(dt_in*2. / max_dt))
      if (my_pe==0) then
       print*,' there are ',nt,' biogeochem. variables '
       print*,' biogeochemical model will do ',ts_npz,' time steps'
       print*,' time step in biochem. model will be ',
     &          dt_in/ts_npz,'sec.'

       print*,' the parameter for the ecosystem model:'
       print*,' alphabio = ',alphabio*86400,' 1/days' 
       print*,' abio     = ', abio* 86400., ' 1/days'
       print*,' bbio     = ', bbio 
       print*,' cbio     = ', cbio 
#ifdef enable_zooplankton
       print*,' phizoo  = ',phizoo
       print*,' a_npz   = ',a_npz
       print*,' d_npz   = ',1./d_npz/86400.,' days'
       print*,' gbio     = ', gbio,' days' 
       print*,' epsbio    = ',epsbio,' days'
#endif
       print*,' parbio   = ',parbio
       print*,' rk1bio   = ',rk1bio
       print*,' dbio     = ', dbio,' m'
       print*,' phiphy   = ',1./phiphy/86400.,' days'
       print*,' remina   = ',1./remina/86400.,' days'
       print*,' w_detr   = ',w_detr *86400. ,' m/day'
       print*,' w_detr2  = ',w_detr2*86400. ,' m/day'
       print*,' c_ON     = ',c_ON
       print*,' c_CN     = ',c_CN
       print*,' '
      endif
      end subroutine tracer_set_number


      subroutine tracer_initial_conditions
c ----------------------------------
c     initial conditions for tracer
c ----------------------------------
      use bgc_module
      implicit none
      integer :: i,j,k
      real :: L_y,y2
      allocate( u_nut(imt,jmt,km) ) ; u_nut = 0.0
      allocate( u_light(imt,jmt,km) ) ; u_light = 0.0
      allocate( solar(imt,jmt) ) ; solar = 0.0
      allocate( sss(imt,jmt) ) ; sss = 0.0
      allocate( u10(imt,jmt) ) ; u10 = 0.0
      allocate( o2_sflx(imt,jmt),dic_sflx(imt,jmt) )  
      o2_sflx = 0.0;  dic_sflx=0.0
      allocate( o2_sat(imt,jmt),pco2(imt,jmt) ) 
      o2_sat = 0.0;   pco2=0.0
c ----------------------------------
c     specify surface boundary conditions
c ----------------------------------
      L_y = yt(jmt)-yt(1)
      y2=L_y*0.75
      do j=1,jmt
       do i=1,imt
        solar(i,j)=200.
        if (yt(j)<L_y/2.0) solar(i,j)=200*yt(j)/(L_y/2.0)
        if (yt(j)>y2)      solar(i,j)=200*(1-(yt(j)-y2)/(yt(jmt)-y2))
        sss(i,j)=35.0
        u10(i,j)=10.0
       enddo
      enddo
c ----------------------------------
c     specify initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt
         tr(i,j,k,:,phy)=0.0001*maskT(i,j,k)
#ifdef enable_zooplankton
         tr(i,j,k,:,zoo)=0.0001*maskT(i,j,k)
#endif
         tr(i,j,k,:,det)=0.0000*maskT(i,j,k)
         if (k<km-2) tr(i,j,k,:,nut)=30*maskT(i,j,k)
         tr(i,j,k,:,oxy)=500*maskT(i,j,k)
         tr(i,j,k,:,dic)=2100*maskT(i,j,k)
        enddo
       enddo
      enddo
      if (my_pe==0) call init_bgc_diag
      end subroutine tracer_initial_conditions


      subroutine tracer_sources
c ----------------------------------
c     Sources and sinks for tracers
c ----------------------------------
      use bgc_module
      implicit none
      integer :: i,j,k,js,je,n
      real :: fxa,fxb,dtsb,dnut(imt,jmt,km),tnut,tphy,tzoo,tdet,graz
      real :: sst(imt),sc(imt),kw(imt),dco2(imt),sdic(imt)
      js=max(2,js_pe); je = min(je_pe,jmt-1)
c ----------------------------------
c    interior sources of biogeochem. variables
c ----------------------------------
      dtsb=c2dt/float(ts_npz)  
      call light_limitation
      dnut(:,js_pe:je_pe,:)=0.
      do n = 1,ts_npz
       call phyto_growth_rate
       do k=2,km-1
        do j=js,je
         do i=2,imt-1
          fxa=min(u_nut(i,j,k),u_light(i,j,k))                             ! growth rate
          tnut=tr(i,j,k,taup1,nut)
          tdet=tr(i,j,k,taup1,det)
          tphy=tr(i,j,k,taup1,phy)
#ifdef enable_zooplankton
          tzoo=tr(i,j,k,taup1,zoo)
          graz = gbio*epsbio*tphy/(gbio+epsbio*tphy*tphy)    ! grazing
c        dP/dt = u(N,Temp.,Light) P - p_P P       - g(P) P Z 
          tr(i,j,k,taup1,phy)= tphy + maskT(i,j,k)*dtsb*
     &             tphy*(fxa - phiphy - graz*tzoo) 
c        dZ/dt = a g(P) P Z - d Z - p_Z Z^2
          tr(i,j,k,taup1,zoo) = tzoo + maskT(i,j,k)*dtsb* 
     &             tzoo*(a_npz*graz*tphy - d_npz - phizoo*tzoo )
c        dN/dt = r D + d Z - u(N,Temp.,Light) P  
          fxb =remina*tdet +d_npz*tzoo -fxa*tphy                    ! nutrient change
          dnut(i,j,k)=dnut(i,j,k)+fxb                                          ! accumulate nutrient change
          tr(i,j,k,taup1,nut)= tnut + maskT(i,j,k)*dtsb*fxb
c        dD/dt =  p_P P -r D + w_D dD/dz          + (1-a) g(P) P Z + p_Z Z^2
          tr(i,j,k,taup1,det)= tdet + maskT(i,j,k)*dtsb* 
     &         (phiphy*tphy-remina*tdet
     &         +(1-a_npz)*graz*tphy*tzoo+phizoo*tzoo**2 )
#else
c        dP/dt = 0.2*u(N,Temp.,Light) P - p_P P     
          tr(i,j,k,taup1,phy)= tphy + maskT(i,j,k)*dtsb*
     &             tphy*(0.2*fxa - phiphy) 
c        dN/dt = r D - u(N,Temp.,Light) P  
          fxb =remina*tdet -fxa*tphy                    ! nutrient change
          dnut(i,j,k)=dnut(i,j,k)+fxb                       ! accumulate nutrient change
          tr(i,j,k,taup1,nut)= tnut + maskT(i,j,k)*dtsb*fxb
c        dD/dt =  p_P P -r D + w_D dD/dz   +0.8 u(N,Temp.,Light) P
          tr(i,j,k,taup1,det)= tdet + maskT(i,j,k)*dtsb* 
     &         (phiphy*tphy-remina*tdet+0.8*fxa*tphy)
#endif
         enddo
        enddo
       enddo
      enddo
c ----------------------------------
c    other tracers
c ----------------------------------
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          tr(i,j,k,taup1,oxy)=max(0.,tr(i,j,k,taup1,oxy)+
     &          maskT(i,j,k)*c2dt*(-c_ON*dnut(i,j,k)) )
          tr(i,j,k,taup1,dic)=max(0.,tr(i,j,k,taup1,dic)+
     &          maskT(i,j,k)*c2dt*(c_CN*dnut(i,j,k)) )
        enddo
       enddo
      enddo
c ----------------------------------
c     sinking of organic materal
c ----------------------------------
      call detritus_sinking
c ----------------------------------
c    surface fluxes of biogeochem. variables
c ----------------------------------
       k=km-1
       do j=js,je
        sst=-b(:,j,k,tau)*1024./9.81/0.2
        sdic=tr(:,j,k,taum1,dic)
        call wanninkhof(sst,u10(:,j),kw,imt)
        call schmidt_o2(sst,sc,imt)
        call eqconc_o2(sst,sss(:,j),o2_sat(:,j),imt)
        o2_sflx(:,j)=kw*sqrt(660.0/sc)*(o2_sat(:,j)-tr(:,j,k,taum1,oxy))
        tr(:,j,k,taup1,oxy)=tr(:,j,k,taup1,oxy)+
     &                             maskT(:,j,k)*c2dt*o2_sflx(:,j)/dz
        call schmidt_co2(sst,sc,imt)
        call eqconc_co2(sst,sss(:,j),sdic,imt,dco2,pco2(:,j))
        dic_sflx(:,j)=  kw*sqrt(660.0/sc)*dco2
        tr(:,j,k,taup1,dic)=tr(:,j,k,taup1,dic)+
     &                           maskT(:,j,k)*c2dt*dic_sflx(:,j)/dz 
      enddo
c ----------------------------------
c    diagnostic output
c ----------------------------------
      fxa=0.0;fxb=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          fxa=fxa+tr(i,j,k,tau,nut)*dx**2*dz*maskT(i,j,k)
          fxa=fxa+tr(i,j,k,tau,det)*dx**2*dz*maskT(i,j,k)
          fxa=fxa+tr(i,j,k,tau,phy)*dx**2*dz*maskT(i,j,k)
#ifdef enable_zooplankton
          fxa=fxa+tr(i,j,k,tau,zoo)*dx**2*dz*maskT(i,j,k)
#endif
          fxb=fxb+tr(i,j,k,tau,oxy)*dx**2*dz*maskT(i,j,k)
        enddo
       enddo
      enddo
      call global_sum(fxa)
      call global_sum(fxb)
      fxa = fxa/1000. /1000/1000/1000
      fxb = fxb/1000. /1000/1000/1000
      if (my_pe==0) print*, 'total nutrient content ',fxa,' Giga mol'
      if (my_pe==0) print*, 'total oxygen  content ',fxb,' Giga mol'
      call sub_flush(6)
      if (snapshot_time_step.or.initial_time==current_time) then
        call diag_bgc
      endif
      end subroutine tracer_sources

c ----------------------------------
c    the rest is specific for biogeochem. model
c ----------------------------------

      subroutine light_limitation
c ----------------------------------
c    compute daily averaged light-limited growth rate
c    analytical integration over layer thickness and day
c    after Evans and Parslow (1985)
c ----------------------------------
      use bgc_module
      implicit none
      integer :: i,j,k,js,je
      real :: fxa,fxb,fx1,fx3,fx4,fu1,fu2
      real :: daylen,cobeta,radbio,rayb(km)
      js=max(2,js_pe); je = min(je_pe,jmt-1)
c    day length from astronomic functions
      call get_daylen(180.,30.0,daylen,cobeta)
      daylen=max(1.e-12,daylen)
c    depth penetration of solar insulation
      do k=1,km-1
        rayb(k)= exp(zw(k)/(cobeta*dbio))
      enddo
      rayb(km) = 1.0
      fx1 = 0.5*daylen*daylen/alphabio
      do j=js,je
       do k=2,km-1
        do i=2,imt-1
          radbio = max(1.0,parbio*solar(i,j))
          fxa = abio*bbio**(-cbio*b(i,j,k,tau)*1024./9.81/0.2)
          fx3 = fx1*fxa/(radbio*rayb(k-1))
          fx4 = fx1*fxa/(radbio*rayb(k))
          fu1 = sqrt(fx3**2.+daylen**2.)
          fu1 = fu1-daylen*log((daylen+fu1)/fx3)
          fu2 = sqrt(fx4**2.+daylen**2.)
          fu2 = fu2-daylen*log((daylen+fu2)/fx4)
          u_light(i,j,k) =fxa/dz*cobeta*dbio*(fu1 - fu2 - fx3 + fx4) 
        enddo
       enddo
      enddo
      end subroutine light_limitation


      subroutine phyto_growth_rate
c ----------------------------------
c      nutrient limited growth rate
c ----------------------------------
      use bgc_module
      implicit none
      integer :: i,j,k,js,je
      real :: fxa,fxb
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
c       saturation growth rate (infinite light, infinite nutrients)
         fxa = abio*bbio**(-cbio*b(i,j,k,tau)*1024./9.81/0.2)
         fxb = tr(i,j,k,taup1,nut)/(rk1bio+tr(i,j,k,taup1,nut))
c       nutrient limited growth rate
         u_nut(i,j,k) = fxa*fxb
        enddo
       enddo
      enddo
      end subroutine phyto_growth_rate


      subroutine detritus_sinking
c ----------------------------------
c     sinking of detritus
c ----------------------------------
      use bgc_module
      implicit none
      integer :: i,j,k,js,je
      real :: adv_ft(imt,jmt,km),betaf(imt,jmt,km),denom,ww
      js=max(2,js_pe); je = min(je_pe,jmt-1)
c    add tendency due to sinking of detritus
      adv_ft(:,js:je,:)=0.0
      do k=1,km-1
        ww = w_detr+min(0.,(w_detr2-w_detr)*(zw(k)+100.)/zw(1))
       do j=js,je
        do i=2,imt-1
          adv_ft(i,j,k)=maskW(i,j,k)*
     &   0.5*ww*(tr(i,j,k,tau,det) + tr(i,j,k+1,tau,det))
         enddo
        enddo
       enddo
c    compute delimiter for outgoing flux
      betaf(:,js:je,:)=2.
      do k=2,km
       do j=js,je
        do i=2,imt-1
         denom =       max(0.,adv_ft(i,j,k)/dz)
         denom = denom-min(0.,adv_ft(i,j,k-1)/dz) 
         denom = denom*c2dt
         denom = sign(1.,denom)*max(1.e-15,abs(denom)) ! should be positive anyway
         betaf(i,j,k)=tr(i,j,k,taup1,det)/denom
        enddo
       enddo
      enddo
c    delimit vertical flux
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
           adv_ft(i,j,k)=
     &         min(1.,betaf(i,j,k   ))*max(0.,adv_ft(i,j,k))
     &       + min(1.,betaf(i,j,k+1))*min(0.,adv_ft(i,j,k))
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          tr(i,j,k,taup1,det) = tr(i,j,k,taup1,det) - 
     &       c2dt*maskT(i,j,k)*(adv_ft(i,j,k) - adv_ft(i,j,k-1))/dz
        enddo
       enddo
      enddo
      end subroutine detritus_sinking


      subroutine get_daylen(day,lat,daylen,cobeta)
c ----------------------------------
c     length of day as function of latitude and day of year
c ----------------------------------
      implicit none
      real, intent(in) :: day,lat
      real, intent(out)   :: daylen,cobeta
      real :: fx1,fx2,timeyear,declin
      real, parameter :: pi=3.1415
c    solar declination 
      timeyear = day/365.
      fx1    = 2.0*pi*(timeyear-int(timeyear))
      declin = 0.006918
     &      -0.399912*cos(   fx1)+0.070257*sin(   fx1)
     &      -0.006758*cos(2.*fx1)+0.000907*sin(2.*fx1)
     &      -0.002697*cos(3.*fx1)+0.001480*sin(3.*fx1)
c    compute solar angle at noon (and assume that this is the equivalent
c    daily averaged incidence angle for direct+diffuse radiation)
c    1. cobeta is cos(incidence angle of solar radiation at noon)
      fx1    = pi/180.*lat
      cobeta = max(0.,sin(fx1)*sin(declin)+cos(fx1)*cos(declin))
c    2. cobeta is cos(incidence angle in water)
c      using Snells law: sin(water)=sin(air)/1.33
      cobeta = sqrt(1.-(1.-cobeta**2.)/1.33**2.)
c    finally,length of day
      fx2    = max(-1., min( 1.,-tan(fx1)*tan(declin)) )
      daylen = acos(fx2)/pi
      end subroutine get_daylen



      subroutine wanninkhof(tc,u,kw,len)
c-----------------------------------------------------------------------
c   Piston velocity in m/s for surface fluxes a la Wanninkhof , 1992
c-----------------------------------------------------------------------
      implicit none
      integer :: len,i
      real :: tc(len),u(len)   ! temperature, wind speed in m/s (input)
      real :: kw(len)          ! piston velocity (output)
      do i=1,len
       kw(i) = 0.39*u(i)*u(i)   
      enddo
      kw=kw/100./3600.   ! convert from cm/hr to m/s
      end subroutine wanninkhof


      subroutine schmidt_co2(t,sc,len)
c-----------------------------------------------------------------------
c    Computes the Schmidt number of CO2 in seawater using the 
c    formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
c    7373-7382).  Input is temperature in deg C.
c-----------------------------------------------------------------------
      implicit none
      integer :: len
      real    :: t(len),sc(len)
      integer :: i
      do i=1,len
       sc(i) = 2073.1 - 125.62*t(i) + 3.6276*t(i)*t(i) 
     &       - 0.043219*t(i)*t(i)*t(i)
      enddo
      end subroutine schmidt_co2


      subroutine schmidt_o2(t,sc,len)
c-----------------------------------------------------------------------
c   Computes the Schmidt number of oxygen in seawater using the
c   formulation proposed by Keeling et al. (1998, Global Biogeochem.
c   Cycles, 12, 141-163).  Input is temperature in deg C.
c-----------------------------------------------------------------------
      implicit none
      integer :: len
      real    :: t(len),sc(len)
      integer :: i
      do i=1,len
       sc(i) = 1638.0-81.83*t(i)+1.483*t(i)*t(i) 
     &             - 0.008004*t(i)*t(i)*t(i)
      enddo
      end subroutine schmidt_o2

      subroutine eqconc_o2(t,s,osa,len)
c-----------------------------------------------------------------------
C   Computes the oxygen saturation concentration at 1 atm 
c   total pressure in mmol/m^3 given the temperature 
c   (t, in deg C) and the salinity (s, in permil, or psu). 
C   FROM GARCIA AND GORDON (1992), LIMNOLOGY and OCEANOGRAPHY.
C   THE FORMULA USED IS FROM PAGE 1310, EQUATION (8).
C   *** NOTE: THE "A3*TS^2" TERM (IN THE PAPER) IS INCORRECT. ***
C   *** IT SHOULD not BE THERE.                                ***
C   osa IS DEFINED BETWEEN T(freezing) <= T <= 40(deg C) AND
c   0 permil <= S <= 42 permil
C   CHECK VALUE:  T = 10.0 deg C, S = 35.0 permil,osa = 0.282015 mol/m^3
c     Convert from ml/l to mol/m^3  osa = o2sato/22391.6*1000.0
c-----------------------------------------------------------------------
      implicit none
      integer :: len
      real :: t(len), s(len), osa(len)
      real :: TT, TK, TS, TS2, TS3, TS4, TS5, CO ,SS
      integer :: i
      real :: A0= 2.00907, A1= 3.22014, A2= 4.05010 
      real :: A3= 4.94457, A4=-2.56847E-1, A5= 3.88767 
      real :: B0=-6.24523E-3, B1=-7.37614E-3
      real :: B2=-1.03410E-2, B3=-8.17083E-3, Cc0=-4.88682E-7
      do i=1,len
         TT  = 298.15-t(i)
         TK  = 273.15+t(i)
         TS  = LOG(TT/TK)
         TS2 = TS*TS
         TS3 = TS2*TS
         TS4 = TS3*TS
         TS5 = TS4*TS
         ss  = s(i)
         CO  = A0 + A1*TS + A2*TS2 + A3*TS3 + A4*TS4 + A5*TS5
     $        + ss*(B0 + B1*TS + B2*TS2 + B3*TS3)
     $        + Cc0*(ss*ss)
         osa(i) = EXP(CO)
         osa(i)=osa(i)/22391.6*1000.0 *1.e3
      enddo
      end subroutine eqconc_o2


      subroutine eqconc_co2(t,s_in,dic_in,imt,dco2,pco2_water)
c-------------------------------------------------------------------------
c   Calculate pco2* from total alkalinity and total CO2 at
c   temperature (t), salinity (s) and "atmpres" atmosphere total pressure. 
c   using a fit of pH as a function of DIC, SALT and TEMP
c   valid range is 1940<DIC<2200 mmol/m^3
c                  -5<T<25 degC and 31.5<S<37.5 PSU
c   accuracy within this range is as good as for other routine
c--------------------------------------------------------------------------
       implicit none
c      INPUT
       integer :: imt         ! vector length
       real   :: t(imt)        ! temperature deg C
       real   :: s_in(imt)     ! salinity in PSU
       real   :: dic_in(imt)   ! diss. inorg. carbon  in mmol/m^3
c      OUTPUT
       real   :: dco2(imt)     ! difference in CO2 at sea surface and saturation CO2 in mmol/m^3
       real   :: pco2_water(imt) ! partial pressure of CO2 at sea surface  (ppmv)

      real, parameter :: rho0 = 1024.0    ! unit conversion factor
      real, parameter :: rrho02 = 1.0/rho0**2
      real, parameter :: permeg=1.e-6, permil = 1.0/rho0 ! unit conversion
      real   :: slp=1013.25      ! Sea level pressure in mbar
      real   :: pco2_air=278.0 ! atmospheric mole fraction CO2 in dry air (ppmv) 
      
c      local work variables
       real :: tk,tk100,tk1002,invtk,dlogtk,s2
       real :: htotal,s,htotal2,co2star,pco2
       real :: dic,ff,k1,k2,atmpres,pH_fit,xx,yy,zz
       real :: xx2,yy2,zz2
       integer :: i

       do i=1,imt
        s = s_in(i)
        dic = dic_in(i)*rrho02
        tk = 273.15 + t(i)
        tk100 = tk/100.0
        tk1002=tk100*tk100
        invtk=1.0/tk
        dlogtk=log(tk)
        s2=s*s
C        f = k0(1-pH2O)*correction term for non-ideality
C        Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6 values)
        ff = exp(-162.8301 + 218.2968/tk100  +
     &		90.9241*log(tk100) - 1.47696*tk1002 +
     &		s*(.025695 - .025225*tk100 + 
     &		0.0049867*tk1002))
C        k1 = [H][HCO3]/[H2CO3]
C        k2 = [H][CO3]/[HCO3]
C        Millero p.664 (1995) using Mehrbach et al. data on seawater scale 
        k1=10**(-1*(3670.7*invtk - 62.008 + 9.7944*dlogtk -
     &		0.0118 * s + 0.000116*s2))
        k2=10**(-1*(1394.7*invtk + 4.777 - 
     &		0.0184*s + 0.000118*s2))
c    calculate pH from estimated fit
      xx=dic_in(i)-2000.0; yy=s-35.0; zz=t(i);
      xx2=xx*xx; yy2=yy*yy; zz2=zz*zz;
      pH_fit=8.456655e+00+(-1.688880e-03)*xx 
     & +(7.390822e-02)*yy+(-1.739867e-02)*zz 
     & +(-1.864020e-06)*xx2+(-2.034953e-03)*yy2 
     & +(6.480540e-05)*zz2 
     & +(8.483447e-07)*xx*zz+(1.945036e-04)*xx*yy 
     & +(-4.480909e-05)*yy*zz 
     & +(-2.946383e-09)*xx**3+(-1.420486e-03)*yy**3 
     & +(-4.430561e-07)*zz**3 
     & +(-1.515261e-05)*xx*yy2+(5.880059e-07)*yy*xx2  
     & +(4.673103e-08)*xx*zz2+(1.772955e-08)*zz*xx2 
     & +(-1.897002e-06)*yy*zz2+(2.194509e-05)*zz*yy2 
     & +(-1.493190e-06)*xx*yy*zz   
	htotal = 10**(-pH_fit)
C       Calculate [CO2*] as defined in DOE Methods Handbook 1994 Ver.2, 
C       ORNL/CDIAC-74, Dickson and Goyet, eds. (Ch 2 p 10, Eq A.49)
	htotal2=htotal*htotal
	co2star=dic*htotal2/(htotal2 + k1*htotal + k1*k2) ! mol/kg
        atmpres=slp/1013.25 ! mbar to atm
        dco2(i)= ( pco2_air*permeg*ff*atmpres - co2star )/permil *1000.0  ! mmol/m^3
        pco2_water(i) = co2star/ff/permeg/atmpres                  ! ppm or uatm
      enddo
      end subroutine eqconc_co2



      subroutine init_bgc_diag
c-----------------------------------------------------------------------
c     initialize NetCDF snapshot file
c-----------------------------------------------------------------------
      use bgc_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,i,j,k,n
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lat_tdim,lat_udim, id
      integer :: dims(4), corner(4), edges(4)
      character :: name*24, unit*16

      call def_grid_cdf('bgc.cdf')
      iret=nf_open('bgc.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)
      dims = (/Lon_tdim,lat_tdim, iTimedim,0/)
      id = ncvdef (ncid,'o2_sflx', NCFLOAT,3,dims,iret)
      name = 'O2 surface flux'; unit = 'mmol/m^2/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)
      id = ncvdef (ncid,'o2_sat', NCFLOAT,3,dims,iret)
      name = 'O2 saturation conc.'; unit = 'mmol/m^3'
      call dvcdf(ncid,id,name,24,unit,16,spval)
      id = ncvdef (ncid,'dic_sflx', NCFLOAT,3,dims,iret)
      name = 'CO2 surface flux'; unit = 'mmol/m^2/s'
      call dvcdf(ncid,id,name,24,unit,16,spval)
      id = ncvdef (ncid,'pco2', NCFLOAT,3,dims,iret)
      name = 'pCO2'; unit = 'ppmv'
      call dvcdf(ncid,id,name,24,unit,16,spval)
      call ncclos (ncid, iret)
      end subroutine init_bgc_diag


      subroutine diag_bgc
c-----------------------------------------------------------------------
c     write to NetCDF snapshot file
c-----------------------------------------------------------------------
      use bgc_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      real :: a(imt,js_pe:je_pe),fxa
      integer :: itdimid,ilen,rid,itimeid,fnid,id
      integer :: i,j,is,ie,js,je
      character :: name*24, unit*16
      type(time_type) :: time

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do npe=0,n_pes
       if (my_pe==npe) then
        iret=nf_open('bgc.cdf',NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,ilen)
        iret=nf_inq_varid(ncid,'Time',itimeid)
        if (my_pe==0) then
         ilen=ilen+1
         time = current_time-initial_time
         fxa = time%days + time%seconds/86400.
         iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
        endif
        Corner = (/1,js_pe,ilen,1/); edges  = (/imt,j_blk,1,1/)
        iret=nf_inq_varid(ncid,'o2_sflx',id)
        a=o2_sflx(:,js_pe:je_pe)
        where( maskT(:,js_pe:je_pe,km-1) == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a)

        iret=nf_inq_varid(ncid,'dic_sflx',id)
        a=dic_sflx(:,js_pe:je_pe)
        where( maskT(:,js_pe:je_pe,km-1) == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a)

        iret=nf_inq_varid(ncid,'o2_sat',id)
        a=o2_sat(:,js_pe:je_pe)
        where( maskT(:,js_pe:je_pe,km-1) == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a)

        iret=nf_inq_varid(ncid,'pco2',id)
        a=pco2(:,js_pe:je_pe)
        where( maskT(:,js_pe:je_pe,km-1) == 0.) a = spval
        iret= nf_put_vara_double(ncid,id,corner,edges,a)

        call ncclos (ncid, iret)
       endif
       call barrier
      enddo
      end subroutine diag_bgc

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c=======================================================================

      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: fac=0.50
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=200*fac;km=25*fac;jmt=imt
      dx=1000/fac; 
      dz=100/fac; 
      dt_in=100/fac
      eps2D_sor = 1e-5
      eps3D_sor = 1e-4
      runlen=0.25/fac**3
      snap_int = 0.01
      enable_cyclic_x            =.true.
      enable_cyclic_y            =.true.
      enable_hydrostatic         =.true.

      enable_quicker_advection   =.true.
      enable_biharmonic_friction =.true.
      enable_vert_biha_friction  =.true.
      enable_biharmonic_diffusion=.true.
      enable_vert_biha_diffusion =.true.
      Ahbi = (15./fac**2)*dx**2
      Khbi = Ahbi
      Avbi = (0.3/fac**2)*dz**2
      Kvbi = Avbi
      lat_ref= 60.
      beta   = 2*omega*cos(lat_ref/180.*pi)/radius
      N_0 = 2.5e-3
      M_0 = 0.
      end subroutine set_parameter


      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: B0,x,fxa,y  ! temp = b/0.2*tho_0/g
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km  ! Rossby radius is  N h /(f pi)
       do j=1,jmt
        do i=1,imt
         x=float(i)/float(imt)
         B0=1e-9*sin(x*2.5*pi)
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo

      do j=1,jmt
       do i=1,imt
        x=float(i-imt/2)*dx
        y=float(j-jmt/2)*dx
        fxa = sqrt( x**2+y**2 )
        if (fxa<40e3) b(i,j,km/2:km,:)=0
       enddo
      enddo

      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones


      subroutine boundary_conditions
      use cpflame_module
      implicit none
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"
    

c=======================================================================
c       integrate passive tracers
c       linked in the code in driver.F and in zonal_averages.F
c       and in bolus_velocity.F and in time_averages.F
c=======================================================================

#ifdef enable_diag_tracer

c=======================================================================
c prevent spurious under shooting by advection of passive tracer
c works only for positive tracer like concentrations
c#define delimit_tracer_fluxes
c=======================================================================

      module tracer_module
      implicit none
      real,allocatable :: tr(:,:,:,:,:)
      integer :: nt=0
      end module tracer_module

c=======================================================================
c      variables setups for tracer in template files
c=======================================================================
c#include "../extra_setup/age_tracer.F"
c#include "../extra_setup/age_theiss1.F"
c#include "../extra_setup/bgc_tracer.F"
c#include "../extra_setup/simple_tracer.F"
c#include "../extra_setup/salinity_THC.F"
#include "../extra_setup/salinity_double_diff1.F"


      subroutine init_tracer
c=======================================================================
c     allocate work space and read restart
c=======================================================================
      use cpflame_module
      use tracer_module
      implicit none
      logical :: file_exists
      if (my_pe==0) then
       print*,' Initializing tracer module '
#ifdef delimit_tracer_fluxes
       print*,' Delimiting passive tracer advective fluxes to prevent'
       print*,' spurios undershooting. Note that this only makes '
       print*,' sense for positive definite tracers like concentrations'
#endif
      endif
      call tracer_set_number
      allocate( tr(imt,jmt,km,0:2,nt) ); tr=0.0
      call tracer_initial_conditions
      if (my_pe==0) call init_tracer_diag
      inquire(FILE='tracer_restart.dta', EXIST=file_exists )
      if (file_exists) call tracer_read_restart
      if (my_pe==0) print*,' done initializing tracer module '
      end subroutine init_tracer


      subroutine tracer_read_restart
c=======================================================================
c     read tracer from restart file
c=======================================================================
      use cpflame_module
      use tracer_module
      implicit none
      integer :: j,io,n
      if (my_pe==0) print*,' reading tracer from restart file '
      call get_free_iounit(io)
      open(io,file='tracer_restart.dta',form='unformatted',status='old')
      do n=1,nt
       do j=1,jmt
        read(io) tr(:,j,:,tau,n),  tr(:,j,:,taum1,n)
       enddo
      enddo
      close(io)
      end subroutine tracer_read_restart


      subroutine tracer_write_restart
c=======================================================================
c     write restart to file
c=======================================================================
      use cpflame_module
      use tracer_module
      implicit none
      integer :: j,io,n,js,je,m
      if (my_pe==0) print*,' writing tracer restart file'
      do m=1,n_pes-1
       if (my_pe==m) then
        call send_integer(js_pe,1,0,0); call send_integer(je_pe,1,0,0)
        do j=js_pe,je_pe
          call send_real(tr(:,j,:,tau  ,:),imt*km*nt,0,0)
          call send_real(tr(:,j,:,taum1,:),imt*km*nt,0,0)
        enddo
       elseif (my_pe==0) then
        call recv_integer(js,1,m,0); call recv_integer(je,1,m,0)
        do j=js,je
          call recv_real(tr(:,j,:,tau  ,:)  ,imt*km*nt,m,0)
          call recv_real(tr(:,j,:,taum1,:)  ,imt*km*nt,m,0)
        enddo
       endif
       call barrier
      enddo
      if (my_pe==0) then
       call get_free_iounit(io)
       open(io,file='tracer_restart.dta',form='unformatted',
     &         status='unknown')
       do n=1,nt
        do j=1,jmt
         write(io) tr(:,j,:,tau,n), tr(:,j,:,taum1,n)
        enddo
       enddo
       close(io)
      endif
      end subroutine tracer_write_restart



      subroutine integrate_tracer
c=======================================================================
c     solve prognostic equation for tracers
c=======================================================================
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k,js,je,n
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km), diff_fn(imt,jmt,km)
      real :: diff_fe(imt,jmt,km),diff_ft(imt,jmt,km),fxa

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do n=1,nt
c---------------------------------------------------------------------------------
c        advection
c---------------------------------------------------------------------------------
       adv_fe(:,js_pe:je_pe,:)=0
       adv_fn(:,js_pe:je_pe,:)=0
       adv_ft(:,js_pe:je_pe,:)=0
       call adv_flux(adv_fe,adv_fn,adv_ft,tr(:,:,:,:,n))
       call border_exchg3D(adv_fn,1)
       call setcyclic3D(adv_fe)
       call setcyclic3D(adv_fn)
#ifdef delimit_tracer_fluxes
       call delimit_adv_flux(n,adv_fe,adv_fn,adv_ft)
#endif
c---------------------------------------------------------------------------------
c      horizontal diffusion
c---------------------------------------------------------------------------------
       diff_fe(:,js_pe:je_pe,:)=0
       diff_fn(:,js_pe:je_pe,:)=0
       diff_ft(:,js_pe:je_pe,:)=0
       do k=2,km-1
        do j=js,je
         do i=1,imt-1
          fxa=K_h*maskU(i,j,k)
          diff_fe(i,j,k)=fxa*(tr(i+1,j,k,taum1,n)-tr(i,j,k,taum1,n))/dx
         enddo
        enddo
       enddo
       call setcyclic3D(diff_fe)
       do k=2,km-1
        do j=js,je 
         do i=2,imt-1
          fxa=K_h*maskV(i,j,k)
          diff_fn(i,j,k)=fxa*(tr(i,j+1,k,taum1,n)-tr(i,j,k,taum1,n))/dx
         enddo
        enddo
       enddo
       call border_exchg3D(diff_fn,1)
       call setcyclic3D(diff_fn)
c---------------------------------------------------------------------------------
c      vertical diffusion
c---------------------------------------------------------------------------------
       do k=1,km-1
        do j=js,je
         do i=2,imt-1
          fxa=K_v*maskW(i,j,k)
          diff_ft(i,j,k)=fxa*(tr(i,j,k+1,taum1,n)-tr(i,j,k,taum1,n))/dz
         enddo
        enddo
       enddo
c---------------------------------------------------------------------------------
c       time tendency of b
c---------------------------------------------------------------------------------
       do k=2,km-1
        do j=js,je
         do i=2,imt-1
          tr(i,j,k,taup1,n)=tr(i,j,k,taum1,n)+maskT(i,j,k)*c2dt*( 
     &  -(adv_fe(i,j,k)-adv_fe(i-1,j,k))/dx
     &  -(adv_fn(i,j,k)-adv_fn(i,j-1,k))/dx
     &  -(adv_ft(i,j,k)-adv_ft(i,j,k-1))/dz
     &  +(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz
     &  +(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
     &  +(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx  )
         enddo
        enddo
       enddo
c---------------------------------------------------------------------------------
c       Biharmonic diffusion (horizontal and vertical)
c---------------------------------------------------------------------------------
       if (enable_biharmonic_diffusion) 
     &         call biha_mix(diff_fe,diff_fn,diff_ft,tr(:,:,:,:,n))
c---------------------------------------------------------------------------------
c       remove unstable stratification      
c---------------------------------------------------------------------------------
       if (enable_hydrostatic) then
         call implicit_tracer_mix(tr(:,:,:,:,n),K_b)
       endif
      enddo

c---------------------------------------------------------------------------------
c      Nudging terms, etc
c---------------------------------------------------------------------------------
      call tracer_sources

      do n=1,nt
c---------------------------------------------------------------------------------
c        boundary exchange
c---------------------------------------------------------------------------------
       call border_exchg3D(tr(:,:,:,taup1,n),2)
       call setcyclic3D(tr(:,:,:,taup1,n) )
c---------------------------------------------------------------------------------
c       apply roberts time filter on time levels 
c---------------------------------------------------------------------------------
       do j=js,je
       tr(:,j,:,tau,n) = tr(:,j,:,tau,n) + gamma*
     &     (0.5*(tr(:,j,:,taup1,n)+tr(:,j,:,taum1,n))-tr(:,j,:,tau,n)) 
       enddo
       call border_exchg3D(tr(:,:,:,tau,n),2)
       call setcyclic3D(tr(:,:,:,tau,n) )
      enddo
c---------------------------------------------------------------------------------
c       Diagnostics
c---------------------------------------------------------------------------------
      if (snapshot_time_step.or.initial_time==current_time) then
        call diag_tracer
      endif
      if (last_time_step) call tracer_write_restart
      end subroutine integrate_tracer





      subroutine delimit_adv_flux(n,adv_fe,adv_fn,adv_ft)
c-----------------------------------------------------------------------
c   delimit advective fluxes for passive tracers
c   using the multidimensional positive definite
c   advection scheme (MPDCD) by Lafore, et al 1998
c-----------------------------------------------------------------------
      use cpflame_module
      use tracer_module
      implicit none
      integer, intent(in) :: n
      real :: adv_fe(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real :: adv_ft(imt,jmt,km)
      real :: betaf(imt,jmt,km)
      integer :: js,je,i,j,k
      real :: fxa,denom
      real, parameter :: small = 1.e-15

      js=max(2,js_pe); je=min(je_pe,jmt-1)
c    compute delimiter for outgoing flux
      betaf(:,js_pe:je_pe,:)=2.
      do j=js,je
        do k=2,km-1
          do i=2,imt-1
           denom =       max(0.,adv_fe(i  ,j,k)/dx)
           denom = denom-min(0.,adv_fe(i-1,j,k)/dx) 
           denom = denom+max(0.,adv_fn(i,j,k  )/dx)
           denom = denom-min(0.,adv_fn(i,j-1,k)/dx)
           denom = denom+max(0.,adv_ft(i,j,k)/dz)
           denom = denom-min(0.,adv_ft(i,j,k-1)/dz)
           denom=denom*c2dt
           denom = sign(1.,denom)*max(small,abs(denom)) ! should be positive anyway
           betaf(i,j,k)=tr(i,j,k,taum1,n)/denom
          enddo
        enddo
      enddo
      call border_exchg3D(betaf,1); call setcyclic3D(betaf)
c   delimit zonal flux
      do j=js,je
        do k=2,km-1
          do i=1,imt-1
           adv_fe(i,j,k)=
     &         min(1.,betaf(i ,j ,k))*max(0.,adv_fe(i,j,k))
     &       + min(1.,betaf(i+1,j,k))*min(0.,adv_fe(i,j,k))
          enddo
        enddo
      enddo
c   delimit meridional flux
      do j=js-1,je
        do k=2,km-1
          do i=2,imt-1
           adv_fn(i,j,k)=
     &         min(1.,betaf(i,j,k  ))*max(0.,adv_fn(i,j,k))
     &       + min(1.,betaf(i,j+1,k))*min(0.,adv_fn(i,j,k))
          enddo
        enddo
      enddo
c   delimit vertical flux
      do j=js,je
        do k=1,km-1
          do i=2,imt-1
           adv_ft(i,j,k)=
     &         min(1.,betaf(i,j,k))*max(0.,adv_ft(i,j,k))
     &       + min(1.,betaf(i,j,k+1))*min(0.,adv_ft(i,j,k))
          enddo
        enddo
      enddo
      end subroutine delimit_adv_flux



      subroutine delimit_adv_flux_taup1(n,adv_fe,adv_fn,adv_ft)
c-----------------------------------------------------------------------
c   same as above but cares for tracer at taup1
c-----------------------------------------------------------------------
      use cpflame_module
      use tracer_module
      implicit none
      integer, intent(in) :: n
      real :: adv_fe(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real :: adv_ft(imt,jmt,km)
      real :: betaf(imt,jmt,km)
      integer :: js,je,i,j,k
      real :: fxa,denom
      real, parameter :: small = 1.e-15

      js=max(2,js_pe); je=min(je_pe,jmt-1)
c    compute delimiter for outgoing flux
      betaf(:,js_pe:je_pe,:)=2.
      do j=js,je
        do k=2,km-1
          do i=2,imt-1
           denom =       max(0.,adv_fe(i  ,j,k)/dx)
           denom = denom-min(0.,adv_fe(i-1,j,k)/dx) 
           denom = denom+max(0.,adv_fn(i,j,k  )/dx)
           denom = denom-min(0.,adv_fn(i,j-1,k)/dx)
           denom = denom+max(0.,adv_ft(i,j,k)/dz)
           denom = denom-min(0.,adv_ft(i,j,k-1)/dz)
           denom=denom*c2dt
           denom = sign(1.,denom)*max(small,abs(denom)) ! should be positive anyway
           betaf(i,j,k)=tr(i,j,k,taup1,n)/denom
          enddo
        enddo
      enddo
      call border_exchg3D(betaf,1); call setcyclic3D(betaf)
c   delimit zonal flux
      do j=js,je
        do k=2,km-1
          do i=1,imt-1
           adv_fe(i,j,k)=
     &         min(1.,betaf(i ,j ,k))*max(0.,adv_fe(i,j,k))
     &       + min(1.,betaf(i+1,j,k))*min(0.,adv_fe(i,j,k))
          enddo
        enddo
      enddo
c   delimit meridional flux
      do j=js-1,je
        do k=2,km-1
          do i=2,imt-1
           adv_fn(i,j,k)=
     &         min(1.,betaf(i,j,k  ))*max(0.,adv_fn(i,j,k))
     &       + min(1.,betaf(i,j+1,k))*min(0.,adv_fn(i,j,k))
          enddo
        enddo
      enddo
c   delimit vertical flux
      do j=js,je
        do k=1,km-1
          do i=2,imt-1
           adv_ft(i,j,k)=
     &         min(1.,betaf(i,j,k))*max(0.,adv_ft(i,j,k))
     &       + min(1.,betaf(i,j,k+1))*min(0.,adv_ft(i,j,k))
          enddo
        enddo
      enddo
      end subroutine delimit_adv_flux_taup1




      subroutine init_tracer_diag
c-----------------------------------------------------------------------
c     initialize NetCDF snapshot file
c-----------------------------------------------------------------------
      use cpflame_module
      use tracer_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,i,j,k,n
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lat_tdim,lat_udim, tr_id(nt)
      integer :: dims(4), corner(4), edges(4)
      character :: name*24, unit*16

      call def_grid_cdf('tracer.cdf')
      iret=nf_open('tracer.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)
      dims = (/Lon_tdim,lat_tdim, z_tdim, iTimedim/)
      do n=1,nt
       write(name, '("tr",i2)') n
       call replace_space_zero(name)
       tr_id(n) = ncvdef (ncid,name, NCFLOAT,4,dims,iret)
       name = 'passive tracer'; unit = ' '
       call dvcdf(ncid,tr_id(n),name,24,unit,16,spval)
      enddo
      call ncclos (ncid, iret)
      end subroutine init_tracer_diag


      subroutine diag_tracer
c-----------------------------------------------------------------------
c     write to NetCDF snapshot file
c-----------------------------------------------------------------------
      use cpflame_module
      use tracer_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      real :: a(imt,js_pe:je_pe,km),fxa
      integer :: itdimid,ilen,rid,itimeid,fnid
      integer :: tr_id(nt)
      integer :: i,j,is,ie,js,je
      character :: name*24, unit*16
      type(time_type) :: time

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do npe=0,n_pes
       if (my_pe==npe) then
        iret=nf_open('tracer.cdf',NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        do n=1,nt
         write(name, '("tr",i2)') n
         call replace_space_zero(name)
         iret=nf_inq_varid(ncid,name,tr_id(n))
        enddo
        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,ilen)
        iret=nf_inq_varid(ncid,'Time',itimeid)
        if (my_pe==0) then
         ilen=ilen+1
         time = current_time-initial_time
         fxa = time%days + time%seconds/86400.
         iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
        endif
        Corner = (/1,js_pe,1,ilen/); 
        edges  = (/imt,je_pe-js_pe+1,km,1/)
        do n=1,nt
         a=tr(:,js_pe:je_pe,:,tau,n)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,tr_id(n),corner,edges,a)
        enddo
        call ncclos (ncid, iret)
       endif
       call barrier
      enddo
      end subroutine diag_tracer

#else
      subroutine tracer_dummy
      end
#endif

#include "options.inc"


c=======================================================================
c       overturning streamfunction diagnostics
c       linked in the code in driver only
c=======================================================================

#ifdef enable_diag_over

      module overturning_module
      implicit none
      real, allocatable :: bax(:)
      integer :: bdim 
      real, allocatable :: phiz(:,:)
      real, allocatable :: phiy(:,:)
      real, allocatable :: phix(:,:)
#ifdef enable_bolus_velocity
      real, allocatable :: phiz_b(:,:),phiy_b(:,:),phix_b(:,:)
#endif
      end module overturning_module


      subroutine init_overturning
      use cpflame_module
      use overturning_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,i
      integer :: z_udim,itimedim,varid,bdimid,bid
      integer :: lon_udim,lat_udim, dims(4)
      character :: name*64, unit*32
      real    :: db,b1=-0.032,b2=0.002

      if (my_pe==0) then
       print*,''
       print*,' Initializing overturning module '
       print*,''
      endif

      bdim=40
      allocate(bax(bdim));bax=0.
      db=(b2-b1)/bdim
      bax(1)=b1
      do i=2,bdim
       bax(i)=bax(i-1)+db
      enddo

      allocate( phiz(bdim,km) )
      allocate( phiy(bdim,jmt) )
      allocate( phix(bdim,imt) )
#ifdef enable_bolus_velocity
      allocate( phiz_b(bdim,km) )
      allocate( phiy_b(bdim,jmt) )
      allocate( phix_b(bdim,imt) )
#endif

      if (my_pe==0) then 

       call def_grid_cdf('over.cdf')
       iret=nf_open('over.cdf',NF_WRITE,ncid)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       call ncredf(ncid, iret)
       bdimid= ncddef(ncid, 'bdim', bdim, iret)
       bid   = ncvdef (ncid,'bdim',NCFLOAT,1,bdimid,iret)
       name = 'buoyancy'; unit = 'm/s^2'
       call ncaptc(ncid,bid,'long_name',NCCHAR,len_trim(name),name,iret) 
       call ncaptc(ncid,bid,'units',NCCHAR,len_trim(unit),unit,iret) 

       iret=nf_inq_dimid(ncid,'xu',lon_udim)
       iret=nf_inq_dimid(ncid,'yu',lat_udim)
       iret=nf_inq_dimid(ncid,'zu',z_udim)
       iret=nf_inq_dimid(ncid,'Time',itimedim)

       dims = (/bdimid, z_udim, iTimedim,1/)
       varid = ncvdef (ncid,'psiz', NCFLOAT,3,dims,iret)
       name = 'Streamfunction'; unit = 'Sv'
       call dvcdf(ncid,varid,name,len_trim(name),
     &            unit,len_trim(unit),spval) 

       dims = (/bdimid, lat_udim, iTimedim,1/)
       varid = ncvdef (ncid,'psiy', NCFLOAT,3,dims,iret)
       call dvcdf(ncid,varid,name,len_trim(name),
     &            unit,len_trim(unit),spval) 

       dims = (/bdimid, lon_udim, iTimedim,1/)
       varid = ncvdef (ncid,'psix', NCFLOAT,3,dims,iret)
       call dvcdf(ncid,varid,name,len_trim(name),
     &            unit,len_trim(unit),spval) 

#ifdef enable_bolus_velocity
       dims = (/bdimid, z_udim, iTimedim,1/)
       varid = ncvdef (ncid,'psiz_b', NCFLOAT,3,dims,iret)
       name = 'Bolus streamfunction'; unit = 'Sv'
       call dvcdf(ncid,varid,name,len_trim(name),
     &            unit,len_trim(unit),spval) 

       dims = (/bdimid, lat_udim, iTimedim,1/)
       varid = ncvdef (ncid,'psiy_b', NCFLOAT,3,dims,iret)
       call dvcdf(ncid,varid,name,len_trim(name),
     &            unit,len_trim(unit),spval) 

       dims = (/bdimid, lon_udim, iTimedim,1/)
       varid = ncvdef (ncid,'psix_b', NCFLOAT,3,dims,iret)
       call dvcdf(ncid,varid,name,len_trim(name),
     &            unit,len_trim(unit),spval) 
#endif

       call ncendf(ncid, iret)
       iret= nf_put_vara_double(ncid,bid,1,bdim,bax)
       call ncclos (ncid, iret)
      endif ! my_pe ==0
      end subroutine init_overturning




      subroutine overturning
      use cpflame_module
      use overturning_module
#ifdef enable_bolus_velocity
      use bolus_module
#endif
      implicit none
#include "netcdf.inc"
      integer :: i,j,k,js,je,n
      integer :: ncid,iret,corner(4), edges(4)
      integer :: itdimid,ilen,itimeid,varid
      type(time_type) :: time
      character :: name*64, unit*32
      real :: ww,fxa, bb

      if (snapshot_time_step.or.initial_time==current_time) then

       js=max(2,js_pe); je = min(je_pe,jmt-1)
       phiz=0;phiy=0;phix=0
#ifdef enable_bolus_velocity
       phiz_b=0;phiy_b=0;phix_b=0
#endif

       do n=1,bdim

        do k=2,km-1
         do j=js,je 
          do i=2,imt-1
           ww=u(i,j,k,3,tau)*maskW(i,j,k)
           bb=0.5*( b(i,j,k,tau)+b(i,j,k+1,tau) )
           if( bb<bax(n) ) ww=0
           phiz(n,k)=phiz(n,k)+ww*dx*dx*1e-6
          enddo 
         enddo 
         call global_sum_vec(phiz(n,k),1)
        enddo 

        do k=2,km-1
         do j=js,je 
          do i=2,imt-1
           ww=u(i,j,k,1,tau)*maskU(i,j,k)
           bb=0.5*( b(i,j,k,tau)+b(i+1,j,k,tau) )
           if( bb<bax(n) ) ww=0
           phix(n,i)=phix(n,i)+ww*dx*dx*1e-6
          enddo 
         enddo 
        enddo 

        do j=js,je 
         do k=2,km-1
          do i=2,imt-1
           ww=u(i,j,k,2,tau)*maskV(i,j,k)
           bb=0.5*( b(i,j,k,tau)+b(i,j+1,k,tau))
           if( bb<bax(n) ) ww=0
           phiy(n,j)=phiy(n,j)+ww*dx*dz*1e-6
          enddo 
         enddo 
        enddo 

#ifdef enable_bolus_velocity
        do k=2,km-1
         do j=js,je 
          do i=2,imt-1
           ww=wb(i,j,k)*maskW(i,j,k)
           bb=0.5*( b(i,j,k,tau)+b(i,j,k+1,tau) )
           if( bb<bax(n) ) ww=0
           phiz_b(n,k)=phiz_b(n,k)+ww*dx*dx*1e-6
          enddo 
         enddo 
         call global_sum_vec(phiz_b(n,k),1)
        enddo 

        do k=2,km-1
         do j=js,je 
          do i=2,imt-1
           ww=ub(i,j,k)*maskU(i,j,k)
           bb=0.5*( b(i,j,k,tau)+b(i+1,j,k,tau) )
           if( bb<bax(n) ) ww=0
           phix_b(n,i)=phix_b(n,i)+ww*dx*dx*1e-6
          enddo 
         enddo 
        enddo 

        do j=js,je 
         do k=2,km-1
          do i=2,imt-1
           ww=vb(i,j,k)*maskV(i,j,k)
           bb=0.5*( b(i,j,k,tau)+b(i,j+1,k,tau))
           if( bb<bax(n) ) ww=0
           phiy_b(n,j)=phiy_b(n,j)+ww*dx*dz*1e-6
          enddo 
         enddo 
        enddo 
#endif
       enddo 

       do i=2,imt-1
         call global_sum_vec(phix(:,i),bdim)
#ifdef enable_bolus_velocity
         call global_sum_vec(phix_b(:,i),bdim)
#endif
       enddo 

      do n=1,n_pes-1
        if (my_pe==n) then
         call send_integer(js_pe,1,0,0)
         call send_integer(je_pe,1,0,0)
         do j=js_pe,je_pe
          call send_real(phiy(:,j),bdim,0,0)
#ifdef enable_bolus_velocity
          call send_real(phiy_b(:,j),bdim,0,0)
#endif
         enddo
        elseif (my_pe==0) then
         call recv_integer(js,1,n,0)
         call recv_integer(je,1,n,0)
         do j=js,je
          call recv_real(phiy(:,j),bdim,n,0)
#ifdef enable_bolus_velocity
          call recv_real(phiy_b(:,j),bdim,n,0)
#endif
         enddo
        endif
        call barrier
      enddo

       if (my_pe==0) then

         iret=nf_open('over.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         iret=nf_inq_dimid(ncid,'Time',itdimid)
         iret=nf_inq_dimlen(ncid, itdimid,ilen)
         iret=nf_inq_varid(ncid,'Time',itimeid)
         ilen=ilen+1
         time = current_time-initial_time
         fxa = time%days + time%seconds/86400.
         iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)

         Corner = (/1,1,ilen,1/); edges  = (/bdim,km,1,1/)
         iret=nf_inq_varid(ncid,'psiz',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,phiz)
#ifdef enable_bolus_velocity
         iret=nf_inq_varid(ncid,'psiz_b',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,phiz_b)
#endif

         Corner = (/1,1,ilen,1/); edges  = (/bdim,jmt,1,1/)
         iret=nf_inq_varid(ncid,'psiy',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,phiy)
#ifdef enable_bolus_velocity
         iret=nf_inq_varid(ncid,'psiy_b',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,phiy_b)
#endif

         Corner = (/1,1,ilen,1/); edges  = (/bdim,imt,1,1/)
         iret=nf_inq_varid(ncid,'psix',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,phix)
#ifdef enable_bolus_velocity
         iret=nf_inq_varid(ncid,'psix_b',varid)
         iret= nf_put_vara_double(ncid,varid,corner,edges,phix_b)
#endif


         call ncclos (ncid, iret)
        endif
        call barrier
      endif
      end subroutine overturning

#else
      subroutine overturning_dummy
      end
#endif

#include "options.inc"
    
c=======================================================================
c      Different advection schemes for buoyancy and other tracers
c=======================================================================


      subroutine adv_flux(adv_fe,adv_fn,adv_ft,var)
c=======================================================================
c       advective tracer flux:  call different schemes
c=======================================================================
      use cpflame_module
      implicit none
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km), var(imt,jmt,km,0:2)

      if (enable_quicker_advection) then
       call setcyclic3D_j2(var(:,:,:,taum1) )
       call adv_flux_quicker(adv_fe,adv_fn,adv_ft,var)
      else if (enable_4th_advection) then
       call setcyclic3D_j2(var(:,:,:,tau) )
       call adv_flux_4th(adv_fe,adv_fn,adv_ft,var)
      else if (enable_upwind_advection) then
       call adv_flux_upw(adv_fe,adv_fn,adv_ft,var)
      else if (enable_lax_advection) then
       call adv_flux_lax_wendroff(adv_fe,adv_fn,adv_ft,var)
      else
       call adv_flux_2th(adv_fe,adv_fn,adv_ft,var)
      endif
      end subroutine adv_flux




      subroutine adv_flux_2th(adv_fe,adv_fn,adv_ft,var)
c=======================================================================
c      2th order advective tracer flux
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km), var(imt,jmt,km,0:2)
      real :: totvel

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         totvel = u(i,j,k,1,tau)
         adv_fe(i,j,k)=
     &  0.5*(var(i,j,k,tau) + var(i+1,j,k,tau) )*totvel
     &    *maskU(i,j,k)
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         totvel = u(i,j,k,2,tau)
         adv_fn(i,j,k)=
     &  0.5*( var(i,j,k,tau) + var(i,j+1,k,tau) )*totvel
     &    *maskV(i,j,k)
        enddo
       enddo
      enddo
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         totvel = u(i,j,k,3,tau)
         adv_ft(i,j,k)=
     &  0.5*( var(i,j,k,tau) + var(i,j,k+1,tau) )*totvel
     &    *maskW(i,j,k)
        enddo
       enddo
      enddo
      end subroutine adv_flux_2th





      subroutine adv_flux_4th(adv_fe,adv_fn,adv_ft,var)
c=======================================================================
c      4th order advective tracer flux
c      author:   r.c.pacanowski       e-mail rcp@gfdl.gov
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je,ip2,im1,jp2,jm1,kp2,km1
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km), var(imt,jmt,km,0:2)
      real,parameter  :: a2nd = 1.0,     b2nd = 0.0
      real,parameter  :: a4th = 7.0/6.0, b4th = -1.0/6.0
      real :: mask

      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
       do k=2,km-1
        do i=1,imt-1
         ip2=i+2
         if (ip2>imt.and..not.enable_cyclic_x) ip2=imt
         if (ip2>imt.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=imt-2
         mask = maskT(im1,j,k)*maskT(ip2,j,k)
         adv_fe(i,j,k) = 0.5*u(i,j,k,1,tau)*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(var(i,  j,k,tau) + 
     &                                      var(i+1,j,k,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(var(im1,j,k,tau) + 
     &                                      var(ip2,j,k,tau)))
        enddo
       enddo
      enddo

      do j=js,je
       do k=2,km-1
        do i=2,imt-1
         jp2=j+2
         if (jp2>jmt.and..not.enable_cyclic_y) jp2=jmt
         if (jp2>jmt.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=jmt-2
         mask = maskT(i,jm1,k)*maskT(i,jp2,k)
         adv_fn(i,j,k) = 0.5*u(i,j,k,2,tau)*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(var(i,  j,k,tau) + 
     &                                      var(i,j+1,k,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(var(i,jm1,k,tau) + 
     &                                      var(i,jp2,k,tau)))
        enddo
       enddo
      enddo
c
      do j=js,je
       do k=1,km-1
        do i=2,imt-1
         kp2=min(k+2,km)
         km1=max(1,k-1)
         mask = maskT(i,j,km1)*maskT(i,j,kp2)
         adv_ft(i,j,k) = 0.5*u(i,j,k,3,tau)*(
     &         (a2nd*(1.0-mask) + a4th*mask)*(var(i,j,  k,tau) + 
     &                                        var(i,j,k+1,tau))+
     &         (b2nd*(1.0-mask) + b4th*mask)*(var(i,j,km1,tau) + 
     &                                        var(i,j,kp2,tau)))
        enddo
       enddo
      enddo

      end subroutine adv_flux_4th






      subroutine adv_flux_quicker(adv_fe,adv_fn,adv_ft,var)
c=======================================================================
c      3th order advective tracer flux
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,ip2,jp2,kp2,im1,jm1,km1,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km), var(imt,jmt,km,0:2)
      real :: totvel,upos,uneg,eastmsk,westmsk
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         ip2=i+2
         if (ip2>imt.and..not.enable_cyclic_x) ip2=imt
         if (ip2>imt.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=imt-2

         totvel = u(i,j,k,1,tau)
         upos = .5*(totvel + abs(totvel))
     &                  *maskt(i,j,k)*maskt(i+1,j,k)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskt(i+1,j,k)*maskt(i,j,k)
         eastmsk=maskt(i,j,k)*(1-maskt(im1,j,k))
         westmsk=maskt(i+1,j,k)*(1-maskt(ip2,j,k))
	 adv_fe(i,j,k) =
     &        0.5*totvel*(var(i,j,k,tau)+var(i+1,j,k,tau))
     &        - 0.5*upos*(0.25*var(i+1,j,k,taum1)-0.5*var(i,j,k,taum1)
     &               +0.25*(var(im1,j,k,taum1)*(1-eastmsk)
     &                          +var(i,j,k,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(var(ip2,j,k,taum1)*(1-westmsk)+
     &          var(i+1,j,k,taum1)*westmsk)-0.5*var(i+1,j,k,taum1)
     &                         +0.25*var(i,j,k,taum1))
          enddo
        enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         jp2=j+2
         if (jp2>jmt.and..not.enable_cyclic_y) jp2=jmt
         if (jp2>jmt.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=jmt-2

         totvel = u(i,j,k,2,tau)
         upos = .5*(totvel + abs(totvel))
     &                  *maskt(i,j,k)*maskt(i,j+1,k)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskt(i,j+1,k)*maskt(i,j,k)
         eastmsk=maskt(i,j,k)*(1-maskt(i,jm1,k))
         westmsk=maskt(i,j+1,k)*(1-maskt(i,jp2,k))
	 adv_fn(i,j,k) =
     &        0.5*totvel*(var(i,j,k,tau)+var(i,j+1,k,tau))
     &        - 0.5*upos*(0.25*var(i,j+1,k,taum1)-0.5*var(i,j,k,taum1)
     &               +0.25*(var(i,jm1,k,taum1)*(1-eastmsk)
     &                          +var(i,j,k,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(var(i,jp2,k,taum1)*(1-westmsk)+
     &          var(i,j+1,k,taum1)*westmsk)-0.5*var(i,j+1,k,taum1)
     &                         +0.25*var(i,j,k,taum1))
          enddo
        enddo
      enddo
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         kp2=min(k+2,km)
         km1=max(1,k-1)
         totvel = u(i,j,k,3,tau)
         upos = .5*(totvel + abs(totvel))
     &                  *maskt(i,j,k)*maskt(i,j,k+1)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskt(i,j,k+1)*maskt(i,j,k)
         eastmsk=maskt(i,j,k)*(1-maskt(i,j,km1))
         westmsk=maskt(i,j,k+1)*(1-maskt(i,j,kp2))
	 adv_ft(i,j,k) =
     &        0.5*totvel*(var(i,j,k,tau)+var(i,j,k+1,tau))
     &        - 0.5*upos*(0.25*var(i,j,k+1,taum1)-0.5*var(i,j,k,taum1)
     &               +0.25*(var(i,j,km1,taum1)*(1-eastmsk)
     &                          +var(i,j,k,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(var(i,j,kp2,taum1)*(1-westmsk)+
     &          var(i,j,k+1,taum1)*westmsk)-0.5*var(i,j,k+1,taum1)
     &                         +0.25*var(i,j,k,taum1))
          enddo
        enddo
      enddo
      end subroutine adv_flux_quicker






      subroutine adv_flux_lax_wendroff(adv_fe,adv_fn,adv_ft,var)
c=======================================================================
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km), var(imt,jmt,km,0:2)
      real :: totvel,d0,d1,absc

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         totvel = u(i,j,k,1,tau)
         absc=abs(totvel*dt/dx)
         adv_fe(i,j,k)=maskU(i,j,k)*0.5*( 
     &        totvel*(var(i+1,j,k,tau)+var(i,j,k,tau))
     &     -abs(totvel)*absc*(var(i+1,j,k,taum1)-var(i,j,k,taum1)) )
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         totvel = u(i,j,k,2,tau)
         absc=abs(totvel*dt/dx)
         adv_fn(i,j,k)=maskV(i,j,k)*0.5*( 
     &        totvel*(var(i,j+1,k,tau)+var(i,j,k,tau))
     &     -abs(totvel)*absc*(var(i,j+1,k,taum1)-var(i,j,k,taum1)) )
        enddo
       enddo
      enddo
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         totvel = u(i,j,k,3,tau)
         absc=abs(totvel*dt/dz)
         adv_ft(i,j,k)=maskW(i,j,k)*0.5*( 
     &        totvel*(var(i,j,k+1,tau)+var(i,j,k,tau))
     &     -abs(totvel)*absc*(var(i,j,k+1,taum1)-var(i,j,k,taum1)) )
        enddo
       enddo
      enddo
      end subroutine adv_flux_lax_wendroff




      subroutine adv_flux_upw(adv_fe,adv_fn,adv_ft,var)
c=======================================================================
c        upwind tracer flux:   F = U b^i 
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km), var(imt,jmt,km,0:2)
      real :: totvel

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         totvel = u(i,j,k,1,tau)
         adv_fe(i,j,k)=maskU(i,j,k)*( 
     &     0.5*totvel*(var(i,j,k,taum1)+var(i+1,j,k,taum1))
     &   - 0.5*abs(totvel)*(var(i+1,j,k,taum1)-var(i,j,k,taum1) ) )
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         totvel = u(i,j,k,2,tau)
         adv_fn(i,j,k)=maskV(i,j,k)*( 
     &     0.5*totvel*(var(i,j,k,taum1)+var(i,j+1,k,taum1))
     &   - 0.5*abs(totvel)*(var(i,j+1,k,taum1)-var(i,j,k,taum1) ) )
        enddo
       enddo
      enddo
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         totvel = u(i,j,k,3,tau)
         adv_ft(i,j,k)=maskW(i,j,k)*( 
     &     0.5*totvel*(var(i,j,k,taum1)+var(i,j,k+1,taum1))
     &   - 0.5*abs(totvel)*(var(i,j,k+1,taum1)-var(i,j,k,taum1) ) )
        enddo
       enddo
      enddo
      end subroutine adv_flux_upw

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c    internal waves  
c=======================================================================


      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: fac=1.0
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=64*fac;km=60*fac;jmt=3
      dx=0.25/fac
      dz=0.25/fac
      dt_in=0.025/fac
      eps2D_sor = 1e-7
      eps3D_sor = 1e-7
      runlen=150./86400.0 !/ fac**2
      snap_int = 0.5/86400.0
      enable_cyclic_x            =.true.
      enable_cyclic_y            =.true.
      enable_quicker_advection   =.true.
      enable_hydrostatic         =.false.
      enable_biharmonic_friction =.true.
      enable_vert_biha_friction  =.true.
      enable_biharmonic_diffusion=.true.
      enable_vert_biha_diffusion =.true.
      Ahbi = (5e-3/fac**2)*dx**2
      Khbi = Ahbi
      Avbi = (5e-3/fac**2)*dx**2
      Kvbi = Avbi
      A_h = 00e-3/fac**2
      A_v = A_h
      K_h = 0
      K_v = 0

      lat_ref=0.
      beta   =0.
      N_0 = 2*pi/10.
      M_0 = 0.0
      end subroutine set_parameter


      subroutine set_back_stratification(bb,u0)
c ----------------------------------
c    overide setting from module back_stratification
c ----------------------------------
      use cpflame_module
      implicit none
      real :: bb(imt,jmt,km),u0(imt,jmt,km),fxa
      integer :: i,j,k
      do k=1,km
       do j=1,jmt
        do i=1,imt
         bb(i,j,k)=-1e-2*tanh( (zt(k)-zt(km/2) ) /zt(1)*100 )
         u0(i,j,k)= tanh( (zt(k)-zt(km/2))/zt(1)*100)
         bb(i,j,k)=bb(i,j,k)*maskT(i,j,k)
         u0(i,j,k)=u0(i,j,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      end subroutine set_back_stratification


      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: fxa,bb,dh
      do k=1,km
       do j=1,jmt
        do i=1,imt
         bb=-1e-2*tanh( (zt(k)-zt(km/2) ) /zt(1)*100 )
         dh=1e-4*zt(1)*sin(xt(i)/(20*dx)*pi)
         fxa=-1e-2*tanh((dh+zt(k)-zt(km/2) ) /zt(1)*100 )
         fxa=fxa-bb
         b(i,j,k,:)=fxa*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions


      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions


      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      free convection
c=======================================================================

#define two_dim

      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: fac=2.0
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=32*fac;km=25*fac;jmt=imt
#ifdef two_dim
      jmt=3
#endif
      dx=1.0/fac; 
      dz=1.0/fac; 
      dt_in=1.0/fac
      eps2D_sor = 1e-6
      eps3D_sor = 1e-6
      snap_int = 20/86400.0
      runlen = 300.*snap_int
      enable_hydrostatic         =.false.
      enable_4th_advection       =.true.
      enable_biharmonic_friction =.true.
      enable_vert_biha_friction  =.true.
      enable_biharmonic_diffusion=.true.
      enable_vert_biha_diffusion =.true.
      Ahbi = (2e-3/fac**2)*dx**2
      Khbi = Ahbi
      Avbi = (2e-3/fac**2)*dx**2
      Kvbi = Avbi
      lat_ref=0.
      beta   =0.
      N_0 = 2.5e-2
      M_0 = 0.0
      end subroutine set_parameter



      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: fxa
      real :: B0,x,y
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt
         x=float(i)/float(imt)
         y=float(j)/float(jmt)
#ifdef two_dim
         B0=1e-6*sin(x*2.5*pi)
#else
         B0=1e-6*sin(x*2.5*pi)*cos(y*3.7*pi)
#endif
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones



      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
c       b=0.2Temp/rho_0*g  
      surf_flux  = 10 *0.2/rho_0*g /4185.5 
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c      Biharmonic friction and diffusion
c=======================================================================

      subroutine biha_hfric_u (diff_fe,diff_fn)
c---------------------------------------------------------------------------------
c      horizontal biharmonic friction for zonal momentum
c      no slip condition is possible
c---------------------------------------------------------------------------------
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: diff_fe(imt,jmt,km), diff_fn(imt,jmt,km) 
      real :: del2(imt,jmt,km),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k) = (diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k) = (diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      diffx = sqrt(abs(ahbi))
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=1,km
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k)=diffx*(u(i+1,j,k,1,taum1)-u(i,j,k,1,taum1))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=1,imt
         diff_fn(i,j,k)=diffx*(u(i,j+1,k,1,taum1)-u(i,j,k,1,taum1))/dx
     &                  *maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js-1,je
         diff_fn(:,j,:)=diff_fn(:,j,:)-2*diffx*u(:,j,:,1,taum1)/dx
     &                   *(1-maskU(:,j+1,:))*maskU(:,j,:)
     &                                +2*diffx*u(:,j+1,:,1,taum1)/dx
     &                   *(1-maskU(:,j,:))*maskU(:,j+1,:)
       enddo
      endif
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      del2(:,js_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
	  del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(del2,1); call setcyclic3D(del2)
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k) =diffx*(del2(i+1,j,k)-del2(i,j,k))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js-1,je
        do i=2,imt-1
         diff_fn(i,j,k) = diffx*(del2(i,j+1,k) - del2(i,j,k))/dx
     &                     *maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js-1,je
         diff_fn(:,j,:)=diff_fn(:,j,:)-2*diffx*del2(:,j,:)/dx
     &                   *(1-maskU(:,j+1,:))*maskU(:,j,:)
     &                                +2*diffx*del2(:,j+1,:)/dx
     &                   *(1-maskU(:,j,:))*maskU(:,j+1,:)
       enddo
      endif
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fu(i,j,k)=fu(i,j,k)
     &        -maskU(i,j,k)*(DIFF_Tx(i,j,k)+DIFF_Ty(i,j,k))
        enddo
       enddo
      enddo
      end subroutine biha_hfric_u




      subroutine biha_hfric_v (diff_fe,diff_fn)
c---------------------------------------------------------------------------------
c      horizontal biharmonic friction for meridional momentum
c      no slip condition is possible
c---------------------------------------------------------------------------------
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: diff_fe(imt,jmt,km), diff_fn(imt,jmt,km) 
      real :: del2(imt,jmt,km),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      diffx = sqrt(abs(ahbi))
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=1,km
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k)=diffx*(u(i+1,j,k,2,taum1)-u(i,j,k,2,taum1))/dx
     &                  *maskV(i,j,k)*maskV(i+1,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js,je
       do i=1,imt-1
         diff_fe(i,j,:)=diff_fe(i,j,:)-2*diffx*u(i,j,:,2,taum1)/dx
     &                   *(1-maskV(i+1,j,:))*maskV(i,j,:)
     &                                +2*diffx*u(i+1,j,:,2,taum1)/dx
     &                   *(1-maskV(i,j,:))*maskV(i+1,j,:)
       enddo
       enddo
      endif
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=1,imt
         diff_fn(i,j,k)=diffx*(u(i,j+1,k,2,taum1)-u(i,j,k,2,taum1))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      del2(:,je_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
	  del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(del2,1); call setcyclic3D(del2)
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k) =diffx*(del2(i+1,j,k)-del2(i,j,k))/dx
     &                     *maskV(i+1,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js,je
       do i=1,imt-1
         diff_fe(i,j,:)=diff_fe(i,j,:)-2*diffx*del2(i,j,:)/dx
     &                   *(1-maskV(i+1,j,:))*maskV(i,j,:)
     &                                +2*diffx*del2(i+1,j,:)/dx
     &                   *(1-maskV(i,j,:))*maskV(i+1,j,:)
       enddo
       enddo
      endif
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         diff_fn(i,j,k) = diffx*(del2(i,j+1,k) - del2(i,j,k))/dx
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          fv(i,j,k)= fv(i,j,k)+maskV(i,j,k)*( 
     &               -DIFF_Tx(i,j,k) - DIFF_Ty(i,j,k))
        enddo
       enddo
      enddo
      end subroutine biha_hfric_v





      subroutine biha_hfric_w (diff_fe,diff_fn)
c---------------------------------------------------------------------------------
c      horizontal biharmonic friction for vertical momentum
c---------------------------------------------------------------------------------
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: diff_fe(imt,jmt,km), diff_fn(imt,jmt,km) 
      real :: del2(imt,jmt,km),diff_tx,diff_ty,diffx
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      diffx = sqrt(abs(ahbi))
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=1,km
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k)=diffx*(u(i+1,j,k,3,taum1)-u(i,j,k,3,taum1))/dx
     &                  *maskW(i,j,k)*maskW(i+1,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=1,imt
         diff_fn(i,j,k)=diffx*(u(i,j+1,k,3,taum1)-u(i,j,k,3,taum1))/dx
     &                  *maskW(i,j,k)*maskW(i,j+1,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      del2(:,je_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
	  del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(del2,1); call setcyclic3D(del2)
      diff_fe(:,js_pe:je_pe,:)=0.0;diff_fn(:,js_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k) =diffx*(del2(i+1,j,k)-del2(i,j,k))/dx
     &                     *maskW(i+1,j,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         diff_fn(i,j,k) = diffx*(del2(i,j+1,k) - del2(i,j,k))/dx
     &                     *maskW(i,j+1,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          fw(i,j,k)= fw(i,j,k)+maskW(i,j,k)*( 
     &               -DIFF_Tx(i,j,k) - DIFF_Ty(i,j,k))
        enddo
       enddo
      enddo
      end subroutine biha_hfric_w



      subroutine biha_vfric (diff_ft,mask,ff,n)
c---------------------------------------------------------------------------------
c       vertical biharmonic friction for  momentum component n
c       result is added to ff
c---------------------------------------------------------------------------------
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je,n
      real,dimension(imt,jmt,km) :: diff_ft,mask,ff
      real :: del2(imt,jmt,km),diff_tz,diffx
      DIFF_Tz(i,j,k)=(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      diffx = sqrt(abs(Avbi))
      diff_ft(:,je_pe:je_pe,:)=0.0
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         diff_ft(i,j,k)=diffx*(u(i,j,k+1,n,taum1)-u(i,j,k,n,taum1))/dz
     &                  *mask(i,j,k)*mask(i,j,k+1)
        enddo
       enddo
      enddo
      del2(:,je_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
	  del2(i,j,k) = DIFF_Tz(i,j,k)*mask(i,j,k)
        enddo
       enddo
      enddo
      diff_ft(:,je_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         diff_ft(i,j,k) =diffx*(del2(i,j,k+1)-del2(i,j,k))/dz
     &                     *mask(i,j,k+1)*mask(i,j,k)
        enddo
       enddo
      enddo
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          ff(i,j,k)= ff(i,j,k)-mask(i,j,k)*DIFF_Tz(i,j,k) 
        enddo
       enddo
      enddo
      end subroutine biha_vfric



      subroutine biha_mix (diff_fe,diff_fn,diff_ft,var)
c---------------------------------------------------------------------------------
c      horizontal biharmonic diffusion of buoyancy
c      also vertical biha. diff. if requested
c---------------------------------------------------------------------------------
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: var(imt,jmt,km,0:2)
      real :: diff_fe(imt,jmt,km), diff_fn(imt,jmt,km) 
      real :: diff_ft(imt,jmt,km)  ,diffz
      real :: del2(imt,jmt,km),diff_tx,diff_ty,diffx,diff_tz
      DIFF_Tx(i,j,k)=(diff_fe(i,j,k)-diff_fe(i-1,j,k))/dx
      DIFF_Ty(i,j,k)=(diff_fn(i,j,k)-diff_fn(i,j-1,k))/dx
      DIFF_Tz(i,j,k)=(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      diffx = sqrt(abs(Khbi))
      diffz = sqrt(abs(Kvbi))
      diff_fe(:,js_pe:je_pe,:)=0.0; diff_fn(:,js_pe:je_pe,:)=0.0
      do k=1,km
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k)=diffx*(var(i+1,j,k,taum1)-var(i,j,k,taum1))/dx
     &                  *maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=1,imt
         diff_fn(i,j,k)=diffx*(var(i,j+1,k,taum1)-var(i,j,k,taum1))/dx
     &                  *maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      del2(:,js_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
	  del2(i,j,k) = (DIFF_Tx(i,j,k) + DIFF_Ty(i,j,k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(del2,1); call setcyclic3D(del2)
      diff_fe(:,js_pe:je_pe,:)=0.0; diff_fn(:,js_pe:je_pe,:)=0.0
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         diff_fe(i,j,k) =diffx*(del2(i+1,j,k)-del2(i,j,k))/dx
     &                     *maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fe,1); call setcyclic3D(diff_fe)
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         diff_fn(i,j,k) = diffx*(del2(i,j+1,k) - del2(i,j,k))/dx
     &                     *maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1); call setcyclic3D(diff_fn)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
          var(i,j,k,taup1)= var(i,j,k,taup1)+c2dt*maskT(i,j,k)*( 
     &               -DIFF_Tx(i,j,k) - DIFF_Ty(i,j,k))
        enddo
       enddo
      enddo
      if (enable_vert_biha_diffusion) then
       diff_ft(:,js_pe:je_pe,:)=0.0
       do k=1,km-1
        do j=js,je
         do i=2,imt-1
          diff_ft(i,j,k)=diffz*(var(i,j,k+1,taum1)-var(i,j,k,taum1))/dz
     &                  *maskW(i,j,k)
         enddo
        enddo
       enddo
       del2(:,js_pe:je_pe,:)=0.0
       do k=2,km-1
        do j=js,je
         do i=2,imt-1
	  del2(i,j,k) = DIFF_Tz(i,j,k)*maskT(i,j,k)
         enddo
        enddo
       enddo
       diff_ft(:,js_pe:je_pe,:)=0.0
       do k=2,km-1
        do j=js,je
         do i=2,imt-1
          diff_ft(i,j,k) =diffz*(del2(i,j,k+1)-del2(i,j,k))/dz
     &                     *maskW(i,j,k)
         enddo
        enddo
       enddo
       do k=2,km-1
        do j=js,je
         do i=2,imt-1
          var(i,j,k,taup1)=var(i,j,k,taup1)
     &              -c2dt*maskT(i,j,k)*DIFF_Tz(i,j,k) 
         enddo
        enddo
       enddo
      endif
      end subroutine biha_mix

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      Eady problem
c=======================================================================


      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: fac=1.0
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt = 32*fac; km  = 20 *fac; jmt = 30*fac

      dx    = 20e3/fac
      dz    = 100.0 /fac
      dt_in = 1200.0 /fac

      Ahbi  = 5e11/fac**2
      Khbi  = Ahbi
      A_v   = 10.e-4 
      K_v   = 1.0e-4 
      cdint = 1e-8 

      eps2D_sor = 1e-9
      runlen    = 50.0 !/ RESOLVE**3
      snap_int  = 0.5

      enable_noslip               = .false.
      enable_interior_stress      = .false.
      enable_cyclic_x             = .true.
      enable_biharmonic_friction  = .true.
      enable_biharmonic_diffusion = .true.
      enable_hydrostatic          = .true.

!   f_0 = 2 om sin(phi/180*pi),  phi = 180/pi*asin(f_0/2/om)
      lat_ref = 180/pi*asin(1e-4/2/omega)
      beta    = 0*2*omega*cos(lat_ref/180.*pi)/radius
      N_0     = 0.004
      end subroutine set_parameter



      subroutine set_back_stratification(bb,u0)
c ----------------------------------
c    overide setting from module back_stratification
c ----------------------------------
      use cpflame_module
      implicit none
      real :: bb(imt,jmt,km),u0(imt,jmt,km),U_0=0.5
      integer :: i,j,k
c     thus best to set U=U_0 z/h  and B=f y U_0/h +f(z)
c     numerically consistent:  B_{j+1}=B_{j} + dx*U_z (coriolis_t(j  )+coriolis_t(j+1))/2.0

      do k=1,km
       u0(:,:,k)=(U_0/2+U_0*zt(k)/(km*dz))*maskU(:,:,k)
      enddo
      bb=0.
      do k=1,km
       do j=1,jmt-1
        bb(:,j+1,k)=bb(:,j,k)+dx*maskT(:,j,k)*U_0/(km*dz)
     &          *(coriolis_t(j)+coriolis_t(j+1))/2.0
       enddo
      enddo
      do k=1,km
       bb(:,:,k)=(bb(:,:,k)-N_0**2*zt(k))*maskT(:,:,k)
      enddo
      end subroutine set_back_stratification




      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: fxa,kx,ky,L_r

      L_r = N_0*(km-2)*dz/(coriolis_t(jmt/2)*pi)
      kx=1./L_r
      kx=1.6*coriolis_t(jmt/2)/N_0/((km-2)*dz)
      ky=pi/((jmt-2)*dx)
      b=0;u=0
#ifndef enable_back_stratification
      call set_back_stratification(b(:,:,:,0),u(:,:,:,1,0))
      b(:,:,:,1)=b(:,:,:,0)
      b(:,:,:,2)=b(:,:,:,0)
      u(:,:,:,1,1)=u(:,:,:,1,0)
      u(:,:,:,1,2)=u(:,:,:,1,0)
#endif
      do k=1,km
       do j=1,jmt
        do i=1,imt
         fxa=1e-4*sin(kx*xt(i))*sin(ky*yt(j))!*cos(zt(k)/(km*dz)*pi)
         b(i,j,k,:)=b(i,j,k,:)+fxa*maskT(i,j,k)
        enddo
       enddo
      enddo

c      do i=-5,imt+5
c        print*,i,mod(i-1,imt)+1
c      enddo
c      stop
      end subroutine initial_conditions


      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: T_rest,B0,om0
      type (time_type) :: time
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
#ifdef notdef
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      time = current_time
      om0=2*pi/coriolis_t(jmt/2)
      om0=2*pi/(0.98*om0)

      B0 =  1./(500.*dt)*sin(om0*time%seconds )
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fv(i,j,k)= fv(i,j,k)-maskv(i,j,k)*B0
     &                *sin(pi*zt(k)/((km-2)*dz))
        enddo
       enddo
      enddo
#endif
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions


      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c     Templates for setup
c=======================================================================


      subroutine set_parameter
      use cpflame_module
      implicit none
c ----------------------------------
c       set here main parameter
c ----------------------------------
c      integer, parameter :: imt=32,km=10,jmt=32

      imt=32;km=10;jmt=32
      dx=1.0*degtom
      dz=100.0
      dt_in=3600.0
      K_h=1000.0
      K_v=1.e-4
      A_h=40000.0
      A_v=10.e-4
      eps2D_sor = 1e-6
      runlen=10*365.0
      snap_int = 5.0
      enable_quicker_advection=.false.
      lat_ref = 45.0      
      beta    = 2*omega*cos(lat_ref/180.*pi)/radius
      N_0     = 0.005
      M_0     = 0.0
      end subroutine set_parameter


      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt
         b(i,j,k,:) = (0.2-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: k,i,j
      real :: x,y
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
! units are m^2/s^3  
! since  b_z = N^2   b[m/s^2]   b_t = F_z   [m/s^3]=[ m^2/s^3]_z

      do j=1,jmt
       do i=1,imt
        surf_flux(i,j)  = dz/dt_in*0.0*maskT(i,j,km-1)
        y = (yu(j)-yu(1))/ (yu(jmt)-yu(1))
        surf_tau(i,j,1) = -0.5e-4*cos(2*pi*y)*maskU(i,j,km-1)
        surf_tau(i,j,2) = 0.0*maskV(i,j,km-1)
       enddo
      enddo

      end subroutine boundary_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones


      subroutine topography
      use cpflame_module
      implicit none
      integer :: i,k
      real :: z,y,hcm,h0
c ----------------------------------
c      Add here topography  
c ---------------------------------- 
      h0 = -zt(1)
      do k=2,km-1
       do i=1,imt
        z=H0*(1-0.3*exp(-(xt(i)-xt(imt/2))**2/800e3**2 ) )
        if (zt(k).lt.-z) maskT(i,:,k)=0.0
       enddo
      enddo
      end subroutine topography

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c        double periodic domain 
c=======================================================================


      subroutine set_parameter
      use cpflame_module
      implicit none
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=32;km=10;jmt=imt
      dx=5e3
      dz=100.0
      dt_in=1200.0
      eps2D_sor = 1e-6
      eps3D_sor = 1e-6
      runlen=10*365.0
      snap_int = 0.05
      lat_ref=30
      beta   =0.

c      enable_noslip=.true.
      enable_hydrostatic         = .true.
      enable_cyclic_x            = .true.
      enable_cyclic_y            = .true.
      enable_biharmonic_friction = .true.
      enable_biharmonic_diffusion= .true.
      Ahbi = 2e8
      Khbi = Ahbi
      A_v=10e-4
      K_v=10e-4
      N_0 = 0.005
!      M_0 = sqrt(1e-5*0.2/rho_0*g)
      M_0 = 0.0
      end subroutine set_parameter



      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: z,r,x,y,B0,fxa
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt

c         x = 8.*pi*xt(i)/(imt-2.)/dx
c         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
c         B0=M_0**2*yt(j)+0.2*0.1/100*sin(x)

         x = (xt(i)-xt(imt/2))/20e3
         y = (yt(j)-yt(jmt/2))/20e3
         B0 = 2.0*exp(-x**2-y**2)*0.2/100
     &           *exp(-(zt(km)-zt(k))/200. )

c         y = 8.*pi*yt(j)/(jmt-2.)/dx
c         z = pi*zt(k)/(km-2.)/dz
c         B0 = sin(x)*sin(y)*cos(z)*2*0.2/100

         b(i,j,k,tau) = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(b(:,:,:,tau))
      b(:,:,:,taum1)=b(:,:,:,tau)

#ifdef notdef
c---------------------------------------------------------------------------------
c      hydrostatic pressure
c---------------------------------------------------------------------------------
      p_hydro = 0
      do j=2,jmt-1
       do k=km-1,1,-1
        p_hydro(:,j,k)= maskT(:,j,k)*
     &    (p_hydro(:,j,k+1)+(b(:,j,k+1,tau)+b(:,j,k,tau))/2.0*dz)
       enddo
      enddo
      call setcyclic3D(p_hydro)

      do k=2,km-1
       do j=2,jmt-1
        do i=2,imt-1
         fxa = 0.5*(p_hydro(i  ,j+1,k)-p_hydro(i  ,j,k))/dx
     &        +0.5*(p_hydro(i+1,j+1,k)-p_hydro(i+1,j,k))/dx
         u(i,j,k,1,tau) = fxa*maskU(i,j,k)/coriolis_t(j)
         fxa = 0.5*(p_hydro(i+1,j  ,k)-p_hydro(i,j  ,k))/dx
     &        +0.5*(p_hydro(i+1,j+1,k)-p_hydro(i,j+1,k))/dx
         u(i,j,k,2,tau) =-fxa*maskV(i,j,k)/coriolis_t(j)
        enddo
       enddo
      enddo
c
c      remove vertical mean from u and v
c
      p_hydro=0;
      do k=2,km-1
       do j=2,jmt-1
        do i=2,imt-1
          p_hydro(i,j,1)=p_hydro(i,j,1)+u(i,j,k,1,tau)*dz*maskU(i,j,k)
          p_hydro(i,j,2)=p_hydro(i,j,2)+u(i,j,k,2,tau)*dz*maskV(i,j,k)
          p_hydro(i,j,3)=p_hydro(i,j,3)+dz*maskU(i,j,k)
          p_hydro(i,j,4)=p_hydro(i,j,4)+dz*maskV(i,j,k)
        enddo
       enddo
      enddo

      p_hydro(:,:,3)=p_hydro(:,:,3)+1e-16
      p_hydro(:,:,4)=p_hydro(:,:,4)+1e-16

      do k=2,km-1
       do j=2,jmt-1
        do i=2,imt-1
         u(i,j,k,1,tau)=
     &       (u(i,j,k,1,tau)-p_hydro(i,j,1)/p_hydro(i,j,3))*maskU(i,j,k)
         u(i,j,k,2,tau)=
     &       (u(i,j,k,2,tau)-p_hydro(i,j,2)/p_hydro(i,j,4))*maskV(i,j,k)
        enddo
       enddo
      enddo
      p_hydro=0;
      call setcyclic3D(u(:,:,:,1,tau))
      call setcyclic3D(u(:,:,:,2,tau))
c
c      w from continuity
c
      u(:,:,1,3,:) = 0.0
      do k=2,km
       do j=2,jmt-1
        do i=2,imt-1
          u(i,j,k,3,tau) = u(i,j,k-1,3,tau)-maskW(i,j,k)*dz*( 
     &            (u(i,j,k,1,tau)-u(i-1,j,k,1,tau))/dx
     &           +(u(i,j,k,2,tau)-u(i,j-1,k,2,tau))/dx)
        enddo
       enddo
      enddo
      do j=2,jmt-1
       u(:,j,:,3,tau) = u(:,j,:,3,tau)*maskW(:,j,:)
      enddo
      call setcyclic3D(u(:,:,:,3,tau))

      u(:,:,:,:,taum1)=u(:,:,:,:,tau)
#endif
      end subroutine initial_conditions




      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: k,i,j
      real :: x,y
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
      integer :: i,k
      real :: z
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c=======================================================================


      subroutine set_parameter
      use cpflame_module
      implicit none
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=32;km=3;jmt=imt
      dx=25
      dz=25 
      dt_in=2.5
      eps2D_sor = 1e-6
      eps3D_sor = 1e-6
      runlen=2*360./86400.0 
      snap_int = 1/86400.0
      enable_cyclic_x            =.true.
      enable_cyclic_y            =.true.
c      enable_4th_advection       =.true.
c      enable_quicker_advection   =.true.
c      enable_upwind_advection   =.true.
      enable_lax_advection   =.true.
      enable_hydrostatic         =.false.

      A_h = 0; K_h = 0; A_v = 0; K_v = 0
      lat_ref=0.; beta   =0.; N_0 = 0.0; M_0 = 0.0
      end subroutine set_parameter



      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: fxa
      do k=1,km
       do j=1,jmt
        do i=1,imt
         b(i,j,k,:)=0*maskT(i,j,k)
         u(i,j,k,1,:)=1
         u(i,j,k,2,:)=1
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: T_rest,B0
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: T_rest,B0
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"


c#define with_topography

c=======================================================================
c     Templates for setup
c
c      spin down of a front
c=======================================================================

c increase this parameter to enhance resolution
#define RESOLVE  1.0


      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: f_0
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt   = 32*RESOLVE
      jmt   = 3
      km    = 20*RESOLVE

      dx    = 20e3/RESOLVE
      dz    = 50.0 /RESOLVE
      dt_in = 1200.0/RESOLVE

      K_h=000.0 /RESOLVE
      A_h=0000.0/RESOLVE
      Ahbi  = 5e11/RESOLVE**2
      Khbi  = Ahbi

      K_v=0.0e-4/RESOLVE
      A_v=10.e-4/RESOLVE
      cdbot = 0e-5*RESOLVE

      eps2D_sor = 1e-9
      runlen    = 1200./RESOLVE**3
      snap_int  = 5.

      enable_noslip               = .false.
      enable_cyclic_x             = .false.
      enable_cyclic_y             = .true.
      enable_bottom_stress        = .false.
      enable_biharmonic_friction  = .true.
      enable_biharmonic_diffusion = .false.
      enable_hydrostatic          = .true.
      enable_quicker_advection    = .false.  

      gamma=0.01
      lat_ref = 25.
      beta    = 0*2*omega*cos(lat_ref/180.*pi)/radius
      N_0     = 0.004
      M_0     = 0

      if (my_pe==0) then
       f_0 = 2*omega*sin(lat_ref/180.*pi)
       print*,' '
       print*,' Rossby radius '
       print*,'  N h/(f pi)     = ',N_0*(km-2)*dz/(f_0*pi)/1e3,' km'
       print*,' '
      endif

      end subroutine set_parameter



      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: fac,B0,x,y,z
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      fac = 2*0.2/rho_0*g
      do j=1,jmt
       do k=1,km
        do i=1,imt
c         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
         y = (xt(i)-xt(2))/ (xt(imt-1)-xt(2))
         B0=fac*0.5*(tanh((y-0.5)/0.1)+1.0)
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
        enddo
      enddo

c      do j=1,jmt
c       do k=km-3,km
c        do i=1,imt
c         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
c         B0=fac*0.5*(tanh((y-0.5)/0.1)+1.0)
c         b(i,j,k,:)  = (B0-0.0010**2*zt(k))*maskT(i,j,k)
c        enddo
c        enddo
c      enddo

      end subroutine initial_conditions


      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones




      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: i,j
      real :: L_y,y,t_rest,bstar
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
      integer :: i,j
      real :: L_x,L_y
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      swashing two layer initial value problem
c=======================================================================

      subroutine set_parameter
      use cpflame_module
      implicit none
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=64*1;km=20*1;jmt=3
      dx=0.25 /1
      dz=0.25 /1
      dt_in=0.5/4
      eps2D_sor = 1e-6
      eps3D_sor = 1e-6
      runlen = 360/86400.
      snap_int = 2./86400.
      enable_4th_advection       =.true.
c      enable_quicker_advection       =.true.
      enable_hydrostatic         =.false.
      enable_biharmonic_friction =.true.
      enable_vert_biha_friction  =.true.
      enable_biharmonic_diffusion=.true.
      enable_vert_biha_diffusion =.true.
      Ahbi = 2e-3*dx**2
      Avbi = Ahbi
      Khbi = Ahbi
      Kvbi = Ahbi
      lat_ref=0.
      beta   =0.
      N_0 = 0.
      M_0 = 0.
      end subroutine set_parameter

        

      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      do k=1,km
       do j=1,jmt
        do i=1,imt
         b(i,j,k,:)=
     &         -0.01*tanh( (zt(k)-zt(km/2)
     &      -zt(1)*cos(i*2./imt) ) /zt(1)*-20 )
         b(i,j,k,:)=b(i,j,k,:)*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones



      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones




      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c      Advection schemes for momentum
c=======================================================================


      subroutine adv_flux_u_2nd(adv_fe,adv_fn,adv_ft)
c=======================================================================
c       advection of zonal momentum
c       fluxes are stored in adv_fe,adv_fn and adv_ft
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km) 
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         adv_fe(i,j,k)=
     &  0.5*( u(i  ,j,k,1,tau) + u(i+1,j,k,1,tau) )*
     &   (u(i,j,k,1,tau)+u(i+1,j,k,1,tau))
     &        *0.5*maskU(i+1,j,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(adv_fe)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         adv_fn(i,j,k)=
     &  0.5*( u(i,j,k,1,tau) + u(i,j+1,k,1,tau) )*
     &   (u(i,j,k,2,tau)+u(i+1,j,k,2,tau))
     &        *0.5*maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         adv_ft(i,j,k)=
     &  0.5*(u(i,j,k,1,tau)+u(i,j,k+1,1,tau))*
     &   (u(i,j,k,3,tau)+u(i+1,j,k,3,tau))
     &        *0.5*maskU(i,j,k+1)*maskU(i,j,k)
        enddo
       enddo
      enddo
      end subroutine adv_flux_u_2nd


      subroutine adv_flux_v_2nd(adv_fe,adv_fn,adv_ft)
c=======================================================================
c       advection of meridional momentum
c       fluxes are stored in adv_fe,adv_fn and adv_ft
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km) 
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         adv_fe(i,j,k)=
     &  0.5*( u(i  ,j,k,2,tau) + u(i+1,j,k,2,tau) )*
     &    (u(i,j,k,1,tau)+u(i,j+1,k,1,tau))
     &        *0.5*maskV(i+1,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(adv_fe)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         adv_fn(i,j,k)=
     &  0.5*( u(i,j,k,2,tau) + u(i,j+1,k,2,tau) )*
     &   (u(i,j,k,2,tau)+u(i,j+1,k,2,tau))
     &        *0.5*maskV(i,j+1,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         adv_ft(i,j,k)=
     &  0.5*( u(i,j,k,2,tau) + u(i,j,k+1,2,tau) )*
     &   (u(i,j,k,3,tau)+u(i,j+1,k,3,tau))
     &        *0.5*maskV(i,j,k+1)*maskV(i,j,k)
        enddo
       enddo
      enddo
      end subroutine adv_flux_v_2nd




      subroutine adv_flux_w_2nd(adv_fe,adv_fn,adv_ft)
c=======================================================================
c       advection of vertical momentum
c       fluxes are stored in adv_fe,adv_fn and adv_ft
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km) 
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         adv_fe(i,j,k)=
     &     0.5*( u(i  ,j,k,3,tau) + u(i+1,j,k,3,tau) )*
     &         (u(i,j,k,1,tau)+u(i,j,k+1,1,tau))
     &        *0.5*maskW(i+1,j,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call setcyclic3D(adv_fe)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         adv_fn(i,j,k)=
     &     0.5*( u(i,j,k,3,tau) + u(i,j+1,k,3,tau) )*
     &     (u(i,j,k,2,tau)+u(i,j,k+1,2,tau))
     &        *0.5*maskW(i,j+1,k)*maskW(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         adv_ft(i,j,k)=
     &     0.5*( u(i,j,k,3,tau) + u(i,j,k+1,3,tau) )*
     &     (u(i,j,k,3,tau)+u(i,j,k+1,3,tau))
     &        *0.5*maskW(i,j,k+1)*maskW(i,j,k)
        enddo
       enddo
      enddo
      end subroutine adv_flux_w_2nd



      subroutine adv_flux_u_4th(adv_fe,adv_fn,adv_ft)
c=======================================================================
c       advection of zonal momentum 4th order
c       fluxes are stored in adv_fe,adv_fn and adv_ft
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je,ip2,im1,jp2,jm1,kp2,km1
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real,parameter  :: a2nd = 1.0,     b2nd = 0.0
      real,parameter  :: a4th = 7.0/6.0, b4th = -1.0/6.0
      real :: mask,totvel

      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
       do k=2,km-1
        do i=1,imt-1
         ip2=i+2
         if (ip2>imt.and..not.enable_cyclic_x) ip2=imt
         if (ip2>imt.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=imt-2
         mask = maskU(im1,j,k)*maskU(ip2,j,k)
c         totvel = 0.5*(u(i+1,j,k,1,tau)+u(i,j,k,1,tau))
         totvel = (u(i+1,j,k,1,tau)*maskU(i+1,j,k)
     &             +u(i,j,k,1,tau)*maskU(i,j,k))/2.0
         adv_fe(i,j,k) = 0.5*totvel*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(u(i,  j,k,1,tau) + 
     &                                      u(i+1,j,k,1,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(u(im1,j,k,1,tau) + 
     &                                      u(ip2,j,k,1,tau)))
        enddo
       enddo
      enddo
      call setcyclic3D(adv_fe)

      do j=js,je
       do k=2,km-1
        do i=2,imt-1
         jp2=j+2
         if (jp2>jmt.and..not.enable_cyclic_y) jp2=jmt
         if (jp2>jmt.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=jmt-2
         mask = maskU(i,jm1,k)*maskU(i,jp2,k)
c         totvel = 0.5*(u(i+1,j,k,2,tau)+u(i,j,k,2,tau))
         totvel = (u(i+1,j,k,2,tau)*maskV(i+1,j,k)
     &             +u(i,j,k,2,tau)*maskV(i,j,k))/2.0
         adv_fn(i,j,k) = 0.5*totvel*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(u(i,  j,k,1,tau) + 
     &                                      u(i,j+1,k,1,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(u(i,jm1,k,1,tau) + 
     &                                      u(i,jp2,k,1,tau)))
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
c
      do j=js,je
       do k=1,km-1
        do i=2,imt-1
         kp2=min(k+2,km)
         km1=max(1,k-1)
         mask = maskU(i,j,km1)*maskU(i,j,kp2)
c         totvel = 0.5*(u(i+1,j,k,3,tau)+u(i,j,k,3,tau))
         totvel = (u(i+1,j,k,3,tau)*maskW(i+1,j,k)
     &             +u(i,j,k,3,tau)*maskW(i,j,k))/2.0
         adv_ft(i,j,k) = 0.5*totvel*(
     &         (a2nd*(1.0-mask) + a4th*mask)*(u(i,j,  k,1,tau) + 
     &                                        u(i,j,k+1,1,tau))+
     &         (b2nd*(1.0-mask) + b4th*mask)*(u(i,j,km1,1,tau) + 
     &                                        u(i,j,kp2,1,tau)))
        enddo
       enddo
      enddo
      end subroutine adv_flux_u_4th



      subroutine adv_flux_v_4th(adv_fe,adv_fn,adv_ft)
c=======================================================================
c       advection of meridional momentum 4th order
c       fluxes are stored in adv_fe,adv_fn and adv_ft
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je,ip2,im1,jp2,jm1,kp2,km1
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real,parameter  :: a2nd = 1.0,     b2nd = 0.0
      real,parameter  :: a4th = 7.0/6.0, b4th = -1.0/6.0
      real :: mask,totvel

      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
       do k=2,km-1
        do i=1,imt-1
         ip2=i+2
         if (ip2>imt.and..not.enable_cyclic_x) ip2=imt
         if (ip2>imt.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=imt-2
         mask = maskV(im1,j,k)*maskV(ip2,j,k)
c         totvel = 0.5*(u(i,j+1,k,1,tau)+u(i,j,k,1,tau))
         totvel = (u(i,j+1,k,1,tau)*maskU(i,j+1,k)
     &             +u(i,j,k,1,tau)*maskU(i,j,k))/2.0
         adv_fe(i,j,k) = 0.5*totvel*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(u(i,  j,k,2,tau) + 
     &                                      u(i+1,j,k,2,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(u(im1,j,k,2,tau) + 
     &                                      u(ip2,j,k,2,tau)))
        enddo
       enddo
      enddo
      call setcyclic3D(adv_fe)

      do j=js,je
       do k=2,km-1
        do i=2,imt-1
         jp2=j+2
         if (jp2>jmt.and..not.enable_cyclic_y) jp2=jmt
         if (jp2>jmt.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=jmt-2
         mask = maskV(i,jm1,k)*maskV(i,jp2,k)
c         totvel = 0.5*(u(i,j+1,k,2,tau)+u(i,j,k,2,tau))
         totvel = (u(i,j+1,k,2,tau)*maskV(i,j+1,k)
     &             +u(i,j,k,2,tau)*maskV(i,j,k))/2.0
         adv_fn(i,j,k) = 0.5*totvel*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(u(i,  j,k,2,tau) + 
     &                                      u(i,j+1,k,2,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(u(i,jm1,k,2,tau) + 
     &                                      u(i,jp2,k,2,tau)))
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
c
      do j=js,je
       do k=1,km-1
        do i=2,imt-1
         kp2=min(k+2,km)
         km1=max(1,k-1)
         mask = maskV(i,j,km1)*maskV(i,j,kp2)
c         totvel = 0.5*(u(i,j+1,k,3,tau)+u(i,j,k,3,tau))
         totvel = (u(i,j+1,k,3,tau)*maskW(i,j+1,k)
     &             +u(i,j,k,3,tau)*maskW(i,j,k))/2.0
         adv_ft(i,j,k) = 0.5*totvel*(
     &         (a2nd*(1.0-mask) + a4th*mask)*(u(i,j,  k,2,tau) + 
     &                                        u(i,j,k+1,2,tau))+
     &         (b2nd*(1.0-mask) + b4th*mask)*(u(i,j,km1,2,tau) + 
     &                                        u(i,j,kp2,2,tau)))
        enddo
       enddo
      enddo
      end subroutine adv_flux_v_4th




      subroutine adv_flux_w_4th(adv_fe,adv_fn,adv_ft)
c=======================================================================
c       advection of vertical momentum 4th order
c       fluxes are stored in adv_fe,adv_fn and adv_ft
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je,ip2,im1,jp2,jm1,kp2,km1
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real,parameter  :: a2nd = 1.0,     b2nd = 0.0
      real,parameter  :: a4th = 7.0/6.0, b4th = -1.0/6.0
      real :: mask,totvel

      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
       do k=2,km-1
        do i=1,imt-1
         ip2=i+2
         if (ip2>imt.and..not.enable_cyclic_x) ip2=imt
         if (ip2>imt.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=imt-2
         mask = maskW(im1,j,k)*maskW(ip2,j,k)
         totvel = (u(i,j,k+1,1,tau)*maskU(i,j,k+1)
     &             +u(i,j,k,1,tau)*maskU(i,j,k))/2.0
         adv_fe(i,j,k) = 0.5*totvel*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(u(i,  j,k,3,tau) + 
     &                                      u(i+1,j,k,3,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(u(im1,j,k,3,tau) + 
     &                                      u(ip2,j,k,3,tau)))
        enddo
       enddo
      enddo
      call setcyclic3D(adv_fe)

      do j=js,je
       do k=2,km-1
        do i=2,imt-1
         jp2=j+2
         if (jp2>jmt.and..not.enable_cyclic_y) jp2=jmt
         if (jp2>jmt.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=jmt-2
         mask = maskW(i,jm1,k)*maskW(i,jp2,k)
         totvel = (u(i,j,k+1,2,tau)*maskV(i,j,k+1)
     &             +u(i,j,k,2,tau)*maskV(i,j,k))/2.0
         adv_fn(i,j,k) = 0.5*totvel*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(u(i,  j,k,3,tau) + 
     &                                      u(i,j+1,k,3,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(u(i,jm1,k,3,tau) + 
     &                                      u(i,jp2,k,3,tau)))
        enddo
       enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)
c
      do j=js,je
       do k=1,km-1
        do i=2,imt-1
         kp2=min(k+2,km)
         km1=max(1,k-1)
         mask = maskW(i,j,km1)*maskW(i,j,kp2)
         totvel = (u(i,j,k+1,3,tau)*maskW(i,j,k+1)
     &             +u(i,j,k,3,tau)*maskW(i,j,k))/2.0
         adv_ft(i,j,k) = 0.5*totvel*(
     &         (a2nd*(1.0-mask) + a4th*mask)*(u(i,j,  k,3,tau) + 
     &                                        u(i,j,k+1,3,tau))+
     &         (b2nd*(1.0-mask) + b4th*mask)*(u(i,j,km1,3,tau) + 
     &                                        u(i,j,kp2,3,tau)))
        enddo
       enddo
      enddo
      end subroutine adv_flux_w_4th






      subroutine adv_flux_u_quicker(adv_fe,adv_fn,adv_ft)
c=======================================================================
c       advection of zonal momentum,   3th order upwind
c       fluxes are stored in adv_fe,adv_fn and adv_ft
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,ip2,jp2,kp2,im1,jm1,km1,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real :: totvel,upos,uneg,eastmsk,westmsk
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         ip2=i+2
         if (ip2>imt.and..not.enable_cyclic_x) ip2=imt
         if (ip2>imt.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=imt-2

         totvel = 0.5*(u(i+1,j,k,1,tau)+u(i,j,k,1,tau))
         upos = .5*(totvel + abs(totvel))
     &                  *maskU(i,j,k)*maskU(i+1,j,k)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskU(i+1,j,k)*maskU(i,j,k)
         eastmsk=maskU(i,j,k)*(1-maskU(im1,j,k))
         westmsk=maskU(i+1,j,k)*(1-maskU(ip2,j,k))
	 adv_fe(i,j,k) =
     &        0.5*totvel*(u(i,j,k,1,tau)+u(i+1,j,k,1,tau))
     &        - 0.5*upos*(0.25*u(i+1,j,k,1,taum1)-0.5*u(i,j,k,1,taum1)
     &               +0.25*(u(im1,j,k,1,taum1)*(1-eastmsk)
     &                          +u(i,j,k,1,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(u(ip2,j,k,1,taum1)*(1-westmsk)+
     &          u(i+1,j,k,1,taum1)*westmsk)-0.5*u(i+1,j,k,1,taum1)
     &                         +0.25*u(i,j,k,1,taum1))
          enddo
        enddo
      enddo
      call setcyclic3D(adv_fe)

      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         jp2=j+2
         if (jp2>jmt.and..not.enable_cyclic_y) jp2=jmt
         if (jp2>jmt.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=jmt-2

         totvel = 0.5*(u(i+1,j,k,2,tau)+u(i,j,k,2,tau))
         upos = .5*(totvel + abs(totvel))
     &                  *maskU(i,j,k)*maskU(i,j+1,k)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskU(i,j+1,k)*maskU(i,j,k)
         eastmsk=maskU(i,j,k)*(1-maskU(i,jm1,k))
         westmsk=maskU(i,j+1,k)*(1-maskU(i,jp2,k))
	 adv_fn(i,j,k) =
     &        0.5*totvel*(u(i,j,k,1,tau)+u(i,j+1,k,1,tau))
     &        - 0.5*upos*(0.25*u(i,j+1,k,1,taum1)-0.5*u(i,j,k,1,taum1)
     &               +0.25*(u(i,jm1,k,1,taum1)*(1-eastmsk)
     &                          +u(i,j,k,1,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(u(i,jp2,k,1,taum1)*(1-westmsk)+
     &          u(i,j+1,k,1,taum1)*westmsk)-0.5*u(i,j+1,k,1,taum1)
     &                         +0.25*u(i,j,k,1,taum1))
          enddo
        enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)

      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         kp2=min(k+2,km)
         km1=max(1,k-1)
         totvel = 0.5*(u(i+1,j,k,3,tau)+u(i,j,k,3,tau))
         upos = .5*(totvel + abs(totvel))
     &                  *maskU(i,j,k)*maskU(i,j,k+1)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskU(i,j,k+1)*maskU(i,j,k)
         eastmsk=maskU(i,j,k)*(1-maskU(i,j,km1))
         westmsk=maskU(i,j,k+1)*(1-maskU(i,j,kp2))
	 adv_ft(i,j,k) =
     &        0.5*totvel*(u(i,j,k,1,tau)+u(i,j,k+1,1,tau))
     &        - 0.5*upos*(0.25*u(i,j,k+1,1,taum1)-0.5*u(i,j,k,1,taum1)
     &               +0.25*(u(i,j,km1,1,taum1)*(1-eastmsk)
     &                          +u(i,j,k,1,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(u(i,j,kp2,1,taum1)*(1-westmsk)+
     &          u(i,j,k+1,1,taum1)*westmsk)-0.5*u(i,j,k+1,1,taum1)
     &                         +0.25*u(i,j,k,1,taum1))
          enddo
        enddo
      enddo
      end subroutine adv_flux_u_quicker





      subroutine adv_flux_v_quicker(adv_fe,adv_fn,adv_ft)
c=======================================================================
c       advection of meridional momentum,   3th order upwind
c       fluxes are stored in adv_fe,adv_fn and adv_ft
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,ip2,jp2,kp2,im1,jm1,km1,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real :: totvel,upos,uneg,eastmsk,westmsk
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         ip2=i+2
         if (ip2>imt.and..not.enable_cyclic_x) ip2=imt
         if (ip2>imt.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=imt-2

         totvel = 0.5*(u(i,j+1,k,1,tau)+u(i,j,k,1,tau))
         upos = .5*(totvel + abs(totvel))
     &                  *maskV(i,j,k)*maskV(i+1,j,k)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskV(i+1,j,k)*maskV(i,j,k)
         eastmsk=maskV(i,j,k)*(1-maskV(im1,j,k))
         westmsk=maskV(i+1,j,k)*(1-maskV(ip2,j,k))
	 adv_fe(i,j,k) =
     &        0.5*totvel*(u(i,j,k,2,tau)+u(i+1,j,k,2,tau))
     &        - 0.5*upos*(0.25*u(i+1,j,k,2,taum1)-0.5*u(i,j,k,2,taum1)
     &               +0.25*(u(im1,j,k,2,taum1)*(1-eastmsk)
     &                          +u(i,j,k,2,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(u(ip2,j,k,2,taum1)*(1-westmsk)+
     &          u(i+1,j,k,2,taum1)*westmsk)-0.5*u(i+1,j,k,2,taum1)
     &                         +0.25*u(i,j,k,2,taum1))
          enddo
        enddo
      enddo
      call setcyclic3D(adv_fe)

      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         jp2=j+2
         if (jp2>jmt.and..not.enable_cyclic_y) jp2=jmt
         if (jp2>jmt.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=jmt-2

         totvel = 0.5*(u(i,j+1,k,2,tau)+u(i,j,k,2,tau))
         upos = .5*(totvel + abs(totvel))
     &                  *maskV(i,j,k)*maskV(i,j+1,k)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskV(i,j+1,k)*maskV(i,j,k)
         eastmsk=maskV(i,j,k)*(1-maskV(i,jm1,k))
         westmsk=maskV(i,j+1,k)*(1-maskV(i,jp2,k))
	 adv_fn(i,j,k) =
     &        0.5*totvel*(u(i,j,k,2,tau)+u(i,j+1,k,2,tau))
     &        - 0.5*upos*(0.25*u(i,j+1,k,2,taum1)-0.5*u(i,j,k,2,taum1)
     &               +0.25*(u(i,jm1,k,2,taum1)*(1-eastmsk)
     &                          +u(i,j,k,2,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(u(i,jp2,k,2,taum1)*(1-westmsk)+
     &          u(i,j+1,k,2,taum1)*westmsk)-0.5*u(i,j+1,k,2,taum1)
     &                         +0.25*u(i,j,k,2,taum1))
          enddo
        enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)

      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         kp2=min(k+2,km)
         km1=max(1,k-1)
         totvel = 0.5*(u(i,j+1,k,3,tau)+u(i,j,k,3,tau))
         upos = .5*(totvel + abs(totvel))
     &                  *maskV(i,j,k)*maskV(i,j,k+1)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskV(i,j,k+1)*maskV(i,j,k)
         eastmsk=maskV(i,j,k)*(1-maskV(i,j,km1))
         westmsk=maskV(i,j,k+1)*(1-maskV(i,j,kp2))
	 adv_ft(i,j,k) =
     &        0.5*totvel*(u(i,j,k,2,tau)+u(i,j,k+1,2,tau))
     &        - 0.5*upos*(0.25*u(i,j,k+1,2,taum1)-0.5*u(i,j,k,2,taum1)
     &               +0.25*(u(i,j,km1,2,taum1)*(1-eastmsk)
     &                          +u(i,j,k,2,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(u(i,j,kp2,2,taum1)*(1-westmsk)+
     &          u(i,j,k+1,2,taum1)*westmsk)-0.5*u(i,j,k+1,2,taum1)
     &                         +0.25*u(i,j,k,2,taum1))
          enddo
        enddo
      enddo
      end subroutine adv_flux_v_quicker



      subroutine adv_flux_w_quicker(adv_fe,adv_fn,adv_ft)
c=======================================================================
c       advection of vertical momentum,   3th order upwind
c       fluxes are stored in adv_fe,adv_fn and adv_ft
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,ip2,jp2,kp2,im1,jm1,km1,js,je
      real :: adv_fe(imt,jmt,km), adv_ft(imt,jmt,km)
      real :: adv_fn(imt,jmt,km)
      real :: totvel,upos,uneg,eastmsk,westmsk
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         ip2=i+2
         if (ip2>imt.and..not.enable_cyclic_x) ip2=imt
         if (ip2>imt.and.     enable_cyclic_x) ip2=3
         im1=i-1
         if (im1<1.and..not. enable_cyclic_x) im1=1
         if (im1<1.and.      enable_cyclic_x) im1=imt-2

         totvel = 0.5*(u(i,j,k+1,1,tau)+u(i,j,k,1,tau))
         upos = .5*(totvel + abs(totvel))
     &                  *maskW(i,j,k)*maskW(i+1,j,k)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskW(i+1,j,k)*maskW(i,j,k)
         eastmsk=maskW(i,j,k)*(1-maskW(im1,j,k))
         westmsk=maskW(i+1,j,k)*(1-maskW(ip2,j,k))
	 adv_fe(i,j,k) =
     &        0.5*totvel*(u(i,j,k,3,tau)+u(i+1,j,k,3,tau))
     &        - 0.5*upos*(0.25*u(i+1,j,k,3,taum1)-0.5*u(i,j,k,3,taum1)
     &               +0.25*(u(im1,j,k,3,taum1)*(1-eastmsk)
     &                          +u(i,j,k,3,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(u(ip2,j,k,3,taum1)*(1-westmsk)+
     &          u(i+1,j,k,3,taum1)*westmsk)-0.5*u(i+1,j,k,3,taum1)
     &                         +0.25*u(i,j,k,3,taum1))
          enddo
        enddo
      enddo
      call setcyclic3D(adv_fe)

      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         jp2=j+2
         if (jp2>jmt.and..not.enable_cyclic_y) jp2=jmt
         if (jp2>jmt.and.     enable_cyclic_y) jp2=3
         jm1=j-1
         if (jm1<1.and..not. enable_cyclic_y) jm1=1
         if (jm1<1.and.      enable_cyclic_y) jm1=jmt-2

         totvel = 0.5*(u(i,j,k+1,2,tau)+u(i,j,k,2,tau))
         upos = .5*(totvel + abs(totvel))
     &                  *maskW(i,j,k)*maskW(i,j+1,k)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskW(i,j+1,k)*maskW(i,j,k)
         eastmsk=maskW(i,j,k)*(1-maskW(i,jm1,k))
         westmsk=maskW(i,j+1,k)*(1-maskW(i,jp2,k))
	 adv_fn(i,j,k) =
     &        0.5*totvel*(u(i,j,k,3,tau)+u(i,j+1,k,3,tau))
     &        - 0.5*upos*(0.25*u(i,j+1,k,3,taum1)-0.5*u(i,j,k,3,taum1)
     &               +0.25*(u(i,jm1,k,3,taum1)*(1-eastmsk)
     &                          +u(i,j,k,3,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(u(i,jp2,k,3,taum1)*(1-westmsk)+
     &          u(i,j+1,k,3,taum1)*westmsk)-0.5*u(i,j+1,k,3,taum1)
     &                         +0.25*u(i,j,k,3,taum1))
          enddo
        enddo
      enddo
      call border_exchg3D(adv_fn,1); call setcyclic3D(adv_fn)

      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         kp2=min(k+2,km)
         km1=max(1,k-1)
         totvel = 0.5*(u(i,j,k+1,3,tau)+u(i,j,k,3,tau))
         upos = .5*(totvel + abs(totvel))
     &                  *maskW(i,j,k)*maskW(i,j,k+1)
         uneg = .5*(totvel - abs(totvel))
     &                  *maskW(i,j,k+1)*maskW(i,j,k)
         eastmsk=maskW(i,j,k)*(1-maskW(i,j,km1))
         westmsk=maskW(i,j,k+1)*(1-maskW(i,j,kp2))
	 adv_ft(i,j,k) =
     &        0.5*totvel*(u(i,j,k,3,tau)+u(i,j,k+1,3,tau))
     &        - 0.5*upos*(0.25*u(i,j,k+1,3,taum1)-0.5*u(i,j,k,3,taum1)
     &               +0.25*(u(i,j,km1,3,taum1)*(1-eastmsk)
     &                          +u(i,j,k,3,taum1)*eastmsk))
     &        - 0.5*uneg*(0.25*(u(i,j,kp2,3,taum1)*(1-westmsk)+
     &          u(i,j,k+1,3,taum1)*westmsk)-0.5*u(i,j,k+1,3,taum1)
     &                         +0.25*u(i,j,k,3,taum1))
          enddo
        enddo
      enddo
      end subroutine adv_flux_w_quicker

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      set similar to Jones and Marshall (1996)
c=======================================================================

#define two_dim

      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: fac=1.0
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=120*fac;km=25*fac;jmt=imt
#ifdef two_dim
      jmt=3
#endif
      dx=250/fac; 
      dz=100/fac; 
      dt_in=15/fac
      eps2D_sor = 1e-5
      eps3D_sor = 1e-4
      runlen=12./24. /fac**3
      snap_int = 15*60./86400. 
      enable_cyclic_x            =.true.
      enable_cyclic_y            =.true.
      enable_hydrostatic         =.false.
      enable_quicker_advection   =.true.
      enable_biharmonic_friction =.true.
      enable_vert_biha_friction  =.true.
      enable_biharmonic_diffusion=.true.
      enable_vert_biha_diffusion =.true.
      Ahbi = (5./fac**2)*dx**2
      Khbi = Ahbi
      Avbi = (0.2/fac**2)*dz**2
      Kvbi = Avbi
      lat_ref=30.
      beta   =0.0
      N_0 = 2.5e-3
      M_0 = 0.0
      end subroutine set_parameter


      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: B0,x,fxa,y  ! temp = b/0.2*tho_0/g
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km  ! Rossby radius is  N h /(f pi)
       do j=1,jmt
        do i=1,imt
         x=float(i)/float(imt)
#ifdef two_dim
         B0=1e-9*sin(x*2.5*pi)
#else
         B0=1e-9*sin(x*2.5*pi)*cos(y*3.7*pi)
#endif
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones




      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: i,j
      real :: x,y
      real :: f0  = 50 *0.2/rho_0*g /4185.5 ,fxa
c       b=0.2Temp/rho_0*g    ! temp = b/0.2*tho_0/g
c      surf_flux  = 50 *0.2/rho_0*g /4185.5 
      surf_flux=0
      do j=1,jmt
       do i=1,imt
         x=float(i-imt/2)*dx
         y=float(j-jmt/2)*dx
         fxa = sqrt( x**2+y**2 )
         if (fxa<5e3) surf_flux(i,j)=f0
       enddo
      enddo
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"


c#define with_topography

c=======================================================================
c     Templates for setup
c
c      Wide eddying channel with restoring zones at side walls
#ifdef with_topography
c      reads topography from file
#endif
c=======================================================================

c increase this parameter to enhance resolution
#define RESOLVE  1.0

c 2D version
#define two_dim

#ifdef notdef
c theiss1d_interior:   dt=1200s,  sigma=6.8, L_r=68
c      cdint = 0.5e-7*RESOLVE
      N_0     = 0.004*0.5*2**0.5
      M_0     = sqrt(1e-5*0.1/rho_0*g)*0.5**0.5
c theiss2_interior.cdf dt=2400s, sigma=6.8 L_r=135km     
      N_0     = 0.004*sqrt(2.0)
      M_0     = sqrt(1e-5*0.1/rho_0*g)
c theiss2d_interior         sigma=6.8  L_r= 191
      N_0     = 0.79978099E-02
      M_0     = 0.11667403E-03
c theiss1g_interior         sigma=6.8  L_r=286
      N_0     = 0.004*3.0
      M_0     = sqrt(1e-5*0.1/rho_0*g)*2.15**0.5
c theiss3b_interior         sigma=5.8  L_r= 57
      N_0     = 0.0048*0.5
      M_0     = sqrt(1e-5*0.1/rho_0*g)*0.5**0.5
c theiss3_interior         sigma=5.8  L_r=115
     N_0     = 0.0048
      M_0     = sqrt(1e-5*0.1/rho_0*g)
c theiss3d_interior         sigma=5.8  L_r=191
      N_0     = 0.79978099E-02
      M_0     = 0.12633236E-03
c theiss3c_interior         sigma=5.8  L_r=229
      N_0     = 0.0048*2.0
      M_0     = sqrt(1e-5*0.1/rho_0*g)*2.0**0.5
c theiss1b_interior  dt=1200      sigma=4.8  L_r=48
      N_0     = 0.004*0.5
      M_0     = sqrt(1e-5*0.1/rho_0*g)*0.5**0.5
c theiss1_interior   dt=2400     sigma=4.8  L_r=96
      N_0     = 0.004
      M_0     = sqrt(1e-5*0.1/rho_0*g)
c theiss1c_interior         sigma=4.8  L_r=191
      N_0     = 0.004*2.0
      M_0     = sqrt(1e-5*0.1/rho_0*g)*2**0.5
c theiss1h_interior         sigma=4.8  L_r=239
      N_0     = 0.004*2.5
      M_0     = sqrt(1e-5*0.1/rho_0*g)*2.5**0.5
c theiss2c_interior         sigma=3.2  L_r=72
      N_0     = 0.004*0.75
      M_0     = sqrt(1e-5*0.1/rho_0*g)*sqrt(1.5)*sqrt(0.75)
c theiss2b_interior         sigma=3.2  L_r=96
      N_0     = 0.004
      M_0     = sqrt(1e-5*0.1/rho_0*g)*sqrt(1.5)
c theiss1f_interior    dt=1200     sigma=3.2  L_r=191
      N_0     = 0.004*2.0
      M_0     = sqrt(1e-5*0.1/rho_0*g)*3**0.5
#endif

      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: f_0,Ro,delta,s,fxa
c ----------------------------------
c       set here main parameter
c ----------------------------------
#ifdef two_dim
      imt   = 3 
#else
      imt   = 128*RESOLVE 
#endif
      km    = 20 *RESOLVE;
      jmt   = 128*RESOLVE

      dx    = 1./3.*degtom*cos(30./180.*pi)/RESOLVE
      dz    = 100.0 /RESOLVE
      dt_in = 2400.0/RESOLVE

      K_h=000.0 /RESOLVE
      K_v=1.0e-4/RESOLVE
      A_h=0000.0/RESOLVE
      A_v=10.e-4/RESOLVE

      Ahbi  = 5e11/RESOLVE**2
      Khbi  = Ahbi
c      cdbot = 1e-6*RESOLVE
      cdbot = 0e-6*RESOLVE
      cdint = 0.5e-7*RESOLVE


      eps2D_sor = 1e-9
      runlen    = 365*5. !/RESOLVE**3
      snap_int  = 3.0

      enable_noslip               = .true.
      enable_cyclic_x             = .true.
c      enable_bottom_stress        = .true.
      enable_bottom_stress        = .false.
      enable_interior_stress      = .true.
      enable_biharmonic_friction  = .true.
      enable_biharmonic_diffusion = .true.
      enable_hydrostatic          = .true.

      gamma=0.01
      lat_ref = 10.
      beta    = 2*omega*cos(lat_ref/180.*pi)/radius
c      lat_ref = 180/pi*asin(0.7e-4/2/omega)
c      beta    = 0.
      N_0     = 0.004
      M_0     = sqrt(1e-5*0.1/rho_0*g)

      if (my_pe==0) then
       f_0 = 2*omega*sin(lat_ref/180.*pi)
       Ro  = (km-2)*dz*M_0**2/((jmt-2)*dx)/f_0**2
       delta = (km-2)*dz/( (jmt-2)*dx )
       s = M_0**2/N_0**2
       print*,' '
       print*,' Theiss setup :'
       print*,' '
       print*,' Prandtl number '
       print*,'   f^2/N^2       = ',f_0**2/N_0**2
       print*,' Isopycnal slope '
       print*,'   s=M^2/N^2     = ',s
       print*,' Aspect ratio '
       print*,'   delta=H/L     = ',delta
       print*,' Rossby number '
       print*,'   H M^2/(L f^2) = ',Ro
       print*,' Burger number '
       print*,'   Ro delta/s    = ',Ro*delta/s
       print*,' '
       print*,' Mean velocity scale'
       print*,'  H M^2/f        = ',M_0**2*(km-2)*dz/f_0,' m/s'
       print*,' Inverse Eady growth rate '
       print*,'   tau=N/M^2     = ',N_0/M_0**2/(60*60*24),' days' 
       print*,' Rossby radius '
       print*,'  N h/(f pi)     = ',N_0*(km-2)*dz/(f_0*pi)/1e3,' km'
       print*,' Rhines scale  '
       print*,'  (H M^2/(beta f))^0.5 = ',
     &               (M_0**2*(km-2)*dz/(f_0*beta))**0.5/1e3,' km'
       print*,' '
      endif

      end subroutine set_parameter




      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: B0,x,y
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt
         x=float(i)/float(imt)
         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
         B0=M_0**2*yt(j)+0.5e-3*sin(x*8.5*pi)*exp(-(y-0.5)**2/0.5**2)
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je, spg_width = 3*RESOLVE
      real :: T_rest=1./(5.*86400),B0
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      if (my_blk_j==1) then
       do k=1,km
        do j=2,spg_width+1
         B0= yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt* 
     &             t_rest/(j-1.)*(B0-b(:,j,k,taum1))
        enddo
       enddo
      endif
      if (my_blk_j==n_pes_j) then
       do k=1,km
        do j=jmt-1,jmt-spg_width,-1
         B0= yt(j)*M_0**2-N_0**2*zt(k)
         b(:,j,k,taup1)=b(:,j,k,taup1)+maskT(:,j,k)*c2dt* 
     &             t_rest/(-1.*(j-jmt))*(B0-b(:,j,k,taum1))
        enddo
       enddo
      endif
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none

#ifdef with_topography
c ----------------------------------
c      Add here topography  
c ----------------------------------
      logical :: file_exists
      integer :: io=37
      integer :: i,j,k, buf(imt,jmt)

      if (my_pe==0) print*,' reading topography from file'
      inquire( FILE='kmt_theiss2.dta', EXIST=file_exists )
      if (.not.file_exists) then 
        call halt_stop(' file not found in topography ')
      endif
      open(io,file='kmt_theiss2.dta',form='unformatted',status='old')
      read(io) i,j,k
      if (i/=imt.or.j/=jmt.or.k/=km) then
        call halt_stop(' dimensions do not match in topography ')
      endif
      read(io) buf; kmt=buf
      close(io)
      if (my_pe==0) print*,' done reading topography'
      maskT=0.0
      do j=1,jmt
       do i=1,imt
        k=kmt(i,j)
        if (k>0) maskT(i,j,k:km-1)=1.0
       enddo
      enddo
#endif
      end subroutine topography

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      double diffusion
c=======================================================================

#define two_dim

      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: fac=1.0
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=64*fac;km=60*fac;jmt=imt
#ifdef two_dim
      jmt=3
#endif
      dx=0.0025/fac 
      dz=0.0025/fac 
      dt_in=0.00025/fac
      eps2D_sor = 1e-12
      eps3D_sor = 1e-12
      runlen=360./86400.0 
      snap_int = .1/86400.0
      enable_cyclic_x            =.true.
      enable_cyclic_y            =.true.
c      enable_4th_advection       =.true.
      enable_hydrostatic         =.false.
c      enable_biharmonic_friction =.true.
c      enable_vert_biha_friction  =.true.
c      enable_biharmonic_diffusion=.true.
c      enable_vert_biha_diffusion =.true.
c      Ahbi = (5e-3/fac**2)*dx**2
c      Khbi = Ahbi
c      Avbi = (5e-3/fac**2)*dx**2
c      Kvbi = Avbi
      A_h = 1e-6/fac**2
      K_h = A_h
      A_v = A_h
      K_v = A_h


      lat_ref=0.
      beta   =0.
      N_0 = 0.0
      M_0 = 0.0
      end subroutine set_parameter




      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: fxa
      do k=1,km
       do j=1,jmt
        do i=1,imt
         fxa=1e-3*zt(1)*sin(5*xt(i)/xt(imt)*2*pi)
         b(i,j,k,:)=1e-2*tanh( (fxa+zt(k)-zt(km/2) ) /zt(1)*100 )
         b(i,j,k,:)=b(i,j,k,:)*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------

      call double_diffusion
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"



      module cpflame_module
c=======================================================================
c      Main module for CPFLAME
c=======================================================================
      use time_manager_module
      use timing_module
      use mpp_module
      implicit none
      real, parameter :: version = 0.98
c---------------------------------------------------------------------------------
c      physical parameter
c---------------------------------------------------------------------------------
      real, parameter :: pi     = 3.14159265358979323846264338327950588
      real, parameter :: radius = 6370.0e3        ! Earth radius in m
      real, parameter :: degtom = radius/180.0*pi ! conversion degrees latitude to meters
      real, parameter :: omega  = pi/43082.0      ! earth rotation frequency in 1/s
      real, parameter :: rho_0  = 1024            ! Reference density in kg/m^3
      real, parameter :: g      = 9.806           ! Earth accelaration constant in m/s^2
c---------------------------------------------------------------------------------
c      variable model parameter
c---------------------------------------------------------------------------------
      integer  :: imt=0,km=0,jmt=0      ! Number of grid points in x,y,z direction
      real :: dx=0,dz=0,dt_in=0        ! Delta z, Delta x in m and Delta t in s
      real :: K_h=0, K_v=0             ! horizontal and vertical diffusivitis in m^2/s
      real :: A_h=0, A_v=0             ! horizontal and vertical viscosities in m^2/s
      real :: cdbot=0                  ! Bottom friction in 1/s
      real :: cdint=0                  ! interior friction in 1/s
      real :: Khbi = .0, Kvbi =.0      ! hor/vert biharmonic diffusivities in m^4/s
      real :: Ahbi = .0, Avbi=.0       ! same for biharmonic viscosities
      real :: runlen=0,snap_int=0      ! length of integration and snapshot interval in days 
      real :: eps2D_sor=0,eps3D_sor=0. ! cut off values for Poisson solver
      real :: lat_ref = 45.0           ! Reference values for f/beta plane in 1/s
      real :: beta    = 2e-11          ! beta for beta plane in 1/m/s
      real :: gamma=0.01               ! value for Roberts time filter
      real :: dtex                         ! time step for external mode 
      real :: h_0                          ! maximal possible depth
c
c      parameters for setup and diagnostics (relevant for for hydrostatic version only)
c
      real :: N_0=0.0          ! Square root of constant reference vertical buoyancy gradient
      real :: M_0=0.0          ! Square root of constant meridional reference buoyancy gradient
      real, allocatable :: b_r(:),p_r(:) ! Veetical reference buoyancy and pressure profiles
c---------------------------------------------------------------------------------
c      domain decomposition (see also mpp_module)
c---------------------------------------------------------------------------------
      integer :: n_pes_j = 1 ! number of PEs in meridional (y) direction
      integer :: my_blk_j= 1 ! number of domain in meridional (y) direction
      integer :: js_pe   = 1 ! start j-index of domain of this PE
      integer :: je_pe   = 1 ! end of j_index of domain of this PE
      integer :: j_blk   = 1 ! number of j-rows at this PE
c---------------------------------------------------------------------------------
c      main model variables, units are SI
c---------------------------------------------------------------------------------
      real, allocatable, dimension(:,:,:,:,:) :: u       ! velocicity components for three time levels
      real, allocatable, dimension(:,:,:,:)   :: b       ! (negative) buoyancy for three time levels
      real, allocatable, dimension(:,:,:,:)   :: p_full  ! full pressure for three time levels
      real, allocatable, dimension(:,:,:)     :: p_hydro ! hydrostatic pressure at time level tau
      real, allocatable, dimension(:,:,:)     :: psi     ! non-hdrostatic pressure at time level tau
      real, allocatable, dimension(:,:)       :: p_surf  ! surface pressure
      real, allocatable, dimension(:,:,:)     :: eta     ! free surface elevation
      real, allocatable, dimension(:,:,:)     :: bu     !  barotropic zonal velocity         (only for enable_expl_free_surf)
      real, allocatable, dimension(:,:,:)     :: bv     !  barotriópic meridonal velocity (only for enable_expl_free_surf)
c
c      auxilliary model variables 
c
      real, allocatable, dimension(:,:,:)     :: K_b     ! vertical diffusivity set in case of static instability
      real, allocatable, dimension(:,:,:)     :: maskT   ! mask for T-grid (1 in water, 0 at land)
      real, allocatable, dimension(:,:,:)     :: maskU   ! same for U-grid
      real, allocatable, dimension(:,:,:)     :: maskV   ! same for V-grid
      real, allocatable, dimension(:,:,:)     :: maskW   ! same for W-grid
      real, allocatable, dimension(:,:,:)     :: fu      ! time tendency of u except pressure gradient
      real, allocatable, dimension(:,:,:)     :: fv      ! time tendency of v except pressure gradient
      real, allocatable, dimension(:,:,:)     :: fw      ! time tendency of w except pressure gradient
      real, allocatable, dimension(:)         :: coriolis_t    ! vertical coriolis parameter
      real, allocatable, dimension(:)         :: coriolis_hor  ! horizontal coriolis parameter
      real, allocatable,dimension(:,:)        :: surf_flux     ! surface buoyancy flux
      real, allocatable,dimension(:,:)        :: bottom_flux   ! bottom buoyancy flux
      real, allocatable,dimension(:,:,:)      :: surf_tau      ! surface flux of momentum (u and v component)
      real, allocatable,dimension(:,:,:)      :: bott_tau      ! bottmom flux of momentum (u and v component)
      real, allocatable :: cf2D(:,:,:,:)      ! array containing coefficients to solve 2D Poisson equation
      real, allocatable :: cf3D(:,:,:,:,:,:)  ! array containing coefficients to solve 3D Poisson equation
c
c      model grid variables  
c
      real, allocatable, dimension(:)   :: zt  ! depth of T-grid point  (positive upward) in meters
      real, allocatable, dimension(:)   :: zw  ! depth of W-grid point in meters
      real, allocatable, dimension(:)   :: xt  ! zonal (x) coordinate of T-grid point in meters
      real, allocatable, dimension(:)   :: xu  ! zonal (x) coordinate of U-grid point in meters
      real, allocatable, dimension(:)   :: yt  ! meridional (y) coordinate of T-grid point in meters
      real, allocatable, dimension(:)   :: yu  ! meridional (y) coordinate of V-grid point in meters
      real, allocatable, dimension(:,:) :: hu  ! depth of water column at U-grid points
      real, allocatable, dimension(:,:) :: hv  ! depth of water column at V-grid points
      real, allocatable, dimension(:,:) :: ht  ! depth of water column at T-grid points
      integer,allocatable,dimension(:,:) :: kmt ! number of verticel levels at T grid points
      integer,allocatable,dimension(:,:) :: kmu ! number of verticel levels at U grid points
      integer,allocatable,dimension(:,:) :: kmv ! number of verticel levels at V grid points
c---------------------------------------------------------------------------------
c       switches to configure model setup
c---------------------------------------------------------------------------------
      logical :: enable_noslip              = .false.  ! no lateral slip for momentum
      logical :: enable_bottom_noslip  = .false. ! also for bottom 
      logical :: enable_cyclic_x            = .false.  ! periodic boundary condition in x
      logical :: enable_cyclic_y            = .false.  ! periodic boundary condition in y
      logical :: enable_quicker_advection   = .false.  ! quicker advection scheme for buoyancy
      logical :: enable_4th_advection       = .false.  ! 4. order advection scheme for buoyancy
      logical :: enable_upwind_advection    = .false.  ! upwind advection scheme for buoyancy
      logical :: enable_lax_advection       = .false.  
      logical :: enable_4th_mom_advection = .false. ! momentum advection
      logical :: enable_quicker_mom_advection = .false. ! momentum advection
      logical :: enable_bottom_stress       = .false.  ! Bottom stress
      logical :: enable_interior_stress     = .false.  ! interior stress
      logical :: enable_biharmonic_friction = .false.  ! biharmonic horizontal friction
      logical :: enable_vert_biha_friction  = .false.  ! biharmonic vertical  friction
      logical :: enable_biharmonic_diffusion= .false.  ! same for diffusion
      logical :: enable_vert_biha_diffusion = .false.  ! biharmonic vertical friction
      logical :: enable_free_surface        = .false.  ! implicit free surface
      logical :: enable_hydrostatic         = .true.   ! hydrostatic approximation
      logical :: enable_expl_free_surf     =.false.  ! explicit free surface
c---------------------------------------------------------------------------------
c      other stuff
c---------------------------------------------------------------------------------
      type(time_type) :: restart_time_in   ! Time of last restart
      integer           :: restart_itt=0     ! number of time steps since last restart
      real             :: spval = -9.9e12   ! special value in netcdf files
      integer           :: sor2D_itts        ! number of iterations of 2D Poisson solver
      integer           :: sor3D_itts        ! number of iterations of 3D Poisson solver
      end module cpflame_module



      subroutine allocate_work_space
c=======================================================================
c      Allocate memory for all arrays in main module
c=======================================================================
      use cpflame_module
      implicit none
      allocate(zt(km),zw(km),xt(imt),xu(imt),yt(jmt),yu(jmt) )
      allocate( u(imt,jmt,km,3,0:2) ); u=0.
      allocate( b(imt,jmt,km,0:2)   ); b=0.
      allocate( K_b(imt,jmt,km)  );    K_b=0.
      allocate( p_hydro(imt,jmt,km) ); p_hydro=0.
      allocate( p_full(imt,jmt,km,0:2)  ); p_full=0.
      allocate( p_surf(imt,jmt)     ); p_surf=0.
      allocate( psi(imt,jmt,km)     ); psi=0.
      allocate( eta(imt,jmt,0:2)    ); eta=0.
      allocate( maskT(imt,jmt,km)   ); maskT=0.
      allocate( maskU(imt,jmt,km)   ); maskU=0.
      allocate( maskV(imt,jmt,km)   ); maskV=0.
      allocate( maskW(imt,jmt,km)   ); maskW=0.
      allocate( fu(imt,jmt,km)      ); fu=0.
      allocate( fv(imt,jmt,km)      ); fv=0.
      allocate( fw(imt,jmt,km)      ); fw=0.
      allocate( surf_flux(imt,jmt)  ); surf_flux=0.
      allocate( bottom_flux(imt,jmt)  ); bottom_flux=0.
      allocate( surf_tau(imt,jmt,2) ); surf_tau=0.
      allocate( bott_tau(imt,jmt,2) ); bott_tau=0.
      allocate(coriolis_t(jmt), coriolis_hor(jmt) )
      coriolis_t=0.;coriolis_hor=0.
      allocate( hu(imt,jmt),hv(imt,jmt),ht(imt,jmt))
      hu=0.;hv=0.;ht=0.
      allocate( kmt(imt,jmt),kmu(imt,jmt),kmv(imt,jmt) )
      kmt=0;kmu=0;kmv=0
      allocate( cf2D(imt,jmt,-1:1,-1:1) )
      if (.not.enable_hydrostatic) then
        allocate( cf3D(imt,jmt,km,-1:1,-1:1,-1:1))
      endif
      allocate( b_r(km), p_r(km) ); b_r=0.; p_r=0.
      if (enable_expl_free_surf) then
       allocate( bu(imt,jmt,0:2)    ); bu=0.
       allocate( bv(imt,jmt,0:2)    ); bv=0.
      endif
      end subroutine allocate_work_space
 

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      free convection
c=======================================================================

#define two_dim

      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: fac=0.5
c ----------------------------------
c       set here main parameter
c       T = L^2/A_h 
c ----------------------------------
      imt=800*fac;km=100*fac;jmt=imt
#ifdef two_dim
      jmt=3
#endif
      dx=25/fac; 
      dz=25/fac; 
      dt_in=7.5/fac
      eps2D_sor = 1e-5
      eps3D_sor = 1e-4
      runlen=16./24. /fac**2
      snap_int = 0.25 /24.
      enable_cyclic_x            =.true.
      enable_cyclic_y            =.true.
      enable_hydrostatic         =.false.

      enable_quicker_advection       =.true.
      enable_biharmonic_friction =.true.
      enable_vert_biha_friction  =.true.
      enable_biharmonic_diffusion=.true.
      enable_vert_biha_diffusion =.true.
      Ahbi = (1.0/fac**2)*dx**2
      Khbi = Ahbi
      Avbi = (1.0/fac**2)*dx**2
      Kvbi = Avbi
      lat_ref=60.
      beta   =0.0
      N_0 = 2.5e-3
      M_0 = 0
      end subroutine set_parameter


      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: B0,x,fxa  ! temp = b/0.2*tho_0/g
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt
         x=float(i)/float(imt)
         B0=1e-9*sin(x*2.5*pi)
         b(i,j,k,:)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: i,j
      real :: x,y
      real :: f0  = 50 *0.2/rho_0*g /4185.5 ,fxa
c       b=0.2Temp/rho_0*g    ! temp = b/0.2*tho_0/g
c      surf_flux  = 50 *0.2/rho_0*g /4185.5 
      surf_flux=0
      do j=1,jmt
       do i=1,imt
         x=float(i-imt/2)*dx
         y=float(j-jmt/2)*dx
#ifdef two_dim
         fxa = sqrt( x**2 )
#else
         fxa = sqrt( x**2 +y**2)
#endif
         if (fxa<5e3) surf_flux(i,j)=f0
       enddo
      enddo
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c      slantwise convection with meridional background flow
c=======================================================================

#define two_dim

      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: fac=4.0
c ----------------------------------
c       set here main parameter
c       T = L^2/A_h 
c ----------------------------------
      imt=32*fac;km=20*fac;jmt=imt
#ifdef two_dim
      jmt=3
#endif
      dx=250/fac; 
      dz=20/fac; 
      dt_in=0.5*30/fac;
      eps2D_sor = 1e-6
      eps3D_sor = 1e-6
      runlen=10 
      snap_int = 0.02
      enable_hydrostatic         =.false.

c      enable_cyclic_x            =.true.
      enable_cyclic_y            =.true.
      enable_noslip  = .true.
c      enable_bottom_stress  = .true.
      enable_4th_advection   =.true.
c      enable_quicker_advection   =.true.
      enable_biharmonic_friction =.true. 
      enable_vert_biha_friction  =.true. 
      enable_biharmonic_diffusion=.true. 
      enable_vert_biha_diffusion =.true. 
      Ahbi = (2*2.0*(2.0/fac)**2)*dx**2
      Khbi = Ahbi
      Avbi = (2*0.005*(2.0/fac)**2)*dz**2
      Kvbi = Avbi

c      A_h=2.0*(2.0/fac)**2
c      K_h=A_h
c      A_v=0.005*(2.0/fac)**2
c      K_v=A_v
      lat_ref = 180/pi*asin(1e-4/2/omega)
      beta   =0.0
      N_0 = 0.007!(8e-4)
      M_0 = 0
      end subroutine set_parameter





      subroutine set_back_stratification(bb,u0)
c ----------------------------------
c    overide setting from module back_stratification
c ----------------------------------
      use cpflame_module
      implicit none
      real :: bb(imt,jmt,km),u0(imt,jmt,km)
      real :: U_0=-1* 0.8e-4/100*0.2*1000/1e-4 
      real :: hh = 800
      integer :: i,j,k

c      with b=g rho/rho_0!!!
c      f v = p_x,  p_z= -b,  f v_z = - b_x
c      V_z = V_0/hh , b_x = - f V_0/hh 
c
c     thus best to set U=U_0 z/h  and B=f y U_0/h +f(z)

       !M^2=0.2/1e4/100*0.2= B_y = -f U_0/h -> U_0 =0.2e-4 h/f
      do k=1,km ! u0 is meridional velocity
       u0(:,:,k)=(-U_0*zt(1)/hh+U_0*zt(k)/hh)*maskV(:,:,k)
      enddo
      bb=0.
      do k=1,km
       do i=1,imt-1
        bb(i+1,:,k)=bb(i,:,k)-dx*maskT(i,:,k)*U_0/hh*coriolis_t(1)
       enddo
      enddo
      do k=1,km
       bb(:,:,k)=(bb(:,:,k)-N_0**2*zt(k))*maskT(:,:,k)
      enddo
      end subroutine set_back_stratification



      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: B0,x,fxa,z  ! temp = b/0.2*tho_0/g
c ----------------------------------
c      add here initial conditions
c ----------------------------------
#ifndef enable_back_stratification
      call set_back_stratification(b(:,:,:,0),u(:,:,:,2,0))
      b(:,:,:,1)=b(:,:,:,0)
      b(:,:,:,2)=b(:,:,:,0)
      u(:,:,:,2,1)=u(:,:,:,2,0)
      u(:,:,:,2,2)=u(:,:,:,2,0)
#endif
      do k=1,km
       do j=1,jmt
        do i=1,imt
         b(i,j,k,:) =b(i,j,k,:)+1e-8*sin(xt(i)/xt(imt)*2.5*pi)
     &         *cos(zt(k)/zt(1)*3*pi) *maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions



      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      integer :: i,j,k,js,je
      real :: T_rest,B0,hh
      js=max(2,js_pe); je = min(je_pe,jmt-1)

      T_rest=1./(5.*dt)
      hh=abs(zt(1))/10.;
      do k=1,km
       B0=t_rest*max(0.,1.-(zt(k)-zt(1))/hh)
       do i=1,imt
        do j=js,je
         b(i,j,k,taup1)=b(i,j,k,taup1)+maskT(i,j,k)*c2dt*
     &                 B0*(0-b(i,j,k,taum1))
        enddo
       enddo
      enddo
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: T_rest,B0,hh

c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      T_rest=1./(5.*dt)
      hh=abs(zt(1))/10.;
      do k=1,km
       B0=t_rest*max(0.,1.-(zt(k)-zt(1))/hh)
       do i=1,imt
        do j=js,je
         fu(i,j,k)= fu(i,j,k)+maskU(i,j,k)*
     &            B0*(0.-u(i,j,k,1,taum1))
         fv(i,j,k)= fv(i,j,k)+maskV(i,j,k)*
     &            B0*(0.-u(i,j,k,2,taum1))
         fw(i,j,k)= fw(i,j,k)+maskW(i,j,k)*
     &            B0*(0.-u(i,j,k,3,taum1))
        enddo
       enddo
      enddo
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: i,j
      real :: x,y
      real :: f0  = 1000 *0.2/rho_0*g /4185.5 ,fxa

c     heat = rho cp T, heat flux= rho cp T v = H
c     temp flux T = H /rho_0 /cp [ J/s/m^2 /kg m^3 /J Kg K=m/s K ]
c     density flux = R = T drho/dt [ K m/s kg/m^3 /K ]
c     buoyancy flux = B = -R/\rho_0 g [ kg/m^3 m/s ]
c     B = -H/rho_0 /cp drho/dt /rho_0 g 
c       = 100/1000^2/4185 0.2 *10=5e-8 

c       b=0.2Temp/rho_0*g    ! temp = b/0.2*tho_0/g
c      surf_flux  = 50 *0.2/rho_0*g /4185.5 
      surf_flux=0
      do j=1,jmt
       do i=1,imt
c         surf_flux(i,j)=f0/rho_0
       enddo
      enddo
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"


c#define with_topography

c=======================================================================
c     Templates for setup
c
c      zonally integrated idealised ACC
c=======================================================================

c increase this parameter to enhance resolution
#define RESOLVE  0.125


      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: f_0
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt   = 3
      km    = 20! *RESOLVE;
      jmt   = 128*RESOLVE

      dx    = 20e3/RESOLVE
      dz    = 50.0! /RESOLVE
      dt_in = 1200.0/RESOLVE

      K_h=0000.0 /RESOLVE
      A_h=10000.0!/RESOLVE
      Ahbi  = 5e11/RESOLVE**2
      Khbi  = Ahbi

      K_v=1.0e-4!/RESOLVE
      A_v=10.e-4!/RESOLVE
      cdbot = 1e-5!*RESOLVE

      eps2D_sor = 1e-9
      runlen    = 365*100
      snap_int  = 50.0

      enable_noslip               = .true.
      enable_cyclic_x             = .true.
      enable_bottom_stress        = .true.
      enable_biharmonic_friction  = .false.
      enable_biharmonic_diffusion = .false.
      enable_hydrostatic          = .true.
      enable_quicker_advection    = .true.  

      gamma=0.01
      lat_ref = -25.
      beta    = 2*omega*cos(lat_ref/180.*pi)/radius
      N_0     = 0.004
      M_0     = 0

      if (my_pe==0) then
       f_0 = 2*omega*sin(lat_ref/180.*pi)
       print*,' '
       print*,' Rossby radius '
       print*,'  N h/(f pi)     = ',N_0*(km-2)*dz/(f_0*pi)/1e3,' km'
       print*,' '
      endif

      end subroutine set_parameter



      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: bstar,B0,x,y
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do j=1,jmt
       call b_surface(bstar,j)
       do k=1,km
        do i=1,imt
         x=float(i)/float(imt)
         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
         B0=0.0e-3*sin(x*8.5*pi)*exp(-(y-0.5)**2/0.5**2)
         b(i,j,k,:)  = 0*(bstar+B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
        enddo
      enddo
      end subroutine initial_conditions


      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: fxa,fric(jmt)
      real, parameter :: r=1./(1*86400.)
      real, parameter :: L_x = 1280e3
      real, parameter :: epsilon = 0.5
c ----------------------------------
c      add zonal pressure gradient to 
c      int_{x1}^{x2}  u_t = - p(x2)+p(x1) 
c
c    u_t = f v - dp/dl - r u
c    v_t  = -fu - p_y -r v + ...
c ----------------------------------

#ifdef notdef
      js=max(2,js_pe); je = min(je_pe,jmt-1); i=2
      do k=2,km-1
        fric=0
        do j=je,max(jmt/2+1,js),-1
         fric(j)=fric(j+1)+dx*u(i,j,k,2,taum1)*maskV(i,j,k)
        enddo
        fric=fric*r/L_x
        do j=max(jmt/2,js+1),je
          fu(i,j,k) = fu(i,j,k)+maskU(i,j,k)*(fric(j)+fric(j+1))/2.0
        enddo
      enddo
#endif
#ifndef notdef
      js=max(2,js_pe); je = min(je_pe,jmt-2); i=2
      do k=2,km-1
        do j=max(jmt/2+1,js),je
          fxa=epsilon*(p_full(i,j+1,k,tau)-p_full(i,j,k,tau))/dx
          fu(i,j,k) = fu(i,j,k)-maskU(i,j,k)*fxa
        enddo
      enddo
#endif
      end subroutine momentum_restoring_zones


      subroutine b_surface(bstar,j)
      use cpflame_module
      implicit none
      integer :: j
      real :: db,bstar,y2,L_y
      L_y = yt(jmt)-yt(1)
      db = -30e-3
      bstar=db
      if (yt(j)<L_y/2.0) then
       bstar=db*yt(j)/(L_y/2.0)
      endif
      y2=L_y*0.75
      if (yt(j)>y2) then
       bstar=db*(1-(yt(j)-y2)/(yt(jmt)-y2) )
      endif
      end subroutine b_surface


      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: i,j
      real :: L_y,y,t_rest,bstar
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      L_y = yt(jmt)-yt(1)
      t_rest=30*86400
      do j=1,jmt
       call b_surface(bstar,j)
       do i=1,imt
        if (yt(j)<L_y/2.0) then
         y = yu(j)/L_y
         surf_tau(i,j,1) = .1e-3*sin(2*pi*y)*maskU(i,j,km-1)
        endif
        surf_flux(i,j)=dz/t_rest*(bstar-b(i,j,km-1,tau)) 
       enddo
      enddo
      end subroutine boundary_conditions


      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c     Templates for setup
c
c
c      twodimensional channel forced by wind stress
c      
c=======================================================================


      subroutine set_parameter
      use cpflame_module
      implicit none
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=3;km=46;jmt=14
      dz=100.0
      dx=40.0e3
      dt_in=1200.0
      ahbi = 2e11

      K_h=000.0
      K_v=0.0e-4
      A_h=0000.0
      A_v=1.e-4
      eps2D_sor = 1e-6
      runlen=3*365.0
      snap_int = 5.0
      enable_noslip              = .true.
      enable_cyclic_x            = .true.
      enable_quicker_advection   = .true.
      enable_bottom_stress       = .true.
      enable_biharmonic_friction = .true.
      enable_hydrostatic         = .true.
      cdbot=2e-5
      lat_ref = 45.0      
      beta    = 2*omega*cos(lat_ref/180.*pi)/radius
      N_0 = 0.005
      M_0 = 0
      end subroutine set_parameter


      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: z,r,x,y,B0
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      do k=1,km
       do j=1,jmt
        do i=1,imt
         y=float(j)/float(jmt)
         B0=0.
         b(i,j,k,:) = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine initial_conditions




      subroutine restoring_zones(fb)
      use cpflame_module
      implicit none
      real :: fb(imt,jmt,km)
      integer :: i,j,k
      real :: z,T_rest,x,y,B0
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones


      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones for momentum
c ----------------------------------
      end subroutine momentum_restoring_zones



      subroutine boundary_conditions
      use cpflame_module
      implicit none
      integer :: k,i,j
      real :: x,y
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      do j=1,jmt
       do i=1,imt
        y = (yu(j)-yu(2))/ (yu(jmt-1)-yu(2))
        surf_tau(i,j,1) = .2e-3*sin(pi*y)*maskU(i,j,km-1)
       enddo
      enddo
      end subroutine boundary_conditions



      subroutine topography
      use cpflame_module
      implicit none
      integer :: i,k
      real :: z
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"


#ifdef enable_smagorinsky_friction

c=======================================================================
c      Smagornisky mixing
c      linked in the code in momentum.F only
c=======================================================================

      module smagorinsky_module
      real, parameter :: smag = ( 4./3.14 )**2
      real,allocatable :: tension_Z(:,:,:), strain_Z(:,:,:)
      real,allocatable :: tension_T(:,:,:), strain_T(:,:,:)
      real,allocatable :: diff_T(:,:,:),    diff_Z(:,:,:)
      end module smagorinsky_module



      subroutine smagorinsky
c=======================================================================
c=======================================================================
      use cpflame_module
      use smagorinsky_module
      implicit none
      integer :: i,j,k,js,je
      logical, save :: first= .true.
#include "netcdf.inc"
      integer :: iret,ncid,npe,itdimid,ilen,itimeid
      type(time_type) :: time
      integer :: corner(4), edges(4),varid
      real :: a(imt,js_pe:je_pe,km),fxa

      if (first) call smagorinsky_init

      call u_x_minus_v_y(tension_T) ! at tracer point
      call border_exchg3D(tension_T,1)
      call setcyclic3D(tension_T)
      call u_y_plus_v_x(strain_Z)   ! at zeta point
      call border_exchg3D(strain_Z,1)
      call setcyclic3D(strain_Z)

      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         strain_T(i,j,k)=0.25*(strain_Z(i,j  ,k)+strain_Z(i-1,j  ,k)
     &                        +strain_Z(i,j-1,k)+strain_Z(i-1,j-1,k))
         tension_Z(i,j,k)=0.25*(tension_T(i,j,k)+tension_T(i+1,j,k)
     &                       +tension_T(i,j+1,k)+tension_T(i+1,j+1,k))
         fxa = strain_T(i,j,k)**2+tension_T(i,j,k)**2
         diff_T(i,j,k)=smag*dx**2*sqrt(fxa)
         fxa = strain_Z(i,j,k)**2+tension_Z(i,j,k)**2
         diff_Z(i,j,k)=smag*dx**2*sqrt(fxa)
        enddo
       enddo
      enddo
      call border_exchg3D(diff_Z,1)
      call setcyclic3D(diff_Z)
      call border_exchg3D(diff_T,1)
      call setcyclic3D(diff_T)


      if (snapshot_time_step.or.initial_time==current_time) then

       do npe=0,n_pes-1
        if (my_pe==npe) then
         iret=nf_open('smagorinsky.cdf',NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         iret=nf_inq_dimid(ncid,'Time',itdimid)
         iret=nf_inq_dimlen(ncid, itdimid,ilen)
         iret=nf_inq_varid(ncid,'Time',itimeid)
         if (my_pe==0) then
          ilen=ilen+1
          time = current_time-initial_time
          fxa = time%days + time%seconds/86400.
          iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
         endif

         Corner = (/1,js_pe,1,ilen/); 
         edges  = (/imt,je_pe-js_pe+1,km,1/)
         iret=nf_inq_varid(ncid,'Strain',varid)
         a=strain_T(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)

         iret=nf_inq_varid(ncid,'Tension',varid)
         a=tension_T(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)

         iret=nf_inq_varid(ncid,'Diff',varid)
         a=Diff_T(:,js_pe:je_pe,:)
         where( maskT(:,js_pe:je_pe,:) == 0.) a = spval
         iret= nf_put_vara_double(ncid,varid,corner,edges,a)

         call ncclos (ncid, iret)
        endif
        call barrier
       enddo
      endif
      first=.false.
      end subroutine smagorinsky



      subroutine smagorinsky_init
c=======================================================================
c=======================================================================
      use cpflame_module
      use smagorinsky_module
      implicit none
#include "netcdf.inc"
      integer :: iret,ncid,dims(4),vid
      integer :: lon_tdim,lat_tdim,z_tdim,z_udim,itimedim
      character (len=80) :: name, unit

      allocate(tension_T(imt,jmt,km),strain_T(imt,jmt,km))
      tension_T=0.; strain_T=0.
      allocate(tension_Z(imt,jmt,km),strain_Z(imt,jmt,km))
      tension_Z=0.; strain_Z=0.
      allocate(Diff_Z(imt,jmt,km),Diff_T(imt,jmt,km))
      Diff_Z=0.; Diff_T=0.

      if (my_pe==0) then
       call def_grid_cdf('smagorinsky.cdf')
       iret=nf_open('smagorinsky.cdf',NF_WRITE,ncid)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       call ncredf(ncid, iret)
       iret=nf_inq_dimid(ncid,'xt',lon_tdim)
       iret=nf_inq_dimid(ncid,'yt',lat_tdim)
       iret=nf_inq_dimid(ncid,'zt',z_tdim)
       iret=nf_inq_dimid(ncid,'zu',z_udim)
       iret=nf_inq_dimid(ncid,'Time',itimedim)
       dims = (/Lon_tdim,lat_tdim, z_tdim, iTimedim/)
       vid = ncvdef (ncid,'Strain', NCFLOAT,4,dims,iret)
       name = 'Strain (u_y+v_x)'; unit = '1/s'
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
       vid = ncvdef (ncid,'Tension', NCFLOAT,4,dims,iret)
       name = 'Tension (u_x-v_y)'; unit = '1/s'
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
       vid = ncvdef (ncid,'Diff', NCFLOAT,4,dims,iret)
       name = 'Viscosity'; unit = 'm^2/s'
      call dvcdf(ncid,vid,name,len_trim(name),unit,len_trim(unit),spval)
       call ncclos (ncid, iret)
      endif
      end subroutine smagorinsky_init



      subroutine smagorinsky_fric_u(diff_fe,diff_fn)
c=======================================================================
c       horizontal harmonic friction for u  
c       diff. fluxes are stored in diff_fe and diff_fn
c       account for no slip boundary condition if requested
c=======================================================================
      use cpflame_module
      use smagorinsky_module
      implicit none
      integer :: i,j,k,js,je
      real :: diff_fn(imt,jmt,km), diff_fe(imt,jmt,km),diff

      js=max(2,js_pe); je = min(je_pe,jmt-1)

      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         diff = diff_T(i+1,j,k)
         diff_fe(i,j,k)=diff*(u(i+1,j,k,1,taum1)-u(i,j,k,1,taum1))/dx
        enddo
       enddo
      enddo
      call setcyclic3D(diff_fe)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         diff = diff_Z(i,j,k)
         diff_fn(i,j,k)=diff*(u(i,j+1,k,1,taum1)-u(i,j,k,1,taum1))/dx
     &                   *maskU(i,j+1,k)*maskU(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do j=js-1,je
        diff_fn(:,j,:)=diff_fn(:,j,:)-2*A_h*u(:,j,:,1,taum1)/dx
     &                   *(1-maskU(:,j+1,:))*maskU(:,j,:)
        diff_fn(:,j,:)=diff_fn(:,j,:)+2*A_h*u(:,j+1,:,1,taum1)/dx
     &                   *(1-maskU(:,j,:))*maskU(:,j+1,:)
       enddo
      endif
      call border_exchg3D(diff_fn,1)
      call setcyclic3D(diff_fn)
      end subroutine smagorinsky_fric_u





      subroutine smagorinsky_fric_v(diff_fe,diff_fn)
c=======================================================================
c       horizontal harmonic friction for v  
c       diff. fluxes are stored in diff_fe and diff_fn
c       account for no slip boundary condition if requested
c=======================================================================
      use cpflame_module
      use smagorinsky_module
      implicit none
      integer :: i,j,k,js,je
      real :: diff_fn(imt,jmt,km), diff_fe(imt,jmt,km),diff

      js=max(2,js_pe); je = min(je_pe,jmt-1)

      do k=2,km-1
       do j=js,je
        do i=1,imt-1
         diff = diff_Z(i,j,k)
         diff_fe(i,j,k)=diff*(u(i+1,j,k,2,taum1)-u(i,j,k,2,taum1))/dx
     &                       *maskV(i+1,j,k)*maskV(i,j,k)
        enddo
       enddo
      enddo
      if (enable_noslip) then
       do i=1,imt-1
         diff_fe(i,:,:)=diff_fe(i,:,:)-2*A_h*u(i,:,:,2,taum1)/dx
     &                   *(1-maskV(i+1,:,:))*maskV(i,:,:)
         diff_fe(i,:,:)=diff_fe(i,:,:)+2*A_h*u(i+1,:,:,2,taum1)/dx
     &                   *(1-maskV(i,:,:))*maskV(i+1,:,:)
       enddo
      endif
      call setcyclic3D(diff_fe)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         diff = diff_T(i,j+1,k)
         diff_fn(i,j,k)=diff*(u(i,j+1,k,2,taum1)-u(i,j,k,2,taum1) )/dx
        enddo
       enddo
      enddo
      call border_exchg3D(diff_fn,1)
      call setcyclic3D(diff_fn)
      end subroutine smagorinsky_fric_v




      subroutine u_y_plus_v_x(tension)
c=======================================================================
c       calculate d/dy u plus d/dx v on zeta points
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: tension(imt,jmt,km)
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         tension(i,j,k)=(u(i,j+1,k,1,tau)-u(i,j,k,1,tau))/dx
     &                   *maskU(i,j,k)*maskU(i,j+1,k)
     &                 +(u(i+1,j,k,2,tau)-u(i,j,k,2,tau))/dx
     &                   *maskV(i,j,k)*maskV(i+1,j,k)
        enddo
       enddo
      enddo
      end subroutine u_y_plus_v_x



      subroutine v_x_minus_u_y(omega_Z)
c=======================================================================
c       calculate relative vorticity on zeta points
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: omega_Z(imt,jmt,km)
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         omega_Z(i,j,k)=-(u(i,j+1,k,1,tau)-u(i,j,k,1,tau))/dx
     &                   *maskU(i,j,k)*maskU(i,j+1,k)
     &                 +(u(i+1,j,k,2,tau)-u(i,j,k,2,tau))/dx
     &                   *maskV(i,j,k)*maskV(i+1,j,k)
        enddo
       enddo
      enddo
      end subroutine v_x_minus_u_y



      subroutine u_x_minus_v_y(strain)
c=======================================================================
c       calculate d/dx u minus d/dy v on tracer points
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,js,je
      real :: strain(imt,jmt,km)
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         strain(i,j,k)=(u(i,j,k,1,tau)-u(i-1,j,k,1,tau))/dx
     &                 *maskU(i,j,k)*maskU(i-1,j,k)
     &                -(u(i,j,k,2,tau)-u(i,j-1,k,2,tau))/dx
     &                 *maskV(i,j,k)*maskV(i,j-1,k)
        enddo
       enddo
      enddo
      end subroutine u_x_minus_v_y

#else
      subroutine viscosity_dummy
      end
#endif

c=======================================================================
c
c     Setup for an idealized tracer for setup theiss1.F
c     linked in the code in ../extra_modules/tracer.F
c=======================================================================

#define RESOLVE  2.0

      subroutine tracer_set_number
c ----------------------------------
c     set number of tracers
c ----------------------------------
      use tracer_module
      implicit none
      nt=1
      end subroutine tracer_set_number


      subroutine tracer_initial_conditions
c ----------------------------------
c     initial conditions for tracer
c ----------------------------------
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k
      real :: B0,x,y
      do k=1,km
       do j=1,jmt
        do i=1,imt
         x=float(i)/float(imt)
         y = (yt(j)-yt(2))/ (yt(jmt-1)-yt(2))
         B0=-M_0**2*yt(j)
         tr(i,j,k,:,1)  = (B0-N_0**2*zt(k))*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine tracer_initial_conditions


      subroutine tracer_sources
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k,js,je, spg_width = 3*RESOLVE
      real :: T_rest=1./(5.*86400),B0
c ----------------------------------
c ----------------------------------
c      add here restoring zones, surface boundary conditions etc.
c ----------------------------------
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      if (my_blk_j==1) then
       do k=1,km
        do j=2,spg_width+1
         B0=-yt(j)*M_0**2-N_0**2*zt(k)
         tr(:,j,k,taup1,1)=tr(:,j,k,taup1,1)+maskT(:,j,k)*c2dt* 
     &             t_rest/(j-1.)*(B0-tr(:,j,k,taum1,1))
        enddo
       enddo
      endif
      if (my_blk_j==n_pes_j) then
       do k=1,km
        do j=jmt-1,jmt-spg_width,-1
         B0=-yt(j)*M_0**2-N_0**2*zt(k)
         tr(:,j,k,taup1,1)=tr(:,j,k,taup1,1)+maskT(:,j,k)*c2dt* 
     &             t_rest/(-1.*(j-jmt))*(B0-tr(:,j,k,taum1,1))
        enddo
       enddo
      endif
      end subroutine tracer_sources

c=======================================================================
c
c     Setup for salinity as tracer
c     linked in the code in ../extra_modules/tracer.F
c=======================================================================


      subroutine tracer_set_number
c ----------------------------------
c     set number of tracers
c ----------------------------------
      use tracer_module
      implicit none
      nt=1
      end subroutine tracer_set_number

      subroutine tracer_initial_conditions
c ----------------------------------
c     initial conditions for tracer
c ----------------------------------
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k
      real :: fac,B0,x,y,z
      end subroutine tracer_initial_conditions


      subroutine tracer_sources
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k,js,je
      real :: salt_flux(jmt)
c ----------------------------------
c      add here restoring zones, surface boundary conditions etc.
c ----------------------------------
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      call get_salt_flux(salt_flux)
      k=km-1
      do j=js,je
       tr(:,j,k,taup1,1)=tr(:,j,k,taup1,1)+maskT(:,j,k)*c2dt*
     &      salt_flux(j)/dz
      enddo
      end subroutine tracer_sources




      subroutine salinity_boundary_conditions
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k,js,je
      real :: fxa,fxb,Ly,t_rest,sst(imt,jmt),sss(imt,jmt),sig(imt,jmt)
      real :: salt_flux(jmt),t_star(jmt)
c ----------------------------------
c      add here restoring zones, surface boundary conditions etc.
c ----------------------------------
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      Ly = yt(jmt)-yt(1)
      call get_salt_flux(salt_flux)
      t_rest=30*86400
      do j=js,je
       t_star(j)=-15*exp(-(yt(j)-yt(jmt-1))**2/(Ly/8.)**2 )
      enddo
      k=km-1
      do j=js,je ! sig = 0.8 S - 0.2T ,  T = (0.8S -sig)/0.2
       sig(:,j)=  b(:,j,k,taum1)*1024/g
       sss(:,j)= tr(:,j,k,taum1,1)
       sst(:,j) = (0.8*sss(:,j)-sig(:,j)) /0.2
       surf_flux(:,j)=dz/t_rest*(t_star(j)-sst(:,j)) 
       surf_flux(:,j)=(0.8*salt_flux-0.2*surf_flux(:,j))/1024*g
      enddo

      end subroutine salinity_boundary_conditions



      subroutine get_salt_flux(salt_flux)
      use cpflame_module
      use tracer_module
      implicit none
      real :: salt_flux(jmt)
      integer :: i,j,k,js,je
      real :: fxa,Ly
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      Ly = yt(jmt)-yt(1)
c     surface forcing
      salt_flux(js:je)=0.0
      fxa=0.5/86400.
      do j=js,je
       salt_flux(j)=-fxa*exp(-(yt(j)-yt(jmt-1))**2/(Ly/8.)**2 )
      enddo
      fxa=0.; 
      do j=js,je
       fxa=fxa+salt_flux(j)
      enddo; 
      call global_sum(fxa)
      fxa=fxa/(jmt-2.)
      salt_flux=salt_flux-fxa
      end subroutine get_salt_flux

#include "options.inc"


c=======================================================================
c   add vertical friction due to residual mean formulation
c    vertical friction of residual momentum: u_t = .. + ( K f^2/N^2 u_z)_z
c    linked in the code in driver.F only 
c=======================================================================

#ifdef enable_vert_friction_trm

c   write diffusivity to netcdf file
c#define enable_vert_friction_diagnostics

      module vert_friction_trm_module
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      implicit none
      real, allocatable :: A_trm(:,:,:) ! vertical viscosity
      real, allocatable :: K_thk(:,:,:) ! thickness diffusivity
      real, allocatable :: Nsqrw(:,:,:) 
      real, allocatable :: fNsqrw(:,:,:) 
      real, parameter :: epsln = 1.0e-20 ! a small parameter
      real, parameter :: K_const=1e3  ! thickness diffusivity in m^2/s
      real :: N_min     = 1e-5       ! minimal threshold for stability freq. N
      real :: fNsqr_max = 0.01       ! limit f^2/N^2 by this value
      real :: aidif_momentum = 1.0   ! choose implicit (=1)/explicit(=0) formulation 
      end module vert_friction_trm_module

      subroutine init_vert_friction_trm
c-----------------------------------------------------------------------
c     initialize module
c-----------------------------------------------------------------------
      use cpflame_module
      use vert_friction_trm_module
      implicit none
      real :: fxa
      if (my_pe==0) print*,' Initializing TRM module '
      allocate( A_trm(imt,jmt,km) ); A_trm=0.
      allocate( K_thk(imt,jmt,km) ); K_thk=K_const
      allocate( Nsqrw(imt,jmt,km) ); Nsqrw=0.
      allocate( fNsqrw(imt,jmt,km) ); fNsqrw=0.
#ifdef enable_vert_friction_diagnostics
      if (my_pe==0) call init_vert_friction_trm_diag
#endif
      if (my_pe==0) then
         print*,' K_const =  ',k_const,' m^2/s'
         print*,' N_min   =  ',N_min,' 1/s'
         print*,' fNsqr_max   =  ',fNsqr_max
      endif
      if (my_pe==0) print*,' done initializing TRM module '
      end subroutine init_vert_friction_trm

      subroutine vert_friction_trm
c-----------------------------------------------------------------------
c     Verteiler funktion
c-----------------------------------------------------------------------
      use cpflame_module
      use vert_friction_trm_module
      implicit none
      integer :: js,je,i,j,k,kp
      real :: fxa,fxb,A_uu(imt,jmt,km),diff_ft(imt,jmt,km)

      js=max(2,js_pe); je = min(je_pe,jmt-1)


#ifdef notdef

      do k=1,km-1
       do j=js,je
c        Nsqrw(:,j,k)=-(b(:,j,k+1,taum1)-b(:,j,k,taum1))/dz
        Nsqrw(:,j,k)=-(b_r(k+1)-b_r(k))/dz
        Nsqrw(:,j,k)=max(Nsqrw(:,j,k),N_min**2)
       enddo
      enddo

      diff_ft=0.
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         kp=min(k+1,km-1)
         diff_ft(i,j,k)=-(b(i,j,k,taum1)-b_r(k)
     &                   +b(i,j,kp,taum1)-b_r(kp) )/2.0
     &                    /Nsqrw(i,j,k)
        enddo
       enddo
      enddo
      diff_ft(:,:,1)=diff_ft(:,:,2)
c      diff_ft(:,:,km-1)=diff_ft(:,:,km-2)

      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fu(i,j,k)=fu(i,j,k)+maskU(i,j,k)*( 
     &     -coriolis_t(j)*(u(i,j  ,k,2,tau)+u(i+1,j  ,k,2,tau)+
     &                    u(i,j-1,k,2,tau)+u(i+1,j-1,k,2,tau))/4.0
     &           *( (diff_ft(i  ,j,k)-diff_ft(i  ,j,k-1))/dz
     &            + (diff_ft(i+1,j,k)-diff_ft(i+1,j,k-1))/dz )/2.0 )
        enddo
       enddo
      enddo

      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fv(i,j,k)= fv(i,j,k)+maskV(i,j,k)*(
     &     +(coriolis_t(j  )*(u(i-1,j  ,k,1,tau)+u(i,j  ,k,1,tau)) 
     &      +coriolis_t(j+1)*(u(i-1,j+1,k,1,tau)+u(i,j+1,k,1,tau)))/4.0
     &           *( (diff_ft(i,j  ,k)-diff_ft(i,j  ,k-1))/dz
     &            + (diff_ft(i,j+1,k)-diff_ft(i,j+1,k-1))/dz )/2.0 )
        enddo
       enddo
      enddo
#endif


#ifndef notdef
c-----------------------------------------------------------------------
c     stability freq.
c-----------------------------------------------------------------------
      do k=1,km-1
       do j=js,je
        Nsqrw(:,j,k)=-(b(:,j,k+1,taum1)-b(:,j,k,taum1))/dz
        Nsqrw(:,j,k)=max(Nsqrw(:,j,k),N_min**2)
       enddo
      enddo
c-----------------------------------------------------------------------
c     Calculate f**2/N**2 on W grid and bound 
c-----------------------------------------------------------------------
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
         fNsqrw(i,j,k)= coriolis_t(j)**2/Nsqrw(i,j,k)
         fNsqrw(i,j,k)=min(fNsqrw(i,j,k),fNsqr_max)
        enddo
       enddo
      enddo
c-----------------------------------------------------------------------
c    vertical viscosity
c-----------------------------------------------------------------------
      do k=1,km-1
       do j=js,je
        do i=2,imt-1
          fxa=K_thk(i,j,k)*maskT(i,j,k)+K_thk(i,j,k+1)*maskW(i,j,k) 
          fxb=maskT(i,j,k)+maskW(i,j,k)+epsln
          A_trm(i,j,k)=fxa/fxb*fNsqrw(i,j,k)
        enddo
       enddo
      enddo
      call border_exchg3D(A_trm,1); call setcyclic3D(A_trm)
c-----------------------------------------------------------------------
c      prepare coefficients for implicit part of vertical friction
c-----------------------------------------------------------------------
       A_uu(:,js:je,:)=0
       do k=1,km-1
        do j=js,je
         do i=2,imt-1
          fxa=A_trm(i,j,k)*maskW(i,j,k)+A_trm(i+1,j,k)*maskW(i+1,j,k)
          fxb=maskW(i,j,k)+maskW(i+1,j,k)+epsln
          A_uu(i,j,k) =fxa/fxb*maskU(i,j,k+1)*maskU(i,j,k)
         enddo
        enddo
       enddo
c-----------------------------------------------------------------------
c     now explicit part
c-----------------------------------------------------------------------
       diff_ft(:,js:je,:)=0.
       do k=1,km-1
        do j=js,je
         do i=2,imt-1
          diff_ft(i,j,k)=A_uu(i,j,k)
     &              *(u(i,j,k+1,1,taum1)-u(i,j,k,1,taum1))/dz
         enddo
        enddo
       enddo
c-----------------------------------------------------------------------
c     Add to zonal momentum tendencies
c-----------------------------------------------------------------------
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fu(i,j,k)=fu(i,j,k)+(1-aidif_momentum)*
     &           maskU(i,j,k)*(diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz
        enddo
       enddo
      enddo
c-----------------------------------------------------------------------
c     implicit part of vertical operator
c-----------------------------------------------------------------------
      call trm_implicit_umix(A_uu,aidif_momentum)
c-----------------------------------------------------------------------
c      prepare coefficients for implicit part of vertical friction
c-----------------------------------------------------------------------
       A_uu(:,js:je,:)=0
       do k=1,km-1
        do j=js,je
         do i=2,imt-1
          fxa=A_trm(i,j,k)*maskW(i,j,k)+A_trm(i,j+1,k)*maskW(i+1,j,k) ! error (j+1) ??
          fxb=maskW(i,j,k)+maskW(i,j+1,k)+epsln
          A_uu(i,j,k) =fxa/fxb*maskV(i,j,k+1)*maskV(i,j,k)
         enddo
        enddo
       enddo
c-----------------------------------------------------------------------
c     now explicit part
c-----------------------------------------------------------------------
       diff_ft(:,js:je,:)=0.
       do k=1,km-1
        do j=js,je
         do i=2,imt-1
          diff_ft(i,j,k)=A_uu(i,j,k)
     &              *(u(i,j,k+1,2,taum1)-u(i,j,k,2,taum1))/dz
         enddo
        enddo
       enddo
c-----------------------------------------------------------------------
c     Add to meridional momentum tendencies
c-----------------------------------------------------------------------
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         fv(i,j,k)=fv(i,j,k)+(1-aidif_momentum)*
     &          maskV(i,j,k)* (diff_ft(i,j,k)-diff_ft(i,j,k-1))/dz
        enddo
       enddo
      enddo
c-----------------------------------------------------------------------
c     implicit part of vertical operator
c-----------------------------------------------------------------------
      call trm_implicit_vmix(A_uu,aidif_momentum)
#endif

#ifdef enable_vert_friction_diagnostics
      if (snapshot_time_step.or.initial_time==current_time) then
        call vert_friction_trm_diag
      endif
#endif
      end subroutine vert_friction_trm






      subroutine trm_implicit_umix(A_uu,aidif)
c=======================================================================
c     implicit vertical friction
c=======================================================================
      use cpflame_module
      implicit none
      real :: A_uu(imt,jmt,km) ,aidif
      integer :: j,k,js,je
      real :: a(imt,km),bb(imt,km),c(imt,km),bet(imt)
      real :: pu(imt,km),gam(imt,km),fxa,r(imt,km)
      js=max(2,js_pe); je = min(je_pe,jmt-1)
c---------------------------------------------------------------------------------
c      first fake integrate du/dt = F_u, then solve for rest
c---------------------------------------------------------------------------------
      u(:,js:je,:,1,taup1)= u(:,js:je,:,1,taum1)
     &         +c2dt*fu(:,js:je,:)*maskU(:,js:je,:)
      do j=js,je
       fxa = aidif*c2dt/dz**2
       bb(:,1) = 1+fxa * A_uu(:,j,1)
       c(:,1)  =  -fxa * A_uu(:,j,1)
       do k=2,km-1
         a(:,k)  =  -fxa * A_uu(:,j,k-1)
         bb(:,k) = 1+fxa * (A_uu(:,j,k)+A_uu(:,j,k-1) )
         c(:,k)  =  -fxa * A_uu(:,j,k)
       enddo
       a(:,km)  =  -fxa * A_uu(:,j,km-1)
       bb(:,km) = 1+fxa * A_uu(:,j,km-1) 
       pu=0.0;gam=0.0
       r=u(:,j,:,1,taup1)*maskU(:,j,:)
       bet=bb(:,1)
       where (bet/=0.0) pu(:,1)=r(:,1)/bet
       do k=2,km
        where (bet/=0.0) gam(:,k)=c(:,k-1)/bet
        bet=bb(:,k)-a(:,k)*gam(:,k)
        where(bet/=0.0) pu(:,k)=(r(:,k)-a(:,k)*pu(:,k-1))/bet
       enddo
       do k=km-1,1,-1
        pu(:,k)=pu(:,k)-gam(:,k+1)*pu(:,k+1)
       enddo
       u(:,j,:,1,taup1)=pu
      enddo
      fu(:,js:je,:)=(u(:,js:je,:,1,taup1)
     &      -u(:,js:je,:,1,taum1))/c2dt*maskU(:,js:je,:)
      end subroutine trm_implicit_umix


      subroutine trm_implicit_vmix(A_uu,aidif)
c---------------------------------------------------------------------------------
c     same for v
c---------------------------------------------------------------------------------
      use cpflame_module
      implicit none
      real :: A_uu(imt,jmt,km) ,aidif
      integer :: j,k,js,je
      real :: a(imt,km),bb(imt,km),c(imt,km),bet(imt)
      real :: pu(imt,km),gam(imt,km),fxa,r(imt,km)
      js=max(2,js_pe); je = min(je_pe,jmt-1)
c---------------------------------------------------------------------------------
c      first fake integrate dv/dt = F_v, then solve for rest
c---------------------------------------------------------------------------------
      u(:,js:je,:,2,taup1)= u(:,js:je,:,2,taum1)
     &       +c2dt*fv(:,js:je,:)*maskV(:,js:je,:)
      do j=js,je
       fxa = aidif*c2dt/dz**2
       bb(:,1) = 1+fxa * A_uu(:,j,1)
       c(:,1)  =  -fxa * A_uu(:,j,1)
       do k=2,km-1
         a(:,k)  =  -fxa * A_uu(:,j,k-1)
         bb(:,k) = 1+fxa * (A_uu(:,j,k)+A_uu(:,j,k-1) )
         c(:,k)  =  -fxa * A_uu(:,j,k)
       enddo
       a(:,km)  =  -fxa * A_uu(:,j,km-1)
       bb(:,km) = 1+fxa * A_uu(:,j,km-1) 
       pu=0.0;gam=0.0
       r=u(:,j,:,2,taup1)*maskV(:,j,:)
       bet=bb(:,1)
       where (bet/=0.0) pu(:,1)=r(:,1)/bet
       do k=2,km
        where (bet/=0.0) gam(:,k)=c(:,k-1)/bet
        bet=bb(:,k)-a(:,k)*gam(:,k)
        where(bet/=0.0) pu(:,k)=(r(:,k)-a(:,k)*pu(:,k-1))/bet
       enddo
       do k=km-1,1,-1
        pu(:,k)=pu(:,k)-gam(:,k+1)*pu(:,k+1)
       enddo
       u(:,j,:,2,taup1)=pu
      enddo
      fv(:,js:je,:)=(u(:,js:je,:,2,taup1)
     &           -u(:,js:je,:,2,taum1))/c2dt*maskV(:,js:je,:)
      end subroutine trm_implicit_vmix

#ifdef enable_vert_friction_diagnostics

      subroutine init_vert_friction_trm_diag
c-----------------------------------------------------------------------
c     initialize NetCDF snapshot file
c-----------------------------------------------------------------------
      use cpflame_module
      use vert_friction_trm_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,i,j,k,n
      integer :: lon_tdim,lon_udim,z_tdim,z_udim,itimedim
      integer :: lat_tdim,lat_udim,varid
      integer :: dims(4), corner(4), edges(4)
      character :: name*24, unit*16
      call def_grid_cdf('vert_friction_trm.cdf')
      iret=nf_open('vert_friction_trm.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call ncredf(ncid, iret)
      iret=nf_inq_dimid(ncid,'xt',lon_tdim)
      iret=nf_inq_dimid(ncid,'xu',lon_udim)
      iret=nf_inq_dimid(ncid,'yt',lat_tdim)
      iret=nf_inq_dimid(ncid,'yu',lat_udim)
      iret=nf_inq_dimid(ncid,'zt',z_tdim)
      iret=nf_inq_dimid(ncid,'zu',z_udim)
      iret=nf_inq_dimid(ncid,'Time',itimedim)
      dims = (/Lon_tdim,lat_tdim, z_udim, iTimedim/)
      varid  = ncvdef (ncid,'kappa', NCFLOAT,4,dims,iret)
      name = 'Vertical viscosity'; unit = 'm^2/s'
      call dvcdf(ncid,varid,name,24,unit,16,spval)
      varid  = ncvdef (ncid,'f2N2', NCFLOAT,4,dims,iret)
      name = 'f^2/N^2               '; unit = ' '
      call dvcdf(ncid,varid,name,24,unit,16,spval)
      call ncclos (ncid, iret)
      end subroutine init_vert_friction_trm_diag


      subroutine vert_friction_trm_diag
c-----------------------------------------------------------------------
c     write to NetCDF snapshot file
c-----------------------------------------------------------------------
      use cpflame_module
      use vert_friction_trm_module
      implicit none
#include "netcdf.inc"
      integer :: ncid,iret,n,npe, corner(4), edges(4)
      real :: a(imt,js_pe:je_pe,km)
      integer :: itdimid,ilen,rid,itimeid
      integer :: i,j,is,ie,js,je
      real :: fxa,ut,vt
      type(time_type) :: time
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do npe=0,n_pes
       if (my_pe==npe) then
        iret=nf_open('vert_friction_trm.cdf',NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,ilen)
        iret=nf_inq_varid(ncid,'Time',itimeid)
        if (my_pe==0) then
         ilen=ilen+1
         time = current_time-initial_time
         fxa = time%days + time%seconds/86400.
         iret= nf_put_vara_double(ncid,itimeid,ilen,1,fxa)
        endif
        Corner = (/1,js_pe,1,ilen/); 
        edges  = (/imt,je_pe-js_pe+1,km,1/)
        iret=nf_inq_varid(ncid,'kappa',rid)
        a=A_trm(:,js_pe:je_pe,:)
        where( maskW(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)
        iret=nf_inq_varid(ncid,'f2N2',rid)
        a=fNsqrw(:,js_pe:je_pe,:)
        where( maskW(:,js_pe:je_pe,:) == 0.) a = spval
        iret= nf_put_vara_double(ncid,rid,corner,edges,a)
        call ncclos (ncid, iret)
       endif
       call barrier
      enddo
      end subroutine vert_friction_trm_diag
#endif


#else
      subroutine vert_friction_trm_dummy
      end subroutine vert_friction_trm_dummy
#endif

#include "options.inc"



      program cpflame
c=======================================================================
c      Top level driver for cpflame
c=======================================================================
      use cpflame_module
      implicit none
      integer :: ierr
c---------------------------------------------------------------------------------
c       Initialize MPI setting
c---------------------------------------------------------------------------------
      call mpi_init(ierr)
      call my_mpi_test()
      call get_mpi_comm_world(my_comm)
      call mpi_comm_rank(my_comm,my_pe,ierr)
      call mpi_comm_size(my_comm,n_pes,ierr)
c---------------------------------------------------------------------------------
c      Initialize model
c---------------------------------------------------------------------------------
      call tic('setup')
      call setup()
#ifdef enable_ekecalc
      call init_ekecalc
#endif
#ifdef enable_ekecalc_3D
      call eke3D_init
#endif
#ifdef enable_linear_closure
      call init_linear_closure
#endif
#ifdef enable_bolus_velocity
      call init_bolus
#endif
#ifdef enable_vert_friction_trm
      call init_vert_friction_trm
#endif
#ifdef enable_tke_closure
      call init_tke_closure
#endif
#ifdef enable_diag_particle
      call init_particle
#endif
#ifdef enable_diag_tracer
      call init_tracer
#endif
#ifdef enable_diag_timeave
      call init_time_averages
#endif
#ifdef enable_diag_zonalave
      call init_zonal_averages
#endif
#ifdef enable_diag_spectral
      call init_spectral
#endif
#ifdef enable_diag_numbers
      call init_numbers
#endif
#ifdef enable_diag_over
      call init_overturning
#endif
#ifdef enable_back_stratification
      call init_back_stratification
#endif

      if (my_pe>0) time_manager_verbose = .false.
      call init_time_manager_raw(dt_in,runlen,snap_int,
     &                       restart_time_in,restart_itt )
      call disable_mixing_time_steps
c       mixing_type = 'euler_foreward' 
c       gamma=0

#ifdef enable_press_perturb
      call init_press_perturb
#endif

      call toc('setup')

c---------------------------------------------------------------------------------
c      Begin main model loop
c---------------------------------------------------------------------------------
 10   call time_step_begin()
      call tic('main loop')
      call boundary_conditions
      if (enable_hydrostatic) call vertical_velocity

      call tic('buoyancy')
      call integrate_buoyancy
#ifdef enable_back_stratification
      call back_stratification
#endif
#ifdef enable_diag_tracer
      call integrate_tracer
#endif
      call toc('buoyancy')

      call tic('momentum')
      call momentum_tendency
#ifdef enable_ekecalc
      call ekecalc
#endif
#ifdef enable_ekecalc_3D
      call eke3D
#endif
#ifdef enable_linear_closure
      call linear_closure
#endif
#ifdef enable_bolus_velocity
      call bolus_velocity
#endif
#ifdef enable_tke_closure
      call tke_closure
#endif
#ifdef enable_vert_friction_trm
      call vert_friction_trm
#endif
#ifdef enable_back_stratification
      call back_strat_momentum
#endif
      call toc('momentum')

      call tic('pressure')
      call solve_pressure
#ifdef enable_press_perturb
      call press_perturb
#endif
      call toc('pressure')

      call tic('integrate')
      call integrate
      call toc('integrate')

      call tic('diagnose')
      call diagnose
#ifdef enable_diag_particle
      call integrate_particle
#endif
#ifdef enable_diag_timeave
      call time_averages
#endif
#ifdef enable_diag_zonalave
      call zonal_averages
#endif
#ifdef enable_diag_spectral
      call spectral
#endif
#ifdef enable_diag_numbers
      call diag_numbers
#endif
#ifdef enable_diag_over
      call overturning
#endif
      call toc('diagnose')
      call toc('main loop')
      call tic('cleanup')
      if (last_time_step) call write_restart
      call toc('cleanup')
      call time_step_end()
      if (.not. end_of_run ) goto 10
c---------------------------------------------------------------------------------
c       End main model loop
c---------------------------------------------------------------------------------

      call show_timing()

      call mpi_finalize(ierr)
      end program cpflame



      subroutine read_restart
c ----------------------------------
c       read the restart file
c ----------------------------------
      use cpflame_module
      implicit none
      integer :: j,io,n,js,je

      if (my_pe==0) print*,' reading from restart file '
      call get_free_iounit(io)
      open(io,file='restart.dta',form='unformatted',status='old')
      read(io) restart_itt,restart_time_in
c        restart_itt=0 !!!!
c        call set_calendar_type(no_leap)
c        restart_time_in = set_date(1900,1,1,0,0,0.0)
      if (my_pe==0) then 
        print*,' days since initial time ',restart_time_in%days
        print*,' secs since initial time ',restart_time_in%seconds
        print*,' itt        = ',restart_itt
      endif
      do j=1,jmt
        read(io) u(:,j,:,:,tau), u(:,j,:,:,taum1)
        read(io) b(:,j,:,tau),   b(:,j,:,taum1)
        read(io) eta(:,j,tau),   eta(:,j,taum1), psi(:,j,:)
        read(io) p_full(:,j,:,tau), p_full(:,j,:,taum1) ! this is new
        if (enable_expl_free_surf) then
         read(io) bu(:,j,tau),bv(:,j,tau)
         read(io) bu(:,j,taum1),bv(:,j,taum1)
        endif
      enddo
      close(io)
      if (my_pe==0) print*,' done reading restart'
      end subroutine read_restart


      subroutine write_restart
c ----------------------------------
c      write a restart file
c ----------------------------------
      use cpflame_module
      implicit none
      integer :: j,io,n,js,je

      if (my_pe==0) then
       print*,' writing restart file '
       call get_free_iounit(io)
       open(io,file='restart.dta',form='unformatted',status='unknown')
       write(io) itt,current_time
       do j=js_pe,je_pe
        write(io) u(:,j,:,:,tau), u(:,j,:,:,taum1)
        write(io) b(:,j,:,tau),   b(:,j,:,taum1)
        write(io) eta(:,j,tau),   eta(:,j,taum1), psi(:,j,:)
        write(io) p_full(:,j,:,tau), p_full(:,j,:,taum1) ! this is new
        if (enable_expl_free_surf) then
         write(io) bu(:,j,tau),  bv(:,j,tau)
         write(io) bu(:,j,taum1),  bv(:,j,taum1)
        endif
       enddo
      endif

      do n=1,n_pes-1
        if (my_pe==n) then
         call send_integer(js_pe,1,0,0)
         call send_integer(je_pe,1,0,0)
         do j=js_pe,je_pe
          call send_real(u(:,j,:,:,tau  ),imt*km*3,0,0)
          call send_real(u(:,j,:,:,taum1),imt*km*3,0,0)
          call send_real(b(:,j,:,tau  )  ,imt*km  ,0,0)
          call send_real(b(:,j,:,taum1)  ,imt*km  ,0,0)
          call send_real(eta(:,j,tau  )  ,imt     ,0,0)
          call send_real(eta(:,j,taum1)  ,imt     ,0,0)
          call send_real(psi(:,j,:)      ,imt*km  ,0,0)
          call send_real(p_full(:,j,:,tau),imt*km ,0,0)
          call send_real(p_full(:,j,:,taum1),imt*km ,0,0)
          if (enable_expl_free_surf) then
           call send_real(bu(:,j,tau  )  ,imt     ,0,0)
           call send_real(bu(:,j,taum1)  ,imt     ,0,0)
           call send_real(bv(:,j,tau  )  ,imt     ,0,0)
           call send_real(bv(:,j,taum1)  ,imt     ,0,0)
          endif
         enddo
        elseif (my_pe==0) then
         call recv_integer(js,1,n,0)
         call recv_integer(je,1,n,0)
         do j=js,je
          call recv_real(u(:,j,:,:,tau  ),imt*km*3,n,0)
          call recv_real(u(:,j,:,:,taum1),imt*km*3,n,0)
          call recv_real(b(:,j,:,tau  )  ,imt*km  ,n,0)
          call recv_real(b(:,j,:,taum1)  ,imt*km  ,n,0)
          call recv_real(eta(:,j,tau  )  ,imt     ,n,0)
          call recv_real(eta(:,j,taum1)  ,imt     ,n,0)
          call recv_real(psi(:,j,:)      ,imt*km  ,n,0)
          call recv_real(p_full(:,j,:,tau),imt*km  ,n,0)
          call recv_real(p_full(:,j,:,taum1),imt*km,n,0)
          if (enable_expl_free_surf) then
           call recv_real(bu(:,j,tau  )  ,imt     ,n,0)
           call recv_real(bu(:,j,taum1)  ,imt     ,n,0)
           call recv_real(bv(:,j,tau  )  ,imt     ,n,0)
           call recv_real(bv(:,j,taum1)  ,imt     ,n,0)
          endif
          write(io) u(:,j,:,:,tau), u(:,j,:,:,taum1)
          write(io) b(:,j,:,tau),   b(:,j,:,taum1)
          write(io) eta(:,j,tau),   eta(:,j,taum1), psi(:,j,:)
          write(io) p_full(:,j,:,tau), p_full(:,j,:,taum1) ! this is new
          if (enable_expl_free_surf) then
           write(io) bu(:,j,tau),  bv(:,j,tau)
           write(io) bu(:,j,taum1),  bv(:,j,taum1)
          endif
         enddo
        endif
        call barrier
      enddo

      if (my_pe==0) close(io)

      if (my_pe==0) then
       call get_free_iounit(io)
       open(io,file='ritt',form='formatted',status='unknown')
       write(io,*) itt
       close(io)
       print*,' bye'
       print*,''
      endif
      end subroutine write_restart







      subroutine show_timing()
c
c--------------------------------------------------------------
c     show timing results here
c--------------------------------------------------------------
c
      use cpflame_module
      implicit none
      real :: fxa,fxb
      integer :: npe,iret
      character (len=128) :: s

      do npe = 0,n_pes
       call barrier

      if (my_pe == npe) then

       print*,''
       print*,'Timing summary for PE #',my_pe 


       print*,' setup time summary       = ',
     &   timing_secs('setup'),' s'
       print*,' cleanup time summary     = ',
     &   timing_secs('cleanup'),' s'
       print*,' costs for measuring      = ',
     &   timing_secs('tictoc'),' s'
       print*,' main loop time summary    = ',
     &   timing_secs('main loop') ,' s'
       fxa= timing_secs('main loop') 

       print*,' '
       print*,' in main loop: '
       print*,' '

       s='buoyancy';fxb=timing_secs(s)
       print*,' ',s(1:len_trim(s)),' time summary     = ',
     &   ' s',fxb, ' = ',fxb/fxa*100,'% of main loop'

       s='momentum';fxb=timing_secs(s)
       print*,' ',s(1:len_trim(s)),' time summary     = ',
     &   ' s',fxb, ' = ',fxb/fxa*100,'% of main loop'

       s='pressure';fxb=timing_secs(s)
       print*,' ',s(1:len_trim(s)),' time summary     = ',
     &   ' s',fxb, ' = ',fxb/fxa*100,'% of main loop'

       s='integrate';fxb=timing_secs(s)
       print*,' ',s(1:len_trim(s)),' time summary     = ',
     &   ' s',fxb, ' = ',fxb/fxa*100,'% of main loop'

       s='diagnose';fxb=timing_secs(s)
       print*,' ',s(1:len_trim(s)),' time summary     = ',
     &   ' s',fxb, ' = ',fxb/fxa*100,'% of main loop'

       endif
       call sub_flush(6)
       call barrier
      enddo
      end subroutine show_timing

c=======================================================================
c
c     Setup for an idealized age tracer
c     linked in the code in ../extra_modules/tracer.F
c=======================================================================


      subroutine tracer_set_number
c ----------------------------------
c     set number of tracers
c ----------------------------------
      use tracer_module
      implicit none
      nt=1
      end subroutine tracer_set_number


      subroutine tracer_initial_conditions
c ----------------------------------
c     initial conditions for tracer
c ----------------------------------
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k
      do k=1,km
       do j=1,jmt
        do i=1,imt
         tr(i,j,k,:,1)=0*maskT(i,j,k)
        enddo
       enddo
      enddo
      end subroutine tracer_initial_conditions


      subroutine tracer_sources
      use cpflame_module
      use tracer_module
      implicit none
      integer :: i,j,k,js,je
c ----------------------------------
c      add here restoring zones, surface boundary conditions etc.
c ----------------------------------
      js=max(2,js_pe); je = min(je_pe,jmt-1)
      do k=2,km-1
       do j=js,je
        do i=2,imt-1
         tr(i,j,k,taup1,1)=tr(i,j,k,taup1,1)+maskT(i,j,k)*c2dt*( 
     &           1.0/86400.
     &        )
        enddo
       enddo
      enddo
      k=km-1
      do j=js,je
       do i=2,imt-1
         tr(i,j,k,taup1,1)=tr(i,j,k,taup1,1)+maskT(i,j,k)*c2dt*( 
     &                  1./(1*86400.)*(-tr(i,j,k,taum1,1)) 
     &        )
       enddo
      enddo
      end subroutine tracer_sources

#include "options.inc"


c#define with_topography

c=======================================================================
c     Templates for setup
c
c      idealised MOC with freshwater forcing
c      see also ../extra_setup/salinity_THC.F
c=======================================================================

c increase this parameter to enhance resolution
#define RESOLVE 0.25
#define vRESOLVE 0.5


      subroutine set_parameter
      use cpflame_module
      implicit none
      real :: f_0
c ----------------------------------
c       set here main parameter
c ----------------------------------
      imt=64 *RESOLVE
      km=30 *vRESOLVE
      jmt   = imt

      dx=80e3  /RESOLVE
      dt_in=2400.0  /RESOLVE  
      dz=50.0  /vRESOLVE
      runlen = 365*50000
      snap_int =  365! 360

      A_h=5.0e4 /RESOLVE**2 ! u_t = A u_xx,  1/T = A /L^2 
      A_v=1e-4
      K_v=1e-4
c      K_gm=0000.0
      K_h=0000.0 
      cdbot = 0e-5!*RESOLVE
      cdint = 2e-6
      eps2D_sor = 1e-9

c      enable_noslip               = .true.
      enable_interior_stress      = .true.
c      enable_bottom_stress        = .true.
      enable_hydrostatic          = .true.
      enable_quicker_advection    = .true.  

      gamma=0.01
      lat_ref = 0
      beta = 2*omega/radius
      N_0     = 0.004
      M_0     = 0
#ifndef enable_diag_tracer
      print*,'ERROR'
      print*,' enable_diag_tracer in options.inc '
      call halt_stop('error')
#endif
      end subroutine set_parameter

      subroutine initial_conditions
      use cpflame_module
      implicit none
      integer :: i,j,k
      real :: bstar,B0,x,y
c ----------------------------------
c      add here initial conditions
c ----------------------------------
      end subroutine initial_conditions

      subroutine restoring_zones
      use cpflame_module
      implicit none
c ----------------------------------
c      add here restoring zones
c ----------------------------------
      end subroutine restoring_zones

      subroutine momentum_restoring_zones
      use cpflame_module
      implicit none
      end subroutine momentum_restoring_zones

      subroutine boundary_conditions
c ----------------------------------
c    add here boundary conditions
c ----------------------------------
      call salinity_boundary_conditions

      end subroutine boundary_conditions

      subroutine topography
      use cpflame_module
      implicit none
c ----------------------------------
c      Add here topography  
c ----------------------------------
      end subroutine topography

#include "options.inc"

c=======================================================================
c choose one of the following template setups
c 
c approved non-hydrostatic setups
c#include "../setup/kelv_helm1.F"
c#include "../setup/convection1.F"
c#include "../setup/rayleigh1.F"
c#include "../setup/mixedlayer1.F"
c#include "../setup/wave1.F"
c#include "../setup/shear1.F"
c
c approved hydrostatic setups
c
#include "../setup/barbi_exp1.F"
c#include "../setup/barbi_exp2.F"
c#include "../setup/wardle+marshall1.F"
c#include "../setup/wardle+marshall2.F"
c#include "../setup/edenetal1.F"
c#include "../setup/eady1.F"

c
c test setups use at your own risk
c#include "../setup/advection_test2.F"
c#include "../setup/small_channel1.F"
c#include "../setup/eddy1.F"
c#include "../setup/channel1.F"
c#include "../setup/channel2.F"
c#include "../setup/schwap1.F"
c#include "../setup/convection2.F"
c#include "../setup/afterconvection1.F"
c#include "../setup/theiss1.F"
c#include "../setup/balu1.F"
c#include "../setup/ACC1.F"
c#include "../setup/ACC_coarse1.F"
c#include "../setup/bolus1.F"

c#include "../setup/slantwise1.F"
c#include "../setup/slantwise2.F"
c#include "../setup/THC_hysterese1.F"
c#include "../setup/double_diff1.F"
c
c=======================================================================



      subroutine setup
c=======================================================================
c      setup cpflame
c=======================================================================
      use cpflame_module
      implicit none
      integer :: i,j,k,n,ierr,indp
      character(len=32) :: stamp
      logical :: file_exists = .false.

      if (my_pe==0) then
       print*,''
       print*,'--------------------------------------------------'
       print'(" setting up CPFLAME version ",f5.3)',version
       print*,'--------------------------------------------------'
       print*,''
      endif
c ----------------------------------
c       Set main parameter
c ----------------------------------
      call set_parameter
c ----------------------------------
c       Some more or less useful output
c ----------------------------------
      if (my_pe==0) then
       print*,''

       print*,''
       if (enable_hydrostatic) then
        print*,' hydrostatic model version'
       else
        print*,' nonhydrostatic model version'
       endif
       if (enable_free_surface) then
        print*,' using implicit linear free surface formulation'
       elseif (enable_expl_free_surf) then
        print*,' using explicit linear free surface formulation'
       else
        print*,' using rigid lid formulation'
       endif
       if (enable_quicker_advection) then
        print*,' using quicker advection scheme'
       else if (enable_4th_advection) then
        print*,' using 4th order advection scheme'
       else
        print*,' using second order advection scheme'
       endif
       if (enable_4th_mom_advection) then
        print*,' using 4th order advection scheme for momentum'
       elseif (enable_quicker_mom_advection) then
        print*,' using quicker advection scheme for momentum'
       else
        print*,' using second order advection scheme for momentum'
       endif
       if (enable_cyclic_x) then
        print*,' using cyclic zonal boundary conditions'
       else
        print*,' using solid zonal boundary conditions'
       endif
       if (enable_cyclic_y) then
        print*,' using cyclic meridional boundary conditions'
       else
        print*,' using solid meridional boundary conditions'
       endif
       if (enable_noslip) then
        print*,' using no slip lateral boundary conditions'
       else
        print*,' using free slip lateral boundary conditions'
       endif
       if (enable_bottom_noslip) then
        print*,' using no slip bottom boundary conditions'
       else
        print*,' using free slip bottom boundary conditions'
       endif

       print*,' grid size    : imt=',imt,' jmt=',jmt,' km=',km
       print*,' grid spacing : Delta x =',dx,'m  Delta z =',dz,'m'
       print*,' domain size  : ',imt*dx,'m X ',jmt*dx,'m X ',km*dz,'m'
       print*,' time step    : ',dt_in,'s'
       print*,' run length   : ',runlen*86400,'s, i.e. ',
     &        runlen*86400/dt_in,' time steps'
       print*,' snap interval: ',snap_int*86400,'s, i.e. any ',
     &        snap_int*86400/dt_in,' time steps'
       print*,' lateral  diffusivity : K_h=',K_h,' m^2/s'
       print*,' vertical diffusivity : K_v=',K_v,' m^2/s'
       print*,' lateral  viscosity   : A_h=',A_h,' m^2/s'
       print*,' vertical viscosity   : A_v=',A_v,' m^2/s'
       print*,' epsilon for 2D solver : ',eps2D_sor 
       print*,' f_0  = ',2*omega*sin(lat_ref/180.*pi),' 1/s'
       print*,' beta = ',beta,' 1/(ms)'
      endif

c ----------------------------------
c      time step splitting for explicit free surface
c ----------------------------------
       h_0 = (km-2)*dz
       dtex=dx/sqrt(g*h_0) /4.
       n=nint(dt_in/dtex)
       dtex=dt_in/n
       if (my_pe==0.and.enable_expl_free_surf) then
        print*,' free surface time step : ',dtex,' s'
       endif
c ----------------------------------
c      domain decomposition for each PE
c ----------------------------------
      if (n_pes>1) then
       n_pes_j = n_pes
       j_blk = (jmt-1)/n_pes_j + 1    ! j-extent of each block
       my_blk_j = my_pe + 1 ! number of PE in j-dir.
       js_pe = (my_blk_j-1)*j_blk + 1
       je_pe = min(my_blk_j*j_blk,jmt)
       call barrier
c ----------------------------------
c      check for incorrect domain decomposition
c ----------------------------------
       if (my_blk_j==n_pes_j .and. js_pe>=je_pe-2) then
        print*,' ERROR: on PE: ', my_pe
        print*,' domain decompositon impossible in j-direction'
        print*,' choose other number of PEs in j-direction'
        call halt_stop(' ... ')
       endif
      else
       n_pes_j = n_pes
       j_blk = jmt
       my_blk_j = 1 
       js_pe = 1
       je_pe = jmt
      endif
c ----------------------------------
c      print out the PE decomposition, let all PEs talk
c ----------------------------------
      if (my_pe==0) print*,' Domain decomposition:'
      do n=0,n_pes-1
       if (my_pe==n) then
         print*,''
         print*,' sub domain for PE #',n
         print*,' my_blk_j=',my_blk_j
         print*,' js_pe=',js_pe,' je_pe=',je_pe
         print*,''
       endif
       call barrier
      enddo
c ----------------------------------
c      allocate work space
c ----------------------------------
      call allocate_work_space
c ----------------------------------
c      setup grid
c ----------------------------------
      xt(1)=0.0
      xu(1)=xt(1)+dx/2.0
      do i=2,imt
        xt(i)=xt(i-1)+dx
        xu(i)=xu(i-1)+dx
      enddo
      yt(1)=0.0
      yu(1)=yt(1)+dx/2.0
      do i=2,jmt
        yt(i)=yt(i-1)+dx
        yu(i)=yu(i-1)+dx
      enddo
      zw(1)=0
      zt(1)=zw(1)-dz/2.0
      do k=2,km
        zt(k)=zt(k-1)+dz
        zw(k)=zw(k-1)+dz
      enddo
      zt=zt-dz*(km-2)
      zw=zw-dz*(km-2)
c ----------------------------------
c      set coriolis parameter
c ----------------------------------
      do j=1,jmt
       coriolis_t(j)  = 2*omega*sin(lat_ref/180.*pi)+beta*yt(j)
       coriolis_hor(j)= 2*omega*cos(lat_ref/180.*pi)
c     &             -2*omega*sin(lat_ref/180.*pi)/radius*yt(j)
      enddo
c
c       Reference buoyancy and pressure profiles for diagnostics
c
      b_r = yt(jmt/2)*M_0**2-zt*N_0**2
      p_r(km) = 0
      do k=km-1,1,-1
       p_r(k)=p_r(k+1)+0.5*(b_r(k+1)+b_r(k))*dz
      enddo
c ----------------------------------
c      Land mask
c ----------------------------------
      maskT=0.0
      maskT(2:imt-1,2:jmt-1,2:km-1)=1.0
      call topography
      if (enable_cyclic_x) maskT(1,:,:)=0.0
      if (enable_cyclic_x) maskT(imt,:,:)=0.0
      if (enable_cyclic_y) maskT(:,1,:)=0.0
      if (enable_cyclic_y) maskT(:,jmt,:)=0.0
      call setcyclic3D(maskT)
      maskU=maskT
      do i=1,imt-1
       maskU(i,:,:)=min(maskT(i,:,:),maskT(i+1,:,:))
      enddo
      call setcyclic3D(maskU)
      maskV=maskT
      do j=1,jmt-1
       maskV(:,j,:)=min(maskT(:,j,:),maskT(:,j+1,:))
      enddo
      call setcyclic3D(maskV)
      maskW=maskT
      do k=1,km-1
       maskW(:,:,k)=min(maskT(:,:,k),maskT(:,:,k+1))
      enddo
      call setcyclic3D(maskW)
c ----------------------------------
c     depth 
c ----------------------------------
      ht=0.0;hu=0.0;hv=0.0 
      do k=1,km
       ht=ht+maskT(:,:,k)*dz
       hu=hu+masku(:,:,k)*dz
       hv=hv+maskv(:,:,k)*dz
      enddo
      kmt=0;kmu=0;kmv=0
      do k=km,1,-1
       where (maskT(:,:,k)>0) kmt=k
       where (maskU(:,:,k)>0) kmu=k
       where (maskV(:,:,k)>0) kmv=k
      enddo
c ----------------------------------
c   initial conditions for rho
c ----------------------------------
      inquire( FILE='restart.dta', EXIST=file_exists )
      if (file_exists) then 
        call read_restart
      else
       if (my_pe==0) print*,' using initial conditions '
       call set_calendar_type(no_leap)
       restart_time_in = set_date(1900,1,1,0,0,0.0)
       u=0.0; b=0.0; p_surf=0.0;p_hydro=0.0;p_full=0.0;eta=0.0;psi=0.0
       if (enable_expl_free_surf) then
           bu=0; bv=0.
       endif
       call initial_conditions
      endif
      call setcyclic3D(b(:,:,:,0) )
      call setcyclic3D(b(:,:,:,1) )
      call setcyclic3D(b(:,:,:,2) )
c ----------------------------------
c   initialize diagnostic       
c ----------------------------------
      if (my_pe==0) call init_snap_cdf()

      end subroutine setup
